﻿-- 20010	游戏币	普通宝箱
-- 20011	经验包	普通宝箱
-- 20020	游戏币	金币宝箱
-- 20021	大经验包	金币宝箱
-- 20022	超大经验包	绑定元宝宝箱
-- 20023	金币	绑定元宝宝箱
-- 20031	游戏币	元宝宝箱
-- 20032	大经验包	元宝宝箱
-- 28009	经验满是发的经验包ID

-- 20010	游戏币  等级*200*1
-- 20011	经验包  等级*2000*1
-- 20020	游戏币  等级*200*1.5
-- 20021	大经验包  等级*2000*1.5
-- 20022	超大经验包 等级*2000*2
-- 20023	游戏币 等级*200*2
-- 20031	游戏币 等级*200*2
-- 20032	大经验包 等级*2000*2


local FactorValue = 10000 
function GetRewardByGoodsID(goodsID)
	API_Trace("goodsID "..goodsID)
	local level = API_GetHeroLevel()
	value = 0
	local typeflag = 0
	local Low_1 = 0.000061
	local Low_2 = 0.03
	local Mid_1 = 0.000082
	local Mid_2 = 0.02
	local Hig_1 = 0.000164
	local Hig_2 = 0.21
	if goodsID == 20010 then
		value = level*200*1
		typeflag = 1
	elseif goodsID == 20011 then
		value = level*2000*1
		typeflag = 0
	elseif goodsID == 20020 then
		value =  math.floor((math.pow(level,3)*Low_1 - Low_2)* 100 + 0.5)/100*3*FactorValue
		typeflag = 1
	elseif goodsID == 20021 then
		value = level*2000*1.5
		typeflag = 0
	elseif goodsID == 20022 then
		value = level*2000*2
		typeflag = 0
	elseif goodsID == 20023 then
		value =  math.floor((math.pow(level,3)*Mid_1 - Mid_2)* 100 + 0.5)/100*3*FactorValue
		typeflag = 1
	elseif goodsID == 20031 then
		value = math.floor((math.pow(level,3)*Hig_1 - Hig_2)* 100 + 0.5)/100*5*FactorValue
		typeflag = 1
	elseif goodsID == 20032 then
		value = level*2000*2
		typeflag = 0
	elseif goodsID == 28009 then
		local uid = core.getHero():GetPacketPart():FindGoods(28009)
		--value = g_pGlobal:GetClientWorld():GetGoods(uid):GetPropNum(enProp_Goods_Base1);
		--value = pGoods:GetPropNum(enProp_Goods_Base1)
		local pGoods = g_pGlobal:GetClientWorld():GetGoods(uid)
		local value = pGoods:GetPropNum(enProp_Goods_Base1)
		typeflag = 0
	end
	return value, typeflag
end



---快捷支付 非上架物品的相关配置
local goodsID_OpenWnd_Cfg = {
	{goodsID = 20003, button = "充值", wndID = 168},
	{goodsID = 20006, button = "购买经验丹", wndID = 542},
	{goodsID = 20000, button = "摇钱树", wndID = 971},}

---非上架物品，根据ID打开窗口
function Goods_OpenWnd_ByGoodsID(goodsID)
	--for  i=1, #goodsID_OpenWnd_Cfg do
	for i,v in ipairs(goodsID_OpenWnd_Cfg) do
		if v.goodsID == goodsID then
			return v.button, v.wndID,0
		end
	end
	return "", 0,0
end