﻿---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\LUA\GoodsAniCfg.lua
--版  权:	(C)盛游
--日  期:	2013.6.20
--描  述:	背包获取物品时的动画的位置配置，25帧.
--					Scale(缩放)的值是scale除以100.
--					alpha(透明度)的值是 0 ~ 255
--			对于某些物品，获取时播放特殊的获取特效
----------------------------------------------------------------------------------------------------------------------
local goods_ani_cfg_table=
{
	{x= 310	,y = 242, scale = 150, alpha = 250,},
	{x= 305	,y = 238, scale = 145, alpha = 240,},
	{x= 300	,y = 236, scale = 140, alpha = 230,},
	{x= 295	,y = 232, scale = 135, alpha = 225,},
	{x= 290	,y = 228, scale = 132, alpha = 220,},
	{x= 285	,y = 224, scale = 129, alpha = 215,},
	{x= 280	,y = 220, scale = 126,  alpha = 210,},
	{x= 275	,y = 216, scale = 123,  alpha = 205,},
	{x= 270	,y = 212, scale = 120,  alpha = 200,},
	{x= 265	,y = 208, scale = 117,  alpha = 195,},
	{x= 260	,y = 204, scale = 114,  alpha = 190,},
	{x= 255	,y = 200, scale = 111,  alpha = 185,},
	{x= 250	,y = 196, scale = 108,  alpha = 180,},
	{x= 245	,y = 192, scale = 105,  alpha = 175,},
	{x= 240	,y = 188, scale = 102,  alpha = 170,},
	{x= 235	,y = 184, scale = 99,  alpha = 165,},
	{x= 230	,y = 180, scale = 96,  alpha = 160,},
	{x= 225	,y = 176, scale = 93,  alpha = 155,},
	{x= 220	,y = 172, scale = 90,  alpha = 150,},
	{x= 215	,y = 168, scale = 87,  alpha = 145,},
	{x= 210	,y = 164, scale = 84,  alpha = 140,},
	{x= 205	,y = 160, scale = 81,  alpha = 135,},
	{x= 200	,y = 156, scale = 78,  alpha = 130,},
	{x= 195 ,y = 152, scale = 75,  alpha = 125,},
	{x= 185	,y = 148, scale = 72,   alpha = 120,},
	{x= 180	,y = 144, scale = 69, alpha = 115,},
	{x= 175	,y = 140, scale = 66, alpha = 110,},
	{x= 170	,y = 136, scale = 63, alpha = 105,},
	{x= 165	,y = 132, scale = 60, alpha = 100,},
	{x= 160	,y = 128, scale = 57, alpha = 95,},
	{x= 155	,y = 124, scale = 54, alpha = 90,},
	{x= 150	,y = 120, scale = 51,  alpha = 85,},
	{x= 145	,y = 116, scale = 48,  alpha = 80,},
	{x= 140	,y = 112, scale = 45,  alpha = 75,},
	{x= 135	,y = 108, scale = 42,  alpha = 70,},
	{x= 130	,y = 104, scale = 39,  alpha = 65,},
	{x= 125	,y = 100, scale = 36,  alpha = 60,},
	{x= 120	,y = 96 , scale = 33,  alpha = 55,},
	{x= 115	,y = 92 , scale = 30,  alpha = 50,},
	{x= 110	,y = 88 , scale = 27,  alpha = 45,},
	{x= 105	,y = 84 , scale = 24,  alpha = 40,},
	{x= 100	,y = 80 , scale = 21,  alpha = 35,},
	{x= 95	,y = 76 , scale = 18,  alpha = 30,},
	{x= 90	,y = 72 , scale = 15,  alpha = 25,},
	{x= 85	,y = 68 , scale = 12,  alpha = 20,},
	{x= 80	,y = 64 , scale = 9,  alpha = 15,},
	{x= 75	,y = 60 , scale = 6,  alpha = 10,},
	{x= 70	,y = 56 , scale = 3,  alpha = 5,},
	{x= 65	,y = 50 , scale = 3,  alpha = 5,},
}

local goods_ani_ex_table=
{
	2105,
}

function get_goods_ani_cfg(actorid,taskid)
	return	cjson.encode(goods_ani_cfg_table)
end

function need_play_goods_ani_ex(goodsID)
	for i,v in pairs(goods_ani_ex_table) do 
		if v==goodsID then
			return true
		end
	end
	
	return false
end
