﻿---------------------------------------------------------------------------------------------------------------------
--文件名:	Data\\Scp\\Lua\\suit_upgrade.lua
--版  权:	(C)盛游
--创建人:	linhongwei
--日  期:	2013.8.8
--版  本:	1.0
--描  述:	命格套装(强化套装)的系数计算，命格套装窗口
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
local suit_upgrade_table2 = {}--命格套装配置表
suit_upgrade_table2[1]={id =1, goodsid = 20161,	statusId = 11000, 	lowLimitStar = 0  ,	name = "天枢"	, desc = "全属性加成1%" 	,desc_condition = "全身一套装备"			,desc_condition2 = "全身一套装备"	,}
suit_upgrade_table2[2]={id =2, goodsid = 20162,	statusId = 11001,	lowLimitStar = 5  ,	name = "天璇"	, desc = "全属性加成2%" 	,desc_condition = "全身一套装备#(image,105)",desc_condition2 = "全身一套装备+5"	,}
suit_upgrade_table2[3]={id =3, goodsid = 20163,	statusId = 11002,	lowLimitStar = 10 ,	name = "天玑"	, desc = "全属性加成3%" 	,desc_condition = "全身一套装备#(image,110)",desc_condition2 = "全身一套装备+10",}
suit_upgrade_table2[4]={id =4, goodsid = 20164,	statusId = 11003,	lowLimitStar = 15 ,	name = "天权"	, desc = "全属性加成5%" 	,desc_condition = "全身一套装备#(image,115)",desc_condition2 = "全身一套装备+15",}
suit_upgrade_table2[5]={id =5, goodsid = 20165,	statusId = 11004,	lowLimitStar = 20 ,	name = "玉衡"	, desc = "全属性加成8%" 	,desc_condition = "全身一套装备#(image,120)",desc_condition2 = "全身一套装备+20",}
suit_upgrade_table2[6]={id =6, goodsid = 20166,	statusId = 11005,	lowLimitStar = 25 ,	name = "开阳"	, desc = "全属性加成12%" 	,desc_condition = "全身一套装备#(image,125)",desc_condition2 = "全身一套装备+25",}
suit_upgrade_table2[7]={id =7, goodsid = 20167,	statusId = 11006,	lowLimitStar = 30 ,	name = "摇光"	, desc = "全属性加成18%" 	,desc_condition = "全身一套装备#(image,130)",desc_condition2 = "全身一套装备+30",}

      
local upgrade_add_table = {}--散件的加成配置表
upgrade_add_table[1]={id =1, factor = 10,lowLimitStar = 15,}
upgrade_add_table[2]={id =2, factor = 30,lowLimitStar = 20,}
upgrade_add_table[3]={id =3, factor = 70,lowLimitStar = 25,}
upgrade_add_table[4]={id =4, factor = 150,lowLimitStar = 30,}
	  
local suit_upgrade_limit_level = 40
	
local desktop 	-- 桌面窗口
SuitUpgradeWnd = {}
SuitUpgradeWnd.thiswnd = nil --自己
SuitUpgradeWnd.vAni = nil
SuitUpgradeWnd.preview_wnd = nil
--**********************************************************--
------------------------函数列表------------------------------
function RecalculateUpgradeFactor2(jsonInfoList)
	local hero 		= core.getHero()
	if hero == nil then return end

	--装备栏中强化对应装备信息表(8个部位)
	local infoList = cjson.decode(jsonInfoList)
	
	local ret = {}
	ret.retStatusId = 0
	--ret.retStatusId2 = 0
	--ret.retSt2Desc = ""
	ret.goodsid = 0
	ret.name = ""
	ret.desc = "无"
	
	
	local count = infoList.equip_count	
	
	--求得整套的最低等级、最低星级和星星、月亮、太阳的数量
	local lowLimitStar  = 100
	for i = 1,count do
		local keyPos = "pos_"..i
		local keyLevel = "level_"..i
		local keyStar = "star_"..i
		local keyUid = "uid_"..i
		
		local pos = infoList[keyPos]
		local level = infoList[keyLevel]
		local star = infoList[keyStar]
		local uid =  core.strToUID(infoList[keyUid])
		
		lowLimitStar = math.min(lowLimitStar,star)
	end		
	
	--如果玩家小于40级没有效果
	--[[local level = hero:GetCrtProp(enProp_Level)
	if level < suit_upgrade_limit_level then
		local str = cjson.encode(ret)
		return str
	end--]]
	
	--件数足够，则计算套装系数
	if count ==8 then 
		for i = 1,#suit_upgrade_table2 do
			if lowLimitStar>= suit_upgrade_table2[i].lowLimitStar then
				ret.retStatusId = suit_upgrade_table2[i].statusId
				ret.goodsid =  suit_upgrade_table2[i].goodsid
				ret.name = suit_upgrade_table2[i].name
				ret.desc = suit_upgrade_table2[i].desc
			else
				break
			end	
		end
	end
	
	--身上有个怎么样的光效的状态ID,用于提示和预览
	--[[if lowLimitStar < 12 then
		ret.retStatusId2 = 10041
		ret.retSt2Desc = "#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+12光效预览)"
	elseif lowLimitStar < 22 then
		ret.retStatusId2 = 10042
		ret.retSt2Desc = "#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+22光效预览)"
	else --lowLimitStar < 27 then
		ret.retStatusId2 = 10043
		ret.retSt2Desc = "#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+27光效预览)"
	end
	--]]
	
	local str = cjson.encode(ret)
	return str
end

function CalculateUpgradePreview(lowLimitStar)
	if lowLimitStar <= 12 then
		return 1000114,"#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+12光效预览)"
	elseif lowLimitStar <= 17 then
		return 1000116,"#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+17光效预览)"
	elseif lowLimitStar <= 22 then
		return 1000117,"#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+22光效预览)"
	else --lowLimitStar < 27 then
		return 1000115,"#(link,0,underlinetype=1,close=0,type=openwindow,winid=291,optype=0,txt=全套+27光效预览)"
	end

end

--散件的加成计算
function RecalculateUpgradeFactor3(nCurStar)
	local factor = 0
	for i = 1,#upgrade_add_table do
		if nCurStar>= upgrade_add_table[i].lowLimitStar then
			factor = upgrade_add_table[i].factor
		else
			break
		end	
	end
		
	return factor
end

function suit_upgrade_actor_level_limit()
	return suit_upgrade_limit_level
end
--模块初始化
local  function suit_upgrade_init()
	desktop = WndSystem:GetInstance():GetGameDesktop()

	--创建各个窗口并初始化
	SuitUpgradeWnd.thiswnd = desktop:FindWindowByID(289) or core.createWindow('Data/Scp/Windows/Windows_SuitUpgrade.scp',289)
	g_pGlobal:GetMainUI():AddActorSubWnd(SuitUpgradeWnd.thiswnd,-1)
	
	--设置显示时的调用
	SuitUpgradeWnd.thiswnd:SetLuaEvent(XWIN_EVENT_SHOW,'suit_upgrade_onshow')

	--关闭按钮
	--local btn_close = SuitUpgradeWnd.thiswnd:GetButton('关闭按钮')
	--btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'suit_upgrade_btn_close')

	--光效组
	SuitUpgradeWnd.vAni ={}
	for i = 1, 8 do
		SuitUpgradeWnd.vAni[i] = SuitUpgradeWnd.thiswnd:GetAni("UI特效"..i)
	end

	--小贴士
	local tipwnd = core.createWindow('Data/Scp/Windows/Windows_SuitUpgrade.scp',290)
	local listbox = tipwnd:GetListBox("listbox")	
	listbox:SetColCount(5);
	listbox:SetColFormat(0,120);
	listbox:SetColAlign(0, 1);
	listbox:SetColFormat(1,215);
	listbox:SetColAlign(1,0);
	listbox:SetColFormat(2,215);
	listbox:SetColAlign(2, 0);	
	listbox:SetLineHeight(28)
	
	
	tipwnd:GetButton('关闭按钮'):SetClickEventHandler2( function ( wnd, event) 	
										WndSystem:GetInstance():ShowWnd(290,0)
										end)
	SuitUpgradeWnd.thiswnd:GetButton('问号'):SetClickEventHandler2( function ( wnd, event) 	
										WndSystem:GetInstance():ToggleWnd(290)
										end)
	
	--强化入口
	SuitUpgradeWnd.thiswnd:GetButton('强化'):SetClickEventHandler2( function ( wnd, event) 	
										local hero = core.getHero()
										if hero == nil then  return end
										if hero:GetPropEx("workskill_task_open_1") == 0 and API_GetHeroLevel() < 50 then
											API_ShowSystemMessage(enSysMsgDisplayType_Float, "不能进行强化，需要任务开启")
											return
										end
										WndSystem:GetInstance():OnEvent(102, 10201,1, 0)
										end)
	
	--初始化命格图标管理器，和小贴士的内容
	local suit_vbmgr = SuitUpgradeWnd.thiswnd:GetViewBoxMgr('命格图标管理器')
	listbox:RemoveAll()
	for i = 1,suit_vbmgr:GetSize() do		
		local vb = suit_vbmgr:GetViewBox(i-1)
		vb:ClearItem()
		if suit_upgrade_table2[i] ~= nil then 
			vb:SetItem(suit_upgrade_table2[i].goodsid,1)
			
			local nCol = 0;
			listbox:AddItem(0)
			listbox:SetItem(i-1, nCol, suit_upgrade_table2[i].name)
			nCol = nCol + 1
			listbox:SetItem(i-1, nCol, suit_upgrade_table2[i].desc)
			nCol = nCol + 1
			listbox:SetItem(i-1, nCol, suit_upgrade_table2[i].desc_condition2)
		
			--[[
			local clr = XColor:new(71,255,219)
			if i == 1 then
				clr = XColor:new(253,0,1)
			elseif i == 2 then
				clr = XColor:new(251,209,1)
			elseif i == 3 then
				clr = XColor:new(0,255,0)
			end
			listbox:SetItemTextColor(i-1, clr);
			--]]
		end
	end
	
	
	--命格光效预览窗口
	SuitUpgradeWnd.preview_wnd = core.createWindow('Data/Scp/Windows/Windows_SuitUpgrade.scp',291)
	SuitUpgradeWnd.preview_wnd:SetLuaEvent2(XWIN_EVENT_HIDE,
			function ( wnd, event) 	
				local hero 			= core.getHero()
				if hero == nil then return end
				local preview_ctrl = SuitUpgradeWnd.preview_wnd:GetCreaturePreviewCtrl("预览控件")
				preview_ctrl:RemoveAllEffect()
			end
			)
	SuitUpgradeWnd.preview_wnd:GetButton('关闭按钮'):SetClickEventHandler2( 
			function ( wnd, event) 	
				WndSystem:GetInstance():ShowWnd(291,0)
			end)
end

function suit_upgrade_show_preview(lowLimitStar)
	local hero 			= core.getHero()
	if hero == nil then return end
	local effect,desc = CalculateUpgradePreview(lowLimitStar)
	local preview_ctrl = SuitUpgradeWnd.preview_wnd:GetCreaturePreviewCtrl("预览控件")
	preview_ctrl:SetActorID(hero:GetActorDBID())
	preview_ctrl:RemoveAllEffect()
	preview_ctrl:AddEffect(effect)
end

--窗口打开时
function suit_upgrade_onshow()
	--先清空
	local cur_suit_name_html = SuitUpgradeWnd.thiswnd:GetHtml('当前命格')
	cur_suit_name_html:Clear()
	cur_suit_name_html:ParseContext("#(color,%%255,97,0%%)当前没有命格#(color,restore)")

	for i = 1, 7 do
		SuitUpgradeWnd.vAni[i]:PlayAni(false)
	end
	
	local hero = core.getHero()
	if hero == nil then return end
	
	
	--找到对应套装
	local equip_info_json = hero:GetEquipmentPart():GetSuitUpgradeFactorEx()
	local equip_info = cjson.decode(equip_info_json)
	local cur_suit_info = nil
	for i = 1,#suit_upgrade_table2 do
		if suit_upgrade_table2[i].goodsid == equip_info.goodsid then
			cur_suit_info = suit_upgrade_table2[i]
			break
		end
	end
	if cur_suit_info ~= nil then
		--更新界面显示
		local str ="当前命格:"..cur_suit_info.name.."    效果:"..cur_suit_info.desc.."    要求:"..cur_suit_info.desc_condition
		
		cur_suit_name_html:Clear()
		cur_suit_name_html:ParseContext(str)
		
		for i = 1, 8 do
			if i<= cur_suit_info.id then
				SuitUpgradeWnd.vAni[i]:PlayAni(true);
			end
		end
	end
end

--点击关闭
function suit_upgrade_btn_close()
	--SuitUpgradeWnd.thiswnd:SetVisible(false)
end

--**********************************************************--
--------------------刷脚本的时候执行--------------------------
-- 开服先刷一次,模块初始化
suit_upgrade_init()


