﻿--------------通用询问窗口--------------

module("MsgAskBox", package.seeall)
local msgAskBoxID		= 792
local msgAskMaxNum		= 5		----通用框显示的最大个数
local AskBoxData 		= {}		----保存弹出确认框的信息
local NoNeedShow		= {}		----保存选择了不再提示的确认框信息

----创建窗口
function createAskBox(wndID)
	-- local msgBoxWnd = MsgBox:new()
	-- local resScript = g_pGlobal:GetScriptManager():LoadResScript("Data\\Scp\\Windows\\Windows_Main.scp")
	-- msgBoxWnd:Create(WndSystem:GetInstance(), WndSystem:GetInstance():GetGameDesktop(), resScript:GetResObject(792), 792+#AskBoxData)
	-- msgBoxWnd:GetButton('按钮1'):SetClickEventHandler2(XWIN_EVENT_CLICK, OnClickBtn1)
	local msgBoxWnd = core.createWindow("Data\\Scp\\Windows\\Windows_Main.scp",msgAskBoxID)
	
	msgBoxWnd:GetButton('按钮1'):SetClickEventHandler2(OnClickBtn1)
	msgBoxWnd:GetButton('按钮2'):SetClickEventHandler2(OnClickBtn2)
	XWinUtil:AlignWindow(WndSystem:GetInstance():GetGameDesktop(), msgBoxWnd, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 0, 0, false)
	return msgBoxWnd
end

-----初始化确认框提示信息 重置不再提示checkbox
function InitAskBox(wndID)
	if AskBoxData[wndID] == nil then
		return
	end
	
	AskBoxData[wndID].boxWnd:GetButton('按钮1'):SetTag1(wndID)
	AskBoxData[wndID].boxWnd:GetButton('按钮2'):SetTag1(wndID)
	AskBoxData[wndID].boxWnd:GetCheckBox('询问勾'):SetState(false)
	
	local html = AskBoxData[wndID].boxWnd:GetHtml('Html控件')
	html:Clear()
	html:ParseContext(AskBoxData[wndID].msg)
end

----点击第一个按钮
function OnClickBtn1(wnd)
	local wndID = XButton:CastToButton(wnd):GetTag1()
	if AskBoxData[wndID].boxWnd:GetCheckBox('询问勾'):GetState() then
		NoNeedShow[AskBoxData[wndID].msgFlag] = AskBoxData[wndID]
		NoNeedShow[AskBoxData[wndID].msgFlag].nIndex = 1
	end
	
	AskBoxData[wndID].boxWnd:SetVisible(false)
	if AskBoxData[wndID].callback ~= nil then
		api_call_function(AskBoxData[wndID].callback, 1, AskBoxData[wndID].useData)
	end
	AskBoxData[wndID].boxWnd:SetVisible(false)
end

----点击第二个按钮
function OnClickBtn2(wnd)
	local wndID = XButton:CastToButton(wnd):GetTag1()
	if AskBoxData[wndID].boxWnd:GetCheckBox('询问勾'):GetState() then
		NoNeedShow[AskBoxData[wndID].msgFlag] = AskBoxData[wndID]
		NoNeedShow[AskBoxData[wndID].msgFlag].nIndex = 2
	end
	
	AskBoxData[wndID].boxWnd:SetVisible(false)
	if AskBoxData[wndID].callback ~= nil then
		api_call_function(AskBoxData[wndID].callback, 2, AskBoxData[wndID].useData)
	end
	AskBoxData[wndID].boxWnd:SetVisible(false)
end

----显示询问框
function ShowAskBox(msg, msgflag, callback, useData)
	
	if msg == nil or msg == "" then
		return
	end
	
	if NoNeedShow[msgflag] ~= nil then
		----用新传进的useData
		api_call_function(NoNeedShow[msgflag].callback, NoNeedShow[msgflag].nIndex, useData)
		return
	end
	-- local wnd = nil
	-- local wndID = 792
	--已有 找没显示的
	-- for askWndID,v in pairs(AskBoxData) do
		-- if AskBoxData[askWndID].boxWnd:IsVisible() == false then
			-- wnd = AskBoxData[askWndID].boxWnd
			-- wndID = askWndID
			-- break
		-- end
	-- end
	
	local wndID = msgAskBoxID
	local wnd = nil
	if AskBoxData[wndID] ~= nil then
		wnd = AskBoxData[wndID].boxWnd
	end
	
	----没有 创建
	if wnd == nil then
		if wndID + #AskBoxData > msgAskBoxID + msgAskMaxNum then
			API_Trace('msgbox wnd id not in enough')
			return
		end
		wnd = createAskBox(wndID + #AskBoxData)
	end
	----保存信息
	AskBoxData[wndID] = {}
	AskBoxData[wndID].wndID		= wndID
	AskBoxData[wndID].boxWnd 	= wnd
	AskBoxData[wndID].msg 		= msg
	AskBoxData[wndID].callback 	= callback
	AskBoxData[wndID].useData 	= useData
	AskBoxData[wndID].msgFlag	= msgflag
	
	InitAskBox(wndID)
	wnd:SetVisible(true)
	
end
