---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_act_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2014.01.24
--版  本:	1.0
--描  述:	世界boss界面


----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
----------------------------------窗口相关变量--
activityBosswnd 					= {}	--自己
activityBosswnd.thisWnd				= nil
--世界boss panel列表
activityBosswnd.worldBossPanelList  = {}
--世界boss 翻页按钮 
activityBosswnd.worldBossPList 		= {}
--精英boss panel列表
activityBosswnd.eliteBossPanelList 	= {}
--精英boss 翻页按钮 
activityBosswnd.eliteBossPList		= {}
--奖励viewboss列表
activityBosswnd.rewardViewBoxList	= {}
activityBosswnd.refreshPlace 		= nil
activityBosswnd.go 					= nil


-----------------------------------其他变量--
--世界boss列表
activityBosswnd.worldBossList		= nil
--精英boss列表
activityBosswnd.eliteBossList		= nil
--选中的boss的信息
activityBosswnd.selectBossInfo 		= nil
-----------------------------------常量----
local eachPageCount = 1

------------------------函数------------------------------

--初始化
function ActivityBossWndInit(wnd)
	activityBosswnd.thisWnd = wnd
	--注册显示回调事件
	activityBosswnd.thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnActivityBossWndShow')
	----------------------
	--精英boss
	----------------------
	local scrollmgr			= activityBosswnd.thisWnd:GetScrollMgr("eliteboss_scrollmgr")
	--滑动事件
	scrollmgr:SetLuaEvent2(XWIN_EVENT_CHUNK_TO,OnEliteBossWndChunkTo)
	--先默认选中一个
	OnEliteBossWndChunkTo()

	local panelMgr 			= scrollmgr:GetPanelMgr("panelMgr")
	local panelCount 		= panelMgr:GetPanelCount()
	for i=1, panelCount do
		local panelwnd 		= panelMgr:GetPanelWnd(i-1)
		panelwnd:SetEventToWindow(scrollmgr)
		
		local panelItem		= {}
		panelItem.panelwnd 	= panelwnd
		panelItem.level		= panelwnd:GetLabel("level")
		panelItem.statusLive= panelwnd:GetLabel("boss_status_live")
		panelItem.statusDead= panelwnd:GetLabel("boss_status_dead")
		panelItem.relive 	= panelwnd:GetLabel("relive")
		panelItem.highlight = panelwnd:GetLabel("highlight")
		panelItem.preview 	= panelwnd:GetCreaturePreviewCtrl('preview')
		
		panelwnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateBossInfo')
		table.insert(activityBosswnd.eliteBossPanelList, panelItem) 
	
	end
	--翻页按钮 精英boss
	local pointmgr = activityBosswnd.thisWnd:GetPanelMgr('elite_point_mgr')

	for i=1,pointmgr:GetPanelCount() do
		local panel = pointmgr:GetPanelWnd(i-1)
		local btn = panel:GetButton("pointBtn")
		btn:SetVisible(false)
		table.insert(activityBosswnd.eliteBossPList, btn)
	end
	-------------------------
	--世界boss
	-------------------------
	local scrollmgr			= activityBosswnd.thisWnd:GetScrollMgr("worldboss_scrollmgr")
	--滑动事件
	scrollmgr:SetLuaEvent2(XWIN_EVENT_CHUNK_TO,OnWorldBossWndChunkTo)
	--先默认选中一个
	OnWorldBossWndChunkTo()

	local panelMgr 			= scrollmgr:GetPanelMgr("panelMgr")
	local panelCount 		= panelMgr:GetPanelCount()
	for i=1, panelCount do
		local panelwnd 		= panelMgr:GetPanelWnd(i-1)
		panelwnd:SetEventToWindow(scrollmgr)

		local panelItem		= {}
		panelItem.panelwnd 	= panelwnd
		panelItem.level		= panelwnd:GetLabel("level")
		panelItem.statusLive= panelwnd:GetLabel("boss_status_live")
		panelItem.statusDead= panelwnd:GetLabel("boss_status_dead")
		panelItem.relive 	= panelwnd:GetLabel("relive")
		panelItem.highlight = panelwnd:GetLabel("highlight")
		panelItem.preview 	= panelwnd:GetCreaturePreviewCtrl('preview')

		panelwnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateBossInfo')
		table.insert(activityBosswnd.worldBossPanelList, panelItem) 
	
	end
	activityBosswnd.wBossPointMgr = activityBosswnd.thisWnd:GetPanelMgr("world_point_mgr")
	--翻页按钮 世界boss
	local pointmgr = activityBosswnd.thisWnd:GetPanelMgr('world_point_mgr')

	for i=1,pointmgr:GetPanelCount() do
		local panel = pointmgr:GetPanelWnd(i-1)
		local btn = panel:GetButton("pointBtn")
		btn:SetVisible(false)
		table.insert(activityBosswnd.worldBossPList, btn)
	end
	----------------------
	--详情部分
	----------------------
	activityBosswnd.BossName 		= activityBosswnd.thisWnd:GetLabel("boss_name")

	activityBosswnd.selectBossLevel = activityBosswnd.thisWnd:GetLabel("select_boss_level")

	activityBosswnd.birthplace 		= activityBosswnd.thisWnd:GetLabel("birthplace")

	activityBosswnd.transmit		= activityBosswnd.thisWnd:GetButton("transmit")
	activityBosswnd.transmit:SetLuaEvent2(XWIN_EVENT_CLICK, function()
			if activityBosswnd.selectBossInfo ~= nil then
				ActivityTransmit(activityBosswnd.selectBossInfo.activityID)
			end
	end)
	--奖励
	local panelMgr 		= activityBosswnd.thisWnd:GetPanelMgr("reward_mgr")
	for i=1, panelMgr:GetPanelCount() do
		local panelwnd 			= panelMgr:GetPanelWnd(i-1)
		local rewardICON 		= panelwnd:getWindow("reward_icon")
		local rewardQuality 	= panelwnd:getWindow("reward_quality")
		
		local reward 			= {
								rewardICON 			= rewardICON,
								rewardQuality		= rewardQuality,
									}
		panelwnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateBossInfo')									
		table.insert(activityBosswnd.rewardViewBoxList, reward)
	end

	timer.setTimer("OnActivityBossWndTimer", 880, 10000)
end

--格式化世界boss下一次更新时间
local function FormatBossNextTime(activityInfo)
	local timestr = ""
	if activityInfo == nil then
		API_TraceError("activityInfo is nil")
		return timestr
	end

	local activityID = activityInfo.activityID
	--Boss还活着
	if ActivityClient.bossStatusList[activityID] ~= nil and ActivityClient.bossStatusList[activityID].islive == true then
		timestr = ""
	else
	--Boss死了
		local currentTime 		= XDate:GetInstance():GetCurrentVTime()
		local currentStime 		= XDate:GetInstance():GetDateStruct()
		local activityBeginTime = activityInfo.activityTime[1]*3600 + activityInfo.activityTime[2]*60
		local currentHourMin 	= currentStime.hour*3600 + currentStime.min*60
		if ActivityClient.bossStatusList[activityID] == nil or ActivityClient.bossStatusList[activityID].nextLiveTime == nil then
			ActivityClient.bossStatusList[activityID] = {}

			local initSTime 		= currentStime
			initSTime.hour 			= activityInfo.activityTime[1]
			initSTime.min 			= activityInfo.activityTime[2]
			initSTime.sec 			= 0
			local initBossNextTime 	= XDate:GetTimeFromSTime(initSTime)
			if currentHourMin > activityBeginTime then
				ActivityClient.bossStatusList[activityID].nextLiveTime = initBossNextTime+86400
			else
				ActivityClient.bossStatusList[activityID].nextLiveTime = initBossNextTime
			end
		end

		local timeLeft = ActivityClient.bossStatusList[activityID].nextLiveTime - currentTime
		--API_Trace(timeLeft)
		if timeLeft > 0 then
			local hourLeft = math.floor(timeLeft / 3600)
			local minLeft = math.floor((timeLeft - hourLeft*3600) / 60)
			timestr = hourLeft.."小时"..minLeft.."分钟"
		else
			ActivityClient.bossStatusList[activityID].islive = true
			timestr = ""
		end
	end
	return timestr
end

--格式化精英boss下一次更新的时间
local function FormatEliteBossNextTime(activityInfo)
	local timestr = ""
	if activityInfo == nil then
		API_TraceError("activityInfo is nil")
		return timestr
	end
	local activityID 		= activityInfo.activityID
	local currentTime 		= XDate:GetInstance():GetCurrentVTime()

	--API_Trace(cjson.encode(ActivityClient.bossStatusList[activityID]).."-"..activityID)
	--Boss还活着
	if ActivityClient.bossStatusList[activityID] ~= nil and ActivityClient.bossStatusList[activityID].islive == true then
		timestr = ""
	elseif ActivityClient.bossStatusList[activityID] == nil then
		timestr = ""
	else
		local timeLeft = ActivityClient.bossStatusList[activityID].nextLiveTime - currentTime
		--API_Trace(timeLeft)
		if timeLeft > 0 then
			local hourLeft = math.floor(timeLeft / 3600)
			local minLeft = math.floor((timeLeft - hourLeft*3600) / 60)
			timestr = hourLeft.."小时"..minLeft.."分钟"
		else
			ActivityClient.bossStatusList[activityID].islive = true
			timestr = ""
		end	
	end
	return timestr
end

--排序函数
local function ActivityWndSortFunc(a, b)

	if a.activityLevel[1] == b.activityLevel[1] then
		return a.activityPriority < b.activityPriority
	else
		return a.activityLevel[1] < b.activityLevel[1]
	end

end

--发送数据请求更新信息
local function GetActivityUpdateInfo()
	--发消息
	local msg = {}
	msg.module   	= "activity_info"
	msg.msg_code 	= "getinfo"
	msg.updatetime 	= ActivityClient.updateTime
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--刷新界面
--Scrollmgr 是左右两边最外层的Scrollmgr
--BossPanelList 是panel容器（activityBosswnd.eliteBossPanelList/activityBosswnd.worldBossPanelList
--BossList 是boss信息列表 （activityBosswnd.eliteBossList/activityBosswnd.worldBossList
--PointList 是翻页按钮列表 （ activityBosswnd.eliteBossPList/activityBosswnd.worldBossPList)
--FormatNextTimeFunc 是获取下次更新时间的函数（ FormatBossNextTime/FormatEliteBossNextTime）
--UpdateBossUI(Scrollmgr,activityBosswnd.eliteBossPanelList, activityBosswnd.eliteBossList, activityBosswnd.eliteBossPList, FormatEliteBossNextTime)
--UpdateBossUI(Scrollmgr,activityBosswnd.worldBossPanelList, activityBosswnd.worldBossList, activityBosswnd.worldBossPList, FormatBossNextTime)
local function UpdateBossUI(Scrollmgr, BossPanelList, BossList, PointList, FormatNextTimeFunc)

	--当前是第几页 从第0页开始
	local n = Scrollmgr:GetChunkNo()
	--API_Trace(n)

	for i=1, #BossPanelList do
		local panelItem 		= BossPanelList[i]
		local worldBossInfo 	= BossList[i]
		
		if worldBossInfo ~= nil then
			panelItem.level:setText(worldBossInfo.activityLevel[1])
			panelItem.preview:SetMonsterID(worldBossInfo.activityMonsterID)
			--不是当前界面的不显示宠物预览 也就是设置宠物id为0
			-- 每页4个 在1-4范围内 属于第一页 5-8是第二页 检测是当前页的 则显示
			if (n+1) <= i and (n+2) >= i then
				panelItem.preview:SetVisible(true)
			else
				panelItem.preview:SetVisible(false)
			end
			--  如果服务端下发状态是活着的 
			--	或者 客户端计算的复活时间到了 
			--  那么认为是活着的状态，因为客户端只有打开界面的那一刻请求服务器boss状态，请求后客户端自行计算倒计时。
			if (ActivityClient.bossStatusList[worldBossInfo.activityID] ~= nil and
				ActivityClient.bossStatusList[worldBossInfo.activityID].islive == true)
				or
				FormatNextTimeFunc(worldBossInfo) == "" then

				panelItem.statusLive:SetVisible(true)
				panelItem.statusDead:SetVisible(false)
				panelItem.relive:SetVisible(false)
			else

				panelItem.relive:SetVisible(true)
				panelItem.statusLive:SetVisible(false)
				panelItem.statusDead:SetVisible(true)
			end
			panelItem.panelwnd:SetVisible(true)
			--更新倒计时
			local timestr = FormatNextTimeFunc(worldBossInfo)
			panelItem.relive:setText("复活："..timestr)
			
			--API_Trace(i.."-")
		else
			--API_Trace(i.."nil")
			panelItem.panelwnd:SetVisible(false)
		end
	end

	--下面的流程是处理翻页按钮和显示多少页panelwnd
	--决定显示多少个翻页小圆点
	for i=1, #PointList do
		if i < #BossList then
			PointList[i]:SetVisible(true)
		else
			PointList[i]:SetVisible(false)
		end
	end
end


function OnActivityBossWndShow(wnd, event)
	--请求数据
	GetActivityUpdateInfo()
	
	if activityBosswnd.worldBossList == nil then
		activityBosswnd.worldBossList = GetAllActivityInfoByActivityType(4)
		table.sort(activityBosswnd.worldBossList, ActivityWndSortFunc)
	end
	if activityBosswnd.eliteBossList == nil then
		activityBosswnd.eliteBossList = GetAllActivityInfoByActivityType(5)
		table.sort(activityBosswnd.eliteBossList, ActivityWndSortFunc)
	end
	--刷新boss主UI
	local scrollmgr = activityBosswnd.thisWnd:GetScrollMgr("eliteboss_scrollmgr")
	--重置下当前页
	scrollmgr:SetChunkNo(0)

	local scrollmgr = activityBosswnd.thisWnd:GetScrollMgr("worldboss_scrollmgr")
	--重置下当前页
	scrollmgr:SetChunkNo(0)
	
	
	--第一次打开默认选中第一个
	OnUpdateBossInfo(activityBosswnd.eliteBossPanelList[1].panelwnd)

end


------------------
--更新详细界面
------------------
function OnUpdateBossInfo(wnd, event)
	if wnd == nil then API_TraceError("OnUpdateBossInfo wnd null") return end
	local panelCount = #activityBosswnd.eliteBossPanelList
	
	for i=1, panelCount do
		local bossInfo = activityBosswnd.eliteBossList[i]
		local panelItem = activityBosswnd.eliteBossPanelList[i]
		if panelItem.panelwnd == wnd and bossInfo ~= nil then
			activityBosswnd.BossName:setText(bossInfo.activityName)
			activityBosswnd.selectBossLevel:setText(bossInfo.activityLevel[1])
			activityBosswnd.birthplace:setText(bossInfo.activityPlace)
			--更新选中bossinfo
			activityBosswnd.selectBossInfo = bossInfo
			panelItem.highlight:SetVisible(true)
		else
			panelItem.highlight:SetVisible(false)
		end
	end

	local panelCount = #activityBosswnd.worldBossPanelList
	for i=1, panelCount do
		local bossInfo = activityBosswnd.worldBossList[i]
		local panelItem = activityBosswnd.worldBossPanelList[i]
		if panelItem.panelwnd == wnd and bossInfo ~= nil then
			activityBosswnd.BossName:setText(bossInfo.activityName)
			activityBosswnd.selectBossLevel:setText(bossInfo.activityLevel[1])
			activityBosswnd.birthplace:setText(bossInfo.activityPlace)
			
			--更新选中bossinfo
			activityBosswnd.selectBossInfo = bossInfo
			panelItem.highlight:SetVisible(true)
		else
			panelItem.highlight:SetVisible(false)
		end
	end

	--更新奖励viewbox
	local bossinfo = activityBosswnd.selectBossInfo
 	for i=1, #activityBosswnd.rewardViewBoxList do
 		if bossinfo.activityReward[i] ~= nil then
 			
 			activityBosswnd.rewardViewBoxList[i].rewardICON:SetBitmap("Icon/"..bossinfo.activityReward[i].rewardICON..".png")
 			activityBosswnd.rewardViewBoxList[i].rewardICON:SetToolTipIndex(bossinfo.activityReward[i].rewardToolTipID)
 			activityBosswnd.rewardViewBoxList[i].rewardICON:SetVisible(true)
 			if bossinfo.activityReward[i].rewardQuality == 0 then
 				activityBosswnd.rewardViewBoxList[i].rewardQuality:SetVisible(false)
 			else
 				activityBosswnd.rewardViewBoxList[i].rewardQuality:SetBitmap( ActivityClient.Quality[bossinfo.activityReward[i].rewardQuality] )
 				activityBosswnd.rewardViewBoxList[i].rewardQuality:SetVisible(true)
 			end
 		else
 			
 			activityBosswnd.rewardViewBoxList[i].rewardICON:SetVisible(false)
 			activityBosswnd.rewardViewBoxList[i].rewardQuality:SetVisible(false)
 			activityBosswnd.rewardViewBoxList[i].rewardICON:SetToolTipIndex(-1)
 		end
 	end

end

--定时器
function OnActivityBossWndTimer()
	if activityBosswnd.thisWnd:IsVisible() == false then return end
	--API_Trace("OnActivityBossWndTimer")
	--刷新boss主UI
	local scrollmgr = activityBosswnd.thisWnd:GetScrollMgr("eliteboss_scrollmgr")
	UpdateBossUI(scrollmgr,activityBosswnd.eliteBossPanelList, activityBosswnd.eliteBossList, activityBosswnd.eliteBossPList, FormatEliteBossNextTime)	
	local scrollmgr = activityBosswnd.thisWnd:GetScrollMgr("worldboss_scrollmgr")
	UpdateBossUI(scrollmgr,activityBosswnd.worldBossPanelList, activityBosswnd.worldBossList, activityBosswnd.worldBossPList, FormatBossNextTime)
end

--滑动页面 通用函数
local function OnWndChunkTo(scrollmgr, pointmgr)
	if scrollmgr == nil or pointmgr == nil then
		API_TraceError("OnWndChunkTo scrollmgr or pointmgr is nil")
		return
	end

	local n = scrollmgr:GetChunkNo()
	if n < 0 or pointmgr == nil then 
		--API_Trace("OnActivityWndChunkTo n < 0")
		return
	end
	
	for i=1,pointmgr:GetPanelCount() do
		local panel = pointmgr:GetPanelWnd(i-1)
		local btn = panel:GetButton("pointBtn")
		if n == (i-1) then
			btn:SetManualRestore(true);
			btn:SetState(BS_DOWN);
		else
			btn:SetManualRestore(false);
			btn:SetState(BS_UP);
		end
	end
end

--精英boss页面滑动了
function OnEliteBossWndChunkTo()
	--API_Trace("OnActivityWndChunkTo")
	local scrollmgr = activityBosswnd.thisWnd:GetScrollMgr('eliteboss_scrollmgr')
	local pointmgr = activityBosswnd.thisWnd:GetPanelMgr('elite_point_mgr')
	OnWndChunkTo(scrollmgr, pointmgr)
	--更新UI 主要是为了更新宠物预览的显示与隐藏
	UpdateBossUI(scrollmgr,activityBosswnd.eliteBossPanelList, activityBosswnd.eliteBossList, activityBosswnd.eliteBossPList, FormatEliteBossNextTime)	
end

--世界boss页面滑动
function OnWorldBossWndChunkTo()
	--API_Trace("OnActivityWndChunkTo")
	local scrollmgr = activityBosswnd.thisWnd:GetScrollMgr('worldboss_scrollmgr')
	local pointmgr = activityBosswnd.thisWnd:GetPanelMgr('world_point_mgr')
	OnWndChunkTo(scrollmgr, pointmgr)
	--更新UI 主要是为了更新宠物预览的显示与隐藏
	UpdateBossUI(scrollmgr,activityBosswnd.worldBossPanelList, activityBosswnd.worldBossList, activityBosswnd.worldBossPList, FormatBossNextTime)
end
