---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_guide_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.10.18
--版  本:	1.0
--描  述:	游戏指南

----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------

gameGuideWnd = {}
gameGuideWnd.thiswnd 			= nil
gameGuideWnd.html_content 		= nil
gameGuideWnd.subtitlewnds		= {}


gameGuideWnd.gameGuideList 		= nil

function GameGuideWndInit(wnd)
	gameGuideWnd.thiswnd = wnd

	gameGuideWnd.thiswnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnGameGuideWndShow')

	local panelmgr 				= gameGuideWnd.thiswnd:GetPanelMgr("guide_mgr")
	for i=1, panelmgr:GetPanelCount() do
		local panelwnd 			= panelmgr:GetPanelWnd(i-1)
		local subtitle 			= panelwnd:GetLabel("subtitle")
		local subtitle_btn		= panelwnd:GetButton("subtitle_btn")
		subtitle_btn:SetManualRestore(true)
		local subtitlewnd 		= {
							panelwnd 		= panelwnd,
							subtitle 		= subtitle,
							subtitle_btn	= subtitle_btn,
								}
		panelwnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateGuideContent')
		table.insert(gameGuideWnd.subtitlewnds, subtitlewnd)
	end

	gameGuideWnd.html_content  = gameGuideWnd.thiswnd:GetHtml("content")

end

function OnGameGuideWndShow(wnd, event)
	if gameGuideWnd.gameGuideList == nil then
		gameGuideWnd.gameGuideList = GetGameGuideList()
		--API_Trace(cjson.encode(gameGuideWnd.gameGuideList))
	end

	if table.maxn(gameGuideWnd.gameGuideList) == 0 then return end

	local guideCount = table.maxn(gameGuideWnd.gameGuideList)
	--API_Trace(""..guideCount)
	for i=1, #gameGuideWnd.subtitlewnds do
		if i <= guideCount then
			local guideInfo = gameGuideWnd.gameGuideList[i]

			gameGuideWnd.subtitlewnds[i].subtitle:setText(guideInfo.guideTitle)
			gameGuideWnd.subtitlewnds[i].panelwnd:SetVisible(true)
		else
			gameGuideWnd.subtitlewnds[i].panelwnd:SetVisible(false)
		end
	end

	--按下第一个
	OnUpdateGuideContent(gameGuideWnd.subtitlewnds[1].panelwnd)
end


function OnUpdateGuideContent(wnd, event)
	for i=1 , #gameGuideWnd.subtitlewnds do
		if gameGuideWnd.subtitlewnds[i].panelwnd == wnd then
			local guideInfo = gameGuideWnd.gameGuideList[i]

			gameGuideWnd.html_content:Clear()
			gameGuideWnd.html_content:ParseContext(guideInfo.guideContent)
			gameGuideWnd.subtitlewnds[i].subtitle_btn:DownButtonState()
		else
			gameGuideWnd.subtitlewnds[i].subtitle_btn:RestoreButtonState()
		end
	end
end


