---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_main_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2014.1.21
--版  本:	1.0
--描  述:	日常面板
----------------------------------------------------------------------------------------------------------------------
--**********************************************************--
------------------------一些变量------------------------------
--聚灵仙阵 活动相关的变量
local max_open_wine_count = 12
local max_open_wine_count_vip6 = 13
local max_open_wine_count_vip7 = 14
local max_open_wine_count_vip8 = 15
local max_open_wine_count_vip9 = 16
local chumoActivityID 		   = 16
local chumo_taskID 			   	= 2001 --除魔令任务id
local chumoling_goodsid 		= {21005,21004,21003,21002,21001}
local wndid_packet = 81			--背包窗口的id


activityRiChangWnd 						= {}	--自己
activityRiChangWnd.thisWnd  			= nil				
activityRiChangWnd.richangPanelList 	= {}
activityRiChangWnd.scrollmgr 			= nil

activityRiChangWnd.activityList 		= nil
activityRiChangWnd.mouseY 				= 0

function activityRiChangWndInit(wnd)
	activityRiChangWnd.thisWnd = wnd
	--注册显示回调事件
	activityRiChangWnd.thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnActivityRiChangShow')

	--日常活动列表
	activityRiChangWnd.scrollmgr 	= activityRiChangWnd.thisWnd:GetScrollMgr("richang_scrollmgr")
	local panelmgr  	= activityRiChangWnd.scrollmgr:GetPanelMgr("reward_mgr")
	local panelCount 	= panelmgr:GetPanelCount()
	for i=1, panelCount do
		local richangPanel = {}
		local panelwnd 				= panelmgr:GetPanelWnd(i-1)
		panelwnd:SetEventToWindow(activityRiChangWnd.scrollmgr)

		richangPanel.panelwnd 			= panelwnd
		richangPanel.headTitle 			= panelwnd:GetLabel("head_title")
		richangPanel.recommendLevel 	= panelwnd:GetHtml("recommend_level")
		richangPanel.expStarPanelmgr 	= panelwnd:GetPanelMgr("exp_star_panelmgr")
		richangPanel.goodsStarPanelmgr 	= panelwnd:GetPanelMgr("goods_star_panelmgr")
		richangPanel.joinCount 			= panelwnd:GetLabel("join_count")
		richangPanel.rewardDes			= panelwnd:GetHtml("reward_des")
		richangPanel.join				= panelwnd:GetButton("join")
		richangPanel.activityID 		= 0
		richangPanel.join:SetClickEventHandler2(
			function(wnd, event)
				for k, v in pairs(activityRiChangWnd.richangPanelList) do
					if v.join == wnd then
						ActivityTransmit(v.activityID)
					end
				end
			end
			)
		richangPanel.use 				= panelwnd:GetButton("btn_use")
		richangPanel.use:SetClickEventHandler("OnActivityUse")

		table.insert(activityRiChangWnd.richangPanelList, richangPanel)
	end

end

--设置多少星
local function SetStar(panelmgr, n)
	if panelmgr ~= nil then
		local panelCount = panelmgr:GetPanelCount()
		for i=1, panelCount do
			local panelwnd 	= panelmgr:GetPanelWnd(i-1)
			local star 		= panelwnd:GetStaticBitmap("star")
			if i <= n then
				star:SetVisible(true)
			else
				star:SetVisible(false)
			end
		end
	end
end


--排序函数
local function ActivityWndSortFunc(a, b)
	
	if a.activityLevel[1] == b.activityLevel[1] then
		return a.activityPriority < b.activityPriority
	else
		return a.activityLevel[1] < b.activityLevel[1]
	end
end

function OnActivityRiChangShow(wnd, event)
	if activityRiChangWnd.activityList == nil then
		activityRiChangWnd.activityList = GetAllActivityInfoByActivityType(2)
		--API_Trace(cjson.encode(activityRiChangWnd.activityList))
		if activityRiChangWnd.activityList == nil then return end
		--排序
		table.sort(activityRiChangWnd.activityList, ActivityWndSortFunc)
	end

	for i=1 ,#activityRiChangWnd.richangPanelList do
		local panel = activityRiChangWnd.richangPanelList[i]
		local richangInfo = activityRiChangWnd.activityList[i]
		if richangInfo ~= nil then
			panel.headTitle:setText(richangInfo.activityName)
			SetStar(panel.expStarPanelmgr, richangInfo.activityExpLevel or 0)
			SetStar(panel.goodsStarPanelmgr, richangInfo.activityGoodsLevel or 0)
			local count, maxCount = GetActivityCanJoinCount(richangInfo)
			if maxCount ~= -1 then
				panel.joinCount:setText(count.."/"..maxCount)
			else
				panel.joinCount:setText("无限制")
			end
			panel.rewardDes:Clear()
			panel.rewardDes:ParseContext(richangInfo.activityRewardDesc)

			panel.recommendLevel:Clear()
			local recommendLevelDes = ""
			if IsCanJoinActivity(richangInfo) then
				recommendLevelDes = "#(color,%%255,255,255%%)LV."..richangInfo.activityLevel[1].."#(color,resole)"
				panel.join:SetEnabled(true)
			else
				recommendLevelDes = "#(color,%%255,0,0%%)LV."..richangInfo.activityLevel[1].."#(color,resole)"
				panel.join:SetEnabled(false)
			end
			panel.recommendLevel:ParseContext("#(color,%%44,247,255%%)推荐#(color,resole)"..recommendLevelDes)

			--关联一下activityID和panel 以便按钮点击知道是哪个活动	
			panel.activityID = richangInfo.activityID

			--除魔令特殊处理
			if richangInfo.activityID == chumoActivityID then
				--panel.use:SetVisible(true)
				if API_HaveTask(chumo_taskID) == true then
					panel.use:SetVisible(false)
					panel.use:PlayAni(false)
				else
					panel.use:SetVisible(true)
					panel.use:PlayAni(true)
				end
			else
				panel.use:SetVisible(false)
			end

			panel.panelwnd:SetVisible(true)
		else
			
			panel.panelwnd:SetVisible(false)
		end
	end
end


--使用
function OnActivityUse(wnd, event )
	local activityID = 0
	for k, v in pairs(activityRiChangWnd.richangPanelList) do
		if v.use == wnd then
			activityID = v.activityID
			break
		end
	end

	if activityID == chumoActivityID then
		local bHasChumo = false
		local ChumoGoodsID = 0
		for k, v in pairs(chumoling_goodsid) do
			if core.getHero():GetPacketPart():GetNumByGoodsID(v) > 0 then
				bHasChumo = true
				ChumoGoodsID = v
			end
		end
		if bHasChumo then			
			--WndSystem:GetInstance():ShowWnd(wndid_packet,0);
			WndSystem:GetInstance():ShowWnd(wndid_packet,1);
			g_pGlobal:GetMainUI():SelectPacketItem(ChumoGoodsID)
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您当前没有除魔令，可通过参加副本获得！")
		end
	else
		API_Trace("error activityID")
	end
end