﻿local activityBox_wnd_ID	= 464

local moduleName 		= 'activity_box'
local juanzhouID 		= 24052

local activityBox 		= {}

local activityBox_wnd 	= nil	----窗口

local m_LabelExp		= nil	----经验奖励
local m_BitExp			= nil	----经验奖励的图标
----保存宝箱viewbox
local m_normalVBs 	= {}
----保存点击开启宝箱的按钮
local m_costsBtns 	= {}
local m_normalBtns 	= {}
----保存宝箱的html描述
local m_costsHtml 	= {}
----保存宝箱的价格
local m_costsLabel 	= {}
----宝箱按钮特效
local m_costsEffect = {}
local m_normalEffect = {}
--复择框
local m_chectBox 	= {}
--需要的多少卷轴
local m_juanzhouHtml = nil
--领取经验按钮
local m_getRewardBtn = nil
local m_juanzhouViewBox = nil
--额外奖励道具的名称
local m_reward_extra 	= nil
--奖励标题
local m_reward_extra_title = nil
--翻牌后的背景
local m_card_opened = {}
--购买按钮
local m_rechargeBtn = nil


local multipleExpCfg = {
								{ multiple = 1, juanzhouCount = 0,},
								{ multiple = 2, juanzhouCount = 3, },
								{ multiple = 3, juanzhouCount = 10,},
							}
local costsBoxIndex = 0
local normalBoxIndex = 0
local openNormalBoxFlag = false		----记录是否开了普通宝箱
local getRewardFlog 	= false 	----记录当前是否领取了奖励（经验）
local basicExp 			= 0 		----记录当前发放的基本经验
local currentSelectChectBoxIndex = 1

local RewardDesc 	= ""
local goodsList = {}

----------初始化窗口-----------
function activityBox_wnd_init()

	--注册消息
    api_reg_module_msg_handler(moduleName, activityBox_msg_handler)

	activityBox_wnd 	= core.createWindow('Data/Scp/Windows/Windows_Task.scp', activityBox_wnd_ID)
	
	local normalVBMgr 	= activityBox_wnd:GetViewBoxMgr('普通宝箱')
	local CloseBtn 		= activityBox_wnd:GetButton('关闭按钮')
	CloseBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'activityBox_CloseWnd')
	m_LabelExp			= activityBox_wnd:GetLabel('经验奖励')
	m_BitExp			= activityBox_wnd:GetStaticBitmap('图标')
	
	activityBox_wnd:SetHideEventHandler2(function() WndSystem:GetInstance():OnEvent(985, 985003, 1, 0) end)
	activityBox_wnd:SetShowEventHandler2(function()
		activityBox.UpdateViewBox()
	end)
	
	-----初始化普通宝箱的控件
	for i=1, 4 do
		m_normalVBs[i] 		= normalVBMgr:GetViewBox(i-1)
		m_normalBtns[i]		= activityBox_wnd:GetButton('普通宝箱按钮'..i)
		m_normalEffect[i] 	= activityBox_wnd:GetAni('普通宝箱特效'..i)
		
		m_normalBtns[i]:SetLuaEvent(XWIN_EVENT_CLICK, 'activityBox_OnOpenNormalBox')
	end

	for i=1, 4 do
		m_card_opened[i] 	= activityBox_wnd:GetStaticBitmap('card_opened'..i)
		m_card_opened[i]:SetVisible(false)
	end
	----初始化复选框
	for i=1, 3 do
		m_chectBox[i]				= {}
		m_chectBox[i].checkbox		= activityBox_wnd:GetCheckBox('checkbox'..i)
		m_chectBox[i].multipleCfg 	= multipleExpCfg[i]
		m_chectBox[i].checkbox:SetLuaEvent(XWIN_EVENT_CHECK_CHANGE, "activityBox_OnCheckExpBox")
	end
	----多少卷轴
	m_juanzhouHtml = activityBox_wnd:GetHtml("juanzhou")
	m_juanzhouHtml:ParseContext("需要#(color,%%255,255,0%%)0个#(color,restore)经验卷轴")
	----经验倍数
	m_multipleExpLabel 	= activityBox_wnd:GetLabel("")

	----领取奖励按钮
	m_getRewardBtn 		= activityBox_wnd:GetButton("getRewardBtn")
	m_getRewardBtn:SetLuaEvent(XWIN_EVENT_CLICK, "activityBox_OnGetReward")

	----卷轴viewbox
	local viewboxMgr 		= activityBox_wnd:GetViewBoxMgr("juanzhouViewBoxMgr")
	m_juanzhouViewBox 		= viewboxMgr:GetViewBox(0)

	----额外奖励的物品名称
	m_reward_extra 			= activityBox_wnd:GetLabel("reward_extra")
	m_reward_extra_title 	= activityBox_wnd:GetLabel("reward_extra_title")

	--购买按钮
	m_rechargeBtn 			= activityBox_wnd:GetButton("rechargeBtn")
	m_rechargeBtn:SetLuaEvent2(XWIN_EVENT_CLICK, function()
		g_pGlobal:GetGoodsClient():ShowQuickPaymentShop(juanzhouID, 'juanzhouShopCallBack')
	end)

end

------消息处理
function activityBox_msg_handler(msg)
	if msg.msg_code == 'ShowActivityBoxWnd' then
		activityBox.activityBox_OnShowWnd(msg)
	--elseif msg.msg_code == 'OnShowCostsReward' then
	--	activityBox.OnShowCostsReward(msg)
	elseif msg.msg_code == 'OnShowNormalReward' then
		activityBox.OnShowNormalReward(msg)
	elseif msg.msg_code == 'OnGetRewardSuccess' then
		activityBox.OnGetRewardSuccess(msg)
	end
end

--function activityBox_OnOpenCostsBox(wnd, event)
--	local btn=XButton:CastToButton(wnd)
--	costsBoxIndex = btn:GetTag1()
--
--	local msg = {}
--	msg.module =  moduleName
--	msg.msg_code = 'OpenCostsBox'
--	msg.boxtype = costsBoxIndex
--	local str = cjson.encode(msg)
--	g_pGlobal:SendScriptMsg(str)	
--end

function activityBox_OnOpenNormalBox(wnd, event)
	local btn=XButton:CastToButton(wnd)
	normalBoxIndex = btn:GetTag1() 
	
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'OpenNormalBox'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)	
end

--local function OnShowCostsReward(msg)
	--m_costsBtns[costsBoxIndex]:SetEnabled(false)
	--m_costsEffect[costsBoxIndex]:PlayAni(true)
	--RewardDesc = msg.RewardDesc
	--goodsList = msg.goodsList
	--timer.setTimer('activityBox_Flush_CostsBox', 1, 800)
	--activityBox.SetBtnTransparent(TO_FORCE_TRANSPARENT)
--end

local function OnShowNormalReward(msg)
	local goodsInfo = msg.goodsInfo
	m_normalVBs[normalBoxIndex]:SetItem(goodsInfo[1], msg.goodsNum, false, goodsInfo[2])
	m_normalBtns[normalBoxIndex]:SetVisible(false)
	m_normalEffect[normalBoxIndex]:PlayAni(true)
	timer.setTimer('activityBox_Flush_NormalBox', 1, 800)
	openNormalBoxFlag = true
	activityBox.SetBtnTransparent(TO_FORCE_TRANSPARENT)
end

----显示宝箱界面
local function activityBox_OnShowWnd(msg)
	
	for i=1, 4 do
		m_normalBtns[i]:SetEnabled(true)
		m_normalBtns[i]:SetVisible(true)
		m_normalVBs[i]:ClearItem()
		m_normalVBs[i]:SetVisible(false)
		m_card_opened[i]:SetVisible(false)
	end

	basicExp = msg.expValue
	openNormalBoxFlag = false
	getRewardFlog 	  = false	
	m_LabelExp:setText('')
	m_LabelExp:setText(''..msg.expValue)
	m_LabelExp:SetVisible(true)
	m_BitExp:SetVisible(true)

	-- local goods_cfg = core.getGoodsConfig(msg.extraGoodsID)
	-- if goods_cfg ~= nil then
		-- m_reward_extra_title:SetVisible(true)
		-- m_reward_extra:SetVisible(true)
		-- m_reward_extra:setText(goods_cfg.szName)
	-- else
		-- m_reward_extra_title:SetVisible(false)
		-- m_reward_extra:SetVisible(false)
	-- end
	m_reward_extra:SetVisible(false)

	-----如果开宝箱没经验 则不允许点击经验奖励的宝箱
	if msg.expValue == 0 then
		m_costsBtns[4]:SetEnabled(false)
		m_LabelExp:SetVisible(false)
		m_BitExp:SetVisible(false)
	end
	costsBoxIndex = 0
	normalBoxIndex = 0

	activityBox.UpdateViewBox()	
	activityBox_wnd:SetVisible(true)
end

function activityBox_Flush_NormalBox()
	timer.killTimer('activityBox_Flush_NormalBox',1)
	m_normalEffect[normalBoxIndex]:PlayAni(false)
	m_card_opened[normalBoxIndex]:SetVisible(true)
	m_normalVBs[normalBoxIndex]:SetVisible(true)
	activityBox.SetBtnTransparent(TO_FORCE_NOT_TRANSPARENT)
end

function activityBox_CloseWnd()

	if openNormalBoxFlag == false then
		g_pGlobal:GetMainUI():ShowMessageBox("您有一个普通宝箱没有打开，是否确定关闭？","activityBox_CloseCallBack",1,0,"确定","取消")
		return
	end

	if getRewardFlog == false then
		g_pGlobal:GetMainUI():ShowMessageBox("您还没有领取经验奖励，关闭将默认领取一倍奖励？","activityBox_CloseCallBack",2,0,"确定","取消")
		return
	end

	activityBox_wnd:SetVisible(false)
	-----通知服务器 关闭了宝箱 回调函数
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'OnCloseBox'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

function activityBox_CloseCallBack(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	if wparam == 1 then
		openNormalBoxFlag = true
	elseif wparam == 2 then
		getRewardFlog = true
	end
	activityBox_CloseWnd()
end

function activityBox_OnCheckExpBox(wnd, event)
	for k, v in pairs(m_chectBox) do
		if wnd == v.checkbox then
			--如果是选中
			if v.checkbox:GetState() then
				currentSelectChectBoxIndex = k
				
				--更新显示
				m_LabelExp:setText('')
				m_LabelExp:setText(basicExp.." X "..v.multipleCfg.multiple)
				m_juanzhouHtml:Clear()
				m_juanzhouHtml:ParseContext("需要#(color,%%255,255,0%%)"..v.multipleCfg.juanzhouCount.."个#(color,restore)经验卷轴")
			else
				currentSelectChectBoxIndex = 0
				
				m_LabelExp:setText('')
				m_LabelExp:setText(''..basicExp)
				m_juanzhouHtml:Clear()
				m_juanzhouHtml:ParseContext("需要#(color,%%255,255,0%%)0个#(color,restore)经验卷轴")
			end
		else
			v.checkbox:SetState(false)
		end
	end
end

--更新viewbox
local function UpdateViewBox()
	local juanzhouCount	= core.getHero():GetPacketPart():GetNumByGoodsID(juanzhouID)
	m_juanzhouViewBox:ClearItem()
	m_juanzhouViewBox:SetItem(juanzhouID, juanzhouCount)

	if getRewardFlog == true then return end

	for i=1, 3 do
		m_chectBox[i].checkbox:SetState(false)
	end
	--如果没有经验卷轴 那么就不显示需要卷轴的checkbox
	--local juanzhouCount	= core.getHero():GetPacketPart():GetNumByGoodsID(juanzhouID)
	if juanzhouCount == 0 then
		m_chectBox[2].checkbox:SetEnabled(false)
		m_chectBox[3].checkbox:SetEnabled(false)
	else
		m_chectBox[2].checkbox:SetEnabled(true)
		m_chectBox[3].checkbox:SetEnabled(true)
	end

	if juanzhouCount >= 3 then
		m_chectBox[2].checkbox:SetState(true)
	else
		m_chectBox[1].checkbox:SetState(true)
	end

	for i=1, 3 do
		if m_chectBox[i].checkbox:GetState() == true then
			currentSelectChectBoxIndex = i
			activityBox_OnCheckExpBox(m_chectBox[i].checkbox)
		end
	end

end

function juanzhouShopCallBack()

	activityBox.UpdateViewBox()
end

--领取奖励
function activityBox_OnGetReward(wnd, event)
	if getRewardFlog == true then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, '您已领取过经验奖励。')
		return
	end
	--当前选中了checkbox
	if currentSelectChectBoxIndex ~= 1 and currentSelectChectBoxIndex ~= 0 then
		--判断经验卷轴是否够
		local juanzhouCount	= core.getHero():GetPacketPart():GetNumByGoodsID(juanzhouID)
		if juanzhouCount < m_chectBox[currentSelectChectBoxIndex].multipleCfg.juanzhouCount then
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您的经验卷轴不足。")
			g_pGlobal:GetGoodsClient():ShowQuickPaymentShop(juanzhouID, 'juanzhouShopCallBack')
			return
		end
	end

	--发消息 领取奖励（目前只有经验）
	local msg 			= {}
	msg.module 			=  moduleName
	msg.msg_code 		= 'OnGetReward'
	msg.multipleIndex 	= currentSelectChectBoxIndex
	local str 			= cjson.encode(msg)
	--API_Trace(str)
	g_pGlobal:SendScriptMsg(str)		

end

local function SetBtnTransparent(bFlag)

	for i=1, 4 do
		m_normalBtns[i]:SetTransparentOption(bFlag)
	end
end

local function OnGetRewardSuccess()
	getRewardFlog = true
	if openNormalBoxFlag == true then
		activityBox_CloseWnd()
	else
		activityBox.UpdateViewBox()
	end
end

----------初始化窗口-----------
activityBox_wnd_init()

activityBox.activityBox_OnShowWnd 	= activityBox_OnShowWnd
--activityBox.OnShowCostsReward 		= OnShowCostsReward
activityBox.OnShowNormalReward		= OnShowNormalReward
activityBox.SetBtnTransparent		= SetBtnTransparent
activityBox.UpdateViewBox 			= UpdateViewBox
activityBox.OnGetRewardSuccess 		= OnGetRewardSuccess

------------------------------------------------------------------------------------------------------------------------

local activity_hard_leaving_wnd_ID	= 466

local moduleName_hard 		= 'activity_hard_leaving'

local activity_hard_leaving_wnd = nil

local closeBtn_hard          = nil   --关闭按钮

local leaveBtn_hard          = nil   --离开按钮

local rewardListViewBoxMgr_hard = nil --获得的物品列表

local expLabel_hard          = nil   --获得的经验值

local activityLeaving_hard   = {}

local rewardListViewBox_hard = {}

--初始化窗口------------------------
function activity_hard_leaving_wnd_init()
	--注册消息处理函数
	api_reg_module_msg_handler(moduleName_hard, activity_hard_leaving_msg_handler)
	--创建窗口
	activity_hard_leaving_wnd = core.createWindow('Data/Scp/Windows/Windows_Task.scp', activity_hard_leaving_wnd_ID)
	--获取窗口控件
	--关闭按钮
	closeBtn_hard = activity_hard_leaving_wnd:GetButton('关闭按钮')
	--离开副本按钮
	leaveBtn_hard = activity_hard_leaving_wnd:GetButton('leaveBtn')
	--获得物品的列表
	rewardListViewBoxMgr_hard = activity_hard_leaving_wnd:GetViewBoxMgr('物品列表')
	--获得的经验值
	expLabel_hard = activity_hard_leaving_wnd:GetLabel('经验奖励')

	for i = 1, 16 do
		rewardListViewBox_hard[i] = rewardListViewBoxMgr_hard:GetViewBox(i - 1)
	end

	--窗口事件
	activity_hard_leaving_wnd:SetHideEventHandler2(function() WndSystem:GetInstance():OnEvent(985, 985003, 1, 0) end)
	closeBtn_hard:SetLuaEvent(XWIN_EVENT_CLICK, 'activity_hard_leaving_wnd_close')
	leaveBtn_hard:SetLuaEvent(XWIN_EVENT_CLICK, 'activity_hard_leaving_wnd_leave')
end

--消息处理
function activity_hard_leaving_msg_handler(msg)
	if msg.msg_code == 'ShowActivityHardLeavingWnd' then
		activityLeaving_hard.OnShow(msg)
	end
end

--关闭窗口
function activity_hard_leaving_wnd_close()
	activity_hard_leaving_wnd:SetVisible(false)
end

--离开副本
function activity_hard_leaving_wnd_leave()
	activity_hard_leaving_wnd_close()

	local msg = {}
	msg.module =  moduleName_hard
	msg.msg_code = 'OnCloseBox'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--更新窗口
local function UpdateViewBoxActivityLeavingHard()
	expLabel_hard:setText('')
	for i = 1, 16 do
		rewardListViewBox_hard[i]:ClearItem()
	end
end

--显示窗口
local function OnShowActivityLeavingHard(msg)
	activityLeaving_hard.UpdateViewBox()
	expLabel_hard:setText(''..msg.expValue)
	local nIndex = 1
	for k, v in pairs(msg.pickItemList) do
		rewardListViewBox_hard[nIndex]:SetItem(k, v)
		nIndex = nIndex + 1
	end

	activity_hard_leaving_wnd:SetVisible(true)
end

--初始化窗口
activity_hard_leaving_wnd_init()

activityLeaving_hard.UpdateViewBox = UpdateViewBoxActivityLeavingHard
activityLeaving_hard.OnShow = OnShowActivityLeavingHard

------------------------------------------------------------------------------------------------------------------------
local pet_paradise_moduleName = 'petparadise_reward_wnd'
local pet_paradise_success = 469
local pet_paradise_success_wnd = nil
local pet_paradise_success_closeBtn = nil   --关闭按钮
local pet_paradise_success_leavebtn = nil   --离开按钮
local pet_paradise_success_levelup = nil
local pet_paradise_success_ViewBoxMgr = nil --获得的物品列表
local pet_paradise_success_expLabel = nil   --获得的经验值
local pet_paradise_success_points = nil
local pet_paradise_success_currlevel = nil
local pet_paradise_success_viewboxlist = {}
local pet_paradise_fail = 475
local pet_paradise_fail_wnd = nil
local pet_paradise_fail_closeBtn = nil
local pet_paradise_fail_leavebtn = nil
local pet_paradise_fail_ViewBoxMgr = nil
local pet_paradise_fail_expLabel = nil
local pet_paradise_fail_points = nil
local pet_paradise_fail_currlevel = nil
local pet_paradise_fail_viewboxlist = {}

--初始化窗口------------------------
function PetParadise_RewardWndInit()
	--注册消息处理函数
	api_reg_module_msg_handler(pet_paradise_moduleName, PetParadise_RewardWndMsgHandler)
	--创建窗口
	pet_paradise_success_wnd = core.createWindow('Data/Scp/Windows/Windows_Task.scp', pet_paradise_success)
	--获取窗口控件
	--关闭按钮
	pet_paradise_success_closeBtn = pet_paradise_success_wnd:GetButton('关闭按钮')
	--离开副本按钮
	pet_paradise_success_leavebtn = pet_paradise_success_wnd:GetButton('leaveBtn')
	pet_paradise_success_levelup = pet_paradise_success_wnd:GetButton('activity_level_up')
	--获得物品的列表
	pet_paradise_success_ViewBoxMgr = pet_paradise_success_wnd:GetViewBoxMgr('物品列表')
	--获得的经验值
	pet_paradise_success_expLabel = pet_paradise_success_wnd:GetLabel('累积获得经验')

	pet_paradise_success_points = pet_paradise_success_wnd:GetLabel('累积获得积分')
	pet_paradise_success_currlevel = pet_paradise_success_wnd:GetLabel('当前副本等级')
	for i = 1, 8 do
		pet_paradise_success_viewboxlist[i] = pet_paradise_success_ViewBoxMgr:GetViewBox(i - 1)
	end

	--创建窗口
	pet_paradise_fail_wnd = core.createWindow('Data/Scp/Windows/Windows_Task.scp', pet_paradise_fail)
	--获取窗口控件
	--关闭按钮
	pet_paradise_fail_closeBtn = pet_paradise_fail_wnd:GetButton('关闭按钮')
	--离开副本按钮
	pet_paradise_fail_leavebtn = pet_paradise_fail_wnd:GetButton('leaveBtn')
	--获得物品的列表
	pet_paradise_fail_ViewBoxMgr = pet_paradise_fail_wnd:GetViewBoxMgr('物品列表')
	--获得的经验值
	pet_paradise_fail_expLabel = pet_paradise_fail_wnd:GetLabel('累积获得经验')

	pet_paradise_fail_points = pet_paradise_fail_wnd:GetLabel('累积获得积分')
	pet_paradise_fail_currlevel = pet_paradise_fail_wnd:GetLabel('当前副本等级')
	for i = 1, 8 do
		pet_paradise_fail_viewboxlist[i] = pet_paradise_fail_ViewBoxMgr:GetViewBox(i - 1)
	end
	--窗口事件
	pet_paradise_success_wnd:SetHideEventHandler2(function() WndSystem:GetInstance():OnEvent(985, 985003, 1, 0) end)
	pet_paradise_fail_wnd:SetHideEventHandler2(function() WndSystem:GetInstance():OnEvent(985, 985003, 1, 0) end)
	pet_paradise_success_closeBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadise_SuccedClose')
	pet_paradise_success_leavebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadise_SuccedLeave')
	pet_paradise_fail_closeBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadise_FailClose')
	pet_paradise_fail_leavebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadise_FailLeave')
	pet_paradise_success_levelup:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadise_RewardWndLevelUp')
end

--消息处理
function PetParadise_RewardWndMsgHandler(msg)
	if msg.msg_code == 'ShowPetParadiseSuccessRewardWnd' then
		PetParadise_SuccessRewardWndShow(msg)
	elseif msg.msg_code == 'ShowPetParadiseFailRewardWnd' then
		PetParadise_FailRewardWndShow(msg)
	end
end

--关闭窗口
function PetParadise_SuccedClose()
	PetParadise_RewardWndClose()
end

function PetParadise_FailClose()
	PetParadise_RewardWndClose()
end

function PetParadise_SuccedLeave()
	PetParadise_RewardWndClose()
end

function PetParadise_FailLeave()
	PetParadise_RewardWndClose()
end

function PetParadise_RewardWndClose()
	pet_paradise_success_wnd:SetVisible(false)
	pet_paradise_fail_wnd:SetVisible(false)
	local msg = {}
	msg.module =  pet_paradise_moduleName
	msg.msg_code = 'OnCloseBox'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

function PetParadise_RewardWndLevelUp()
	API_ShowMessageBox("提升副本等级后，怪物难度将会提高，是否确定提升？", "", 0x0080, "PetParadise_ConfirmLevelUp")
end

function PetParadise_ConfirmLevelUp(nMsgID, wParam, lParam)
	if(nMsgID ~= WE_AW_MSGOK) then
		return
	end
	
	pet_paradise_success_wnd:SetVisible(false)
	local msg = {}
	msg.module =  pet_paradise_moduleName
	msg.msg_code = 'OnActivityLevelUp'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--更新窗口
function PetParadise_RewardWndUpdate()
	pet_paradise_success_expLabel:setText('')
	pet_paradise_fail_expLabel:setText('')
	pet_paradise_success_points:setText('')
	pet_paradise_fail_points:setText('')
	pet_paradise_success_currlevel:setText('')
	pet_paradise_fail_currlevel:setText('')
	for i = 1, 8 do
		pet_paradise_success_viewboxlist[i]:ClearItem()
		pet_paradise_fail_viewboxlist[i]:ClearItem()
	end
end

--显示窗口
function PetParadise_SuccessRewardWndShow(msg)
	PetParadise_RewardWndUpdate()
	pet_paradise_success_currlevel:setText(''..msg.petparadiseLevel)
	pet_paradise_success_points:setText(''..msg.acquiredpoints)
	pet_paradise_success_expLabel:setText(''..msg.expValue)
	local nIndex = 1
	for k, v in pairs(msg.pickItemList) do
		pet_paradise_success_viewboxlist[nIndex]:SetItem(k, v)
		nIndex = nIndex + 1
	end
	pet_paradise_success_wnd:SetVisible(true)
end

function PetParadise_FailRewardWndShow(msg)
	PetParadise_RewardWndUpdate()
	pet_paradise_fail_currlevel:setText(''..msg.petparadiseLevel)
	pet_paradise_fail_points:setText(''..msg.acquiredpoints)
	pet_paradise_fail_expLabel:setText(''..msg.expValue)
	local nIndex = 1
	for k, v in pairs(msg.pickItemList) do
		pet_paradise_fail_viewboxlist[nIndex]:SetItem(k, v)
		nIndex = nIndex + 1
	end
	pet_paradise_fail_wnd:SetVisible(true)
end

--初始化窗口
PetParadise_RewardWndInit()