
local m_chumo={}


local yb_goods_id= 21026
local m_cur_ling_index=0 
local m_speed=0
local m_timerNum=0
local m_cur_light_index=0

--网络消息处理
local function chumo_msg_handler(msg)

	if(msg.msg_code=="openui") then
		--m_chumo.openui(msg)
	elseif (msg.msg_code=="change") then
		--m_chumo.on_change(msg)
	elseif (msg.msg_code=="take_task") then
		m_chumo.on_take_task(msg);
	elseif(msg.msg_code=="give_good") then
		m_chumo.on_give_good(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end


--快速购买返回，刷新一下玉版数目
function chumo_quick_pay_call_back()
local yb_count = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(yb_goods_id)
	chumo_wnd:GetLabel('lbl_yb_count'):setText(''..yb_count)
end
--换令
function chumo_btn_change_clicked(wnd,event)
	
	local yb_count = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(yb_goods_id)
	if yb_count < 1 then
		g_pGlobal:GetGoodsClient():ShowQuickPaymentShop(yb_goods_id,'chumo_quick_pay_call_back');
		return 
	end
	
	--api_log('change_click')
	--初始化
	local ling_list = chumo_wnd:GetViewBoxMgr('ling_list')
	for k=1, ling_list:GetSize() do
		local vb = ling_list:GetViewBox(k-1)
		vb:SetShowForeImg(false)
	end

	local msg={module =  "slayerCall",msg_code = "change",
				good_id = chumo_wnd:GetItemViewBox('myling'):GetPropertyInt32('goods_id') }

	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str);
end

local function chumo_init()

	api_reg_module_msg_handler("slayerCall",chumo_msg_handler)
		
	chumo_wnd = core.createWindow('Data/Scp/Windows/Windows_Activity_Chumo.scp',993)
	--关闭按钮
	chumo_wnd:GetButton('close'):SetClickEventHandler2( function ( wnd, event) 	
												--锁定玉版
										core.getHero():GetPacketPart():LockGoods(yb_goods_id,false)
										chumo_wnd:SetVisible(false)
										end)
	--换令按钮
	chumo_wnd:GetButton('change'):SetClickEventHandler('chumo_btn_change_clicked')
	--接任务
	chumo_wnd:GetButton('take_task'):SetClickEventHandler2(function (wnd,event)
						local msg = { module =  "slayerCall",msg_code =  "take_task"}
						local str = cjson.encode(msg)
						g_pGlobal:SendScriptMsg(str)
						end )
	--帮助
	chumo_wnd:GetButton('help'):SetClickEventHandler2( function(wnd,event)
					local help="1.每天可以完成三次除魔令任务。#(br,2)2.除魔令有白（1倍），绿（2倍），蓝（3倍），紫（4倍），橙（5倍）五档，完成不同颜色的令牌任务，所获得的经验不同。#(br,2)3.五个同一档次的除魔令可以通过炼器界面的合成功能提高品质。#(br,2)4.使用玉板，可在领取除魔令任务时，提升当前任务的品质。"
					g_pGlobal:GetMainUI():ShowHelpWnd(995,help,"Data/UI/text1/chumolingtitle.png")
					end)

end

local function openui(msg)
	chumo_wnd:SetVisible(true)
	
	--当前的令牌
	local iv_myling = chumo_wnd:GetItemViewBox('myling')
	iv_myling:SetItem(msg.good_ID, 1)
	--玉版显示
	local yb_count = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(yb_goods_id)
	chumo_wnd:GetLabel('lbl_yb_count'):setText(''..yb_count)
	chumo_wnd:GetItemViewBox('vb_yb'):SetItem(yb_goods_id,1)
	--滚动列表
	local  goods_list = msg.goods_list
	local vb_list = chumo_wnd:GetViewBoxMgr('ling_list')
	local i=0 --记录是那个窗口，有点挫
	local ratio=1
	for k,v in pairs(goods_list) do
		local vbox = vb_list:GetViewBox(i)
		i=i+1
		--vbox:SetBdOffset(3,3)
		vbox:SetAlwaysLight(true)
		vbox:SetItem(v.GoodsID,1)
		--由于上面的SetItem会修改前景图，这里改回去
		vbox:SetForeImage("Data/UI/Activity/faguangquan.png")
		vbox:SetImgForeOffset(-7,-7)
		vbox:SetShowForeImg(false);
		if v.GoodsID == msg.good_ID then
			ratio = i
		end
	end
	
	chumo_wnd:GetLabel('lbl_ratio'):setText('x '..ratio)
	--锁定玉版
	--core.getHero():GetPacketPart():LockGoods(yb_goods_id,true)
	
	--记录当前令牌ID
	iv_myling:SetPropertyInt32('goods_id', msg.good_ID)
	
end

function chumo_light_run()
	m_timerNum = m_timerNum + 10
	--api_log(''..m_timerNum)
	
	if(m_timerNum>=m_speed) then
		
			--跑马灯
				local ling_list =chumo_wnd:GetViewBoxMgr('ling_list')
				local vb = ling_list:GetViewBox(m_cur_light_index)
				vb:SetShowForeImg(false);
				
				m_cur_light_index = m_cur_light_index + 1
				if m_cur_light_index >= ling_list:GetSize() then
					m_cur_light_index = 0
				end 
				
				vb = ling_list:GetViewBox(m_cur_light_index)
				vb:SetShowForeImg(true);
				
				m_speed = m_speed+20;
				m_timerNum = 0;
				---时间到，刷新任务
				if(m_speed >= 200 and m_cur_light_index == m_cur_ling_index-1) then --注意lua和c数组起始不同
					api_log('send give msg')
					timer.killTimer('chumo_light_run',0)
					local msg={module = "slayerCall",msg_code = "give"}
					local str = cjson.encode(msg)
					g_pGlobal:SendScriptMsg(str);
					
					chumo_wnd:GetButton('take_task'):SetEnabled(true);
					chumo_wnd:GetButton('change'):SetEnabled(true);
				end
		end
		
end
local function chumo_on_change(msg)
	api_log('goods_index'..msg.good_index)
	m_cur_ling_index = msg.good_index;	
	
	--准备跑马灯效果
	m_timerNum=0
	m_speed=0
	m_cur_light_index=0
	local ling_list =chumo_wnd:GetViewBoxMgr('ling_list')
	local vb = ling_list:GetViewBox(m_cur_light_index)
	vb:SetShowForeImg(true);
	
	timer.setTimer('chumo_light_run',0,20);
	--玉版显示
	local yb_count = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(yb_goods_id)
	chumo_wnd:GetLabel('lbl_yb_count'):setText(''..yb_count)
	chumo_wnd:GetButton('change'):SetEnabled(false)
	chumo_wnd:GetButton('take_task'):SetEnabled(false)
	chumo_wnd:GetItemViewBox('myling'):SetPropertyInt32('goods_id', msg.good_ID)
	
end
---令牌已经更换，任务已经刷新
local function chumo_on_give_goods(msg)

	chumo_wnd:GetButton('change'):SetEnabled(true)
	chumo_wnd:GetButton('take_task'):SetEnabled(true)
	chumo_wnd:GetItemViewBox('myling'):SetItem(msg.good_ID,1)
	chumo_wnd:GetLabel('lbl_ratio'):setText('x '..m_cur_ling_index)	
	
	
end
local function chumo_on_take_task(msg)
	--锁定玉版
	core.getHero():GetPacketPart():LockGoods(yb_goods_id,false)
	chumo_wnd:SetVisible(false)
end

m_chumo.openui=openui
m_chumo.on_change = chumo_on_change
m_chumo.on_take_task = chumo_on_take_task
m_chumo.on_give_good = chumo_on_give_goods

chumo_init()

