--消息回调函数
local m_clanList = {}

local clanListBox
local clanTenet
local applyClan
local btnClose
local btnCreate

local label_clanname		--公会名字
local label_clanMemberCount --公会人数
local label_chairman 		--会长名字
local label_vicechairman 	--副会长
local label_createman 		--创始人
local label_vitality 		--活跃度
local clanListCurrentPage = 1
local CreateClanCost = 1000000 --100金


local listDataCache = {}

--模块初始化
function clanListInit(  )
	
	clanList_wnd = core.createWindow('Data/Scp/Windows/Windows_ClanMember.scp', 1041)
	clanListBox = clanList_wnd:GetListBox("clan_list")	
	clanListBox:SetColCount(6);
	clanListBox:SetColFormat(0,67);
	clanListBox:SetColAlign(0, 1);
	clanListBox:SetColFormat(1,129);
	clanListBox:SetColAlign(1, 1);
	clanListBox:SetColFormat(2,49);
	clanListBox:SetColAlign(2, 1);
	clanListBox:SetColFormat(3,85);
	clanListBox:SetColAlign(3, 1);
	clanListBox:SetColFormat(4,85);
	clanListBox:SetColAlign(4, 1);
	clanListBox:SetColFormat(5,75);
	clanListBox:SetColAlign(5, 1);
	clanListBox:SetLineHeight(32)
	clanListBox:SetSelEventHandler2(updateClanListInfo);
	clanListBox:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, "OnMouseDownClanListbox")
	clanListBox:SetLuaEvent(XWIN_EVENT_MOUSEUP, "OnMouseUpClanListbox")
	clanTenet = clanList_wnd:GetHtml("clan_list_tenet")
	--申请按钮
	applyClan = clanList_wnd:GetButton("clan_list_btn_apply")
	applyClan:SetLuaEvent(XWIN_EVENT_CLICK, 'OnApplyClan')
	--创建按钮
	btnCreate = clanList_wnd:GetButton("clan_list_btn_create")
	btnCreate:SetLuaEvent(XWIN_EVENT_CLICK, 'OnClanCreate')
	--关闭按钮
	btnClose = clanList_wnd:GetButton("clan_list_btn_close")
	btnClose:SetLuaEvent(XWIN_EVENT_CLICK, 'OnCloseClanList')
	--页码
	label_listpage = clanList_wnd:GetLabel("clan_list_page")
	--右边信息展示
	label_clanname 			= clanList_wnd:GetLabel("clan_list_clanname")
	label_clanMemberCount 	= clanList_wnd:GetLabel("clan_list_member_count")
	label_chairman 			= clanList_wnd:GetLabel("clan_list_chairman")
	label_vicechairman 		= clanList_wnd:GetLabel("clan_list_vicechairman")
	label_vicechairman2 	= clanList_wnd:GetLabel("clan_list_vicechairman2")
	label_createman 		= clanList_wnd:GetLabel("clan_list_createman")
	label_activityValue 	= clanList_wnd:GetLabel("clan_list_vitality")

	clanList_wnd:SetLuaEvent(XWIN_EVENT_SHOW, 'clanListShow')

	clanList_wnd:SetVisible(false)
end



local xPointPre = XPoint:new()
--鼠标按下操作
function OnMouseDownClanListbox(wnd, event)
	xPointPre = XDesktop:GetInstance():GetMouseXY()
end
--鼠标弹起事件
function OnMouseUpClanListbox(wnd, event)

	local xPointNow = XDesktop:GetInstance():GetMouseXY()
	
	if xPointNow.x - xPointPre.x > 100 then
		if wnd == clanListBox then
			clanListPage(-1)
		end
	elseif  xPointNow.x - xPointPre.x < -100 then
		if wnd == clanListBox then
			clanListPage(1)
		end		
	end
end

function OnClanCreate()
	local hero 			= core.getHero()
	if hero == nil then	return	end

	local clanID 	= hero:GetCrtProp(enProp_ClanID)
	if clanID ~= nil and clanID ~= 0 then
		g_pGlobal:GetMainUI():ShowMessageBox("对不起！你已经存在公会关系，请解除公会关系后再来创建！","",0,0,"确定");
		return
	end
	if hero:GetCrtProp(enProp_Level) < 30 then
		g_pGlobal:GetMainUI():ShowMessageBox("对不起！你的等级未达到30级，暂时无法创建公会！","",0,0,"确定");
		return
	end

	g_pGlobal:GetMainUI():ShowMessageBox("创建公会需要消耗游戏币#(money,"..CreateClanCost..")，是否确定？","OnClanCreateCallBack",0,0,"确定","取消");
end

--创建公会按钮
function OnClanCreateCallBack(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end

	local hero 			= core.getHero()
	if hero == nil then	return	end	
	if hero:GetCrtProp(enProp_Actor_M_Silver) < CreateClanCost then
		g_pGlobal:GetMainUI():ShowMessageBox("对不起！你身上游戏币不足#(money,"..CreateClanCost..")","",0,0,"确定");
		return
	end

	--API_Trace("show 1021")
	if WndSystem:GetInstance():IsWindowVisible(1042) == true then
		--先隐藏下 然后再显示 以保持置顶状态
		WndSystem:GetInstance():ShowWnd(1042,0)
		WndSystem:GetInstance():ShowWnd(1042,1)
	else
		WndSystem:GetInstance():ShowWnd(1042,1)
	end
end

--窗口显示时的回调函数
function clanListShow(wnd, event)
	updateClanListUI()
end

local function GetClanInfoByClanID(clanID)
	if clanID == nil  then  return {} end
	for k, v in pairs(listDataCache) do
		if v.clanID == clanID then
			return v
		end
	end
	return {}
end

--数据返回时刷新左边的公会列表
function updateClanList(msg)
	listDataCache = msg.list
	--清空
	clanListBox:RemoveAll()
	label_clanname:setText("")
	label_clanMemberCount:setText("")
	label_chairman:setText("")
	label_vicechairman:setText("")
	label_createman:setText("")
	label_activityValue:setText("")
	clanTenet:Clear()
	
	if next(listDataCache) == nil then
		return
	end
	clanListCurrentPage = msg.page
	local pageCount = msg.pageCount
	label_listpage:setText(clanListCurrentPage.."/"..pageCount)

	local i = 0
	for k, v in pairs(listDataCache) do		
		local nCol = 0;
		clanListBox:AddItem(0, v.clanID)
		clanListBox:SetItem(i, nCol, v.rankNum)--排名 暂未实现
		nCol = nCol + 1
		clanListBox:SetItem(i, nCol, v.clanName)--名称
		nCol = nCol + 1
		clanListBox:SetItem(i, nCol, v.level)--等级
		nCol = nCol + 1
		clanListBox:SetItem(i, nCol, v.prosperity)--繁荣度
		nCol = nCol + 1
		clanListBox:SetItem(i, nCol, v.activityValue)--活跃度
		nCol = nCol + 1
		clanListBox:SetItem(i, nCol, v.memberSize.."/"..v.actorUpperLimit)
		i = i + 1
	end
	clanListBox:SetCurSel(0)
end
--刷新右边的详细信息
function updateClanListInfo( wnd, event )

	local sel 	= clanListBox:GetCurSel()
	local index = clanListBox:GetItemData(sel)
	--刷新右侧界面
	local data = GetClanInfoByClanID(tostring(index))
	if data == nil or next(data) == nil then return end
	label_clanname:setText(data.clanName)
	label_clanMemberCount:setText(data.memberSize.."/"..data.actorUpperLimit)
	label_chairman:setText(data.chairman[1].actorName)
	label_createman:setText(data.createman.actorName)
	if data.viceChairman ~= nil and data.viceChairman[1] ~= nil then
		label_vicechairman:setText(data.viceChairman[1].actorName)	
	else
		label_vicechairman:setText("")	
	end
	
	if data.viceChairman ~= nil and data.viceChairman[2] ~= nil then
		label_vicechairman2:setText(data.viceChairman[2].actorName)	
	else
		label_vicechairman2:setText("")	
	end

	--API_Trace(data.activityValue)
	label_activityValue:setText(data.activityValue)
	clanTenet:Clear()
	clanTenet:ParseContext("#(color,%%0,255,255%%)"..data.clanTenet.."#(color,restore)")
end
--请求数据
function updateClanListUI()
	--请求公会列表数据
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code 	= 'getClanData'
	msg.page		= 1
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--申请公会
function OnApplyClan( )
	local sel 		= clanListBox:GetCurSel() 
	local clanID 	= clanListBox:GetItemData(sel)
	if clanID == nil or clanID == 0 then
		return
	end
	local hero 		= core.getHero()
	if hero == nil then return end
	local actorClanID = hero:GetCrtProp(enProp_ClanID) 
	if actorClanID ~= nil and actorClanID ~= 0 then
		g_pGlobal:GetMainUI():ShowMessageBox("对不起！你已经存在公会关系，请解除公会关系后再来申请！","",0,0,"确定");
		return
	end
	if hero:GetCrtProp(enProp_Level) < 20 then
		g_pGlobal:GetMainUI():ShowMessageBox("对不起！你的等级未达到20级，暂时无法加入公会！","",0,0,"确定");
		return
	end
	--发送申请消息
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='applyToJoinClan'
	msg.clanID		= clanID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end
--翻页
-- -1上一页 +1下一页
function clanListPage(page)
	--
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code 	= 'getClanData'
	msg.page		= clanListCurrentPage + page
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end


function OnCloseClanList(msg)
	--API_Trace("OnCloseClanList")
	clanList_wnd:SetVisible(false)
	--关闭社交界面的窗口
	local pWndRelation = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(360)
	pWndRelation:SetVisible(false)
	local createClanWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1042)
	if createClanWnd:IsVisible() == true then
		createClanWnd:SetVisible(false)
	end

	if msg ~= nil and msg.bIsClear == true then
		API_Trace("ClearClanClientData")
		ClearClanClientData()
	end
end

clanListInit( )

m_clanList.updateClanList = updateClanList