
local clanTenet
local btnCreate
local btnCancel

local createClanWnd

local clanID

local CreateClanCost = 1000000 --100金

function CreateClanInit()
	
	createClanWnd = core.createWindow('Data/Scp/Windows/Windows_ClanMember.scp', 1042)
	createClanWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'clanWndOnshow')
	
	btnCreate = createClanWnd:GetButton("create_clan_btn_create")
	btnCreate:SetLuaEvent(XWIN_EVENT_CLICK, 'OnCreateClan')

	btnCancel = createClanWnd:GetButton("create_clan_btn_cancel")
	btnCancel:SetLuaEvent(XWIN_EVENT_CLICK, 'OnCreateClanCancel')

	btnClose = createClanWnd:GetButton("create_clan_btn_close")
	btnClose:SetLuaEvent(XWIN_EVENT_CLICK, 'OnCreateClanCancel')

	editClanName = createClanWnd:GetEdit("create_clan_name")
	editClanTenet = createClanWnd:GetEdit("create_clan_tenet")


	createClanWnd:SetVisible(false)
end

function OnCreateClan(msg)
	local clanName = editClanName:getText()
	clanName = trim1(clanName)
	local clanTenet = editClanTenet:getText()
	clanTenet = trim1(clanTenet)
	local hero 			= core.getHero()
	if hero == nil then	return	end
	

	local KeywordFilter = g_pGlobal:GetKeywordFilter()
	
	if clanName == "" then
		g_pGlobal:GetMainUI():ShowMessageBox("请输入公会名称","",0,0,"确定");
		editClanName:setText("")
		return
	end
	if KeywordFilter:IsLegalString(clanName) == false then
		g_pGlobal:GetMainUI():ShowMessageBox("公会名称包含非法字符，请修改后重试！","",0,0,"确定");
		return
	end
	if clanTenet == "" then
		g_pGlobal:GetMainUI():ShowMessageBox("请输入公会宗旨","",0,0,"确定");
		editClanTenet:setText("")
		return
	end
	if KeywordFilter:IsLegalString(clanTenet) == false then
		g_pGlobal:GetMainUI():ShowMessageBox("公会宗旨包含非法字符，请修改后重试！","",0,0,"确定");
		return
	end

	--发送请求clanid
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code 	= 'getClanID'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--显示的时候调用
function clanWndOnshow(wnd, event)
	--清空输入框的内容
	editClanName:setText("")
	editClanTenet:setText("")
end


function CreateClanByClanID(msg)

	local clanID = msg.clanID
	
	if clanID == nil or clanID == 0 then 
		g_pGlobal:GetMainUI():ShowMessageBox("创建失败。","",0,0,"确定");
		return 
	end
	local clanName = editClanName:getText()
	local clanTenet = editClanTenet:getText()
	--API_Trace(tostring(clanName)..tostring(clanTenet))
	--发送请求创建公会
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code 	= 'createClan'
	msg.clanName	= clanName
	msg.clanTenet	= clanTenet
	msg.clanID 		= clanID
	local str = cjson.encode(msg)
	--API_Trace(str)
	g_pGlobal:SendScriptMsg(str)
end

local function createClanInitUI()
	editClanName:setText("")
	editClanTenet:setText("")
end

function createClanSuccess( msg )
	WndSystem:GetInstance():ShowWnd(1042,0)
	WndSystem:GetInstance():ShowWnd(1041,0)
	createClanInitUI()
	updateClanMemberListUI()
end

function OnCreateClanCancel()
	createClanWnd:SetVisible(false)
end

function trim1(s)
  return (s:gsub("^%s*(.-)%s*$", "%1"))
end

CreateClanInit()