---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\gift_extend.lua
--版  权:	(C)盛游
--创建人:	林洪伟
--日  期:	2013.8.21
--版  本:	1.0
--描  述:	礼包相关扩展。新手礼包窗口和在线礼包窗口
----------------------------------------------------------------------------------------------------------------------

-----------------------新手礼包窗口-------------------------------------------------------
NewHandGiftWnd = {}
NewHandGiftWnd.thiswnd = nil --自己

local new_hand_gift_cfg = {}
--10级礼包--打开可获得降魔•蓝×5、蓬莱仙酿•蓝×5、经验卷轴×6、传送符×10。
new_hand_gift_cfg[#new_hand_gift_cfg + 1] ={
	goodsId = 29001, name = "10级礼包" ,desc ="#(image,Data/UI/flow_num/golden2/001.png)#(image,Data/UI/flow_num/golden2/000.png)#(image,Data/UI/text1/jilingqu.png)",
	gift_content =
	{
		{occop = enActorOccupation_Assassin,goodsID = 			{29002,1,-1,21003,5,-1,21033,5,-1,24052,6,-1,24053,10,-1,},},--刺客 物品ID,数量,默认品质，-1为与物品脚本一致。
		{occop = enActorOccupation_SwordKnightErrant,goodsID =  {29002,1,-1,21003,5,-1,21033,5,-1,24052,6,-1,24053,10,-1,},},--剑侠
		{occop = enActorOccupation_Paladin,goodsID = 			{29002,1,-1,21003,5,-1,21033,5,-1,24052,6,-1,24053,10,-1,},},--游侠
		{occop = enActorOccupation_Tao,goodsID = 				{29002,1,-1,21003,5,-1,21033,5,-1,24052,6,-1,24053,10,-1,},},--琴师
	}
}
--20级礼包--打开可获得降魔•蓝×10、蓬莱仙酿•蓝×10、经验卷轴×6、洗髓丹×1、传送符×20。
new_hand_gift_cfg[#new_hand_gift_cfg + 1]={
	goodsId = 29002, name = "20级礼包" ,desc ="#(image,Data/UI/flow_num/golden2/002.png)#(image,Data/UI/flow_num/golden2/000.png)#(image,Data/UI/text1/jilingqu.png)",
	gift_content =
	{
		{occop = enActorOccupation_Assassin,goodsID = 			{29003,1,-1,21003,10,-1,21033,10,-1,24052,6,-1,24054,1,-1,24053,20,-1,},},--刺客
		{occop = enActorOccupation_SwordKnightErrant,goodsID =  {29003,1,-1,21003,10,-1,21033,10,-1,24052,6,-1,24054,1,-1,24053,20,-1,},},--剑侠
		{occop = enActorOccupation_Paladin,goodsID = 			{29003,1,-1,21003,10,-1,21033,10,-1,24052,6,-1,24054,1,-1,24053,20,-1,},},--游侠
		{occop = enActorOccupation_Tao,goodsID = 				{29003,1,-1,21003,10,-1,21033,10,-1,24052,6,-1,24054,1,-1,24053,20,-1,},},--琴师
	}
}
--30级礼包--打开可获得降魔•蓝×15、蓬莱仙酿•蓝×15、经验卷轴×6、强化石×8、洗髓丹×2、筑基丹×5、传送符×30。
new_hand_gift_cfg[#new_hand_gift_cfg + 1]={
	goodsId = 29003, name = "30级礼包" ,desc ="#(image,Data/UI/flow_num/golden2/003.png)#(image,Data/UI/flow_num/golden2/000.png)#(image,Data/UI/text1/jilingqu.png)",
	gift_content =
	{
		{occop = enActorOccupation_Assassin,goodsID = 			{29004,1,-1,21003,15,-1,21033,15,-1,24052,6,-1,24006,8,-1,24054,2,-1,25100,5,-1,24053,30,-1,},},--刺客
		{occop = enActorOccupation_SwordKnightErrant,goodsID =  {29004,1,-1,21003,15,-1,21033,15,-1,24052,6,-1,24006,8,-1,24054,2,-1,25100,5,-1,24053,30,-1,},},--剑侠
		{occop = enActorOccupation_Paladin,goodsID = 			{29004,1,-1,21003,15,-1,21033,15,-1,24052,6,-1,24006,8,-1,24054,2,-1,25100,5,-1,24053,30,-1,},},--游侠
		{occop = enActorOccupation_Tao,goodsID = 				{29004,1,-1,21003,15,-1,21033,15,-1,24052,6,-1,24006,8,-1,24054,2,-1,25100,5,-1,24053,30,-1,},},--琴师
	}
}
--40级礼包--打开可获得降魔•蓝×20、蓬莱仙酿•蓝×20、经验卷轴×12、极效强化石×12、洗髓丹×3、筑基丹×10、200绑定元宝、荣誉值8000点、传送符×50。
new_hand_gift_cfg[#new_hand_gift_cfg + 1] ={
	goodsId = 29004, name = "40级礼包" ,desc ="#(image,Data/UI/flow_num/golden2/004.png)#(image,Data/UI/flow_num/golden2/000.png)#(image,Data/UI/text1/jilingqu.png)",
	gift_content =
	{
		{occop = enActorOccupation_Assassin,goodsID = 			{29005,1,-1,21003,20,-1,21033,20,-1,24052,12,-1,24007,12,-1,24054,3,-1,25100,10,-1,20044,200,-1,20045,8000,-1,24053,50,-1,},},--刺客
		{occop = enActorOccupation_SwordKnightErrant,goodsID =  {29005,1,-1,21003,20,-1,21033,20,-1,24052,12,-1,24007,12,-1,24054,3,-1,25100,10,-1,20044,200,-1,20045,8000,-1,24053,50,-1,},},--剑侠
		{occop = enActorOccupation_Paladin,goodsID = 			{29005,1,-1,21003,20,-1,21033,20,-1,24052,12,-1,24007,12,-1,24054,3,-1,25100,10,-1,20044,200,-1,20045,8000,-1,24053,50,-1,},},--游侠
		{occop = enActorOccupation_Tao,goodsID = 				{29005,1,-1,21003,20,-1,21033,20,-1,24052,12,-1,24007,12,-1,24054,3,-1,25100,10,-1,20044,200,-1,20045,8000,-1,24053,50,-1,},},--琴师
	}
}
--50级礼包--打开可获得降魔•蓝×25、蓬莱仙酿•蓝×25、经验卷轴×18、极效强化石×18、洗髓丹×4、筑基丹×15、500绑定元宝、荣誉值18000点、传送符×99。
new_hand_gift_cfg[#new_hand_gift_cfg + 1] ={
	goodsId = 29005, name = "50级礼包" ,desc ="#(image,Data/UI/flow_num/golden2/005.png)#(image,Data/UI/flow_num/golden2/000.png)#(image,Data/UI/text1/jilingqu.png)",
	gift_content =
	{
		{occop = enActorOccupation_Assassin,goodsID = 			{29006,1,-1,21003,25,-1,21033,25,-1,24052,18,-1,24007,18,-1,24054,4,-1,25100,15,-1,20044,500,-1,20045,18000,-1,24053,99,-1,},},--刺客
		{occop = enActorOccupation_SwordKnightErrant,goodsID =  {29006,1,-1,21003,25,-1,21033,25,-1,24052,18,-1,24007,18,-1,24054,4,-1,25100,15,-1,20044,500,-1,20045,18000,-1,24053,99,-1,},},--剑侠
		{occop = enActorOccupation_Paladin,goodsID = 			{29006,1,-1,21003,25,-1,21033,25,-1,24052,18,-1,24007,18,-1,24054,4,-1,25100,15,-1,20044,500,-1,20045,18000,-1,24053,99,-1,},},--游侠
		{occop = enActorOccupation_Tao,goodsID = 				{29006,1,-1,21003,25,-1,21033,25,-1,24052,18,-1,24007,18,-1,24054,4,-1,25100,15,-1,20044,500,-1,20045,18000,-1,24053,99,-1,},},--琴师
	}
}
--60级礼包--打开可获得降魔•蓝×30、蓬莱仙酿•蓝×30、经验卷轴×27、神品强化石×30、洗髓丹×6、筑基丹×20、1000绑定元宝、荣誉值28000点、传送符×198。
new_hand_gift_cfg[#new_hand_gift_cfg + 1] ={
	goodsId = 29006, name = "60级礼包" ,desc ="#(image,Data/UI/flow_num/golden2/006.png)#(image,Data/UI/flow_num/golden2/000.png)#(image,Data/UI/text1/jilingqu.png)",
	gift_content =
	{
		{occop = enActorOccupation_Assassin,goodsID = 			{21003,30,-1,21033,30,-1,24052,27,-1,24008,30,-1,24054,6,-1,25100,20,-1,20044,1000,-1,20045,28000,-1,24053,198,-1,},},--刺客
		{occop = enActorOccupation_SwordKnightErrant,goodsID =  {21003,30,-1,21033,30,-1,24052,27,-1,24008,30,-1,24054,6,-1,25100,20,-1,20044,1000,-1,20045,28000,-1,24053,198,-1,},},--剑侠
		{occop = enActorOccupation_Paladin,goodsID = 			{21003,30,-1,21033,30,-1,24052,27,-1,24008,30,-1,24054,6,-1,25100,20,-1,20044,1000,-1,20045,28000,-1,24053,198,-1,},},--游侠
		{occop = enActorOccupation_Tao,goodsID = 				{21003,30,-1,21033,30,-1,24052,27,-1,24008,30,-1,24054,6,-1,25100,20,-1,20044,1000,-1,20045,28000,-1,24053,198,-1,},},--琴师
	}
}

local function new_hand_gift_wnd_init()
	--判断下如果已经初始化过就不用初始化了
	if NewHandGiftWnd.thiswnd ~= nil then
		return
	end

	--创建各个窗口并初始化
	NewHandGiftWnd.thiswnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',491)
	NewHandGiftWnd.bk = NewHandGiftWnd.thiswnd:GetLabel('背景')--erect = 0,0,800,480
	NewHandGiftWnd.bk1 = NewHandGiftWnd.thiswnd:getWindow('背景1')--erect = 231,2,423,473
	NewHandGiftWnd.bk2 = NewHandGiftWnd.thiswnd:getWindow('背景2')--erect = 231,2,423,473
	NewHandGiftWnd.bk3 = NewHandGiftWnd.thiswnd:getWindow('背景3')--erect = 15,71,312,457
	NewHandGiftWnd.bk4 = NewHandGiftWnd.thiswnd:getWindow('价值背景2')--erect = 345,167,101,20
	NewHandGiftWnd.bk5 = NewHandGiftWnd.thiswnd:getWindow('价值背景')--erect = 346,162,170,24
	NewHandGiftWnd.html_jiazhi = NewHandGiftWnd.thiswnd:GetHtml('价值')--erect = 413,159,100,30
	NewHandGiftWnd.html_miaoshu = NewHandGiftWnd.thiswnd:GetHtml('描述')--erect = 291,222,200,30
	NewHandGiftWnd.html_wupinglan = NewHandGiftWnd.thiswnd:GetViewBoxMgr('物品栏')--erect = 292,248,380,120
	NewHandGiftWnd.btn_close = NewHandGiftWnd.thiswnd:GetButton('关闭按钮') --erect = 572,70,63,63
	NewHandGiftWnd.btn_get = NewHandGiftWnd.thiswnd:GetButton('领取奖励按钮') --erect = 342,410,200,33
	
	
	--设置显示时的调用
	NewHandGiftWnd.thiswnd:SetLuaEvent(XWIN_EVENT_SHOW,'new_hand_gift_wnd_onshow')

	--关闭按钮
	
	NewHandGiftWnd.btn_close:SetClickEventHandler('new_hand_gift_wnd_btn_close')

	--领取按钮
	NewHandGiftWnd.btn_get:SetClickEventHandler('new_hand_gift_wnd_btn_get')

	--背包双击物品监听
	api_reg_packet_listen(new_hand_gift_wnd_packet_listen)
	
	--背包获得下一阶段的新手礼包的时候弹出窗口
	api_reg_packet_add_listen(function (CGoods)
					local goodsId  = CGoods:GetGoodsID()
					local curGoodsId =NewHandGiftWnd.get_cur_new_hand_gift_from_pack()
					if goodsId == curGoodsId and goodsId ~= 29001 then
						--NewHandGiftWnd.thiswnd:SetVisible(false)
						NewHandGiftWnd.update_ui()
						NewHandGiftWnd.thiswnd:SetVisible(true)
					end
					
				end )
end

function new_hand_gift_wnd_onshow()
	NewHandGiftWnd.update_ui()
end

function new_hand_gift_wnd_btn_close()
	NewHandGiftWnd.thiswnd:SetVisible(false)
end

function new_hand_gift_wnd_btn_get()
	local hero 		= core.getHero()
	if hero == nil then return end

	local targetId = 0
	for i =#new_hand_gift_cfg,1,-1 do
		local uidGift =  core.getHero():GetPacketPart():FindGoods(new_hand_gift_cfg[i].goodsId)
		if uidGift ~= nil and uidGift ~= 0 and uidGift:ToString() ~= '0' then
			g_pGlobal:GetGoodsClient():UseGoods(uidGift,core.getHeroUID(),XPoint:new())
			targetId = new_hand_gift_cfg[i].goodsId
		end
	end
	if 29007 == targetId or 29006 == targetId then
		NewHandGiftWnd.thiswnd:SetVisible(false)
	end
end

--玩家双击了背包的物品
function new_hand_gift_wnd_packet_listen(uid)
	--获取下goodsid
	local pCGoods = core.getHero():GetPacketPart():GetContainerGoods2(uid)
	if pCGoods ==  nil then
		return false
	end
	if pCGoods:IsLock() == true then
		return false
	end
	local goodsId  = pCGoods:GetGoodsID()

	--判断双击的是不是新手礼包
	if goodsId ~= 0 and goodsId == NewHandGiftWnd.get_cur_new_hand_gift_from_pack() then
		NewHandGiftWnd.thiswnd:SetVisible(true)
		return true
	else
		return false
	end
end

--在背包里找下玩家当前持有哪个新手礼包
local function get_cur_new_hand_gift_from_pack()
	if core.getHero() == nil then
		return 0
	end

	for  i =#new_hand_gift_cfg,1,-1 do
		local uidGift =  core.getHero():GetPacketPart():FindGoods(new_hand_gift_cfg[i].goodsId)
		if uidGift ~= nil and uidGift ~= 0 and uidGift:ToString() ~= '0' then
			return new_hand_gift_cfg[i].goodsId
		end
	end
	return 0
end

local function update_ui()
	--调整下位置先
	local desktop = WndSystem:GetInstance():GetGameDesktop()
	local deskRect = desktop:GetWindowXRect()
	NewHandGiftWnd.thiswnd:SetWindowRect(deskRect)
	NewHandGiftWnd.bk:SetWindowRect(deskRect)
	XWinUtil:AlignWindow(desktop, NewHandGiftWnd.thiswnd, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 0, 0, false)
	XWinUtil:AlignWindow(NewHandGiftWnd.thiswnd, NewHandGiftWnd.bk, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 0, 0, false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk, NewHandGiftWnd.bk1, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0,0,  0, false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.bk2, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 328-231,0, 66-2,  0, false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.bk3, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 15-231,0, 71-2,  0, false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.bk4, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 345-231,0, 167-2,  0,false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.bk5, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 346-231,0, 162-2,  0,false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.html_jiazhi, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 413-231,0, 159-2,  0,false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.html_miaoshu, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 291-231,0, 222-2,  0, false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.html_wupinglan, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 292-231,0, 248-2,  0,false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.btn_close, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 572-231,0, 70-2,  0,false)
	XWinUtil:AlignWindow(NewHandGiftWnd.bk1, NewHandGiftWnd.btn_get, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 342-231,0, 410-2,  0,false)	
	
	
	--清空先
	local desc_html = NewHandGiftWnd.thiswnd:GetHtml('描述')
	desc_html:Clear()

	local vbmgr = NewHandGiftWnd.thiswnd:GetViewBoxMgr('物品栏')
	for i=1, vbmgr:GetSize() do
		local vb = vbmgr:GetViewBox(i-1)
		vb:ClearItem()
	end

	--获取当前背包中的新手礼包id
	local cur_new_hand_goodsid = NewHandGiftWnd.get_cur_new_hand_gift_from_pack()
	if cur_new_hand_goodsid == 0 then
		NewHandGiftWnd.thiswnd:SetVisible(false)
		return
	end

	--获取玩家职业
	local hero 		= core.getHero()
	if hero == nil then return end
	local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local level = hero:GetCrtProp(enProp_Level)

	for i =1,#new_hand_gift_cfg do
		if cur_new_hand_goodsid == new_hand_gift_cfg[i].goodsId then
			--描述
			desc_html:ParseContext(new_hand_gift_cfg[i].desc)

			--找到对应职业的奖励内容
			local goodsID = nil
			for k,v in pairs(new_hand_gift_cfg[i].gift_content) do
				if v.occop  == cur_occ then
					goodsID = v.goodsID
				end
			end
			if goodsID== nil then
				break
			end

			--viewbox
			for i=1, vbmgr:GetSize() do
				local vb = vbmgr:GetViewBox(i-1)
				if #goodsID < i*3 then
					break
				end
				if goodsID[3*i] == -1 then
					vb:SetItem(goodsID[3*i-2],goodsID[3*i-1])
				else
					vb:SetItem(goodsID[3*i-2],goodsID[3*i-1],false,goodsID[3*i])
				end

			end

			--按钮状态
			local goods_cfg = core.getGoodsConfig(cur_new_hand_goodsid)
			if goods_cfg == nil or level < goods_cfg.lNeedLevel then
				NewHandGiftWnd.thiswnd:GetButton('领取奖励按钮'):SetEnabled(false)
			else
				NewHandGiftWnd.thiswnd:GetButton('领取奖励按钮'):SetEnabled(true)
			end
			break
		end
	end
end


-------读脚本时就执行
new_hand_gift_wnd_init()

NewHandGiftWnd.update_ui = update_ui
NewHandGiftWnd.get_cur_new_hand_gift_from_pack = get_cur_new_hand_gift_from_pack

-----------------------新手礼包窗口 结束-------------------------------------------------------

-----------------------在线礼包窗口-------------------------------------------------------
DailyOnlineGiftWnd = {}
DailyOnlineGiftWnd.thiswnd = nil --自己

local function daily_online_wnd_init()
	--判断下如果已经初始化过就不用初始化了
	if DailyOnlineGiftWnd.thiswnd ~= nil then
		return
	end

	--创建各个窗口并初始化
	DailyOnlineGiftWnd.thiswnd = core.createWindow('Data/Scp/Windows/Windows_ActivityGift.scp',817)

	--设置显示时的调用
	DailyOnlineGiftWnd.thiswnd:SetLuaEvent(XWIN_EVENT_SHOW,'daily_online_wnd_onshow')

	--关闭按钮
	local btn_close = DailyOnlineGiftWnd.thiswnd:GetButton('关闭按钮')
	btn_close:SetClickEventHandler('daily_online_wnd_btn_close')

	--领取按钮
	local btn_get = DailyOnlineGiftWnd.thiswnd:GetButton('领取奖励按钮')
	btn_get:SetClickEventHandler('daily_online_wnd_btn_get')
end


function daily_online_wnd_onshow()

end

function daily_online_wnd_btn_close()
	DailyOnlineGiftWnd.thiswnd:SetVisible(false)
end

function daily_online_wnd_btn_get()
	g_pGlobal:GetActivityClient():GetDailyOLGift()
	DailyOnlineGiftWnd.thiswnd:SetVisible(false)
end

function daily_online_wnd_update_ui(jsonParam)
	if DailyOnlineGiftWnd.thiswnd:IsVisible() == false then
		return
	end

	--清空先
	local desc_html = DailyOnlineGiftWnd.thiswnd:GetHtml('描述')
	desc_html:Clear()

	local vbmgr = DailyOnlineGiftWnd.thiswnd:GetViewBoxMgr('物品栏')
	for i=1, vbmgr:GetSize() do
		local vb = vbmgr:GetViewBox(i-1)
		vb:ClearItem()
	end

	local param = cjson.decode(jsonParam)

	if param.nNeedTime < 0 then
		DailyOnlineGiftWnd.thiswnd:GetButton('领取奖励按钮'):SetEnabled(true)
		desc_html:ParseContext("可领取")
	else
		DailyOnlineGiftWnd.thiswnd:GetButton('领取奖励按钮'):SetEnabled(false)
		if param.nNeedTime <60 then
			desc_html:ParseContext(param.nNeedTime.."#(color,light_green)秒后可以领取#(color,restore)")
		elseif param.nNeedTime <60*60 then
			local nMin = math.floor(param.nNeedTime/60)
			local sec = param.nNeedTime - nMin*60
			desc_html:ParseContext(nMin.."#(color,light_green)分#(color,restore)"..sec.."#(color,light_green)秒后可以领取#(color,restore)")
		else
			local nHour = math.floor(param.nNeedTime/3600)
			local nMin = math.floor((param.nNeedTime - nHour*3600)/60)
			local sec = param.nNeedTime - nHour*3600 - nMin*60
			desc_html:ParseContext(nHour.."#(color,light_green)小时#(color,restore)"..nMin.."#(color,light_green)分#(color,restore)"..sec.."#(color,light_green)秒后可以领取#(color,restore)")
		end
	end

	--获取玩家职业
	local hero 		= core.getHero()
	if hero == nil then return end
	local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local level = hero:GetCrtProp(enProp_Level)
	local sex  = hero:GetCrtProp(enProp_Sex)

	for i = 1,param.count do
		if i > vbmgr:GetSize() then
			break
		end

		local vb = vbmgr:GetViewBox(i-1)

		local keyType = "rewardtype_"..i
		local keyId = "id_"..i
		local keyNum = "num_"..i
		local keyQuality = "quality_"..i

		local rewardtype = param[keyType]
		local id = param[keyId]
		local num = param[keyNum]
		local quality = param[keyQuality]

		--这里要预判下职业和性别是否符合
		local bOccOK = true
		if rewardtype == 2 then
			local goods_cfg = core.getGoodsConfig(id)
			if goods_cfg ~= nil and goods_cfg.lClass == enGoodsCategory_Equip_Actor then
				if g_pGlobal:GetGoodsClient():NeedCompare(id,cur_occ,sex) == false then
					bOccOK =false
				end
			end
		end

		if bOccOK == true then
			--如果是钱需要转换下id
			if rewardtype == 1 then
				if id == enNumResourceType_Gold then
					id = 20040
				elseif id == enNumResourceType_Silver then
					id = 20041
				elseif id == enNumResourceType_Exp then
					id = 20042
				elseif id == enNumResourceType_GoldIngot then
					id = 20043
				elseif id == enNumResourceType_Coffer_Gold then
					id = 20044
				elseif id == 30 then
					id = 20045
				end
			end

			vb:SetItem(id,num,false,quality)
		end
	end
end

-------读脚本时就执行
daily_online_wnd_init()

-----------------------在线礼包窗口 结束-------------------------------------------------------

-----------------------首冲礼包launch-------------------------------------------------------
FRGiftClient = {}
FRGiftClient.launch_wnd = nil
FRGiftClient.launch_btn = nil
FRGiftClient.this_wnd = nil 
FRGiftClient.first_recharge2_gift_table = nil
FRGiftClient.is_vip_icon = false
local function first_recharge_launch_init()
	--创建各个窗口并初始化
	FRGiftClient.launch_wnd = core.createWindow('Data/Scp/Windows/Windows_ActivityGift.scp',830, false, g_pGlobal:GetMainUI():GetSystemIconSet(0, true))

	--按下按钮
	FRGiftClient.launch_btn = FRGiftClient.launch_wnd:GetButton("btn")
	FRGiftClient.launch_btn:SetClickEventHandler2(FRGiftClient.launch_click)
	
	--监听玩家切换场景的时候
	api_reg_hero_all_data_ready_listen(FRGiftClient.send_request)
	
	--监听网络消息
	api_reg_module_msg_handler("ACT_FR_GIFT",FRGiftClient.msg_handle)
	
	--创建各个窗口并初始化
	FRGiftClient.this_wnd = core.createWindow('Data/Scp/Windows/Windows_ActivityGift.scp',831)

	--按下按钮
	FRGiftClient.this_wnd:GetButton("btn_close"):SetClickEventHandler2( function ( wnd, event) 	
										WndSystem:GetInstance():ShowWnd(831,0)
										end)
	
	--充值按钮X3
	FRGiftClient.this_wnd:GetButton('btn_chongzhi_1'):SetClickEventHandler2( function ( wnd, event) 	
										g_pGlobal:GetGoodsClient():Recharge()
										WndSystem:GetInstance():ShowWnd(831,0)
										end)
	FRGiftClient.this_wnd:GetButton('btn_chongzhi_2'):SetClickEventHandler2( function ( wnd, event) 	
										g_pGlobal:GetGoodsClient():Recharge()
										WndSystem:GetInstance():ShowWnd(831,0)
										end)
	FRGiftClient.this_wnd:GetButton('btn_chongzhi_3'):SetClickEventHandler2( function ( wnd, event) 	
										g_pGlobal:GetGoodsClient():Recharge()
										WndSystem:GetInstance():ShowWnd(831,0)
										end)
	FRGiftClient.this_wnd:GetButton('btn_chongzhi_4'):SetClickEventHandler2( function ( wnd, event) 	
										g_pGlobal:GetGoodsClient():Recharge()
										WndSystem:GetInstance():ShowWnd(831,0)
										end)
										
	FRGiftClient.this_wnd:GetButton('btn_lingqu_1'):SetClickEventHandler2( function ( wnd, event) 	
										FRGiftClient.send_get(1)
										end)
	FRGiftClient.this_wnd:GetButton('btn_lingqu_2'):SetClickEventHandler2( function ( wnd, event) 	
										FRGiftClient.send_get(2)
										end)
	FRGiftClient.this_wnd:GetButton('btn_lingqu_3'):SetClickEventHandler2( function ( wnd, event) 	
										FRGiftClient.send_get(3)
										end)	
	FRGiftClient.this_wnd:GetButton('btn_lingqu_4'):SetClickEventHandler2( function ( wnd, event) 	
										FRGiftClient.send_get(4)
										end)	
										
										
end

local function refresh_launch_btn()
	local fcmParent = XFlowCtrlMgr:CastToFlowCtrlMgr(FRGiftClient.launch_wnd:GetParent())
	local launchWndID = FRGiftClient.launch_wnd:GetID()
	
	--如果没有初始化过或者都领过了
	if FRGiftClient.first_recharge2_gift_table == nil or #FRGiftClient.first_recharge2_gift_table.gifts == 0  then
		--fcmParent:SetChildVisible(launchWndID, false)
		FRGiftClient.launch_btn:SetBitmap("text3/icon_vip.png")
		FRGiftClient.is_vip_icon = true
		WndSystem:GetInstance():ShowWnd(831,0)
		return
	end
	local bShow =false
	for i =1, #FRGiftClient.first_recharge2_gift_table.gifts do
		local tGiftitem = FRGiftClient.first_recharge2_gift_table.gifts[i]
		if tGiftitem.canget ~= 2 then
			bShow = true
			break
		end
	end
	if bShow == false then
		--fcmParent:SetChildVisible(launchWndID, false)
		FRGiftClient.launch_btn:SetBitmap("text3/icon_vip.png")
		FRGiftClient.is_vip_icon = true
		WndSystem:GetInstance():ShowWnd(831,0)
		return
	end

	--fcmParent:SetChildVisible(launchWndID, true)
	FRGiftClient.launch_btn:SetBitmap("text3/icon_firstrecharge.png")
	FRGiftClient.is_vip_icon = false
end

--监听玩家切换场景的时候，请求服务端重新发
local function send_request()
	local msg 		= {}
	msg.module 		= "ACT_FR_GIFT"
	msg.msg_code	= "get_gift_cfg"
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

local function send_get(sel)
	if FRGiftClient.first_recharge2_gift_table == nil or FRGiftClient.first_recharge2_gift_table.gifts[sel] == nil then
		return
	end

	--获取首冲礼包
	local msg 		= {}
	msg.module 		= "ACT_FR_GIFT"
	msg.msg_code	= "get_gift"
	msg.gift_id		= FRGiftClient.first_recharge2_gift_table.gifts[sel].id
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

local function first_recharge_launch_btn()
	FRGiftClient.send_request()
	
	if FRGiftClient.is_vip_icon == false then
		WndSystem:GetInstance():ShowWnd(831,1)
	else
		WndSystem:GetInstance():ShowWnd(872,1)
	end
	
	local ani = FRGiftClient.launch_wnd:GetAni("flashanim")
	ani:PlayAni(false)
	
end

local function first_recharge_update_ui()
local hero 		= core.getHero()
	if hero == nil then return end
	local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local level = hero:GetCrtProp(enProp_Level)
	local sex  = hero:GetCrtProp(enProp_Sex)
	
	if FRGiftClient.first_recharge2_gift_table ~= nil then
		for i =1,#FRGiftClient.first_recharge2_gift_table.gifts do
			local tGiftitem = FRGiftClient.first_recharge2_gift_table.gifts[i]
			
			--冲多少
			local html_recharge_val = FRGiftClient.this_wnd:GetHtml("recharge_val_"..i)
			html_recharge_val:Clear()
			if html_recharge_val ~= nil then
				--获取长度
				local str = tostring(math.floor(tGiftitem.recharge_val/10))
				local len = string.len(str)
				local strTemp = ""
		
				--显示
				for j = 1,len do
					local strOne = string.sub(str,j,j)
					strTemp = strTemp.."#(image,Data/UI/flow_num/red2/00"..strOne..".png)"
				end
				html_recharge_val:ParseContext(strTemp)
			end

			--返还多少
			local html_return_val = FRGiftClient.this_wnd:GetHtml("goldingot_"..i)
			html_return_val:Clear()
			if html_return_val ~= nil then
				html_return_val:ParseContext("#(SilverIngot,"..tGiftitem.rewards[1].nums..")")
			end
			
			--充值和领取按钮的状态
			local btn_lingqu = FRGiftClient.this_wnd:GetButton("btn_lingqu_"..i)
			local btn_chongzhi = FRGiftClient.this_wnd:GetButton("btn_chongzhi_"..i)
			if tGiftitem.canget == 0 then
				btn_lingqu:SetVisible(false)
				btn_chongzhi:SetVisible(true)
			elseif tGiftitem.canget == 1 then
				btn_lingqu:SetVisible(true)
				btn_chongzhi:SetVisible(false)
			else
				btn_lingqu:SetVisible(false)
				btn_chongzhi:SetVisible(false)
			end
			
			
			--viewbox
			local showNum = 1
			for j =1,#tGiftitem.rewards do
				local vb = FRGiftClient.this_wnd:GetItemViewBox("vb_"..i.."_"..showNum)
				if vb == nil then
					break
				end
				
				vb:ClearItem()
				local reward = tGiftitem.rewards[j]
				if reward.id ~= 4 then
					local rewardtype = reward.rewardtype
					local id = reward.id
					local num = reward.nums
					local quality = reward.quality

					--这里要预判下职业和性别是否符合
					local bOccOK = true
					if rewardtype == "goods" then
						local goods_cfg = core.getGoodsConfig(id)
						if goods_cfg ~= nil and goods_cfg.lClass == enGoodsCategory_Equip_Actor then
							if g_pGlobal:GetGoodsClient():NeedCompare(id,cur_occ,sex) == false then
								bOccOK =false
							end
						end
					end

					if bOccOK == true then
						--如果是钱需要转换下id
						if rewardtype == "money" then
							if id == enNumResourceType_Gold then
								id = 20040
							elseif id == enNumResourceType_Silver then
								id = 20041
							elseif id == enNumResourceType_Exp then
								id = 20042
							elseif id == enNumResourceType_GoldIngot then
								id = 20043
							elseif id == enNumResourceType_Coffer_Gold then
								id = 20044
							elseif id == 30 then
								id = 20045
							end
						end

						vb:SetItem(id,num,false,quality)
						showNum = showNum+1
					end
				end
			end
		end
	end
end
local function first_recharge_msg_handle(msg)
	if (msg.msg_code=="get_gift_cfg") then
		FRGiftClient.first_recharge2_gift_table = msg.first_recharge2_gift_table
		FRGiftClient.refresh_launch_btn()
		FRGiftClient.first_recharge_update_ui()
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end
-------函数列表
FRGiftClient.refresh_launch_btn = refresh_launch_btn
FRGiftClient.init = first_recharge_launch_init
FRGiftClient.launch_click = first_recharge_launch_btn
FRGiftClient.send_request = send_request
FRGiftClient.send_get = send_get
FRGiftClient.first_recharge_update_ui = first_recharge_update_ui
FRGiftClient.msg_handle = first_recharge_msg_handle
-------读脚本时就执行
FRGiftClient.init()

-----------------------首冲礼包launch 结束-------------------------------------------------------
