﻿
--**********************************************************--
------------------------一些变量------------------------------
local thisWnd  						--自己
local mainCtrlFlip 					--主窗口flip控件
local shopCtrlFlip 					--荣誉商店flip控件
local curPageIndex			= 0 	--当前所在的页
local subWndList			= {}	--子窗口列表
local redColor				= XColor:new(255,0,0)
local normalColor 			= XColor:new(255,200,0)

local eventID_Open_RewardWnd	= 103401
--**********************************************************--
------------------------函数列表------------------------------

--初始化
function honorShopMainWnd(wnd)
	thisWnd = wnd
	--注册显示回调事件
	thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnhonorShopMainWndShow')

	--设置切页时的调用	
	mainCtrlFlip 		= thisWnd:GetFlipPage('主切换页')
	local mainPageCount 	= mainCtrlFlip:GetPageNum()
	for k=1, mainPageCount do 
		local pagebtn 	= mainCtrlFlip:GetPageBtnx(k-1)
		pagebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'OnMainFlipSwitch')
	end
	
	shopCtrlFlip		= thisWnd:GetFlipPage('荣誉切换页')
	local shopPageCount		= shopCtrlFlip:GetPageNum()
	for k=1, shopPageCount do
		local pagebtn 	= shopCtrlFlip:GetPageBtnx(k-1)
		pagebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'OnShopFlipSwitch')
	end
	
	--关闭按钮
	local btn_close = thisWnd:GetButton('关闭按钮')
	btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'OnHonorMainWndClose')

	--发来显示某个子窗口的事件
	thisWnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT,OnHonorMainWndEvent)
	
	
	--thisWnd:SetClientRectChangedCallback("honor_on_client_rect_change")
	
	thisWnd:SetVisible(false)
end

--主窗口显示回调
function OnhonorShopMainWndShow()
	--第一次显示的时候 切换到第一页
	HonorMainWndFlipSwitch(0)
	curPageIndex = 0
end

--关闭事件
function OnHonorMainWndClose()
	thisWnd:SetVisible(false)
end

--OnEvent事件
function OnHonorMainWndEvent(pWnd,event,eventID,param1,param2)
	if eventID == eventID_Open_RewardWnd then
		HonorMainWndFlipSwitch(param1)
		thisWnd:SetVisible(true)
	end
end

--flip切换函数
--pageIndex 为第几页
function HonorMainWndFlipSwitch(pageIndex)
	--检查
	if subWndList[pageIndex] == nil then
		API_Trace("HonorMainWndFlipSwitch pageIndex nil ")
		return
	else
	
		local pagebtn 	= mainCtrlFlip:GetPageBtnx(1) ----荣誉兑换分页按钮
		
		subWndList[curPageIndex]:SetVisible(false)
		curPageIndex 			= pageIndex
		subWndList[pageIndex]:SetVisible(true)
		mainCtrlFlip:TurnPage(pageIndex)
		local bk2 = thisWnd:GetStaticBitmap('背景2')
		local bk3 = thisWnd:GetStaticBitmap('背景3')
		local rongyu = thisWnd:GetLabel('荣誉字')
		if pageIndex == 0 then
			shopCtrlFlip:SetVisible(false)
			bk2:SetVisible(false)
			bk3:SetVisible(false)
			rongyu:SetVisible(false)
			pagebtn:SetVisible(true)
			
		elseif pageIndex == 1 then
			shopCtrlFlip:SetVisible(true)
			bk2:SetVisible(true)
			bk3:SetVisible(true)
			rongyu:SetVisible(true)
			pagebtn:SetVisible(false)
			shopCtrlFlip:TurnPage(0)
		end
		
		--honor_on_client_rect_change()
	end
end

function honor_on_client_rect_change()
	XWinUtil:AlignWindow(thisWnd, subWndList[curPageIndex],  XWinUtil.enXUAlign_LEFT_LEFT, 52);
	XWinUtil:AlignWindow(thisWnd, subWndList[curPageIndex],  XWinUtil.enXUAlign_TOP_TOP, 212);
end

--添加子窗口
function honorMainWndSubWnd(tag, wnd)
	thisWnd:AddWindow(wnd)
	subWndList[tag] 	= wnd
end

--点击切页
function OnMainFlipSwitch(wnd)
	HonorMainWndFlipSwitch(XButton:CastToButton(wnd):GetTag1())
end

----点击荣誉商店的切换页
function OnShopFlipSwitch(wnd)
	local pageIndex = XButton:CastToButton(wnd):GetTag1()
	honorWndFlipSwitch(pageIndex)
	shopCtrlFlip:TurnPage(pageIndex-1)
end


------荣誉兑换窗口
---------------------------------------------------------------------------------------------------------------------------------------
local honorWnd = {}
honorWnd.thisWnd 	= nil	
honorWnd.panelList 	= {}	--物品列表
honorWnd.borderList	= {}	--选中边框列表
honorWnd.honorNum	= nil	--荣誉值

local m_goodsID		= 0
local m_goodsPrice 	= 0
local GoodsList 	= {}		--物品列表
local m_pageIndex 	= 0

local honor_ModuleName = 'honorShop'

function honorWndInit(wnd)

	honorWnd.thisWnd = wnd
	if honorWnd.thisWnd == nil then
		return
	end

	api_reg_module_msg_handler(honor_ModuleName,honor_msg_handler)
	
	--兑换按钮
	local exchangeBtn	= honorWnd.thisWnd:GetButton('兑换')
	exchangeBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'honor_OnClickExchange')
	
	----问号
	local helpBtn		= honorWnd.thisWnd:GetAni('问号')
	helpBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'honor_OnClickHelp')
	
	----荣誉值
	honorWnd.honorNum	= honorWnd.thisWnd:GetLabel('荣誉值')
	
	----panel列表
	local scrollMgr = honorWnd.thisWnd:GetScrollMgr('scrollmgr') 
	local panelmgr = scrollMgr:GetPanelMgr('panelmgr')
	local  panel_count = panelmgr:GetPanelCount()
	for k=1, panel_count do
		honorWnd.panelList[k] = panelmgr:GetPanelWnd(k-1)
		local btn = honorWnd.panelList[k]:GetButton('选中按钮')
		btn:SetEventToWindow(scrollMgr)
		--honorWnd.panelList[k]:GetItemViewBox('icon'):SetEventToWindow(btn)
	end
		
	----监听窗口显示
	honorWnd.thisWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'honor_OnOpenHonorShop')
end

----消息处理
function honor_msg_handler(msg)
	if msg.msg_code == 'OnShowGoodsList' then
		GoodsList = msg.goodsList
		honorWndFlipSwitch(1)
	elseif msg.msg_code == 'OnGetOK' then
		honorUpdatehonor()
	end
end

----点击兑换
function honor_OnClickExchange()
	if m_goodsID == 0 or m_goodsPrice == 0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先选中物品")
		return
	end
	local goods_cfg = core.getGoodsConfig(m_goodsID)
	--这里要预判下职业和性别是否符合
	local hero = core.getHero()
	local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local sex  = hero:GetCrtProp(enProp_Sex)
	if goods_cfg ~= nil and goods_cfg.lClass == enGoodsCategory_Equip_Actor then
		if g_pGlobal:GetGoodsClient():NeedCompare(m_goodsID,cur_occ,sex) == false then
			g_pGlobal:GetMainUI():ShowMessageBox("这件装备不符合您穿戴，是否确认兑换？","honorShop_not_suit",0,0,"确定","取消")	
			return
		end
	end	
	
	g_pGlobal:GetMainUI():ShowMessageBox("是否使用#(color,orange)"..m_goodsPrice.."荣誉值#(color, restore)兑换#(color,orange)"..goods_cfg.szName.."#(color,restore)","honorShop_buy_goods",0,0,"确定","取消")	
end

---兑换成功更新数值
function honorUpdatehonor()
	local honorNum = core.getHero():GetCrtProp(enProp_Actor_HonorValue)
	honorWnd.honorNum:setText(honorNum)
end

---不符合职业性别的确认提示
function honorShop_not_suit(msgid,wparam,lparam)
	if(msgid == WE_AW_BTN1_CLICKED) then
		local goods_cfg = core.getGoodsConfig(m_goodsID)
		g_pGlobal:GetMainUI():ShowMessageBox("是否使用#(color,orange)"..m_goodsPrice.."荣誉值#(color, restore)兑换#(color,orange)"..goods_cfg.szName.."#(color,restore)","honorShop_buy_goods",m_goodsID,0,"确定","取消")	
	end
end

----发送请求 购买
function honorShop_buy_goods(msgid,wparam,lparam)
	if(msgid == WE_AW_BTN1_CLICKED) then
		local msg = {}
		msg.module =  honor_ModuleName
		msg.msg_code = 'buyGoods'
		msg.goodsID = m_goodsID
		msg.pageIndex = m_pageIndex
		local str = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(str)
	end
end

----点击问号
function honor_OnClickHelp()
	local helpWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(109)
	helpWnd:SetVisible(true)
end

----荣誉兑换窗口打开
function honor_OnOpenHonorShop()
	m_goodsID = 0
	m_goodsPrice = 0
	for k=1, #honorWnd.borderList do
		honorWnd.borderList[k]:SetVisible(false)
	end
	local honorNum = core.getHero():GetCrtProp(enProp_Actor_HonorValue)
	honorWnd.honorNum:setText(honorNum)
	
	--请求服务器获得物品列表
	local msg = {}
	msg.module =  honor_ModuleName
	msg.msg_code = 'GetGoodsList'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

-----荣誉切换页
function honorWndFlipSwitch(pageIndex)
	m_pageIndex = pageIndex
	local goodsList = GoodsList[pageIndex]
	for k=1, #honorWnd.panelList do
		local panel = honorWnd.panelList[k]
		
		if k<= #goodsList then
			local goodsInfo = goodsList[k]
			panel:SetVisible(true)
			----物品名
			local goodsName = panel:GetLabel('name')
			local goods_cfg = core.getGoodsConfig(goodsInfo.goodsID)
			
			local hero = core.getHero()
			local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
			local sex  = hero:GetCrtProp(enProp_Sex)
			goodsName:setText(goods_cfg.szName)
			
			if goods_cfg ~= nil and goods_cfg.lClass == enGoodsCategory_Equip_Actor then
				if g_pGlobal:GetGoodsClient():NeedCompare(goodsInfo.goodsID,cur_occ,sex) == false then
					goodsName:SetForeColor(redColor)
				else
					goodsName:SetForeColor(normalColor)
				end
			end
			----价格
			local priceLabel = panel:GetLabel('荣誉值')
			priceLabel:setText(''..goodsInfo.price)
			----物品icon
			local viewbox = panel:GetItemViewBox('icon')
			viewbox:SetItem(goodsInfo.goodsID,goodsInfo.qualityInfo[2],false,goodsInfo.qualityInfo[1])
			----选中框
			local border = panel:getWindow('选中框')
			border:SetVisible(false)
			honorWnd.borderList[k] = border
			----兑换按钮
			local btn = panel:GetButton('选中按钮')
			btn:SetClickEventHandler('honorShop_checked')
			btn:SetPropertyInt32('goodsID',goodsInfo.goodsID)
			btn:SetPropertyInt32('goodsPrice',goodsInfo.price)
			btn:SetPropertyInt32('index',k)
			viewbox:SetClickEventHandler('honorShop_checked')
			viewbox:SetPropertyInt32('goodsID',goodsInfo.goodsID)
			viewbox:SetPropertyInt32('goodsPrice',goodsInfo.price)
			viewbox:SetPropertyInt32('index',k)
		else
			panel:SetVisible(false)
		end
	end
end

-----选中物品
function honorShop_checked(wnd, eventid)
	
	m_goodsID = wnd:GetPropertyInt32('goodsID')
	m_goodsPrice = wnd:GetPropertyInt32('goodsPrice')
	local index = wnd:GetPropertyInt32('index')
	for k=1, #honorWnd.borderList do
		if k == index then
			honorWnd.borderList[k]:SetVisible(true)
			honorWnd.borderList[k]:SetTransparentOption(1)
		else
			honorWnd.borderList[k]:SetVisible(false)
		end
	end
end

------初始化窗口
----------------------------------------------------------------------------------------------------------------------
function honorShopMainInit()
	--判断下如果已经初始化过就不用初始化了
	if WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1034) ~= nil then
		--return
	end
	
	--创建各个窗口并初始化
	local mainWnd 			= core.createWindow("Data\\Scp\\Windows\\Windows_Goods2.scp",1034)
	honorShopMainWnd(mainWnd)

	--子窗口 从0开始记 0:奖励窗口 1:荣誉窗口
	---奖励窗口初始化
	LMTargetClient.lm_target_init()
	local rewardWnd =  WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1079)
	honorMainWndSubWnd(0, rewardWnd)
	
	--荣誉兑换子窗口
	local honorShopWnd		= core.createWindow("Data\\Scp\\Windows\\Windows_Goods2.scp",1035)
	honorWndInit(honorShopWnd)
	honorMainWndSubWnd(1, honorShopWnd)

end
--脚本初始化
honorShopMainInit()