---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\auction\laddersmatch_client.lua
--版  权:	(C)盛游
--创建人:	linhongwei
--日  期:	2013.9.29
--版  本:	1.0
--描  述:	天梯赛客户端，消息码及窗口实现
----------------------------------------------------------------------------------------------------------------------
--日  期:	2013.11.8
--版  本:	1.1
--描  述:	天梯目标奖励窗口的实现
----------------------------------------------------------------------------------------------------------------------


--**********************************************************--
------------------------一些变量------------------------------
LMClient = {} 
LMClient.this_wnd 				= nil  	--自己
LMClient.head_bmp				= nil
LMClient.no_html				= nil
LMClient.honor_html				= nil
LMClient.report_html			= nil
LMClient.honor_desc_html		= nil
LMClient.panelmgr				= nil --被挑战者列表框
LMClient.cd_val_label			= nil
LMClient.times_label			= nil --今天还可以挑战的次数
LMClient.monet_desc_html		= nil
LMClient.get_reward_btn			= nil

LMClient.vOpponent				= {} --被挑战者列表

LMClient.MouseX					= nil --用于查看按钮被点击时判断是否在滚动状态，是则不显示玩家信息

LMClient.module_name = "laddersmatch"

--**********************************************************--
------------------------函数列表------------------------------
--模块初始化
local  function lm_init()	
	--创建窗口
	LMClient.this_wnd = core.createWindow('Data/Scp/Windows/Windows_Arena.scp',953)--,false)	
	
	--添加到父窗口
	g_pGlobal:GetActivityClient():AddArenaMainSub(LMClient.this_wnd,0)
	
	--初始化
	LMClient.head_bmp=LMClient.this_wnd:GetStaticBitmap('英雄头像')
	LMClient.no_html = LMClient.this_wnd:GetHtml('排名值')
	LMClient.honor_html = LMClient.this_wnd:GetHtml('荣誉值')
	LMClient.report_html = LMClient.this_wnd:GetHtml('一条战报')
	LMClient.honor_desc_html = LMClient.this_wnd:GetHtml('间隔荣誉值')
	LMClient.cd_val_label = LMClient.this_wnd:GetLabel('挑战冷却时间值')
	LMClient.times_label = LMClient.this_wnd:GetLabel('今日还可次数')
	LMClient.monet_desc_html = LMClient.this_wnd:GetHtml('金币值')
	LMClient.money_bk_sb = LMClient.this_wnd:GetStaticBitmap('金币背景框3')
	
	LMClient.srcollmgr =LMClient.this_wnd:GetScrollMgr('滚动管理')
	LMClient.panelmgr = LMClient.srcollmgr:GetPanelMgr('列表框')
	for i=1,LMClient.panelmgr:GetPanelCount() do
		local panel = LMClient.panelmgr:GetPanelWnd(i-1)
		
		local btn_chakan = panel:GetButton('查看信息')
		btn_chakan:SetEventToWindow(LMClient.srcollmgr)
		btn_chakan:SetTag1(i)
		btn_chakan:SetLuaEvent(XWIN_EVENT_MOUSEUP,"on_btn_LM_chakan")
		btn_chakan:SetLuaEvent(XWIN_EVENT_MOUSEDOWN,"on_btn_down_LM_chakan")
		
		local btn_tiaozhan = panel:GetButton('挑战')
		btn_tiaozhan:SetTag1(i)
		btn_tiaozhan:SetClickEventHandler2(LMClient.on_btn_tiaozhan)
	end
	
	--荣誉兑换按钮
	LMClient.get_reward_btn = LMClient.this_wnd:GetButton('荣誉兑换')
	LMClient.get_reward_btn:PlayAni(false)
	LMClient.get_reward_btn:SetClickEventHandler2(
		function ( wnd, event) 	
			--WndSystem:GetInstance():OnEvent(501, 50101,0, 0);
			WndSystem:GetInstance():GetGameDesktop():FindWindowByID(936):SetVisible(false)
			WndSystem:GetInstance():OnEvent(1034,103401,0,0);
		end
		)
	
	--天梯榜按钮
	LMClient.this_wnd:GetButton('天梯榜'):SetClickEventHandler2(
		function ( wnd, event) 	
			WndSystem:GetInstance():OnEvent(906, 90605,3, 0);
		end
		)
	
	--战报按钮
	LMClient.this_wnd:GetButton('战报'):SetClickEventHandler2(
		function ( wnd, event) 	
			WndSystem:GetInstance():ToggleWnd(968)
		end
		)
	
	--秒CD按钮
	LMClient.this_wnd:GetButton('秒CD'):SetClickEventHandler2(LMClient.on_btn_buyCD)
	
	--买次数按钮
	LMClient.this_wnd:GetButton('添加挑战'):SetClickEventHandler2(LMClient.on_btn_buyTimes)
	
	
	--打开的时候
	WndSystem:GetInstance():GetGameDesktop():FindWindowByID(936):SetShowEventHandler2(LMClient.on_show)
	
	--向前滚按钮
	LMClient.this_wnd:GetButton('前一chunk'):SetClickEventHandler2(
		function ( wnd, event) 	
			local chunkNo = LMClient.srcollmgr:GetChunkNo()
			if chunkNo > 0 then
				LMClient.srcollmgr:SetChunkNo(chunkNo-1)
			end	
		end
		)
		
	--向后滚按钮
	LMClient.this_wnd:GetButton('后一chunk'):SetClickEventHandler2(
		function ( wnd, event) 	
			local chunkNo = LMClient.srcollmgr:GetChunkNo()
			if chunkNo < 4 then
				LMClient.srcollmgr:SetChunkNo(chunkNo+1)
			end	
		end
		)
	
	
	
	--监听玩家属性变化
	--g_pGlobal:GetEventServer():onEvent(make_msgid(CIRCULTYPE_CC, MSG_ACTION_SYNC_PROP), LMClient.on_sync_prop)
	
	--注册网络消息
	api_reg_module_msg_handler(LMClient.module_name,LMClient.msg_handler)
	
	--定时器
	timer.setTimer('ontime_LM_cd',953,1000);
end

--挑战对手
local function on_btn_tiaozhan(wnd)
	local info = LMClient.vOpponent[XButton:CastToButton(wnd):GetTag1()]
	if info ~= nil and info.uid ~= nil then
		local msg = {}
		msg.module   = LMClient.module_name
		msg.msg_code = "challenge"
		msg.uid = info.uid
		local jsonstr = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(jsonstr)
	end
end
	
--查看对手信息
function on_btn_LM_chakan(wnd)
	--滚动的时候防止被点击到
	if LMClient.MouseX == nil or math.abs(LMClient.MouseX - XDesktop:GetInstance():GetMouseXY().x) > 10 then
		return
	end

	local info = LMClient.vOpponent[XButton:CastToButton(wnd):GetTag1()]
	--API_Trace("info.actorID ="..info.actorID)
	if info ~= nil and info.actorID ~= nil and info.actorID ~= 0 then
		API_ViewActorInfo(info.actorID)
	end	
end

function on_btn_down_LM_chakan(wnd)
	LMClient.MouseX = XDesktop:GetInstance():GetMouseXY().x
end

--定时器
function ontime_LM_cd()
	if(  WndSystem:GetInstance():GetGameDesktop():FindWindowByID(936):IsVisible() == false) then
		return
	end
	
	LMClient.fresh_wnd()
	
	if XDate:GetInstance():GetCurrentVTime() % 20 ==0 then
		local msg = {}
		msg.module   = LMClient.module_name
		msg.msg_code = "open_wnd"
		local jsonstr = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(jsonstr)
	end
end
	
--玩家属性变化
--[[local function on_sync_prop(obj,msgid)
	--窗口不可见就忽略
	if( not LMClient.this_wnd:IsVisible() or not obj:IsHero()) then return end

	LMClient.fresh_wnd()
end
--]]

--显示的时候
local function on_show()
	local msg = {}
	msg.module   = LMClient.module_name
	msg.msg_code = "open_wnd"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
	
	LMClient.fresh_wnd()
end

local function fresh_wnd()
	local hero = core.getHero()
	if hero==nil  then
		return
	end
	
	--头像
	local nResID=hero:GetHeadPicResID()
	--local bmpHead = g_pGlobal:GetResourceMgr():RequestIcon(nResID);
	LMClient.head_bmp:SetBitmapIcon(nResID)
	
	--名次
	local nNo = hero:GetCrtProp(enProp_Actor_LM_No)
	LMClient.no_html:Clear()
	if nNo == 0 then
		LMClient.no_html:ParseContext("无名次")
	else
		--获取长度
		local strNo = tostring(nNo)
		local len = string.len(strNo)
		local strTemp = ""
		
		--为了居中填充点空位
		if len == 1 then
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space2.png)".."#(image,Data/UI/flow_num/golden/space.png)"
		elseif len == 2 then
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space.png)"
		elseif len == 3 then
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space2.png)"
		end
		
		--显示
		for i = 1,len do
			local strOne = string.sub(strNo,i,i)
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/00"..strOne..".png)"
		end
		LMClient.no_html:ParseContext(strTemp)
	end
	
	--荣誉值
	local nHonor = hero:GetCrtProp(enProp_Actor_HonorValue)
	LMClient.honor_html:Clear()
	LMClient.honor_html:ParseContext("#(color,orange_yellow)"..nHonor.."#(color,restore)")	
	
	--CD时间
	local lastTime = hero:GetCrtProp(enProp_Actor_LastLaddersMatchTime)
	local nCdTimes = hero:GetCrtProp(enProp_Actor_LMCD_Times)
	local nLeftTime = lastTime+5*60 -XDate:GetInstance():GetCurrentVTime()
	if nLeftTime > 0 and nCdTimes==0 then
		local minute = math.floor(nLeftTime/60)
		local sec = nLeftTime%60
		
		local strMin = tostring(minute)
		if minute< 10 then
			strMin = "0"..strMin
		end
		
		local strSec = tostring(sec)
		if sec< 10 then
			strSec = "0"..strSec
		end
		
		LMClient.cd_val_label:setText(strMin..":"..strSec)
	else
		LMClient.cd_val_label:setText("00:00")
	end
	
	--还可以挑战的次数
	local enterLasttime = hero:GetCrtProp(enProp_Actor_LaddersMatchEnterLast)
	local canEnter = hero:GetCrtProp(enProp_Actor_LaddersMatchEnter)
	if XDate:GetInstance():IsToday(enterLasttime) ==false then
		canEnter = 6
	end
	LMClient.times_label:setText( tostring(canEnter))
end

--战报更新
function LM_update_report(strJson)
	local vReport = cjson.decode(strJson)
	
	LMClient.report_html:Clear()
	if vReport.count ~= nil and vReport.count ~= 0 then
		local key = "index_"..vReport.count
		LMClient.report_html:ParseContext(vReport[key])
	end
	
end

--更新界面，被挑战者
local function fresh_opponent()
	for i=1,LMClient.panelmgr:GetPanelCount() do
		local panel = LMClient.panelmgr:GetPanelWnd(i-1)
		local info = LMClient.vOpponent[i]
		if info == nil then
			panel:SetVisible(false)
		else
			panel:SetVisible(true)
			
			--名字
			local name_label = panel:GetLabel('名字')
			name_label:setText(info.name)
			
			--头像
			local head_bmp = panel:GetStaticBitmap('头像')
			head_bmp:SetBitmapIcon(API_GetHeadIcon(info.headPic))
				
			--排名	
			local no_html = panel:GetHtml('排名值')
			no_html:Clear()
			local nNo = info.no
			--获取长度
			local strNo = tostring(nNo)
			local len = string.len(strNo)
			local strTemp = ""
			--为了居中填充点空位
			if len == 1 then
				strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space2.png)".."#(image,Data/UI/flow_num/golden/space.png)"
			elseif len == 2 then
				strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space.png)"
			elseif len == 3 then
				strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space2.png)"
			end
			--显示
			for i = 1,len do
				local strOne = string.sub(strNo,i,i)
				strTemp = strTemp.."#(image,Data/UI/flow_num/golden/00"..strOne..".png)"
			end
			no_html:ParseContext(strTemp)
	
			--等级
			local level_label = panel:GetLabel('等级值')
			level_label:setText(tostring(info.level))			
		end
	end

--LMClient.vOpponent				= {} --被挑战者列表
end

--秒CD
local function on_btn_buyCD()
	local hero = core.getHero()
	if hero==nil  then
		return
	end
	
	local lastTime = hero:GetCrtProp(enProp_Actor_LastLaddersMatchTime)
	local nCdTimes = hero:GetCrtProp(enProp_Actor_LMCD_Times)
	local nLeftTime = lastTime+5*60-XDate:GetInstance():GetCurrentVTime()
	local todayMatchTime = hero:GetCrtProp(enProp_Actor_LaddersMatchTimesCurDay)
	if XDate:GetInstance():IsToday(lastTime) ==false then
		todayMatchTime = 0
	end
	
	if nLeftTime<=0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "您当前不处于天梯赛的冷却状态中，不需重置")
		return
	end

	if nCdTimes == 1 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "您的天梯赛冷却时间已经重置,不需要再重置")
		return
	end
	
	if nCdTimes == 2 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "您上一场挑战天梯赛胜利了，不需冷却就能继续挑战")
		return
	end

	if todayMatchTime ==LaddersMatchMaxTimesPerDay then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "您今天达到挑战上限了，请先增加挑战次数")
		return
	end

	local minCount = math.floor(nLeftTime/60) + 1
	g_pGlobal:GetMainUI():ShowMessageBox("您决定花费"..minCount.."个元宝重置天梯赛的冷却时间？","lm_msgcb_buyCD",0,0,"确定","取消");	
end

function lm_msgcb_buyCD(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then return end

	local msg = {}
	msg.module   = "activity_info"
	msg.msg_code = "lmcd"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--增加挑战次数
local function on_btn_buyTimes()
	g_pGlobal:GetActivityClient():AddLaddersMatchChallengeTimes()
end

--------网络消息处理--------
--接收网络消息
local function msg_handler(msg)
	if (msg.msg_code=="cb_open_wnd") then
		LMClient.cb_open_wnd(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end

local function cb_open_wnd(msg)
	LMClient.honor_desc_html:Clear()
	LMClient.honor_desc_html:ParseContext("#(color,pinzhiblue)"..msg.honor_desc.."#(color,restore)")

	local rect = LMClient.money_bk_sb:GetWindowXRect()
	local length = math.floor(142*((tostring(msg.money_desc))/(tostring(msg.money_max_desc))))
	rect.right = rect.left + length;
	LMClient.money_bk_sb:SetWindowRect(rect)	
	
	LMClient.monet_desc_html:Clear()
	LMClient.monet_desc_html:ParseContext(msg.money_desc.."#(image,8503)/"..(tostring(msg.money_max_desc)).."#(image,8503)")
	
	
	LMClient.vOpponent = {}
	LMClient.vOpponent = msg.vOpponent
	
	LMClient.fresh_opponent()
end

--**********************************************************--
--------------------刷脚本的时候执行--------------------------
LMClient.on_sync_prop = on_sync_prop
LMClient.fresh_wnd = fresh_wnd
LMClient.on_show = on_show
LMClient.msg_handler = msg_handler
LMClient.cb_open_wnd = cb_open_wnd
LMClient.fresh_opponent = fresh_opponent
LMClient.on_btn_tiaozhan = on_btn_tiaozhan
LMClient.on_btn_buyCD = on_btn_buyCD
LMClient.on_btn_buyTimes = on_btn_buyTimes

-- 开服先刷一次,模块初始化
lm_init()


--**********************************************************--
------------------------天梯奖励窗口------------------------------
LMTargetClient = {} 
LMTargetClient.this_wnd 				= nil  	--自己
LMTargetClient.desc_html = nil
LMTargetClient.xiuwei_link_html = nil
LMTargetClient.panel_mgr = nil
LMTargetClient.progress_sb = nil
LMTargetClient.progress_html = nil
LMTargetClient.no_html = nil
LMTargetClient.lm_target_table = nil

LMTargetClient.module_name = "ACT_LM_TARGET_GIFT"



--模块初始化
local  function lm_target_init()	
	--创建窗口
	LMTargetClient.this_wnd = core.createWindow('Data/Scp/Windows/Windows_LaddersmatchTarget.scp',1079)--,false)	
	
	--添加到父窗口
	--g_pGlobal:GetActivityClient():AddArenaMainSub(LMTargetClient.this_wnd,0)
	
	--初始化
	LMTargetClient.desc_html = LMTargetClient.this_wnd:GetHtml('描述')
	LMTargetClient.xiuwei_link_html = LMTargetClient.this_wnd:GetHtml('修为链接')
	LMTargetClient.progress_sb = LMTargetClient.this_wnd:GetStaticBitmap('进度图片')
	LMTargetClient.progress_html = LMTargetClient.this_wnd:GetHtml('进度值')
	LMTargetClient.no_html = LMTargetClient.this_wnd:GetHtml('名次值')
	
	local scroll_mgr = LMTargetClient.this_wnd:GetScrollMgr('滚动管理')
	LMTargetClient.panel_mgr = scroll_mgr:GetPanelMgr('礼包列表')
	for i=1,LMTargetClient.panel_mgr:GetPanelCount() do
		local panel = LMTargetClient.panel_mgr:GetPanelWnd(i-1)
		panel:SetVisible(false)
		
		local btn = panel:GetButton('领取按钮')
		btn:SetTag1(i)
		btn:SetClickEventHandler2(LMTargetClient.on_btn_lmt_lingqu)
	end
	
	--修为入口
	LMTargetClient.xiuwei_link_html:Clear()
	LMTargetClient.xiuwei_link_html:ParseContext("#(link,0,underlinetype=1,close=0,type=openwindow,winid=95,optype=3,eventid=256,param1=1,txt=升级修为技能)")

	--打开的时候触发刷新界面，这里天梯窗口打开的时候也触发下，要更新按钮的状态
	WndSystem:GetInstance():GetGameDesktop():FindWindowByID(936):SetShowEventHandler2(LMTargetClient.on_show)
	WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1034):SetShowEventHandler2(LMTargetClient.on_show)
	
	--注册网络消息
	api_reg_module_msg_handler(LMTargetClient.module_name,LMTargetClient.msg_handler)
end

local function on_show2()
	local msg = {}
	msg.module   = LMTargetClient.module_name
	msg.msg_code = "get_gift_cfg"
	if LMTargetClient.lm_target_table ~= nil then
		msg.only_need_status = true
	end
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
	
	--显示天梯排名
	local hero = core.getHero()
	if hero==nil  then
		return
	end
	local nNo = hero:GetCrtProp(enProp_Actor_LM_No)
	LMTargetClient.no_html:Clear()
	if nNo == 0 then
		LMTargetClient.no_html:ParseContext("无名次")
	else
		--获取长度
		local strNo = tostring(nNo)
		local len = string.len(strNo)
		local strTemp = ""
		
		--为了居中填充点空位
		if len == 1 then
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space2.png)".."#(image,Data/UI/flow_num/golden/space.png)"
		elseif len == 2 then
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space.png)"
		elseif len == 3 then
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/space2.png)"
		end
		
		--显示
		for i = 1,len do
			local strOne = string.sub(strNo,i,i)
			strTemp = strTemp.."#(image,Data/UI/flow_num/golden/00"..strOne..".png)"
		end
		LMTargetClient.no_html:ParseContext(strTemp)
	end
end

--领取按钮
local function on_btn_lmt_lingqu(wnd)
	local index = XButton:CastToButton(wnd):GetTag1()
	if LMTargetClient.lm_target_table.gifts[index] ~= nil then
		local msg = {}
		msg.module   = LMTargetClient.module_name
		msg.msg_code = "get_gift"
		msg.gift_id = LMTargetClient.lm_target_table.gifts[index].id
		local jsonstr = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(jsonstr)	
	end
end

--接收网络消息
local function msg_handler2(msg)
	if (msg.msg_code=="get_gift_cfg") then
		LMTargetClient.cb_get_gift_cfg(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end

local function cb_get_gift_cfg(msg)
	if msg.only_need_status == nil then
		LMTargetClient.lm_target_table = msg.lm_target_table
	else
		for i=1,#msg.lm_target_table.gifts do
			LMTargetClient.lm_target_table.gifts[i].canget = msg.lm_target_table.gifts[i].canget
		end
	end

	--描述
	LMTargetClient.desc_html:Clear()
	LMTargetClient.desc_html:ParseContext(LMTargetClient.lm_target_table.description)
	
	--奖励mgr
	local total_gift = #LMTargetClient.lm_target_table.gifts
	local alreadyGet = 0 --已经获取数
	local canGet = 0 --可以获取数
	for i=1,LMTargetClient.panel_mgr:GetPanelCount() do
		local panel = LMTargetClient.panel_mgr:GetPanelWnd(i-1)
		
		if i>#LMTargetClient.lm_target_table.gifts then
			panel:SetVisible(false)
		else
			panel:SetVisible(true)
			local desc = panel:GetHtml("条件描述")
			local money = panel:GetHtml("金币值")
			local vbmgr = panel:GetViewBoxMgr("奖励管理器")
			local sb = panel:GetStaticBitmap('已领图片')
			local btn = panel:GetButton('领取按钮')
			
			
			local gift =LMTargetClient.lm_target_table.gifts[i]
			
			--目标
			desc:Clear()
			desc:ParseContext(gift.description)
			
			--奖励
			--API_Trace(cjson.encode(gift))
			local moneycount =math.floor(gift.rewards[1].nums)
			money:Clear()
			money:ParseContext(moneycount.."#(image,8503)   +")
			for i = 1, vbmgr:GetSize() do
				local vb = vbmgr:GetViewBox(i-1)
				
				if gift.rewards[i+1] ~= nil and gift.rewards[i+1].rewardtype == "goods" then
					vb:SetVisible(true)
					if gift.rewards[i+1].quality == -1 then
						vb:SetItem(gift.rewards[i+1].id,gift.rewards[i+1].nums)
					else
						vb:SetItem(gift.rewards[i+1].id,gift.rewards[i+1].nums,false,gift.rewards[i+1].quality)
					end
				else
					vb:SetVisible(false)
				end				
			end
			
			--领取状态
			if gift.canget == 0 then
				sb:SetVisible(false)
				btn:SetVisible(true)
				btn:SetEnabled(false)
			elseif gift.canget == 1 then
				sb:SetVisible(false)
				btn:SetVisible(true)
				btn:SetEnabled(true)
				canGet 	= canGet+1
			elseif gift.canget == 2 then
				alreadyGet = alreadyGet+1
				sb:SetVisible(true)
				btn:SetVisible(false)
			end
		end
	end	
	
	--进度
	local rect = LMTargetClient.progress_sb:GetWindowXRect()
	local length = math.floor(245*alreadyGet/total_gift)
	rect.right = rect.left + length;
	LMTargetClient.progress_sb:SetWindowRect(rect)	
	
	LMTargetClient.progress_html:Clear()
	LMTargetClient.progress_html:ParseContext(alreadyGet.."/"..total_gift)
	
	if canGet> 0 then
		LMClient.get_reward_btn:PlayAni(true)
	else
		LMClient.get_reward_btn:PlayAni(false)
	end
end

LMTargetClient.msg_handler = msg_handler2
LMTargetClient.on_show = on_show2
LMTargetClient.on_btn_lmt_lingqu = on_btn_lmt_lingqu
LMTargetClient.cb_get_gift_cfg = cb_get_gift_cfg
LMTargetClient.lm_target_init = lm_target_init
