﻿local Peach_Wnd_ID = 822

local moduleName 	= 'peach'

local Peach = {}

local Peach_Wnd		= nil	

local m_Panel3k 	= nil
local m_Panel6k 	= nil
local m_Panel9k 	= nil

local m_Viewbox3k 	= nil
local m_Viewbox6k 	= nil
local m_Viewbox9k 	= nil

local m_html3k		= nil

local m_btnGet1		= nil

local m_peachAi		= {}

------蟠桃园物品预览配置 	物品ID，个数
local Peach_Goods_List = {
	[9] = {28031,150,28032,1,28033,1},		----9千年
	[6] = {28031,20,28034,1,28035,1},		----6千年
	[3] = {28036,1, 21053,1,21005,1},		----3千年
}

local PeachWnd_Event_Get2	= 82201		-----摘取蟠桃园的消息
local PeachWnd_Event_Get3 	= 82202

-----------------------------------------------------蟠桃园抽奖窗口--------------------------------------------------------------------------------------
------初始化窗口
function Peach_wnd_init()
	--注册消息
    api_reg_module_msg_handler(moduleName, Peach_msg_handler)
	
	Peach_Wnd = core.createWindow('Data/Scp/Windows/Windows_Activity.scp',Peach_Wnd_ID)
	
	local PanelMgr3K = Peach_Wnd:GetPanelMgr('PanelMgr3K')
	local PanelMgr6K = Peach_Wnd:GetPanelMgr('PanelMgr6K')
	local PanelMgr9K = Peach_Wnd:GetPanelMgr('PanelMgr9K')
	
	m_Panel3k = PanelMgr3K:GetPanelWnd(0)
	m_Panel6k = PanelMgr6K:GetPanelWnd(0)
	m_Panel9k = PanelMgr9K:GetPanelWnd(0)
	
	m_Viewbox3k = m_Panel3k:GetViewBoxMgr('物品栏')
	m_Viewbox6k = m_Panel6k:GetViewBoxMgr('物品栏')
	m_Viewbox9k = m_Panel9k:GetViewBoxMgr('物品栏')
	
	----3千年蟠桃物品初始化
	for i = 1, m_Viewbox3k:GetSize() do
		local vb = m_Viewbox3k:GetViewBox(i-1)
		if i <= #Peach_Goods_List[3]/2 then
			vb:SetItem(Peach_Goods_List[3][i*2-1],Peach_Goods_List[3][i*2],false)
		else
			vb:ClearItem()
		end
	end
	
	----6千年蟠桃物品初始化
	for i = 1, m_Viewbox6k:GetSize() do
		local vb = m_Viewbox6k:GetViewBox(i-1)
		if i <= #Peach_Goods_List[6]/2 then
			vb:SetItem(Peach_Goods_List[6][i*2-1],Peach_Goods_List[6][i*2],false)
		else
			vb:ClearItem()
		end
	end
	
	----9千年蟠桃物品初始化
	for i = 1, m_Viewbox9k:GetSize() do
		local vb = m_Viewbox9k:GetViewBox(i-1)
		if i <= #Peach_Goods_List[9]/2 then
			vb:SetItem(Peach_Goods_List[9][i*2-1],Peach_Goods_List[9][i*2],false)
		else
			vb:ClearItem()
		end
	end
	
	m_btnGet1 = m_Panel3k:GetButton('摘取按钮')
	local btnGet2 = m_Panel6k:GetButton('摘取按钮')
	local btnGet3 = m_Panel9k:GetButton('摘取按钮')
	
	m_peachAi[1] = m_Panel3k:GetAni('效果')
	m_peachAi[2] = m_Panel6k:GetAni('效果')
	m_peachAi[3] = m_Panel9k:GetAni('效果')
	
	m_peachAi[1]:PlayAni(true)
	
	m_html3k = m_Panel3k:GetHtml('html')
	
	m_html3k:Clear()
	
	m_btnGet1:SetLuaEvent(XWIN_EVENT_CLICK, 'Peach_OnBtnGetReward1')
	btnGet2:SetLuaEvent(XWIN_EVENT_CLICK, 'Peach_OnGetReward2Ask')
	btnGet3:SetLuaEvent(XWIN_EVENT_CLICK, 'Peach_OnGetReward3Ask')
	
	Peach_Wnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT,OnPeachWndEvent)
	
	--Peach_Wnd:SetLuaEvent(XWIN_EVENT_SHOW,'Peach_OnShowWnd')
	Peach_Wnd:SetShowEventHandler2(function() timer.setTimer('peach_flush_time', Peach_Wnd_ID, 800) end)
	Peach_Wnd:SetHideEventHandler2(function() timer.killTimer('peach_flush_time',Peach_Wnd_ID) end)
	
end

-- function Peach_OnShowWnd()
	-- local shopMainWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1032)
	--XWinUtil:AlignWindow(shopMainWnd, Peach_Wnd,  XWinUtil.enXUAlign_RIGHT_RIGHT, XWinUtil.enXUAlign_TOP_TOP, 80, 0, 10, 0, false);
    -- XWinUtil:AlignWindow(shopMainWnd, Peach_Wnd,  XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 22,0, 78,  0,false);
-- end	
function OnPeachWndEvent(pWnd,event,eventID,param1,param2)
	if eventID == PeachWnd_Event_Get2 then
		Peach_OnBtnGetReward2()
	elseif eventID == PeachWnd_Event_Get3 then
		Peach_OnBtnGetReward3()
	end
end

function Peach_OnBtnGetReward1()
	local msg_type = 1
	Peach.SendMsgToServer(msg_type)
end

function Peach_OnBtnGetReward2(nBtnIdx, useData)
	if nBtnIdx == 1 then
		local msg_type = 2
		Peach.SendMsgToServer(msg_type)
	end
end

function Peach_OnGetReward2Ask()
	MsgAskBox.ShowAskBox("你确定要使用#(GoldIngot,100)摘取6千年蟠桃吗？", "Peach3K", Peach_OnBtnGetReward2,0)
end


function Peach_OnBtnGetReward3(nBtnIdx, useData)
	if nBtnIdx == 1 then
		local msg_type = 3
		Peach.SendMsgToServer(msg_type)
	end
end

function Peach_OnGetReward3Ask()
	MsgAskBox.ShowAskBox("你确定要使用#(GoldIngot,300)摘取9千年蟠桃吗？", "Peach9K",Peach_OnBtnGetReward3,0)
end

local function SendMsgToServer(msg_type)
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'peach_GetReward'
	msg.type = msg_type
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

local function OnOpenRewardWnd(msg)
	local rewardGoods = {}
	for k,v in pairs(msg.goodsList) do
		rewardGoods[k] = {v[1], v[2]}
	end
	Peach_OnShowReward(msg.RewardDesc, rewardGoods)
end

function peach_flush_time()
	local hero = core.getHero()
	if hero == nil then
		return
	end
	local lastTime = hero:GetCrtProp(enProp_Actor_Peach1_Last_time)
	local nowTime = XDate:GetInstance():GetCurrentVTime()
	local times = hero:GetCrtProp(enProp_Actor_Peach1_GetNum)
	m_html3k:Clear()
	--API_Trace("lastTime "..lastTime.." nowTime "..nowTime.." theTIme "..(nowTime-lastTime))
	
	if XDate:GetInstance():IsSameDay(nowTime, lastTime) == false then
		m_html3k:ParseContext("#(color,orange)可摘#(color,restore)")
		--m_peachAi[1]:PlayAni(true)
		m_btnGet1:PlayAni(true)
		m_btnGet1:SetEnabled(true)
		return
	end
	
	if times >= 10 then
		m_html3k:ParseContext('摘完')--("#(color,%%85,85,85%%)摘完#(color,restore)")
		--m_peachAi[1]:PlayAni(false)
		m_btnGet1:PlayAni(false)
		m_btnGet1:SetEnabled(false)
		return
	end
		
	if nowTime - lastTime >= 20*60 then
		m_html3k:ParseContext("#(color,orange)可摘#(color,restore)")
		--m_peachAi[1]:PlayAni(true)
		m_btnGet1:PlayAni(true)
		m_btnGet1:SetEnabled(true)
	else
		needTime = 20*60 - (nowTime - lastTime)
		local strTime = ""
		if needTime/60 < 10 then
			strTime = "0"..math.floor(needTime/60)..":"..(needTime-math.floor(needTime/60)*60)
		else
			strTime = math.floor(needTime/60)..":"..(needTime-math.floor(needTime/60)*60)
		end
		m_html3k:ParseContext('#(color,pinzhiblue)'..strTime..'#(color,restore)')
		--m_peachAi[1]:PlayAni(false)
		m_btnGet1:PlayAni(false)
		m_btnGet1:SetEnabled(false)
	end
end

---网络消息处理
function Peach_msg_handler(msg)
	if msg.msg_code == 'OnShowReward' then
		Peach.OnOpenRewardWnd(msg)
	end
end

-----------------------------------------------------抽奖结果显示窗口-----------------------------------------------------------------------

local Reward_Show_Wnd = nil
local Peach_ShowReward_Wnd_ID = 826
local Reward_btn_close = nil

local Reward_wnd = {}
local Goods1 = {}
local Goods2 = {}
local Goods3 = {}

function Peach_Reward_wnd_init()
	--注册消息
    api_reg_module_msg_handler(moduleName, Peach_msg_handler)
	
	Reward_Show_Wnd = core.createWindow('Data/Scp/Windows/Windows_Activity.scp',Peach_ShowReward_Wnd_ID)
	
	Reward_btn_close = Reward_Show_Wnd:GetButton('关闭')
	
	Reward_btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'Reward_OnClose')
	local viewboxMgr1 = Reward_Show_Wnd:GetViewBoxMgr('物品1')
	local viewboxMgr2 = Reward_Show_Wnd:GetViewBoxMgr('物品2')
	Goods1.viewbox 	= viewboxMgr2:GetViewBox(0)
	Goods1.label	= Reward_Show_Wnd:GetLabel('奖励物品名')
	Goods2.viewbox 	= viewboxMgr1:GetViewBox(0)
	Goods2.label	= Reward_Show_Wnd:GetLabel('奖励物品名1')
	Goods3.viewbox 	= viewboxMgr1:GetViewBox(1)
	Goods3.label	= Reward_Show_Wnd:GetLabel('奖励物品名2')
	
end

function Reward_OnClose()
	Reward_Show_Wnd:SetVisible(false)
	----通知黄粱梦界面的奖励领取了
	WndSystem:GetInstance():OnEvent(985,985003,0,0)
end

function Peach_OnShowReward(goodsDesc, goodsList)
	local color = XColor:new(255,255,255)
	if #goodsList == 1 then
	
		Goods1.label:SetVisible(true)
		Goods1.viewbox:SetVisible(true)
	
		local goods_cfg = core.getGoodsConfig(goodsList[1][1])
		Goods1.label:setText(goods_cfg.szName)
		Goods1.viewbox:SetItem(goodsList[1][1], goodsList[1][2])
		Goods1.viewbox:Set_RB_Color(color)
		
		Goods2.viewbox:SetVisible(false)
		Goods2.label:SetVisible(false)
		Goods3.viewbox:SetVisible(false)
		Goods3.label:SetVisible(false)
	else
		Goods1.label:SetVisible(false)
		Goods1.viewbox:SetVisible(false)
		
		local goods_cfg1 = core.getGoodsConfig(goodsList[1][1])
		Goods2.label:setText(goods_cfg1.szName)
		Goods2.viewbox:SetItem(goodsList[1][1], goodsList[1][2])
		Goods2.viewbox:Set_RB_Color(color)
		
		local goods_cfg2 = core.getGoodsConfig(goodsList[2][1])
		Goods3.label:setText(goods_cfg2.szName)
		Goods3.viewbox:SetItem(goodsList[2][1], goodsList[2][2])
		Goods3.viewbox:Set_RB_Color(color)
		
		Goods2.viewbox:SetVisible(true)
		Goods2.label:SetVisible(true)
		Goods3.viewbox:SetVisible(true)
		Goods3.label:SetVisible(true)
	end
	
	local rect = WndSystem:GetInstance():GetGameDesktop():GetWindowXRect()
	Reward_Show_Wnd:SetWindowRect(rect)
	Reward_Show_Wnd:SetVisible(true)
end

---------------------初始化窗口--------------------
Peach_wnd_init()
Peach_Reward_wnd_init()

Peach.SendMsgToServer = SendMsgToServer
Peach.OnOpenRewardWnd = OnOpenRewardWnd

---------------------神工商店、蟠桃园图标----------
local godworkshop		 	= {}	--本脚本一些窗口变量
godworkshop.wndsys			= nil	--窗口系统
godworkshop.desktop 		= nil	--桌面
godworkshop.mainwndid		= 1099	--主窗口ID
godworkshop.mainwnd			= nil	--主窗口
godworkshop.buttonid		= 10990	--按钮ID
godworkshop.animateid		= 10991	--光效ID
godworkshop.button			= nil	--按钮
godworkshop.init			= nil	--初始函数
godworkshop.animate			= nil	--光效
godworkshop.launch			= nil	--启动按钮点击函数
godworkshop.godworkwndid	= 1032	--神工商店窗口ID

local function godworkshop_init()
	--获取一些全局的窗口
	godworkshop.wndsys    = WndSystem:GetInstance()
	godworkshop.desktop   = godworkshop.wndsys:GetGameDesktop()
	
	--创建主窗口
	godworkshop.mainwnd	 = godworkshop.desktop:FindWindowByID(godworkshop.mainwndid) or core.createWindow('Data/Scp/Windows/Windows_Goods2.scp', godworkshop.mainwndid, false, g_pGlobal:GetMainUI():GetSystemIconSet(1, true))
	--获取按钮
	godworkshop.button = godworkshop.mainwnd:FindWindowByID(godworkshop.buttonid)
	--点击事件
	godworkshop.button:SetClickEventHandler2(godworkshop.launch)
	
	godworkshop.mainwnd:SetLuaEvent(XWIN_EVENT_SHOW, 'SetGodsShopAnimate')
end

local function godworkshop_onlaunch()
	godworkshop.wndsys:ShowWnd(godworkshop.godworkwndid, 1);
	godworkshop.animate:PlayAni(false)
end

function SetGodsShopAnimate()
	local hero = core.getHero()
	if hero == nil then
		return
	end
	godworkshop.animate = godworkshop.mainwnd:GetAni('flashanim')
	local lastTime = hero:GetCrtProp(enProp_Actor_Peach1_Last_time)
	local nowTime = XDate:GetInstance():GetCurrentVTime()
	local times = hero:GetCrtProp(enProp_Actor_Peach1_GetNum)
	
	if times < 10 and (nowTime - lastTime >= 20*60) then
		godworkshop.animate:PlayAni(true)
	else
		godworkshop.animate:PlayAni(false)
	end
end

godworkshop.init = godworkshop_init
godworkshop.launch = godworkshop_onlaunch

godworkshop.init()