﻿local pet_skill_goods_cfg =
{
	[0] = {25001,25002,25003,25004,25005,25006,25007,25008,25010,25011,25012,25013,25014,25015,25016,25017,25018,25019,25020},
	[1] = {25021,25022,25023,25024,25025,25026,25028,25029,25031,25032,25033,25034,25035,25036,25037,25038,25039,25040,25041,25042},
}

local pet_skill_intro		= {}
pet_skill_intro.main_wndid	= 1092
pet_skill_intro.peach_wndid = 1032
pet_skill_intro.wndsys		= nil
pet_skill_intro.desktop		= nil
pet_skill_intro.main_wnd	= nil
pet_skill_intro.flippage	= nil
pet_skill_intro.html_desc	= nil

function pet_skill_intro_refresh(index)
	local cfg = pet_skill_goods_cfg[index]
	local str = "#(linespace,1)"
	for i = 1, #cfg do
		local goods_cfg = core.getGoodsConfig(cfg[i])
		if goods_cfg then
			str = str .. "#(color,%%255,255,50%%)" .. goods_cfg.szName .. "#(color,restore): #(color,%%255,255,255%%)" .. goods_cfg.strDescDetail .. "#(color,restore)#(br,1)"
		end
	end
	pet_skill_intro.html_desc:Clear()
	pet_skill_intro.html_desc:ParseContext(str)
end

function pet_skill_intro_init()
	--获取一些窗口引用
	pet_skill_intro.wndsys   = WndSystem:GetInstance()
	pet_skill_intro.desktop  = pet_skill_intro.wndsys:GetGameDesktop()
	pet_skill_intro.main_wnd = pet_skill_intro.desktop:FindWindowByID(pet_skill_intro.main_wndid) or core.createWindow('Data/Scp/Windows/Windows_PetMain.scp', pet_skill_intro.main_wndid)
	pet_skill_intro.flippage = pet_skill_intro.main_wnd:GetFlipPage("切换页")
	local panelIntro = pet_skill_intro.main_wnd:GetPanel("技能书描述页")
	pet_skill_intro.html_desc= panelIntro:GetHtml("技能描述")
	local btnGoPeach = panelIntro:GetButton("去蟠桃园")
	local btnClose   = pet_skill_intro.main_wnd:GetButton("关闭按钮")
	
	btnGoPeach:SetClickEventHandler2(function() 
		pet_skill_intro.wndsys:ShowWnd(pet_skill_intro.peach_wndid, 1)
		pet_skill_intro.main_wnd:SetVisible(false)
	end)
	btnClose:SetClickEventHandler2(function() pet_skill_intro.main_wnd:SetVisible(false) end)
	
	for i = 0,pet_skill_intro.flippage:GetPageNum() - 1 do
		local btn = pet_skill_intro.flippage:GetPageBtnx(i)
		btn:SetClickEventHandler2(function() 
			local tag1 = btn:GetTag1()
			pet_skill_intro.flippage:TurnPage(tag1)
			pet_skill_intro_refresh(tag1)
		end)
	end
	
	pet_skill_intro_refresh(0)
end

pet_skill_intro_init()