--宠物乐园积分商店

local petparadise_shop_wnd = nil
local petparadise_shop_pointsnum = nil
local shop_ctrl_flip = nil
local module_name = 'petparadiseShop'
local petparadise_shop_wnd_id = 478
local pageindex = 1
local shopmainwnd = nil
local shopmainwndid = 480
local tabctrlflip = nil
local Message = nil

--初始化窗口
function PetParadiseShopInit()
	petparadise_shop_wnd = core.createWindow('Data/Scp/Windows/Windows_Task.scp', petparadise_shop_wnd_id)

	--petparadise_shop_wnd:SetLuaEvent(XWIN_EVENT_SHOW, 'PetParadiseShopGetGoodsList')
	petparadise_shop_pointsnum = petparadise_shop_wnd:GetLabel('积分数量')
	petparadise_shop_pointsnum:setText('0')
end

function PetParadiseShopMsgHandler(msg)
	if(msg.msg_code == 'OnShowGoodsList') then
		PetParadiseShopUpdateGoodsList(msg)
	elseif(msg.msg_code == 'OnBuyOK') then
		PetParadiseShopUpdatePointsNum(msg)
	end
end

function PetParadiseShopUpdateGoodsList(msg)
	Message = msg
	shopmainwnd:SetVisible(true)
	petparadise_shop_wnd:SetVisible(true)
	local pointsnum = msg.petparadisepoints
	petparadise_shop_pointsnum:setText(''..pointsnum)
	local panelmgr = petparadise_shop_wnd:GetScrollMgr('scrollmgr'):GetPanelMgr('panelmgr')
	local panelmgrcount = panelmgr:GetPanelCount()
	for i = 1, panelmgrcount do
		local panel = panelmgr:GetPanelWnd(i - 1)
		if(i <= #msg.goodslist[pageindex]) then
			local goodsinfo = msg.goodslist[pageindex][i]
			panel:SetVisible(true)
			--设置物品名
			local goodname = panel:GetLabel('name')
			local goodcfg = core.getGoodsConfig(goodsinfo.goodsID)
			goodname:setText(goodcfg.szName)
			--设置物品价格
			local goodprice = panel:GetLabel('积分数量')
			goodprice:setText(''..goodsinfo.price)
			--物品图标
			local goodicon = panel:GetItemViewBox('icon')
			goodicon:SetItem(goodsinfo.goodsID, goodsinfo.number, false, goodsinfo.quality)
			--兑换按钮
			local buybtn = panel:GetButton('兑换')
			buybtn:SetClickEventHandler('PetParadiseShopBuyHandler')
			buybtn:SetPropertyInt32('goodsID', goodsinfo.goodsID)
			buybtn:SetPropertyInt32('price', goodsinfo.price)
		else
			panel:SetVisible(false)
		end
	end
end

function PetParadiseShopUpdatePointsNum(msg)
	local pointsnum = msg.petparadisepoints
	local goodscfg = core.getGoodsConfig(msg.goodsid)
	petparadise_shop_pointsnum:setText(''..pointsnum)
	API_ShowSystemMessage(enSysMsgDisplayType_Float, "兑换"..goodscfg.szName.."成功，消耗宠物乐园积分"..msg.price.."点。")
end

--[[function PetParadiseShopGetGoodsList()
	local pointsnum = API_GetHeroPropNum(enProp_Actor_PetParadisePoints)
	petparadise_shop_pointsnum:setText(''..pointsnum)
	local msg = {}
	msg.module = module_name
	msg.msg_code = 'GetGoodsList'
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end
]]
function PetParadiseShopBuyHandler(wnd, event)
	local price = wnd:GetPropertyInt32('price')
	local goodsid = wnd:GetPropertyInt32('goodsID')
	local goodscfg = core.getGoodsConfig(goodsid)
	API_ShowMessageBox("是否使用#(color, orange)"..price.."积分#(color, restore)兑换#(color,orange)"..goodscfg.szName.."#(color,restore)", "", 0x0080, "PetParadiseConfirmBuy", goodsid, 0)
end

function PetParadiseConfirmBuy(msgid, wparam, lparam)
	if(msgid ~= WE_AW_MSGOK) then
		return
	end

	local msg = {}
	msg.module = module_name
	msg.goodsid = wparam
	msg.msg_code = 'BuyGoods'
	msg.pageindex = pageindex
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--初始化
PetParadiseShopInit()

-------------------------------------------------------------------------------------------------------------
--宠物乐园积分商店主窗口
-------------------------------------------------------------------------------------------------------------


--主窗口初始化
function PetParadiseShopMainWndInit()
	shopmainwnd = core.createWindow("Data/Scp/Windows/Windows_Task.scp", shopmainwndid)
	pageindex = 1
	tabctrlflip = shopmainwnd:GetFlipPage('切换页')
	local mainpagecount = tabctrlflip:GetPageNum()

	for i = 1, mainpagecount do
		local pagebtn = tabctrlflip:GetPageBtnx(i - 1)
		pagebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadiseShopMainWndFlipSwitch')
	end

	local closebtn = shopmainwnd:GetButton('关闭按钮')
	closebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadiseShopClose')

	local petshopwnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(petparadise_shop_wnd_id)
	XWinUtil:AlignWindow(shopmainwnd, petshopwnd,  XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 22,0, 78,  0,false)
	shopmainwnd:AddWindow(petshopwnd)

	shopmainwnd:SetVisible(false)
end

function PetParadiseShopMainWndFlipSwitch(wnd)
	pageindex = XButton:CastToButton(wnd):GetTag1()
	tabctrlflip:TurnPage(pageindex - 1)
	PetParadiseShopUpdateGoodsList(Message)
end

function PetParadiseShopClose()
	shopmainwnd:SetVisible(false)
	pageindex = 1
	tabctrlflip:TurnPage(pageindex - 1)
end

function PetParadiseShopSwitchPage(index)
	if subwndlist[index] == nil then
		API_Trace("PetParadise switch page index out of range")
		return
	end
end

PetParadiseShopMainWndInit()
api_reg_module_msg_handler(module_name, PetParadiseShopMsgHandler)


-------------------------------------------------------------------------------------------------------------
--宠物乐园等级窗口
-------------------------------------------------------------------------------------------------------------
local petparadiselevelwnd = nil
local petparadiselevellabel = nil
local currlevelentertimeslabel = nil
local petparadiselevelclose = nil

function PetParadiseLevelWndInit()
	petparadiselevelwnd = core.createWindow("Data/Scp/Windows/Windows_Task.scp", 483)
	petparadiselevellabel = petparadiselevelwnd:GetLabel('当前等级')
	currlevelentertimeslabel = petparadiselevelwnd:GetLabel('当前通关')
	petparadiselevelclose = petparadiselevelwnd:GetButton('关闭按钮')
	petparadiselevelclose:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadiseLevelWndClose')
	petparadiselevelwnd:SetVisible(false)
end

function PetParadiseLevelWndMsgHandler(msg)
	if(msg.msg_code == 'ShowLevelWnd') then
		PetParadiseLevelWndShow(msg)
	end
end

function PetParadiseLevelWndShow(msg)
	petparadiselevellabel:setText(''..msg.level)
	currlevelentertimeslabel:setText(''..msg.currleveltimes)
	petparadiselevelwnd:SetVisible(true)
end

function PetParadiseLevelWndClose()
	petparadiselevelwnd:SetVisible(false)
end

PetParadiseLevelWndInit()
api_reg_module_msg_handler('petparadiselevelwnd', PetParadiseLevelWndMsgHandler)
-------------------------------------------------------------------------------------------------------------
--宠物乐园规则窗口
-------------------------------------------------------------------------------------------------------------
local petparadiserulewnd = nil
local petparadiseruleclose = nil

function PetParadiseRuleWndInit()
	petparadiserulewnd = core.createWindow("Data/Scp/Windows/Windows_Task.scp", 484)
	petparadiseruleclose = petparadiserulewnd:GetButton('关闭按钮')
	petparadiseruleclose:SetLuaEvent(XWIN_EVENT_CLICK, 'PetParadiseRuleWndClose')
	petparadiserulewnd:SetVisible(false)
end

function PetParadiseRuleWndMsgHandler(msg)
	if(msg.msg_code == 'ShowRuleWnd') then
		PetParadiseRuleWndShow(msg)
	end
end

function PetParadiseRuleWndShow(msg)
	petparadiserulewnd:SetVisible(true)
end

function PetParadiseRuleWndClose()
	petparadiserulewnd:SetVisible(false)
end

PetParadiseRuleWndInit()
api_reg_module_msg_handler('petparadiserulewnd', PetParadiseRuleWndMsgHandler)