---------------------------------------------------------------------------------------------------------------------
--文件名:	pvp_act_zhengba_target.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.12.3
--版  本:	1.0
--描  述:	仙界争霸目标
----------------------------------------------------------------------------------------------------------------------
--**********************************************************--
------------------------天梯奖励窗口------------------------------
ZBTargetClient = {} 
ZBTargetClient.this_wnd 				= nil  	--自己
ZBTargetClient.panel_mgr = nil
ZBTargetClient.target_table = nil

ZBTargetClient.module_name = "ACT_ZB_TARGET_GIFT"



--模块初始化
local  function zb_target_init()	
	--创建窗口
	ZBTargetClient.this_wnd = core.createWindow('Data/Scp/Windows/Windows_Zhengba.scp',1086)
	
	local scroll_mgr = ZBTargetClient.this_wnd:GetScrollMgr('滚动管理')
	ZBTargetClient.panel_mgr = scroll_mgr:GetPanelMgr('礼包列表')
	for i=1,ZBTargetClient.panel_mgr:GetPanelCount() do
		local panel = ZBTargetClient.panel_mgr:GetPanelWnd(i-1)
		panel:SetVisible(false)
		
		local btn = panel:GetButton('领取按钮')
		btn:SetTag1(i)
		btn:SetClickEventHandler2(ZBTargetClient.on_btn_lingqu)
	end
	
	--打开的时候触发刷新界面，这里天梯窗口打开的时候也触发下，要更新按钮的状态
	WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1028):SetShowEventHandler2(ZBTargetClient.on_show)
	ZBTargetClient.this_wnd:SetShowEventHandler2(ZBTargetClient.on_show)
	
	ZBTargetClient.this_wnd:GetButton('btn_close'):SetClickEventHandler2( function ( wnd, event) 	
										WndSystem:GetInstance():ShowWnd(1086,0)
										end)
										
	--注册网络消息
	api_reg_module_msg_handler(ZBTargetClient.module_name,ZBTargetClient.msg_handler)
end

local function on_show2()
	local msg = {}
	msg.module   = ZBTargetClient.module_name
	msg.msg_code = "get_gift_cfg"
	if ZBTargetClient.target_table ~= nil then
		msg.only_need_status = true
	end
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--领取按钮
local function on_btn_lingqu(wnd)
	local index = XButton:CastToButton(wnd):GetTag1()
	if ZBTargetClient.target_table.gifts[index] ~= nil then
		local msg = {}
		msg.module   = ZBTargetClient.module_name
		msg.msg_code = "get_gift"
		msg.gift_id = ZBTargetClient.target_table.gifts[index].id
		local jsonstr = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(jsonstr)	
	end
end

--接收网络消息
local function msg_handler2(msg)
	if (msg.msg_code=="get_gift_cfg") then
		ZBTargetClient.cb_get_gift_cfg(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end

local function cb_get_gift_cfg(msg)
	if msg.only_need_status == nil then
		ZBTargetClient.target_table = msg.target_table
	else
		for i=1,#msg.target_table.gifts do
			ZBTargetClient.target_table.gifts[i].canget = msg.target_table.gifts[i].canget
		end
	end
	
	--奖励mgr
	local total_gift = #ZBTargetClient.target_table.gifts
	local alreadyGet = 0 --已经获取数
	local canGet = 0 --可以获取数
	for i=1,ZBTargetClient.panel_mgr:GetPanelCount() do
		local panel = ZBTargetClient.panel_mgr:GetPanelWnd(i-1)
		
		if i>#ZBTargetClient.target_table.gifts then
			panel:SetVisible(false)
		else
			panel:SetVisible(true)
			
			local title_sb = panel:GetStaticBitmap("称号图片")
			local desc = panel:GetHtml("条件")
			local money = panel:GetHtml("金币值")
			local sb = panel:GetStaticBitmap('已领图片')
			local btn = panel:GetButton('领取按钮')
			
			local gift =ZBTargetClient.target_table.gifts[i]
			
			--称号图片,这里需要缩放下，不然放不下
			local bmp = g_pGlobal:GetResourceMgr():RequestIcon2(gift.iconId)
			if bmp ~= nil then
				local cxt = XDrawCxt:new()
				cxt.scalex = 120/bmp:GetWidth()
				cxt.scaley = cxt.scalex
				title_sb:SetBitmapIcon(gift.iconId,cxt)
			end
			
			
			--目标
			desc:Clear()
			desc:ParseContext(gift.description)
			
			--奖励
			local moneycount =math.floor(gift.rewards[1].nums)
			money:Clear()
			money:ParseContext(moneycount.."#(image,8507)")
			
			--领取状态
			if gift.canget == 0 then
				sb:SetVisible(false)
				btn:SetVisible(true)
				btn:SetEnabled(false)
			elseif gift.canget == 1 then
				sb:SetVisible(false)
				btn:SetVisible(true)
				btn:SetEnabled(true)
				canGet 	= canGet+1
			elseif gift.canget == 2 then
				alreadyGet = alreadyGet+1
				sb:SetVisible(true)
				btn:SetVisible(false)
			end
		end
	end	
	
	--能领取的话，仙界争霸的主界面上应该显示个高亮光效
	if canGet> 0 then
		ZBClient.this_wnd:GetButton("称号"):PlayAni(true)
	else
		ZBClient.this_wnd:GetButton("称号"):PlayAni(false)
	end
end

ZBTargetClient.msg_handler = msg_handler2
ZBTargetClient.on_show = on_show2
ZBTargetClient.on_btn_lingqu = on_btn_lingqu
ZBTargetClient.cb_get_gift_cfg = cb_get_gift_cfg
ZBTargetClient.init = zb_target_init

