﻿local sign_wnd_ID 	= 821

local moduleName = 'sign'

local sign 		= {}
local sign_wnd	= nil

local m_GetBtn = nil
local BitmapList = {}
local LabelNameList = {}
local viewboxList = {}

----初始化窗口-----
function sign_wnd_init()
	--注册消息
    api_reg_module_msg_handler(moduleName, sign_msg_handler)
	
	sign_wnd = core.createWindow('Data/Scp/Windows/Windows_Activity.scp', sign_wnd_ID)
	
	m_GetBtn = sign_wnd:GetButton('领取奖励')
	m_GetBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'sign_OnBtn_GetReward')
	sign_wnd:SetShowEventHandler('sign_OnShowWnd_request')
	viewboxmgr = sign_wnd:GetViewBoxMgr('viewboxMgr1')
	
	for i=1, 5 do
		BitmapList[i] = sign_wnd:GetStaticBitmap('已签到'..i)
		LabelNameList[i] = sign_wnd:GetLabel('day'..i)
		viewboxList[i] = viewboxmgr:GetViewBox(i-1)
		BitmapList[i]:SetVisible(false)
	end
end

function sign_OnShowWnd_request()
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'GetSignGoodsList'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

function sign_OnBtn_GetReward()
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'GetSignReward'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
	WndSystem:GetInstance():ShowWnd(820,0);
end

----消息处理
function sign_msg_handler(msg)
	if msg.msg_code == "ShowSignWnd" then
		sign.Sign_OnShowSign_wnd(msg)
	elseif msg.msg_code == "SignRewardGetOK" then
		sign.SignRewardGetOK(msg)
	end
end

local function SignRewardGetOK(msg)
	m_GetBtn:SetEnabled(false)
	local SignTimes = core.getHero():GetCrtProp(enProp_Actor_Sign_Flag)
	for i=1, 5 do 
		BitmapList[i]:SetVisible(SignTimes+1 > i)
	end
end

local function Sign_OnShowSign_wnd(msg)
	if sign_wnd:IsVisible() == false then
		WndSystem:GetInstance():ShowWnd(820, 1)
	end
	local hero = core.getHero()
	local SignTimes = hero:GetCrtProp(enProp_Actor_Sign_Flag)
	
	local lastSignTime	= hero:GetCrtProp(enProp_Actor_Sign_Last_time)
	
	for i=1, 5 do
		BitmapList[i]:SetVisible(SignTimes+1 > i)
		local goods_cfg = core.getGoodsConfig(msg.goodsList[i].goodsID)
		LabelNameList[i]:setText(goods_cfg.szName)
		viewboxList[i]:ClearItem()
		viewboxList[i]:SetItem(msg.goodsList[i].goodsID, msg.goodsList[i].num, false, 0)
	end
	
	-----判断今天是否已经签到 已签到 领取按钮变灰
	if XDate:GetInstance():IsSameDay(XDate:GetInstance():GetCurrentVTime(), lastSignTime) == true then	----今天已经签到
		m_GetBtn:SetEnabled(false)
	else
		m_GetBtn:SetEnabled(true)
		if SignTimes == 5 then
			for i=1, #BitmapList do
				BitmapList[i]:SetVisible(false)
			end
		end
	end
	
	
end

----初始化窗口-----
sign_wnd_init()

sign.Sign_OnShowSign_wnd	= Sign_OnShowSign_wnd
sign.SignRewardGetOK 		= SignRewardGetOK