---------------------------------------------------------------------------------------------------------------------
--文件名:	VipClient.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2014.1.3
--版  本:	2.0
--描  述:	vip客户端
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("VipClient",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
local modName = "VipClient"
cfg = {}
curviplevel =0
nextLvLeft = 0
tempviplevel = 0
curNeedMoney = 0
local updateTime = 0
--*常量 end**********************************************************--


--*3 变量************************************************************--
--*变量 end**********************************************************--


--*4 函数实现********************************************************--
--接网络消息
function MsgHandler(msg)
	if msg.msg_code == 'cb_vipgiftlist' then
		RequestCfg(msg)
	elseif msg.msg_code == 'OnBuyOK' then
		OnBuyOK(msg)
	end
end

--发网络消息，请求打开随身仓库
function MsgDispatchRequestCfg()
	local ret = {}
	ret.module	= "ACT_VIP_GIFT"
	ret.msg_code= "get_vipgiftlist"
	ret.updatetime= updateTime
	local jsonstr = cjson.encode(ret)
	g_pGlobal:SendScriptMsg(jsonstr)
end


--发网络消息，获取vip的配置表
function MsgDispatchOpenWarehouse()
	local ret = {}
	ret.module	= "ACT_VIP_GIFT"
	ret.msg_code= "open_warehouse"
	local jsonstr = cjson.encode(ret)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发网络消息，领取vip礼包
function MsgDispatchGetVipGift(vipGiftLv)
	if cfg[vipGiftLv] == nil then
		API_Trace(modName.." error.MsgDispatchGetVipGift() cfg[vipGiftLv] == nil ")
	end
	local ret = {}
	ret.module	= "ACT_VIP_GIFT"
	ret.msg_code= "get_vipgift"
	ret.updatetime = updateTime
	ret.vip_level_id = cfg[vipGiftLv].id
	local jsonstr = cjson.encode(ret)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function RequestCfg(msg)
	updateTime = msg.updatetime
	
	--刷新配置
	if #cfg == 0 then
		cfg = msg.giftlist.gifts
	else
		for k,v in pairs(cfg) do
			for k2,v2 in pairs(msg.giftlist.gifts) do
				if v.id == v2.id then
					v.canget = v2.canget
				end
			end
		end
	end
	
	curviplevel = msg.giftlist.curviplevel
	nextLvLeft = msg.giftlist.nextlevelleft
	tempviplevel = msg.giftlist.tempviplevel
	curNeedMoney = msg.giftlist.curNeedMoney
	--API_Trace(" "..cjson.encode(cfg).." "..curNeedMoney.." "..nextLvLeft.." "..tempviplevel.." "..curNeedMoney)
	--刷新界面
	VipMainWnd.FlashWnd()
	
	local wParam = 0 --判断是否有可领取的vip礼包
	for k,v in pairs(cfg) do
		if v.canget == 1 then -- UnGet 0 ,CanGet 1,IsGet 2
			wParam = 1
			break
		end
	end
	WndSystem:GetInstance():OnEvent(55, 81503, wParam, 0)	
end

--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
--注册网络消息
api_reg_module_msg_handler("ACT_VIP_GIFT",MsgHandler)

--玩家创建的action
g_pGlobal:GetEventServer():onAction(make_msgid(CIRCULTYPE_CSC, MSG_ACTION_HERO_BORN), 
	function(obj,msgid)
		MsgDispatchRequestCfg()
	end)
	
--rawset(_G,"xxxxx",xxxxxxx)--把函数设置成全局的
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--
API_LoadScript("Data\\Scp\\Lua\\window\\vip\\VipMainWnd.lua")		--vip主窗口
API_LoadScript("Data\\Scp\\Lua\\window\\vip\\VipAllDescWnd.lua")	--全部特权描述窗口
--*加载子模块 end****************************************************--

