---------------------------------------------------------------------------------------------------------------------
--文件名:	VipMainWnd.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2014.1.3
--版  本:	1.0
--描  述:	vip主窗口
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("VipMainWnd",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
local modName = "VipMainWnd"
local thisWnd = nil
--*常量 end**********************************************************--


--*3 变量************************************************************--
--*变量 end**********************************************************--


--*4 函数实现********************************************************--
function init()
	--创建窗口
	thisWnd = core.createWindow('Data/Scp/Windows/Windows_VipGift.scp',872)
	
	--关闭按钮
	thisWnd:GetButton('关闭按钮'):SetClickEventHandler2(function()
			thisWnd:SetVisible(false)
		end)
	
	--充值按钮
	thisWnd:GetButton('充值按钮'):SetClickEventHandler2(function()
			g_pGlobal:GetGoodsClient():Recharge()
		end)
	
	--全部特权显示按钮
	thisWnd:GetButton('全部特权'):SetClickEventHandler2(function()
			WndSystem:GetInstance():ShowWnd(873,1)
		end)
	
	--随身仓库
	thisWnd:GetButton('随身仓库'):SetClickEventHandler2(function()
			local hero = core.getHero()
			if hero == nil then return  end
			
			if hero:GetVipLevel() < 4 then
				API_ShowSystemMessage(enSysMsgDisplayType_Float, "达到VIP4才能使用随身仓库")
				return
			end

			--向服务器请求打开玩家的随身仓库
			VipClient.MsgDispatchOpenWarehouse()
			
			thisWnd:SetVisible(false)
		end)
	
	--显示的时候
	thisWnd:SetShowEventHandler2(function()
			--向服务器获取礼包的领取状态
			VipClient.MsgDispatchRequestCfg()
			
			--滚动到对应的vip的页面
			local hero = core.getHero()
			if hero == nil then return  end
			
			local  vipLv = hero:GetVipLevel()
			vipLv = ((vipLv-1) >=0 and (vipLv-1)) or 0
			thisWnd:GetScrollMgr("滚动管理"):SetChunkNo(vipLv)
			local pointmgr = thisWnd:GetPanelMgr('pointMgr')
			for i=1,pointmgr:GetPanelCount() do
				local panel = pointmgr:GetPanelWnd(i-1)
				local btn = panel:GetButton("pointBtn")
				if vipLv == (i-1) then
					btn:SetManualRestore(true);
					btn:SetState(BS_DOWN);
				else
					btn:SetManualRestore(false);
					btn:SetState(BS_UP);
				end
			end
		end)
	
	--领取按钮
	local srcollmgr = thisWnd:GetScrollMgr('滚动管理')
	local panelmgr = srcollmgr:GetPanelMgr('列表框')
	for i=1,panelmgr:GetPanelCount() do
		local panel = panelmgr:GetPanelWnd(i-1)
		
		--让viewbox的消息能传到滚动控件
		local vbMgr = panel:GetViewBoxMgr("奖励管理器")
		for j=1, vbMgr:GetSize() do
			local vb = vbMgr:GetViewBox(j-1)
			vb:ClearItem()
			vb:SetVisible(false)
			vb:SetEventToWindow(srcollmgr)
		end
		
		panel:GetButton('领取'):SetClickEventHandler2(OnBtnLingqu)
		panel:GetButton('领取'):SetVisible(false)
	end
	
	--滚动翻页的问题
	srcollmgr:SetLuaEvent2(XWIN_EVENT_CHUNK_TO,OnChunkTo)
	OnChunkTo()--初始化，滚到第一页
end

--vip礼包页滑动了
function OnChunkTo()
	local srcollmgr = thisWnd:GetScrollMgr('滚动管理')
	local pointmgr = thisWnd:GetPanelMgr('pointMgr')
	local n = srcollmgr:GetChunkNo()
	if n < 0 or pointmgr == nil then 
		return
	end
	
	for i=1,pointmgr:GetPanelCount() do
		local panel = pointmgr:GetPanelWnd(i-1)
		local btn = panel:GetButton("pointBtn")
		if n == (i-1) then
			btn:SetManualRestore(true);
			btn:SetState(BS_DOWN);
		else
			btn:SetManualRestore(false);
			btn:SetState(BS_UP);
		end
	end
end

--点击了某个礼包页的按钮
function OnBtnLingqu(pWnd)
	local srcollmgr = thisWnd:GetScrollMgr('滚动管理')
	local panelmgr = srcollmgr:GetPanelMgr('列表框')
	for i=1,panelmgr:GetPanelCount() do
		local panel = panelmgr:GetPanelWnd(i-1)
		local lingquBtn = panel:GetButton('领取')
		
		if lingquBtn == XButton:CastToButton(pWnd)	then
			VipClient.MsgDispatchGetVipGift(i)
			break
		end
	end
end

local vip_level_icon_cfg =
{
	[1] = "Icon/8515.png",
	[2] = "Icon/8516.png",
	[3] = "Icon/8517.png",
	[4] = "Icon/8518.png",
	[5] = "Icon/8519.png",
	[6] = "Icon/8520.png",
	[7] = "Icon/8521.png",
	[8] = "Icon/8522.png",
	[9] = "Icon/8523.png",
	[10]= "Icon/8524.png",
}

--刷新界面
function FlashWnd()
	--当前vip
	local curVipLvHtml = thisWnd:GetHtml("当前Vip等级")
	curVipLvHtml:Clear()
	if VipClient.curviplevel == 0 then
		curVipLvHtml:ParseContext("#(color,%%255,241,0%%)您当前不是VIP玩家#(color,restore)")
	else
		curVipLvHtml:ParseContext("#(color,%%255,241,0%%)您当前级别#(color,restore)#(image,"..(8514+VipClient.curviplevel)..")")
	end
	
	--进度条
	local progressSb = thisWnd:GetStaticBitmap('进度图片')
	local rect = progressSb:GetWindowXRect()
	local lf = math.max(VipClient.curNeedMoney - VipClient.nextLvLeft,0)
	local length = math.floor(245*lf/VipClient.curNeedMoney)
	rect.right = rect.left + length;
	progressSb:SetWindowRect(rect)	
	
	--还差多少
	local nextLvLfHtml = thisWnd:GetHtml("提示元宝值")
	nextLvLfHtml:Clear()
	if VipClient.curviplevel ~= #VipClient.cfg then
		nextLvLfHtml:ParseContext("#(color,%%255,241,0%%)再冲"..VipClient.nextLvLeft.."#(color,restore)#(image,8506)#(color,%%255,241,0%%)您能晋升VIP"..(VipClient.curviplevel+1).."#(color,restore)")
	end
	
	--当前展示的VIP等级
	local curShowVIPLevel = math.max(1, math.min(10, VipClient.curviplevel));

	--当前特权图标
	local curVIPIcon = thisWnd:GetStaticBitmap("当前VIP特权图标")
	curVIPIcon:SetBitmap(vip_level_icon_cfg[curShowVIPLevel]);
	
	--当前特权
	local curDescHtml = thisWnd:GetHtml("当前特权")
	curDescHtml:Clear()
	for k,v in pairs(VipClient.cfg) do
		if v.viplevel == curShowVIPLevel then
			curDescHtml:ParseContext(v.description)
			break
		end
	end
	
	--礼包内容
	local srcollmgr = thisWnd:GetScrollMgr('滚动管理')
	local panelmgr = srcollmgr:GetPanelMgr('列表框')
	for i=1,panelmgr:GetPanelCount() do
		local panel = panelmgr:GetPanelWnd(i-1)
		local titleLabel = panel:GetLabel("标题")
		local vbMgr = panel:GetViewBoxMgr("奖励管理器")
		local lingquBtn = panel:GetButton("领取")
		
		--找到配置先
		local giftCfg = VipClient.cfg[i]
		
		if giftCfg == nil then 
			panel:SetVisible(false)
		else
			panel:SetVisible(true)
			
			--标题
			titleLabel:setText("VIP"..i.."礼包")
			
			--领取按钮的状态
			if giftCfg.canget == 0 then -- UnGet 0 ,CanGet 1,IsGet 2
				lingquBtn:SetVisible(true);
				lingquBtn:SetEnabled(false);
			elseif giftCfg.canget == 1 then 
				lingquBtn:SetVisible(true);
				lingquBtn:SetEnabled(true);
			elseif giftCfg.canget == 2 then 
				lingquBtn:SetVisible(false);
			end
			
			--viewbox
			local vbMgr = panel:GetViewBoxMgr("奖励管理器")
			for j=1, vbMgr:GetSize() do
				local vb = vbMgr:GetViewBox(j-1)
				local rewardCfg = giftCfg.rewards[j]
				vb:ClearItem()
				
				if rewardCfg == nil then
					vb:SetVisible(false)
				else
					vb:SetVisible(true)
					local  goodId = 0
					local  num = 0
					if rewardCfg.rewardtype == "money" then
						--钱是哪种，抵用金还是金币，还是经验,这里得转换成对应的物品Id
						if (rewardCfg.id == enNumResourceType_Gold) then -- 金币
							goodId = 20040;
							num = rewardCfg.nums;
						elseif (rewardCfg.id == enNumResourceType_Silver) then --游戏币
							goodId = 20041;
							num = rewardCfg.nums;
						elseif (rewardCfg.id == enNumResourceType_Exp) then -- 经验
							goodId = 20042;
							num = rewardCfg.nums;
						elseif rewardCfg.id == enNumResourceType_GoldIngot then -- 元宝
							goodId = 20043;
							num = rewardCfg.nums;
						elseif rewardCfg.id == enNumResourceType_Coffer_Gold then  --绑定元宝	
							goodId = 20044;
							num = rewardCfg.nums;
						elseif rewardCfg.id == 30 then --荣誉
							goodId = 20045;
							num = rewardCfg.nums;
						end
					
					elseif rewardCfg.rewardtype == "goods" then
						goodId = rewardCfg.id
						num = rewardCfg.nums
					end
					
					if rewardCfg.quality == nil then
						vb:SetItem(goodId,num)
					else
						vb:SetItem(goodId,num,false,rewardCfg.quality)
					end
					
				end
			end
		end
	end
end

--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
init()
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--

--*加载子模块 end****************************************************--

