--------------------公共------------------------
local warrior_trial = {}
--变量
warrior_trial.wndsys			= nil
warrior_trial.desktop			= nil
warrior_trial.modulename		= "ShiLianGu"

--函数
warrior_trial.init				= nil

--网络函数
warrior_trial.fun_on_net_msg	= nil
warrior_trial.req_is_in_map		= nil
warrior_trial.ret_is_in_map		= nil
warrior_trial.req_warrior_info	= nil
warrior_trial.ret_warrior_info	= nil
warrior_trial.req_reward_info	= nil
warrior_trial.ret_reward_info	= nil

--------------------启动图标--------------------
local warrior_trial_launch = {}
--变量
warrior_trial_launch.mainwndid	= 853
warrior_trial_launch.mainwnd	= nil

--函数
warrior_trial_launch.init		= nil
warrior_trial_launch.heroborn	= nil

--------------------主窗口----------------------
local warrior_trial_main = {}
--变量
warrior_trial_main.mainwndid		= 852
warrior_trial_main.cur_page			= 1
warrior_trial_main.levellist		= {}
warrior_trial_main.currentleveinfo	= {}

warrior_trial_main.mainwnd			= nil
warrior_trial_main.flippage			= nil

warrior_trial_main.panel_warrior	= nil
warrior_trial_main.lbl_curmaxlv		= nil
warrior_trial_main.lbl_maxlvactor	= nil
warrior_trial_main.cp_first_warrior	= nil
warrior_trial_main.actor_preview_btn= nil
warrior_trial_main.bmp_waiting		= nil
warrior_trial_main.warrior_ctrls	= nil

warrior_trial_main.panel_reward 	= nil
warrior_trial_main.reward_btns		= nil
warrior_trial_main.flip_reward		= nil
warrior_trial_main.lbl_mstname		= nil
warrior_trial_main.lbl_mstlv		= nil
warrior_trial_main.lbl_lvkingname	= nil
warrior_trial_main.lbl_lvkingtime	= nil
warrior_trial_main.lbl_capacity		= nil
warrior_trial_main.lbl_rewardexp	= nil
warrior_trial_main.lbl_rewardhonor	= nil
warrior_trial_main.html_dropgoods	= nil
warrior_trial_main.html_firstreward	= nil

--函数
warrior_trial_main.init				= nil
warrior_trial_main.clear			= nil
warrior_trial_main.switchpanel		= nil
warrior_trial_main.on_warrior_show	= nil
warrior_trial_main.on_reward_show	= nil
warrior_trial_main.update_warrior	= nil
warrior_trial_main.update_reward	= nil
warrior_trial_main.changerewardpage = nil
warrior_trial_main.refreshcurlevel  = nil
warrior_trial_main.on_click_preview = nil

--------------------公共函数--------------------
function warrior_trial.init()
	--获取一些窗口引用
	warrior_trial.wndsys  = WndSystem:GetInstance()
	warrior_trial.desktop = XDesktop:GetInstance()

	warrior_trial_launch.init()
	warrior_trial_main.init()
end

function warrior_trial.fun_on_net_msg(msg)
	if (msg.msg_code == "IsInMap") then
		warrior_trial.ret_is_in_map(msg)
	elseif (msg.msg_code == "WarriorInfo") then
		warrior_trial.ret_warrior_info(msg)
	elseif (msg.msg_code == "RewardInfo") then
		warrior_trial.ret_reward_info(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end

function warrior_trial.req_is_in_map()
	--请求是否在试炼谷副本里
	local msg = {}
	msg.module   = warrior_trial.modulename
	msg.msg_code = "IsInMap"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function warrior_trial.ret_is_in_map(msg)
	local icon_set = XFlowCtrlMgr:CastToFlowCtrlMgr(warrior_trial_launch.mainwnd:GetParent())
	if icon_set then
		icon_set:SetChildVisible(warrior_trial_launch.mainwndid, msg.isinmap or false)
	end
end

function warrior_trial.req_warrior_info()
	--查询第一勇士信息
	local msg = {}
	msg.module   = warrior_trial.modulename
	msg.msg_code = "WarriorInfo"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function warrior_trial.ret_warrior_info(msg)
	warrior_trial_main.update_warrior(msg.data)
end

function warrior_trial.req_reward_info(gamelv)
	--查询关卡奖励信息
	local msg = {}
	msg.module   = warrior_trial.modulename
	msg.msg_code = "RewardInfo"
	msg.gamelevel= gamelv or 0
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function warrior_trial.ret_reward_info(msg)
	warrior_trial_main.update_reward(msg.data)
end

--------------------启动图标函数----------------
function warrior_trial_launch.init()
	--注册网络消息
	api_reg_module_msg_handler(warrior_trial.modulename, warrior_trial.fun_on_net_msg)

	local icon_set = g_pGlobal:GetMainUI():GetSystemIconSet(1, true)
	warrior_trial_launch.mainwnd = icon_set:FindWindowByID(warrior_trial_launch.mainwndid) or core.createWindow('Data/Scp/Windows/Windows_WarriorTrial.scp', warrior_trial_launch.mainwndid, false, icon_set)
	
	--启动按钮
	local btn = warrior_trial_launch.mainwnd:GetButton("启动按钮")
	btn:SetClickEventHandler2(function()
		warrior_trial.wndsys:ToggleWnd(warrior_trial_main.mainwndid)
	end)
	
	api_reg_hero_all_data_ready_listen(warrior_trial_launch.heroborn)
end

function warrior_trial_launch.heroborn()
	warrior_trial.req_is_in_map()
end

--------------------主窗口函数------------------
function warrior_trial_main.init()
	--跨图清理
	api_reg_hero_all_data_ready_listen(warrior_trial_main.clear)

	warrior_trial_main.mainwnd = warrior_trial.desktop:FindWindowByID(warrior_trial_main.mainwndid) or core.createWindow('Data/Scp/Windows/Windows_WarriorTrial.scp', warrior_trial_main.mainwndid)
	
	warrior_trial_main.mainwnd:SetShowEventHandler2(function()
		warrior_trial_main.switchpanel(0)
	end)
	
	local btnClose = warrior_trial_main.mainwnd:GetButton("关闭")
	btnClose:SetClickEventHandler2(function()
		warrior_trial_main.mainwnd:SetVisible(false)
	end)
	
	--切换标签
	warrior_trial_main.flippage = warrior_trial_main.mainwnd:GetFlipPage("切换页")	
	for i = 1,warrior_trial_main.flippage:GetPageNum() do 
		local page_btn = warrior_trial_main.flippage:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler2(function()
			warrior_trial_main.switchpanel(page_btn:GetTag1())
		end)
	end

	warrior_trial_main.panel_warrior = warrior_trial_main.mainwnd:GetPanel("勇士专区面板")
	warrior_trial_main.panel_warrior:SetShowEventHandler2(warrior_trial_main.on_warrior_show)

	warrior_trial_main.lbl_curmaxlv		= warrior_trial_main.panel_warrior:GetLabel("最高关卡值")
	warrior_trial_main.lbl_curmaxlv:setText("")
	
	warrior_trial_main.lbl_maxlvactor	= warrior_trial_main.panel_warrior:GetLabel("关卡霸主值")
	warrior_trial_main.lbl_maxlvactor:setText("")

	warrior_trial_main.cp_first_warrior	= warrior_trial_main.panel_warrior:GetCreaturePreviewCtrl("角色预览")
	warrior_trial_main.cp_first_warrior:SetActorID(0)
	warrior_trial_main.cp_first_warrior:SetVisible(false)
	
	warrior_trial_main.actor_preview_btn = warrior_trial_main.panel_warrior:GetButton("角色预览按钮")
	warrior_trial_main.actor_preview_btn:SetClickEventHandler2(warrior_trial_main.on_click_preview)

	warrior_trial_main.bmp_waiting		= warrior_trial_main.panel_warrior:GetStaticBitmap("虚位以待")
	warrior_trial_main.bmp_waiting:SetVisible(true)

	warrior_trial_main.warrior_ctrls	= {}
	local scroll_mgr 	= warrior_trial_main.panel_warrior:GetScrollMgr("奖励滚动管理")
	local panels_mgr 	= scroll_mgr:GetPanelMgr("列表框")
	for i = 1,panels_mgr:GetPanelCount() do
		local ctrls = {}
		ctrls.panel = panels_mgr:GetPanelWnd(i - 1)
		ctrls.html  = ctrls.panel:GetHtml("说明")
		ctrls.vbmgr = ctrls.panel:GetViewBoxMgr("物品栏")

		ctrls.html:Clear()
		for j = 1,ctrls.vbmgr:GetSize() do
			ctrls.vbmgr:ClearViewBoxItem(j - 1)
		end

		warrior_trial_main.warrior_ctrls[#warrior_trial_main.warrior_ctrls + 1] = ctrls		
	end
		
	warrior_trial_main.panel_reward  = warrior_trial_main.mainwnd:GetPanel("通关奖励面板")	
	warrior_trial_main.panel_reward:SetShowEventHandler2(warrior_trial_main.on_reward_show)

	warrior_trial_main.reward_btns = {}
	local panels_mgr2 = warrior_trial_main.panel_reward:GetPanelMgr("列表框")
	for i = 1,panels_mgr2:GetPanelCount() do
		local panel = panels_mgr2:GetPanelWnd(i - 1)
		local btn = panel:GetButton("层数")
		btn:setText("")
		btn:SetVisible(false)
		btn:SetClickEventHandler2(function()
			warrior_trial.req_reward_info(btn:GetTag1())
		end)
		warrior_trial_main.reward_btns[#warrior_trial_main.reward_btns + 1] = btn
	end
	warrior_trial_main.flip_reward		= warrior_trial_main.panel_reward:GetFlipPage("切换按钮")
	warrior_trial_main.flip_reward:SetVisible(false)
	for i = 1,warrior_trial_main.flip_reward:GetPageNum() do 
		local page_btn = warrior_trial_main.flip_reward:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler2(function()
			warrior_trial_main.cur_page = page_btn:GetTag1()
			warrior_trial_main.changerewardpage()
		end)
	end

	warrior_trial_main.lbl_mstname		= warrior_trial_main.panel_reward:GetLabel("怪物名字值")
	warrior_trial_main.lbl_mstname:setText("")

	warrior_trial_main.lbl_mstlv		= warrior_trial_main.panel_reward:GetLabel("怪物等级值")
	warrior_trial_main.lbl_mstlv:setText("")

	warrior_trial_main.lbl_lvkingname	= warrior_trial_main.panel_reward:GetLabel("关卡霸主值")
	warrior_trial_main.lbl_lvkingname:setText("")

	warrior_trial_main.lbl_lvkingtime	= warrior_trial_main.panel_reward:GetLabel("通关时间值")
	warrior_trial_main.lbl_lvkingtime:setText("")

	warrior_trial_main.lbl_capacity		= warrior_trial_main.panel_reward:GetLabel("能力推荐值")
	warrior_trial_main.lbl_capacity:setText("")

	warrior_trial_main.lbl_rewardexp	= warrior_trial_main.panel_reward:GetLabel("经验奖励值")
	warrior_trial_main.lbl_rewardexp:setText("")

	warrior_trial_main.lbl_rewardhonor	= warrior_trial_main.panel_reward:GetLabel("荣誉奖励值")
	warrior_trial_main.lbl_rewardhonor:setText("")

	warrior_trial_main.html_dropgoods	= warrior_trial_main.panel_reward:GetHtml("物品掉落值")
	warrior_trial_main.html_dropgoods:Clear()

	warrior_trial_main.html_firstreward	= warrior_trial_main.panel_reward:GetHtml("首次通关奖励值")
	warrior_trial_main.html_firstreward:Clear()
end

function warrior_trial_main.clear()
	warrior_trial_main.update_warrior({})
	warrior_trial_main.update_reward({})
end

function warrior_trial_main.switchpanel(index)
	warrior_trial_main.flippage:TurnPage(index)
	if index == 1 then
		warrior_trial_main.panel_warrior:SetVisible(false)
		warrior_trial_main.panel_reward:SetVisible(true)
	else
		warrior_trial_main.panel_warrior:SetVisible(true)
		warrior_trial_main.panel_reward:SetVisible(false)
	end
end

function warrior_trial_main.on_warrior_show()
	warrior_trial.req_warrior_info()
end

function warrior_trial_main.on_reward_show()
	warrior_trial.req_reward_info(0)
end

function warrior_trial_main.update_warrior(data)
	warrior_trial_main.lbl_curmaxlv:setText(tostring(data.max_pass_game_lv or 0))
	warrior_trial_main.lbl_maxlvactor:setText(data.max_pass_actor_name or "")
	if nil ~= data.max_pass_actor_id and 0 ~= data.max_pass_actor_id then
		warrior_trial_main.cp_first_warrior:SetActorID(data.max_pass_actor_id)
		warrior_trial_main.cp_first_warrior:SetVisible(true)
		warrior_trial_main.actor_preview_btn:SetTag1(data.max_pass_actor_id)
		warrior_trial_main.bmp_waiting:SetVisible(false)
	else
		warrior_trial_main.cp_first_warrior:SetActorID(0)
		warrior_trial_main.cp_first_warrior:SetVisible(false)
		warrior_trial_main.actor_preview_btn:SetTag1(0)
		warrior_trial_main.bmp_waiting:SetVisible(true)
	end
	local rewards = data.first_pass_rewards or {}
	for i = 1,#warrior_trial_main.warrior_ctrls do
		local item = warrior_trial_main.warrior_ctrls[i]
		item.html:Clear()
		for j = 1,item.vbmgr:GetSize() do
			item.vbmgr:ClearViewBoxItem(j - 1)
		end
		if i <= #rewards then
			local o = rewards[i]
			if o.level and o.goods then
				item.html:ParseContext(string.format("#(font,system20)#(color,%%%%200,200,255%%%%)闯关#(color,yellow)%d#(color,restore)层#(color,restore)", o.level))				
				for j = 1,math.min(item.vbmgr:GetSize(), #o.goods) do
					local vb = item.vbmgr:GetViewBox(j - 1)
					local o2 = o.goods[j]
					vb:SetItem(o2.goodsid or 0, o2.count or 1, false, o2.quality or 0, 0)
				end
			end
		end
	end
end

function warrior_trial_main.update_reward(data)
	warrior_trial_main.levellist		= data.levellist or {}
	warrior_trial_main.currentleveinfo	= data.current or {}
	
	warrior_trial_main.changerewardpage()
	warrior_trial_main.refreshcurlevel()
end

function warrior_trial_main.refreshcurlevel()
	--当前奖励信息
	local level_info = warrior_trial_main.currentleveinfo
	warrior_trial_main.lbl_mstname:setText(level_info.mstname or "无")
	warrior_trial_main.lbl_mstlv:setText(level_info.mstlv or "无")
	warrior_trial_main.lbl_lvkingname:setText(level_info.lvkingname or "暂无")
	if level_info.lvkingtime then
		local time1 = XDate:GetTimeStruct(level_info.lvkingtime)
		local time2 = XDate:GetInstance():GetTimeString(time1)
		warrior_trial_main.lbl_lvkingtime:setText(time2)
	else
		warrior_trial_main.lbl_lvkingtime:setText("暂无")
	end
	warrior_trial_main.lbl_capacity:setText(level_info.capacity or "无")
	warrior_trial_main.lbl_rewardexp:setText(level_info.rewardexp or "无")
	warrior_trial_main.lbl_rewardhonor:setText(level_info.rewardhonor or "无")
	warrior_trial_main.html_dropgoods:Clear()
	warrior_trial_main.html_dropgoods:ParseContext(level_info.dropgoods or "无")
	warrior_trial_main.html_firstreward:Clear()
	warrior_trial_main.html_firstreward:ParseContext(level_info.firstreward or "无")	
end

function warrior_trial_main.changerewardpage()
	--关卡数字
	local levels_list = warrior_trial_main.levellist
	--当前奖励信息
	local level_info = warrior_trial_main.currentleveinfo
	local reward_btns = warrior_trial_main.reward_btns
	local btns_count  = #reward_btns
	local total_page  = math.ceil(#levels_list / btns_count)
	local cur_page	  = warrior_trial_main.cur_page
	cur_page		  = math.max(math.min(cur_page, total_page), 1)
	--按钮高亮
	warrior_trial_main.flip_reward:TurnPage(cur_page - 1)
	--设置下面的切换按钮数量
	warrior_trial_main.flip_reward:SetVisibleNum(total_page)
	--当前页的关卡数字
	local start_lv_index = (cur_page - 1) * btns_count
	local end_lv_index   = math.min(cur_page * btns_count, #levels_list)
	for i = 1, btns_count do
		local index = start_lv_index + i
		if index <= end_lv_index then
			local lv = levels_list[index]
			reward_btns[i]:SetVisible(true)
			reward_btns[i]:SetTag1(lv)			
			if level_info.level and level_info.level == lv then 
				reward_btns[i]:setText("[" .. lv .. "]")
			else
				reward_btns[i]:setText(lv)
			end
		else
			reward_btns[i]:SetVisible(false)
			reward_btns[i]:setText("")
			reward_btns[i]:SetTag1(0)
		end
	end
end

function warrior_trial_main.on_click_preview(wnd)
	local btn = XButton:CastToButton(wnd)
	if not btn then
		API_TraceError("wnd cast to btn fail")
		return
	end

	local actorid = btn:GetTag1()
	if actorid ~= 0 then
		--弹出poplist
		local pt = XDesktop:GetInstance():GetMouseXY()
		pt.x = pt.x + 15
		g_pGlobal:GetMainUI():ShowCreaturePopMenu(actorid, pt)
	end
end
--------------------调用启动函数----------------
warrior_trial.init()