--副本奖励信息配置表
drop_info_table={}

--血魔窟奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 205, --地图ID
	name = "血魔窟" , --副本名称
	rewards =
	{
		{vb = {28017,1,3,},desc = "有概率获得50级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25073,1,0,},desc = "有概率获得金乌丹，使用后可小幅提升当前召唤的宠物经验。",},
		{vb = {25074,1,0,},desc = "有概率获得玄元丹，使用后可中幅提升当前召唤的宠物经验。",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {28021,1,0,},desc = "有概率获得白色伙伴卷轴，随机获得普通资质伙伴一个。",},
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},
	},
}
--精英血魔窟奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 409, --地图ID
	name = "精英血魔窟" , --副本名称
	rewards =
	{
		{vb = {23502,1,3,},desc = "有概率获得多彩元魂。",},
		{vb = {23002,1,2,},desc = "有概率获得1、2级宝石",},
		{vb = {24012,1,2,},desc = "有概率获得2档精炼石。",},
		{vb = {20011,1,0,},desc = "经验",},
	},
}

--轮回谷奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 402, --地图ID
	name = "轮回谷" , --副本名称
	rewards =
	{
		{vb = {28015,1,3,},desc = "有概率获得随机获得30级卓越装备一件。",},
		{vb = {25073,1,0,},desc = "有概率获得金乌丹，使用后可小幅提升当前召唤的宠物经验。",},
		{vb = {25074,1,0,},desc = "有概率获得玄元丹，使用后可中幅提升当前召唤的宠物经验。",},
		{vb = {28021,1,0,},desc = "有概率获得白色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},
	},
}

--五行阵奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 210, --地图ID
	name = "五行阵" , --副本名称
	rewards =
	{
		{vb = {28018,1,3,},desc = "有概率获得60级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25074,1,0,},desc = "有概率获得玄元丹，使用后可中幅提升当前召唤的宠物经验。",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},
	},
}
--精英五行阵奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 410, --地图ID
	name = "精英五行阵" , --副本名称
	rewards =
	{
		{vb = {23502,1,3,},desc = "有概率获得多彩元魂。",},
		{vb = {23002,1,2,},desc = "有概率获得1、2级宝石",},
		{vb = {24013,1,3,},desc = "有概率获得3档精炼石。",},
		{vb = {20011,1,0,},desc = "经验",},
	},
}


--锁妖塔一层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 201, --地图ID
	name = "锁妖塔一层" , --副本名称
	rewards =
	{
		{vb = {28019,1,3,},desc = "有概率获得70级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25074,1,0,},desc = "有概率获得玄元丹，使用后可中幅提升当前召唤的宠物经验。",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},
	},
}

--锁妖塔二层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 202, --地图ID
	name = "锁妖塔二层" , --副本名称
	rewards =
	{
		{vb = {28019,1,3,},desc = "有概率获得70级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25074,1,0,},desc = "有概率获得玄元丹，使用后可中幅提升当前召唤的宠物经验。",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},
	},
}

--锁妖塔三层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 203, --地图ID
	name = "锁妖塔三层" , --副本名称
	rewards =
	{
		{vb = {28019,1,3,},desc = "有概率获得70级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25074,1,0,},desc = "有概率获得玄元丹，使用后可中幅提升当前召唤的宠物经验。",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},		
	},
}
--精英锁妖塔一层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 406, --地图ID
	name = "精英锁妖塔一层" , --副本名称
	rewards =
	{
		{vb = {23502,1,3,},desc = "有概率获得多彩元魂。",},
		{vb = {23002,1,2,},desc = "有概率获得1、2级宝石",},
		{vb = {24014,1,4,},desc = "有概率获得3档精炼石。",},
		{vb = {20011,1,0,},desc = "经验",},	
	},
}

--精英锁妖塔二层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 407, --地图ID
	name = "精英锁妖塔二层" , --副本名称
	rewards =
	{
		{vb = {23502,1,3,},desc = "有概率获得多彩元魂。",},
		{vb = {23002,1,2,},desc = "有概率获得1、2级宝石",},
		{vb = {24014,1,4,},desc = "有概率获得3档精炼石。",},
		{vb = {20011,1,0,},desc = "经验",},	
	},
}

--精英锁妖塔三层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 408, --地图ID
	name = "精英锁妖塔三层" , --副本名称
	rewards =
	{
		{vb = {23502,1,3,},desc = "有概率获得多彩元魂。",},
		{vb = {23002,1,2,},desc = "有概率获得1、2级宝石",},
		{vb = {24014,1,4,},desc = "有概率获得3档精炼石。",},
		{vb = {20011,1,0,},desc = "经验",},	
	},
}

--琅环阁一层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 206, --地图ID
	name = "琅环阁一层" , --副本名称
	rewards =
	{
		{vb = {28020,1,3,},desc = "有概率获得80级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},	
	},              
}

--琅环阁二层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 207, --地图ID
	name = "琅环阁二层" , --副本名称
	rewards =
	{
		{vb = {28020,1,3,},desc = "有概率获得80级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},		
	},              
}

--琅环阁三层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 208, --地图ID
	name = "琅环阁三层" , --副本名称
	rewards =
	{
		{vb = {28020,1,3,},desc = "有概率获得80级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},		
	},              
}

--琅环阁四层奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 209, --地图ID
	name = "琅环阁四层" , --副本名称
	rewards =
	{
		{vb = {28020,1,3,},desc = "有概率获得80级卓越装备一件。",},
		{vb = {20050,1,0,},desc = "有概率获得20绑定元宝，使用礼包后会获得20绑定元宝",},
		{vb = {25075,1,0,},desc = "有概率获得灵魄丹，使用后可大幅提升当前召唤的宠物经验。",},
		{vb = {25076,1,0,},desc = "有概率获得火磷丹，使用后可巨幅提升当前召唤的宠物经验。",},		
		{vb = {28022,1,2,},desc = "有概率获得蓝色伙伴卷轴，使用可获得优秀资质伙伴一个。",},
		{vb = {20011,1,0,},desc = "大量经验",},		
	},
}

--魔族来袭奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 301, --地图ID
	name = "魔族来袭" , --副本名称
	rewards =
	{
		{vb = {24006,1,0,},desc = "强化石，用于提升角色装备星级。",},
		{vb = {25100,1,0,},desc = "筑基丹，用于提升伙伴星级。",},
		{vb = {23001,1,0,},desc = "一级宝石，可镶嵌在装备上提升装备能力。",},
		{vb = {25013,1,0,},desc = "伙伴技能书，用于伙伴技能训练。",},
		{vb = {20001,1,0,},desc = "金币，游戏内交换货币。",},
		
	},
}

--魔族来袭奖励信息
drop_info_table[#drop_info_table + 1] ={
	mapId = 302, --地图ID
	name = "魔族来袭" , --副本名称
	rewards =
	{
		{vb = {24006,1,0,},desc = "强化石，用于提升角色装备星级。",},
		{vb = {25100,1,0,},desc = "筑基丹，用于提升伙伴星级。",},
		{vb = {23001,1,0,},desc = "一级宝石，可镶嵌在装备上提升装备能力。",},
		{vb = {25013,1,0,},desc = "伙伴技能书，用于伙伴技能训练。",},
		{vb = {20001,1,0,},desc = "金币，游戏内交换货币。",},
		
	},
}
--{11101,1,2,}第一个参数是物品id(这里就算不是物品也得在goods里配个假的)，
--第2个参数是数量这里填1就不显示数量了，
--第三个参数是品质框填-1就是物品的默认品质，填0就是没有品质边框，从1开始的品质边框	


