﻿------------------------------------------------------七日修仙条件及奖励配置-----------------------------------------------------

-- id 是保存条件是否完成的标记 第一天从 con_1开始 第二天从 con_6 开始 依次累加
-- condition 是任务的描述

local achievement_condition_cfg = {
	{id = 'achievement_con_1', condition = '·等级提升到30级'},
	{id = 'achievement_con_2', condition = '·试练谷挑战到20层'},
	{id = 'achievement_con_3', condition = '·强化一件装备到5星'},
	{id = 'achievement_con_4', condition = '·天梯赛提升至1500名'},
	{id = 'achievement_con_5', condition = '·修为技能健体升到20级'},
	{id = 'achievement_con_6', condition = '·完成一轮黄粱梦'},
	{id = 'achievement_con_7', condition = '·试炼谷挑战到30层'},
	{id = 'achievement_con_8', condition = '·修为技能健体升到30级'},
	{id = 'achievement_con_9', condition = '·参加一次魔族来袭'},
	{id = 'achievement_con_10', condition = '·合成一次伙伴'},
	{id = 'achievement_con_11', condition = '·连续三日上线'},
	{id = 'achievement_con_12', condition = '·天梯赛提升至1000名'},
	{id = 'achievement_con_13', condition = '·炼化一张伙伴卡'},
	{id = 'achievement_con_14', condition = '·洗髓一次伙伴'},
	{id = 'achievement_con_15', condition = '·镶嵌一颗2级以上宝石'},
	{id = 'achievement_con_16', condition = '·试炼谷挑战到35层'},
	{id = 'achievement_con_17', condition = '·开启命格天璇'},
	{id = 'achievement_con_18', condition = '·参加一次热血沙场'},
	{id = 'achievement_con_19', condition = '·参加一次竞技场'},
	{id = 'achievement_con_20', condition = '·训练一次伙伴'},
	{id = 'achievement_con_21', condition = '·连续五日上线'},
	{id = 'achievement_con_22', condition = '·淬炼一次装备'},
	{id = 'achievement_con_23', condition = '·精炼一次装备'},
	{id = 'achievement_con_24', condition = '·天梯赛提升至600名'},
	{id = 'achievement_con_25', condition = '·强化伙伴到一星'},
	{id = 'achievement_con_26', condition = '·试炼谷挑战到40层'},
	{id = 'achievement_con_27', condition = '·竞技场胜利一次'},
	{id = 'achievement_con_28', condition = '·强化一件装备到10星'},
	{id = 'achievement_con_29', condition = '·热血沙场胜利一次'},
	{id = 'achievement_con_30', condition = '·修为技能健体升到40级'},
	{id = 'achievement_con_31', condition = '·连续七日上线'},
	{id = 'achievement_con_32', condition = '·天梯赛提升至300名'},
	{id = 'achievement_con_33', condition = '·淬炼出一条特殊属性'},
	{id = 'achievement_con_34', condition = '·伙伴战力提升至8000'},
	{id = 'achievement_con_35', condition = '·等级提升到50级'},
	{id = 'achievement_con_36', condition = '·充值任意金额'},
	{id = 'achievement_con_37', condition = '·累积充值50000元宝'},
}

local scroll_notice = {
	'充值10元宝#(color,%%255,255,0%%)返还1000元宝#(color,restore)，更有#(color,%%255,255,0%%)60神工大礼#(color,restore)相赠',
	'散仙奖励有的需要#(color,%%255,255,0%%)连续上线多日#(color,restore)才能领取哦',
	'不知道怎么玩，散仙任务教你如何修仙',
	'#(color,%%255,255,0%%)限量版橙色宠物#(color,restore)完成金仙任务就能领取哦',
	'当日没有领取，没关系，只要补领就好了啦',
	'补领需要消耗10元宝，领取奖励一定要及时哦',
}

local broad_world_message = {
	'第一次总是美好的，首冲千元大礼返还，惊喜不断',
	'7日修仙之旅，好礼拿不完，八仙修行从这里开始',
	'活动仙界争霸，天梯榜前300名才有资格参加，荣誉、权利、霸气称号、绚丽高属性翅膀、高额元宝等你来挑战',
}

-- 游侠（男）----3
-- 剑侠（男）----4
-- 刺客（女）----5
-- 琴师（女）----6
local achievement_reward_cfg = {
[3] = {		-----游侠
			--------任意完成 3 项任务奖励--------		--------任意完成 5 项任务奖励--------		--------充值任意金额奖励--------			--------充值 5000 奖励--------
	[1] = {[1] = {24006,2,10, 21003,2,10}, 				[2] = {11304,3,1}, 							[3] = {28307,3,1, 24006,2,10, 23002,1,1}, 	[4] = {29032,4,1}},
	[2] = {[1] = {24006,2,10, 28308,3,1,  24052,2,10}, 	[2] = {13204,3,1, 13404,3,1}, 				[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[3] = {[1] = {23063,1,1,  23073,1,1,  21033,2,10}, 	[2] = {13304,4,1}, 							[3] = {28304,3,1, 28309,3,1}, 				[4] = {24008,4,5}},
	[4] = {[1] = {24006,2,10, 24052,2,10},				[2] = {12105,3,1, 12005,3,1},				[3] = {28304,3,1}, 							[4] = {28310,3,1}},
	[5] = {[1] = {24012,2,10, 25100,2,10, 21003,2,10}, 	[2] = {13505,4,1},							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[6] = {[1] = {28307,3,1,  21033,2,10}, 				[2] = {13105,4,1}, 							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[7] = {[1] = {24052,2,10, 21003,2,10, 21033,2,10}, 	[2] = {11306,4,1, 28309,3,1}, 				[3] = {28304,3,1, 24022,5,1}, 				[4] = {23007,5,1}},
	},
[4] = {		-----剑侠
			--------任意完成 3 项任务奖励--------		--------任意完成 5 项任务奖励--------		--------充值任意金额奖励--------			--------充值 5000 奖励--------
	[1] = {[1] = {24006,2,10, 21003,2,10}, 				[2] = {11204,3,1}, 							[3] = {28307,3,1, 24006,2,10, 23002,1,1},	[4] = {29032,4,1}},
	[2] = {[1] = {24006,2,10, 28308,3,1,  24052,2,10}, 	[2] = {13204,3,1, 13404,3,1}, 				[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[3] = {[1] = {23063,1,1,  23073,1,1,  21033,2,10}, 	[2] = {13304,4,1}, 							[3] = {28304,3,1, 28309,3,1}, 				[4] = {24008,4,5}},
	[4] = {[1] = {24006,2,10, 24052,2,10},				[2] = {12105,3,1, 12025,3,1},				[3] = {28304,3,1}, 							[4] = {28310,3,1}},
	[5] = {[1] = {24012,2,10, 25100,2,10, 21003,2,10}, 	[2] = {13505,4,1},							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[6] = {[1] = {28307,3,1,  21033,2,10}, 				[2] = {13105,4,1}, 							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[7] = {[1] = {24052,2,10, 21003,2,10, 21033,2,10}, 	[2] = {11206,4,1, 28309,3,1}, 				[3] = {28304,3,1, 24022,5,1}, 				[4] = {23007,5,1}},
	},                                                                                             
[5] = {		-----刺客
			--------任意完成 3 项任务奖励--------		--------任意完成 5 项任务奖励--------		--------充值任意金额奖励--------			--------充值 5000 奖励--------
	[1] = {[1] = {24006,2,10, 21003,2,10}, 				[2] = {11104,3,1}, 							[3] = {28307,3,1, 24006,2,10, 23002,1,1}, 	[4] = {29032,4,1}},
	[2] = {[1] = {24006,2,10, 28308,3,1,  24052,2,10},	[2] = {13204,3,1, 13404,3,1}, 				[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[3] = {[1] = {23063,1,1,  23073,1,1,  21033,2,10},	[2] = {13304,4,1}, 							[3] = {28304,3,1, 28309,3,1}, 				[4] = {24008,4,5}},
	[4] = {[1] = {24006,2,10, 24052,2,10},				[2] = {12105,3,1, 12005,3,1},				[3] = {28304,3,1}, 							[4] = {28310,3,1}},
	[5] = {[1] = {24012,2,10, 25100,2,10, 21003,2,10},	[2] = {13505,4,1},							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[6] = {[1] = {28307,3,1,  21033,2,10}, 				[2] = {13105,4,1}, 							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[7] = {[1] = {24052,2,10, 21003,2,10, 21033,2,10},	[2] = {11106,4,1, 28309,3,1}, 				[3] = {28304,3,1, 24022,5,1}, 				[4] = {23007,5,1}},
	},                                                                                             
[6] = {		-----琴师
			--------任意完成 3 项任务奖励--------		--------任意完成 5 项任务奖励--------		--------充值任意金额奖励--------			--------充值 5000 奖励--------
	[1] = {[1] = {24006,2,10, 21003,2,10}, 				[2] = {11404,3,1},							[3] = {28307,3,1, 24006,2,10, 23002,1,1}, 	[4] = {29032,4,1}},
	[2] = {[1] = {24006,2,10, 28308,3,1,  24052,2,10},	[2] = {13204,3,1, 13404,3,1}, 				[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[3] = {[1] = {23063,1,1,  23073,1,1,  21033,2,10},	[2] = {13304,4,1}, 							[3] = {28304,3,1, 28309,3,1}, 				[4] = {24008,4,5}},
	[4] = {[1] = {24006,2,10, 24052,2,10},				[2] = {12105,3,1, 12025,3,1},				[3] = {28304,3,1}, 							[4] = {28310,3,1}},
	[5] = {[1] = {24012,2,10, 25100,2,10, 21003,2,10},	[2] = {13505,4,1},							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[6] = {[1] = {28307,3,1,  21033,2,10}, 				[2] = {13105,4,1}, 							[3] = {28304,3,1}, 							[4] = {24008,4,5}},
	[7] = {[1] = {24052,2,10, 21003,2,10, 21033,2,10},	[2] = {11406,4,1, 28309,3,1}, 				[3] = {28304,3,1, 24022,5,1}, 				[4] = {23007,5,1}},
	},                                                                                             
}

function GetAchievementConditions()
	return achievement_condition_cfg
end

function GetAchievementRewards()
	return achievement_reward_cfg
end

function GetAchievementScrollNotice()
	return scroll_notice
end