﻿
--新手引导相关脚本

----------------任务相关指引------------------------

------需要新手引导的任务表
local FreshHelp_Accept_taskID = {1401,1403,1402,1404,1405,1406,1407,1408,1413,1414,1415,1416,1417,1419,1420,1421,1422}
----有些任务 完成的指引 是要在点击关闭窗口后进行的
local FreshHelp_Finish_taskID = {1400,1401,1403,1404,1405,1406,1407,1408,1413,1414,1415,1416,1417,1418,1421,1422,1423}
-----完成任务与npc对话的ID
local FreshHelp_FinishTalk_taskID = {0,1400,1401,1402,1403,1404,1405,1406,1407,1408,1409,1410,1411,1412,1413,1414,1415,1416,1417,1418,1419,1420,1421,1422,1423}
----新功能开启需要指一下新功能的任务ID
local FunctionGuid_taskID	= {1402,1409,1410,1411,1412,1414,1418,1419,1421}

-----标记是否已经进行过引导
local IsFreshHelp = {}

function GetIsFreshHelpFlag(flag)
	return IsFreshHelp[flag]
end

function SetIsFreshHelpFlag(flag, num)
	IsFreshHelp[flag] = num
end

----引导点击新功能UI
function OnClickNewFunctionGuid()
	for k, v in pairs(FunctionGuid_taskID) do
		if API_HaveTask(v) then
			--API_Trace('click new function taskID ------ '..v)
			API_ShowWndRect("1089/108904", 100)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnClickNewFunctionGuid')
			break
		end
	end
end
-----接受任务
function OnAcceptTask(taskID)
	--API_Trace('accept task ID '..taskID)
	local IsGiftShow = API_IsWindowVisible('491') ---- 在出现礼包窗口时 不指引
	for k, v in pairs(FreshHelp_Accept_taskID) do
		if (v == taskID) and IsGiftShow == false then
			API_ShowWndRect2("70/7004/70040", 100, -8, -5, 200, 70)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnAcceptTask')
			break
		end
	end
	
	----如果是学习技能任务 在接受任务时 注册学习技能窗口打开事件
	if taskID == 1409 or taskID == 1410 or taskID == 1411 or taskID == 1412 then
		local skillWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(95)
		skillWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'LearnSkill_Start')
	end
	
	--如果是使用伙伴卡任务 注册背包窗口打开事件
	-- if taskID == 1414 then
		-- local packetWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(81)
		-- packetWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'UseMonsterCard_Start')
	-- end
	
	----接到三五知己任务 注册好友推荐窗口打开事件
	if taskID == 1418 then
		local friendWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(998)
		friendWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'AddFriend_Start')
	end

	----接到悉心培育摇钱树浇水任务 注册摇钱树窗口打开事件
	if taskID == 1420 then
		local treeWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(971)
		treeWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'MoneyTree_Start')
	end
	
	if taskID == 1140 then
		IsFreshHelp["xisui"] = 0	----标记洗髓功能需要引导
		API_RegisterWinTrigger('802/1091', XWIN_EVENT_SHOW, 'OnPet_XiSuiGuide', true, 'OnPet_XiSuiGuide')	
	end
	
	if taskID == 1154 then
		IsFreshHelp["qianghua"] = 0	----标记强化功能需要引导
		API_RegisterWinTrigger('102/261', XWIN_EVENT_SHOW, 'OnSkill_QiangHuaGuide', true, 'OnSkill_QiangHuaGuide')	
	end
	
	if taskID == 1159 then
		IsFreshHelp["qiandao"] = 0	----标记签到功能需要引导
		API_RegisterWinTrigger('820/821', XWIN_EVENT_SHOW, 'OnSign_StartGuide', true, 'OnSign_StartGuide')	
		--API_RegisterWinTrigger('820/822', XWIN_EVENT_CLICK, 'OnSign_SetPeachFlag', true, 'OnSign_StartGuide')
	end
	
	if taskID == 1165 then
		IsFreshHelp["peach"] = 0	----标记是否摘取蟠桃
		API_RegisterWinTrigger('1032/822', XWIN_EVENT_SHOW, 'OnSign_PeachGuide', true, 'OnSign_StartGuide')	 ----蟠桃园窗口打开指引
	end
	
	if taskID == 1169 then
		IsFreshHelp["baoshihecheng"] = 0  ----标记宝石合成需要引导
		API_RegisterWinTrigger('102/264', XWIN_EVENT_SHOW, 'OnWorkSkill_OnOpenGemInlayWnd', true, 'OnWorkSkill')	----注册炼器界面打开事件
	end
	
	if taskID == 2511 then
		--IsFreshHelp["tianti"] = 0  ----标记天梯赛需要引导
		--API_RegisterWinTrigger('936', XWIN_EVENT_SHOW, 'ArenaWnd_Open', true, 'Arena')	----注册炼器界面打开事件
	end
	
	if taskID == 1150 then
		IsFreshHelp["hecheng"] = 0  ----标记物品合成需要引导
		API_RegisterWinTrigger('102/286', XWIN_EVENT_SHOW, 'GoodsComposeWnd_Open', true, 'GoodsComposeWnd')	----注册物品合成界面打开事件
	end
	
	if taskID == 1179 then
		IsFreshHelp["cuilian"] = 0  ----标记装备淬炼需要引导
		API_RegisterWinTrigger('102/282', XWIN_EVENT_SHOW, 'EquipAdvance_Open', true, 'EquipAdvance')	----注册物品合成界面打开事件
	end
	
	if taskID == 1425 then
		IsFreshHelp["chumo"] = 0  ----标记除魔令需要引导
		API_RegisterWinTrigger('81', XWIN_EVENT_SHOW, 'OnActorMainWnd_Open', true, 'OnActorMainWnd')	----注册物品合成界面打开事件
	end
	
	--创建角色后进入场景时并没有1400任务，但后面能收到1400
	if taskID == 1400 then
		On_ShowSystemWndGuide()
	end
	
	----活动开启时 第一次打开 要打开活动指引界面
	if taskID == 1145 then
		IsFreshHelp["activity"] = 0  ----标记活动需要引导
		-- local actWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(866)
		-- actWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'OnFirstOpenActivityWnd')	----注册窗口的打开事件
	end
	
	----斩草除根任务会进入副本 指一下确认挂机提示框
	if taskID == 1423 then
		IsFreshHelp["guaji"] = 0  ----标记活动需要引导
		API_RegisterWinTrigger('730', XWIN_EVENT_SHOW, 'Guaji_OnMsgBoxShow', true, 'Guaji_OnMsgBoxShow')	----注册确认框打开事件
	end
	
	----修为的相关引导
	if taskID == 2504 then
		IsFreshHelp['xiuweijineng'] = 0	----修为技能
		IsFreshHelp['xiuweijingjie'] = 0	----修为境界
		API_RegisterWinTrigger('95/97', XWIN_EVENT_SHOW, 'XiuWeiJiNengWnd_OnOpen', true, 'XiuWeiJiNengWnd')	----注册修为技能窗口打开事件
		API_RegisterWinTrigger('95/98', XWIN_EVENT_SHOW, 'XiuWeiJingJieWnd_OnOpen', true, 'XiuWeiJingJieWnd')	----注册修为境界窗口打开事件
	end
	
	if taskID == 1182 then
		----开启神工商店
		OnShenGongShop_SetFlag()
	end
end

-----完成任务
function OnFinishTask(taskID, objItem)
	--API_Trace('finishtask taskID '..taskID)
	
	-- if taskID == 1414 then
		-- UsePet_StartGuid()
		-- return
	-- end
	
	local IsGiftShow = API_IsWindowVisible('491') ---- 在出现礼包窗口时 不指引
	
	for k, v in pairs(FreshHelp_Finish_taskID) do
		if v == taskID and objItem ~= 2 and IsGiftShow == false then  ----非杀怪任务 (杀怪任务 杀完会自动寻路)
			API_ShowWndRect2("70/7004/70040", 100, -8, -5, 200, 70)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnFinishTask')
			break
		end
	end
end

-----完成任务与npc对话时 显示指引
function FreshmanHelpFinishTask(taskID)
	--API_Trace('FreshmanHelpFinishTask -- '..taskID)
	for k, v in pairs(FreshHelp_FinishTalk_taskID) do
		if v == taskID and API_IsWindowVisible('460/46006/4600602') and API_IsWindowVisible('460/46006/4600604') then
			API_ShowWndRect("460/46006/4600602", 100)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'FreshmanHelpFinishTask')
			break
		end
	end
end

-----去除指引
function RemoveHelpEffect()
	API_RemoveScreenEffect()
end

--------获取炼器界面的viewbox并指向
function OnWorkSkill_ShowItemRect(goodsID)
	local uid = core.getHero():GetPacketPart():FindGoods(goodsID)
	local pItemVB = g_pGlobal:GetWorkSkillSystem():FindPacketItem(uid)
    local rect = pItemVB:GetWindowXRect()
	
	local skillMainWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(102)
	local goodsPacket = skillMainWnd:FindWindowByID(10204)
	local PackWnd = goodsPacket:GetWindowXRect()
	API_ShowWndRect2('102/10204', 100, rect.left - PackWnd.left, rect.top - PackWnd.top, rect:Width(), rect:Height())
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
end

----关闭炼器窗口
function OnWorkSkill_Close()
	API_ShowWndRect('102/10202', 100)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
end

-----------------------------------第一次进副本挂机 指一下确定------------------

function Guaji_OnMsgBoxShow()
	if IsFreshHelp["guaji"] ~= nil and IsFreshHelp["guaji"] == 0 then
		API_ShowWndRect("730/0", 100)
		IsFreshHelp["guaji"] = 1
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Guaji_OnMsgBoxShow')
	end
end

------------------------------------除魔令使用指引-----------------------
function OnActorMainWnd_Open()
	if IsFreshHelp["chumo"] ~= nil and IsFreshHelp["chumo"] == 0 then
		IsFreshHelp["chumo"] = 1
		API_ShowGoodsRect( 21003, 10, 10, 0, 0)
		--API_ShowWndRect('95/95000', 10, 0, 0, 0)
		API_RegisterWinTrigger("77", XWIN_EVENT_SHOW, "Chumo_DelayClickTips", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Chumo')
	end
end

function Chumo_DelayClickTips()
	timer.setTimer('Chumo_ClickUse',1425, 500)
end

function Chumo_ClickUse()
	API_ShowWndRect("77/4", 100)
	API_RegisterWinTrigger("77/4", XWIN_EVENT_CLICK, "ChumoWnd_Close", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Chumo')
	timer.killTimer('Chumo_ClickUse', 1425)
end

function ChumoWnd_Close()
	API_ShowWndRect("81/81004", 100)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Chumo')
end

----延时点击tips的使用
function Delay_ClickTips()
	timer.setTimer('OnClick_Tips',1169, 500)
end

----点击tips的使用
function OnClick_Tips()
	if API_IsWindowVisible('77') == true then
		API_ShowWndRect("77/4", 100)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnClick_Tips')
		timer.killTimer('OnClick_Tips', 1169)
	end
end

---------------------------------装备淬炼引导--------------------------------
-----点击放入装备
function EquipAdvance_Open()
	if IsFreshHelp["cuilian"] ~= nil and IsFreshHelp["cuilian"] == 0 then
		IsFreshHelp["cuilian"] = 1
		API_ShowWndRect2('102/10210/3', 100, 10, -10, 165, 90)	----指向武器
		API_RegisterEventTrigger(enFreshmanHelpEvent_EquipAdvance_AddEquip, "EquipAdvanceWnd_ClickAdvance", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
	end
end
-----点击淬炼
function EquipAdvanceWnd_ClickAdvance()
	API_ShowWndRect('102/282/28219', 100)
	API_RegisterWinTrigger("102/282/28219", XWIN_EVENT_CLICK, "OnWorkSkill_Close", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
end

----------------------------------物品合成引导-------------------------------
----点击放入酒

function GoodsComposeWnd_Open()
	if IsFreshHelp["hecheng"] ~= nil and IsFreshHelp["hecheng"] == 0 then
		----引导点击物品 酒
		IsFreshHelp["hecheng"] = 1
		OnWorkSkill_ShowItemRect(21033)
		API_RegisterWinTrigger("77", XWIN_EVENT_SHOW, "Delay_ClickTips", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_EquipGoodsCompose_AddGoods, "GoodsComposeWnd_ClickCompose", true)
	end
end

----点击合成
function GoodsComposeWnd_ClickCompose()
	API_ShowWndRect('102/286/28611', 100)
	API_RegisterWinTrigger("102/286/28611", XWIN_EVENT_CLICK, "OnWorkSkill_Close", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'GoodsComposeWnd')
end

-----------------------------------公会引导-------------------------
----点击公会标签页
function Relation_Open()
	if IsFreshHelp["gonghui"] ~= nil and IsFreshHelp["gonghui"] == 0 then
		IsFreshHelp["gonghui"] = 1
		API_ShowWndRect('360/36000/4', 100)
		API_RegisterWinTrigger("360/36000/4", XWIN_EVENT_CLICK, "Relation_ClickCreate", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Relation')
	end
end
-----点击申请公会
function Relation_ClickCreate()
	API_ShowWndRect('1041/104110', 100)
	--API_RegisterWinTrigger("1041/104110", XWIN_EVENT_CLICK, "Relation_ClickClose", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Relation')
end
----点击关闭
function Relation_ClickClose()
	API_ShowWndRect('1041/104109', 100)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Relation')
end

----------------------------------天梯赛引导------------------------

function ArenaWnd_Open()
	if IsFreshHelp["tianti"] ~= nil and IsFreshHelp["tianti"] == 0 then
		IsFreshHelp["tianti"] = 1
		API_ShowWndRect('936/953/95332/95320/0/9', 100)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Arena')
	end
end

-----------------------------------宝石合成引导--------------------
----点击宝石合成标签页
function OnWorkSkill_OnOpenGemInlayWnd()
	if IsFreshHelp["baoshihecheng"] ~= nil and IsFreshHelp["baoshihecheng"] == 0 then
		----开始宝石合成引导
		IsFreshHelp["baoshihecheng"] = 1
		API_ShowWndRect('102/10201/8', 100)
		API_RegisterWinTrigger("102/10201/8", XWIN_EVENT_CLICK, "OnWorkSkill_ClickGem", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
	end
end

----点击背包宝石
function OnWorkSkill_ClickGem()
	local hero = core.getHero()
	local occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local goodsID = 0
	if occ == enActorOccupation_SwordKnightErrant or occ == enActorOccupation_Tao then
		goodsID = 23031		----神剑 琴师 给的是紫宝石
	else
		goodsID = 23021		----其他职业给的是黄宝石
	end
	----引导点击物品
	OnWorkSkill_ShowItemRect(goodsID)
	API_RegisterWinTrigger("77", XWIN_EVENT_SHOW, "Delay_ClickTips", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_EquipGemCompose_AddEquip, "OnWorkSkill_ClickPacketItem", true)
end

----点击自动放入
function OnWorkSkill_ClickPacketItem()
	API_ShowWndRect('102/266/26606', 100)
	API_RegisterWinTrigger("102/266/26606", XWIN_EVENT_CLICK, "OnWorkSkill_ClickCombin", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
end
----点击合成
function OnWorkSkill_ClickCombin()
	API_ShowWndRect('102/266/26603', 100)
	API_RegisterWinTrigger("102/266/26603", XWIN_EVENT_CLICK, "OnWorkSkill_Close", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnWorkSkill')
end

----------------------------------签到引导---------------------
function OnSign_StartGuide()
	API_Trace('OnSign_StartGuide ---- ')
	if IsFreshHelp["qiandao"] ~= nil and IsFreshHelp["qiandao"] == 0 then
		IsFreshHelp["qiandao"] = 1
		API_ShowWndRect('820/821/821001', 100)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnSign_StartGuide')
	end
end

function OnSign_SetPeachFlag()
	IsFreshHelp["peach"] = 1
end

function OnSign_PeachGuide()
	if IsFreshHelp["peach"] ~= nil and IsFreshHelp["peach"] == 0 then
		local btn = API_GetWindowByPath('1032/822/8221/0/2')
		if btn:IsEnabled() == true then
			IsFreshHelp["peach"] = 1
			API_ShowWndRect('1032/822/8221/0/2', 100)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnSign_StartGuide')
		end		
	end
end

-----------------------------武器强化引导------------------
function OnSkill_QiangHuaGuide()
	if IsFreshHelp["qianghua"] ~= nil and IsFreshHelp["qianghua"] == 0 then
		IsFreshHelp["qianghua"] = 1
		API_ShowWndRect('102/10210/3', 100)
		API_RegisterEventTrigger(enFreshmanHelpEvent_EquipGrade_AddEquip, "OnSkill_ClickEquip", true)
		API_RegisterWinTrigger("77", XWIN_EVENT_SHOW, "Delay_ClickTips", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnSkill_QiangHuaGuide')
	end
end

function OnSkill_ClickEquip()
	API_ShowWndRect('102/261/26103', 100)
	API_RegisterWinTrigger("102/261/26103", XWIN_EVENT_CLICK, "OnSkill_ClickClose", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnSkill_QiangHuaGuide')
end

function OnSkill_ClickClose()
	API_ShowWndRect('102/10202', 100)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnSkill_QiangHuaGuide')
end

------------------------------洗髓引导-------------------
function OnPet_XiSuiGuide()
	if IsFreshHelp["xisui"] ~= nil and IsFreshHelp["xisui"] == 0 then
		IsFreshHelp["xisui"] = 1	----标记洗髓功能已经引导
		API_ShowWndRect("802/1091/1091001", 100)
		API_RegisterWinTrigger("802/1091/1091001", XWIN_EVENT_CLICK, "OnPet_ClickQueDing", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnPet_XiSuiGuide')
	end
end

function OnPet_ClickQueDing()
	API_ShowWndRect("802/1091/1091002", 100)
	API_RegisterWinTrigger("802/1091/1091002", XWIN_EVENT_CLICK, "OnPet_ClickClose", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnPet_XiSuiGuide')
end

function OnPet_ClickClose()
	API_ShowWndRect("802/80203", 100)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnPet_XiSuiGuide')
end

-----------------------引导点击伙伴出战------------------------
function UsePet_StartGuid()
	API_SetWindowVisible(81, false)
	API_SetWindowVisible(68, false)
	if API_HaveTask(1414) then
		API_SetWindowVisible(60, true)
		API_ShowWndRect("60", 100)
		--API_RegisterWinTrigger("60/60005/600051", XWIN_EVENT_CLICK, "UsePet_clickSysPet", true)
		API_RegisterWinTrigger('802/800', XWIN_EVENT_SHOW, 'UsePet_clickSysPet', true, 'UsePet_StartGuid')	
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'UsePet_StartGuid')
	end
end

function UsePet_clickSysPet()
	--if API_HaveTask(1414) then
		API_ShowWndRect("802/800/800005", 100)
		API_RegisterWinTrigger("802/800/800005", XWIN_EVENT_CLICK, "UsePet_clickUse", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'UsePet_StartGuid')
	--end
end

function UsePet_clickUse()
	if API_HaveTask(1414) then
		API_ShowWndRect("802/802008", 100)
		API_RegisterWinTrigger("802/802008", XWIN_EVENT_CLICK, "UsePet_clickClose", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'UsePet_StartGuid')
	end
end

function UsePet_clickClose()
	if API_HaveTask(1414) then
		OnContinueTask()
	end
end

------------------学习技能引导----------------------
----引导选中技能
function LearnSkill_Start()
	if API_IsWindowVisible('95/90/90029/90025/1/0') == true then
		local bShow = false
		if API_HaveTask(1409) and API_IsTaskComplete(1409) == false then
			bShow = true
		elseif API_HaveTask(1410) and API_IsTaskComplete(1410) == false then
			bShow = true
		elseif API_HaveTask(1411) and API_IsTaskComplete(1411) == false then
			bShow = true
		elseif API_HaveTask(1412) and API_IsTaskComplete(1412) == false then
			bShow = true
		end
		
		if bShow == true then
			API_ShowWndRect('95/90/90029/90025/1/0', 10, 0, 0, 0)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'LearnSkillGuid')
			API_RegisterWinTrigger("95/90/90029/90025/1/0", XWIN_EVENT_CLICK, "LearnSkill_Guid_1", true)
		end
	end
end

----引导点击升级
function LearnSkill_Guid_1()
	API_ShowWndRect('95/90/90017', 10, 0, 0, 0)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'LearnSkillGuid')
	API_RegisterWinTrigger("95/90/90017", XWIN_EVENT_CLICK, "LearnSkill_Guid_2", true)
end
----引导点击关闭
function LearnSkill_Guid_2()
	API_ShowWndRect('95/95000', 10, 0, 0, 0)
	API_RegisterWinTrigger("95/95000", XWIN_EVENT_CLICK, "OnContinueTask", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'LearnSkillGuid')
end

-----引导继续进行任务
function OnContinueTask()
	API_ShowWndRect2("70/7004/70040", 100, 0, 0, 180, 70)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'OnFinishTask')	
end
-----------------------------------------------伙伴卡使用任务指引-------------------
local pCardVB = nil
function UseMonsterCard_Start()
	----设置伙伴卡为选中物品
	local pCardVB = g_pGlobal:GetGoodsClient():FindGoodsItem(25197)
	if pCardVB ~= nil then
		pCardVB:SetAlwaysLight(true)
		API_ShowGoodsRect(25197, 10, 10, 0, 0)
		--API_ShowWndRect('95/95000', 10, 0, 0, 0)
		API_RegisterWinTrigger("77", XWIN_EVENT_SHOW, "Delay_ClickTips", true)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'UseMonsterCard')
	end
end

function UseMonsterCard_OnFinish()
	if pCardVB ~= nil then		
		pCardVB:SetAlwaysLight(false)
		OnContinueTask()
	end
	RemoveHelpEffect()
end


--------------------------好友推荐引导----------------------
function AddFriend_Start()
	API_ShowWndRect('998/99806', 10, 0, 0, 0)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'UseAddFriend')
end
	
----------------------摇钱树浇水-------------------------------

function MoneyTree_Start()
	if API_HaveTask(1420) and API_IsTaskComplete(1420) == false then
		API_ShowWndRect('971/97105', 10, 0, 0, 0)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'MoneyTree')
		API_RegisterWinTrigger("971/97105", XWIN_EVENT_CLICK, "MoneyTree_OnClickClose", true)
	end
end

function MoneyTree_OnClickClose()
	API_ShowWndRect('971/97104', 10, 0, 0, 0)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'MoneyTree')
	API_RegisterWinTrigger("971/97104", XWIN_EVENT_CLICK, "MoneyTree_OnFinish", true)
end

function MoneyTree_OnFinish()
	OnContinueTask()
end

-------------------------------------------------------------------------------------------------------------------------------------------------------------


----------------------新邮件引导开始----------------------------
function OnGet_New_Email()
	API_SetWindowVisible(81, true)
	API_SetWindowVisible(1015, false)
	API_ShowWndRect('81/81005/1', 15, 0, 0, 0)
	API_RegisterWinTrigger("81/83", XWIN_EVENT_SHOW, "OnActorMain_Email", true, 'NewEmail')
	API_RegisterWinTrigger("81", XWIN_EVENT_HIDE, "OnEmailWnd", true, 'NewEmail')
end

function OnActorMain_Email()
	API_ShowWndRect('81/83/83034', 15, 0, 0, 0)
	API_RegisterWinTrigger("1015", XWIN_EVENT_SHOW, "OnEmailWnd", true, 'NewEmail')
	API_RegisterWinTrigger("81/83", XWIN_EVENT_HIDE, "OnEmailWnd", true, 'NewEmail')
end

function OnEmailWnd()
	API_RemoveScreenEffect()
	API_UnregisterAllWinTrigger('NewEmail')
	API_SetWindowVisible(1015, true)
end

----------------------新邮件引导结束----------------------------
----------------------升级新手礼包提示 开始----------------------------
function OnLevelUp_FreshmanGiftTip()
	
	local tFleshManGift = 
	{
		{ goodsID=29001, name = "#(color,light_green)10级礼包#(color,restore)", limitLevel = 10 , description = "打开可获得降魔•蓝×5、蓬莱仙酿•蓝×5、经验卷轴×3。",},
		{ goodsID=29002, name = "#(color,light_green)20级礼包#(color,restore)", limitLevel = 20 , description = "打开可获得降魔•蓝×10、蓬莱仙酿•蓝×10、经验卷轴×5、强化石×5、洗髓丹×1。",},
		{ goodsID=29003, name = "#(color,light_green)30级礼包#(color,restore)", limitLevel = 30 , description = "打开可获得降魔•蓝×15、蓬莱仙酿•蓝×15、经验卷轴×8、强化石×10、洗髓丹×2、筑基丹×5。",},
		{ goodsID=29004, name = "#(color,light_green)40级礼包#(color,restore)", limitLevel = 40 , description = "打开可获得降魔•蓝×20、蓬莱仙酿•蓝×20、经验卷轴×12、极效强化石×12、洗髓丹×3、筑基丹×10、200绑定元宝、铜质荣誉勋章×1。",},
		{ goodsID=29005, name = "#(color,light_green)50级礼包#(color,restore)", limitLevel = 50 , description = "打开可获得降魔•蓝×25、蓬莱仙酿•蓝×25、经验卷轴×18、极效强化石×18、洗髓丹×4、筑基丹×15、500绑定元宝、银质荣誉勋章×1。",},
		{ goodsID=29006, name = "#(color,light_green)60级礼包#(color,restore)", limitLevel = 60 , description = "打开可获得降魔•蓝×30、蓬莱仙酿•蓝×30、经验卷轴×27、神品强化石×30、洗髓丹×6、筑基丹×20、1000绑定元宝、金质荣誉勋章×1。",},
	}
	
	--1.在背包中找到对应的礼包
	local gift
	for i=1, #(tFleshManGift) do 
		if API_GetPacketGoodNum(tFleshManGift[i].goodsID) > 0 then
			gift = tFleshManGift[i]
			break
		end
	end
	if gift == nil then
		return
	end
	
	--2.查看等级，符合则弹出提示
	if API_GetHeroLevel() >= gift.limitLevel then
		--API_ShowMessageBox("可以使用"..gift.name.."了。"..gift.description.."前往背包?","标题",eOkCancelMask,'OnMsgBox_FreshmanGiftTip')
		NewHandGiftWnd.thiswnd:SetVisible(true)
		API_RemoveScreenEffect()
		return
	end
	
	API_RemoveScreenEffect()
end

function OnMsgBox_FreshmanGiftTip(nMsgID,wParam,lParam)
	--是则显示背包
	if WE_AW_MSGOK == nMsgID then
		API_SetWindowVisible(68,true)
	end
end

----------------------升级新手礼包提示 结束----------------------------

----------------------------欢迎界面引导-----------------------------
function On_ShowSystemWndGuide()
	if 3 == API_GetHeroMapID() and API_GetHeroLevel() < 20 then
		if API_HaveTask(1400) == true then
			API_SetWindowVisible(1090, true)
			API_ShowWndRect("1090/109001", 100)
			API_RegisterWinTrigger("1090/109001", XWIN_EVENT_CLICK, "OnContinueTask", true)
			API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, "RemoveHelpEffect", true, 'Welcome')
		else
			OnContinueTask()
		end
	end
end

------------------------------公会开启设置标记----------------------
function OnGongHuiOpen_SetFlag()
	IsFreshHelp["gonghui"] = 0  ----标记公会需要引导
	API_RegisterWinTrigger('360', XWIN_EVENT_SHOW, 'Relation_Open', true, 'Relation')	----注册关系界面打开事件
end

------------------------------标记神工商店开启--------------------------
function OnShenGongShop_SetFlag()
	IsFreshHelp["shengong"] = 0
	API_RegisterWinTrigger('1032', XWIN_EVENT_SHOW, 'OnShenGongWnd_FirstOpen', true, 'ShenGong')
end

function OnShenGongWnd_FirstOpen()
	if IsFreshHelp["shengong"] ~= nil and IsFreshHelp["shengong"] == 0 then
		IsFreshHelp["shengong"] = 1
		WndSystem:GetInstance():OnEvent(1032, 82005, 0, 0)
	end
end

-------------------------------修为引导--------------------------------
function XiuWeiJiNengWnd_OnOpen()
	if IsFreshHelp['xiuweijineng'] ~= nil and IsFreshHelp['xiuweijineng'] == 0 then
		IsFreshHelp['xiuweijineng'] = 1
		API_ShowWndRect('95/97/97100/971001/0/0', 10, 0, 0, 0)
		API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'XiuWeiJiNengWnd')
		API_RegisterWinTrigger("95/97/97100/971001/0/0", XWIN_EVENT_CLICK, "LearnXiuweiSkill_Guid_1", true)
	end
end

----引导点击升级
function LearnXiuweiSkill_Guid_1()
	API_ShowWndRect('95/97/97017', 10, 0, 0, 0)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'XiuWeiJiNengWnd')
	--API_RegisterWinTrigger("95/97/97017", XWIN_EVENT_CLICK, "LearnXiuweiSkill_Guid_2", true)
end
----引导点击关闭
function LearnXiuweiSkill_Guid_2()
	API_ShowWndRect('95/95000', 10, 0, 0, 0)
	--API_RegisterWinTrigger("95/95000", XWIN_EVENT_CLICK, "OnContinueTask", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'XiuWeiJiNengWnd')
end

function XiuWeiJingJieWnd_OnOpen()
	if IsFreshHelp['xiuweijingjie'] ~= nil and IsFreshHelp['xiuweijingjie'] == 0 then
		IsFreshHelp['xiuweijingjie'] = 1
		local levelUpBtn = API_GetWindowByPath('95/98/9806')
		XiuWeiJingJieWnd_Click()
		-- if levelUpBtn:IsEnabled() == true then
			-- API_ShowWndRect('95/98/9806', 10, 0, 0, 0)
			-- API_RegisterWinTrigger("95/98/9806", XWIN_EVENT_CLICK, "XiuWeiJingJieWnd_Click", true)
			-- API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'XiuWeiJiNengWnd')
		-- else
			-- XiuWeiJingJieWnd_Click()
		-- end
	end
end

function XiuWeiJingJieWnd_Click()
	API_ShowWndRect('95/98/9807', 10, 0, 0, 0)
	API_RegisterWinTrigger("95/98/9807", XWIN_EVENT_CLICK, "LearnXiuweiSkill_Guid_2", true)
	--API_RegisterWinTrigger("95/98/9807", XWIN_EVENT_CLICK, "XiuWeiJingJieWnd_Click", true)
	API_RegisterEventTrigger(enFreshmanHelpEvent_GlobalMouseUp, 'RemoveHelpEffect', true, 'XiuWeiJiNengWnd')
end

---------------------------------活动界面引导---------------------
function OnFirstOpenActivityWnd()
	if IsFreshHelp["activity"] ~= nil and IsFreshHelp["activity"] == 0 then
		IsFreshHelp["activity"] = 1
		WndSystem:GetInstance():OnEvent(866, 86606, 3, 0)		-----打开新手指引窗口
	end
end

---------------------------------上线时 如果可以签到 给提示--------------------------

function On_ShowSignAnimate()
	local lastSignTime	= core.getHero():GetCrtProp(enProp_Actor_Sign_Last_time)
	if XDate:GetInstance():IsSameDay(XDate:GetInstance():GetCurrentVTime(), lastSignTime) == true then	----今天已经签到
		return
	end
	
	local signWnd = API_GetWindowByPath('2013/201301/819')
	local animat = signWnd:GetAni('flashanim')
	local singBtn = API_GetWindowByPath('2013/201301/819/81900')
	if animat ~= nil then
		animat:PlayAni(true)
		singBtn:SetClickEventHandler2(function(wnd, evt, p1, p2, p3)
					animat:PlayAni(false)
					end)
	end
end


