local TaskRewardDisplayCfg =
{
    {rewardtype = 0,	iconid = 0, 	tip = ""},
    {rewardtype = 1, 	iconid = 0,		tip = ""},
	{rewardtype = 2, 	iconid = 13000, tip = "@interact_reward_exp"},
	{rewardtype = 3, 	iconid = 13001,	tip = "@interact_reward_silver"},
	{rewardtype = 4, 	iconid = 8509,	tip = "@interact_reward_gold"},
	{rewardtype = 5, 	iconid = 0,		tip = "@interact_reward_good"},
	{rewardtype = 6, 	iconid = 0,		tip = "@interact_reward_pet"},
	{rewardtype = 7, 	iconid = 13000, tip = "@interact_reward_petexp"},
	{rewardtype = 8, 	iconid = 0,		tip = "@interact_reward_good"},
	{rewardtype = 9, 	iconid = 0,		tip = ""},
	{rewardtype = 10,	iconid = 8512,	tip = "@interact_reward_silveringot"},
	{rewardtype = 11,	iconid = 8313,	tip = "@interact_reward_goldingot"},
	{rewardtype = 12, 	iconid = 0,		tip = "@interact_reward_ride"},
	{rewardtype = 13, 	iconid = 0,		tip = ""},
};
function GetTaskRewardDisplayCfg()
	return cjson.encode(TaskRewardDisplayCfg)
end

--t类型，1绑定元宝，2物品，n数值，如果类型是绑定元宝，则是数目，如果是物品，则是物品ID
local download_res_reward = 
{
	{t = 1, n = 20044, c = 100},
	{t = 2, n = 24054, c =   3},
	{t = 2, n = 24052, c =   5},
}

function GetDownloadResReward()
	cjson.encode_sparse_array(true)
	return cjson.encode(download_res_reward)
end

local GroupAttackSkillIDs = 
{
	6020, --呼风唤雨
	4030, --云龙三折
	5050, --漫天花雨
	3050, --覆雨箭
}

function GetGroupAttackSkillIDs()
	return GroupAttackSkillIDs
end

--扩展可打印字符范围
local ExtPrintableCharRange =
{
	{from = 0x0080, to = 0x00FF},	--Latin-1 Supplement
	{from = 0x0100, to = 0x024F},	--Latin Extended-A, -B
	{from = 0x0300, to = 0x036F},	--Diacritical Marks
	{from = 0x1E00, to = 0x1EFF},	--Latin Extended Additional
	{from = 0xAC00, to = 0xD7AF},	--Korea
}
function GetExtPrintableCharRange()
	cjson.encode_sparse_array(true)
	return cjson.encode(ExtPrintableCharRange)
end

------------全局变量设置------------
--不要单词内换行分割
bcl.setProperty("NoWordBreak", 0)

--是否显示删除按钮
bcl.setProperty("BShowDelBtn", 1)

--玩家最高等级
bcl.setProperty("Actor_Max_Level",100)
--玩家可以升到的最高等级
bcl.setProperty("Actor_Levelup_Max_Level",79)
--System自动帮玩家升级的最大等级
bcl.setProperty("Sys_Auto_Levelup_Max_Level",79)
--max actor count
bcl.setProperty("MaxAccountActorCreateCount", 1)

--显示拍卖按钮
bcl.setProperty("ShowAuctionButton", 1)

--副伙伴有装备是否能合成
bcl.setProperty("VicePetEquipCanCompose", 1)

--伙伴加寿命的物品ID
bcl.setProperty("AddPetLifeGoodsID", 25114)

--tooltip是否不显示类别名
bcl.setProperty("BNotShowToolClass", 0)