﻿
----节日兑换商店 npc处打开

module("FestShop", package.seeall)

local festShop_Wnd_ID	= 1051
local moduleName = 'FestShop'

local ShopWnd 		= nil
local LimiteGoodsNum  = 5

local XingChenID	= 21221		----节日星尘ID
local JingPoID		= 21222		----节日精魄ID

local LimitGoodsPanel = {}

local catchGoods = {}

local msgBoxIsOpen = false		----是否打开了确认框

-----窗口初始化
function festShop_Wnd_init()
	--注册消息
    api_reg_module_msg_handler(moduleName, festShop_msg_handler)
	
	ShopWnd = core.createWindow('Data/Scp/Windows/Windows_FestivalShop.scp',festShop_Wnd_ID)
	
	ShopWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'FestShopOpen')
	
end

function festShop_msg_handler(msg)
	API_Trace('msg.msg_code '..msg.msg_code.. 'msg.moduleName '..msg.module)
	if msg.msg_code == 'OnShowWnd' then
		Shop_updateList(msg)
	elseif msg.msg_code == 'OnBuyOK' then
		Shop_updateShenLNum(msg)
	end
end

----更新左边栏元宝道具数量
function festShop_updateItem()
	local hero = core.getHero()
	if hero == nil then
		return
	end
	local goldIngot 	= hero:GetCrtProp(enProp_Actor_M_GoldIngot)
	local silverIngot 	= hero:GetCrtProp(enProp_Actor_SilverIngot)
	local xingChenNum 	= hero:GetPacketPart():GetNumByGoodsID(XingChenID)
	local jingPoNum 	= hero:GetPacketPart():GetNumByGoodsID(JingPoID)
	ShopWnd:GetLabel('星尘数量'):setText(''..xingChenNum)
	ShopWnd:GetLabel('节日精魄'):setText(''..jingPoNum)
	ShopWnd:GetMoneyLabel('元宝'):SetMoney(goldIngot)
	ShopWnd:GetMoneyLabel('绑定元宝'):SetMoney(silverIngot)
end

function Shop_updateList(msg)

	local shopMainWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1050)
	shopMainWnd:SetVisible(true)
	XWinUtil:AlignWindow(shopMainWnd, ShopWnd,  XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 22,0, 78,  0,false);
	----获得购买数量
	LimiteGoodsNum 	= msg.limitGoodsNum
	XingChenID		= msg.XingChenID
	JingPoID		= msg.JingPoID
	----显示节日兑换道具和元宝数量
	festShop_updateItem()
	catchGoods = {}
	local panelmgr = ShopWnd:GetScrollMgr('scrollmgr'):GetPanelMgr('panelmgr')
	local  panel_count = panelmgr:GetPanelCount()
	for k=1, panel_count do
		local panel = panelmgr:GetPanelWnd(k-1)
		if k<= #msg.goodsList then
			local panel = panelmgr:GetPanelWnd(k-1)
			goodsInfo = msg.goodsList[k]
			panel:SetVisible(true)
			----物品名
			local goodsName = panel:GetLabel('name')
			local goods_cfg = core.getGoodsConfig(goodsInfo.goodsID)
			goodsName:setText(goods_cfg.szName)
			
			----兑换按钮
			local btn_buy = panel:GetButton('兑换')
			btn_buy:SetClickEventHandler('festShop_buy_handler')
			btn_buy:SetPropertyInt32('goodsID',goodsInfo.goodsID)
			btn_buy:SetPropertyInt32('goldType',goodsInfo.goldType)
			btn_buy:SetPropertyInt32('goldNum',goodsInfo.goldNum)
			btn_buy:SetPropertyInt32('itemID',goodsInfo.itemID)
			btn_buy:SetPropertyInt32('itemNum',goodsInfo.itemNum)
			btn_buy:SetPropertyInt32('itemID1',goodsInfo.itemID1)
			btn_buy:SetPropertyInt32('itemNum1',goodsInfo.itemNum1)
			btn_buy:SetEnabled(true)
			
			----buyType是0时 表示非限购物品
			local moneyLabel = panel:GetMoneyLabel('moneyLabel')
			----限制购买的个数显示label
			local limitLabel = panel:GetLabel('limiteLabel')
			
			----购买所需道具数量和图标设置
			local itemNum 	= panel:GetLabel('节日道具')
			local itemBit 	= panel:GetStaticBitmap("道具图标")
			local itemNum1 	= panel:GetLabel('节日道具2')
			local itemBit1 	= panel:GetStaticBitmap("道具图标2")
			if goodsInfo.itemID == XingChenID then
				itemBit:SetBitmap('Icon/1013.png')
			elseif goodsInfo.itemID == JingPoID then
				itemBit:SetBitmap('Icon/1014.png')
			end
			
			if goodsInfo.buyType == 0 then
				limitLabel:SetVisible(false)
				
				----设置兑换所需物品的显示
				local firstLabel = false
				----是否显示元宝
				if goodsInfo.goldNum > 0 then
					moneyLabel:SetVisible(true)
					moneyLabel:SetMoneyType(goodsInfo.goldType)
					moneyLabel:SetMoney(goodsInfo.goldNum)
					
					itemNum1:SetVisible(false)
					itemBit1:SetVisible(false)
					firstLabel = true
				else
					itemNum1:SetVisible(true)
					itemBit1:SetVisible(true)
					moneyLabel:SetVisible(false)
				end
				----
				if firstLabel == true then
					if goodsInfo.itemNum > 0 then
						itemNum:setText(''..goodsInfo.itemNum)
						itemBit:SetBitmap('Icon/1013.png')
					elseif goodsInfo.itemNum1 > 0 then
						itemNum1:setText(''..goodsInfo.itemNum)
						itemBit1:SetBitmap('Icon/1014.png')
					end
				else
					if goodsInfo.itemNum > 0 then
						itemNum:setText(''..goodsInfo.itemNum)
						itemBit:SetBitmap('Icon/1013.png')
					end
					if goodsInfo.itemNum1 > 0 then
						itemNum1:setText(''..goodsInfo.itemNum1)
						itemBit1:SetBitmap('Icon/1014.png')
					end
				end
			else
				----将限购的物品所在的panel 保存下来
				LimitGoodsPanel[goodsInfo.goodsID] = panel
				moneyLabel:SetVisible(false)
				itemNum1:SetVisible(false)
				itemBit1:SetVisible(false)
				limitLabel:SetVisible(true)
				local leftNum = LimiteGoodsNum - goodsInfo.buyNum
				limitLabel:setText('限购：'..leftNum)
				limitLabel:SetForeColor(XColor:new(255, 255, 255))
				
				if goodsInfo.itemNum > 0 then
					itemNum:setText(''..goodsInfo.itemNum)
					itemBit:SetBitmap('Icon/1013.png')
				end
				
				if goodsInfo.itemNum1 > 0 then
					itemNum:setText(''..goodsInfo.itemNum1)
					itemBit:SetBitmap('Icon/1014.png')
				end
				 
				
				if leftNum <= 0 then
					limitLabel:setText('限购：0')
					limitLabel:SetForeColor(XColor:new(255, 0, 0))
					btn_buy:SetEnabled(false)
				else
					btn_buy:SetEnabled(true)
				end
				
			end
			
			----物品icon
			local viewbox = panel:GetItemViewBox('icon')
			
			viewbox:SetItem(goodsInfo.goodsID,1,false,0)
			
		else
			panel:SetVisible(false)
		end
	end
end

function Shop_updateShenLNum(msg)
	---- 限购物品 更新购买个数
	if msg.buyType == 1 then
		local panel = LimitGoodsPanel[msg.goodsID]
		local btn_buy = panel:GetButton('兑换')
		local limitLabel = panel:GetLabel('limiteLabel')
		local leftNum = msg.leftNum
		limitLabel:setText('限购：'..leftNum)
		limitLabel:SetForeColor(XColor:new(255, 255, 255))
		if leftNum <= 0 then
			limitLabel:setText('限购：0')
			limitLabel:SetForeColor(XColor:new(255, 0, 0))
			btn_buy:SetEnabled(false)
		else
			btn_buy:SetEnabled(true)
		end
	end
	festShop_updateItem()
end

function festShop_buy_handler(wnd,event)
	-- local goldType = wnd:GetPropertyInt32('goldType')
	catchGoods.itemID 	= wnd:GetPropertyInt32('itemID')
	catchGoods.itemNum	= wnd:GetPropertyInt32('itemNum')
	catchGoods.itemID1	= wnd:GetPropertyInt32('itemID1')
	catchGoods.itemNum1 = wnd:GetPropertyInt32('itemNum1')
	catchGoods.goldNum 	= wnd:GetPropertyInt32('goldNum')
	catchGoods.goodsID 	= wnd:GetPropertyInt32('goodsID')
	
	local goods_cfg = core.getGoodsConfig(catchGoods.goodsID)
	if msgBoxIsOpen == false then
		g_pGlobal:GetMainUI():ShowMessageBox("是否确定兑换#(color,orange)"..goods_cfg.szName.."#(color,restore)","festShop_buy_goods",catchGoods.goodsID,0,"确定","取消")
		msgBoxIsOpen = true
	end
end
rawset(_G, "festShop_buy_handler", festShop_buy_handler)

function festShop_buy_goods(msgid,wparam,lparam)
	msgBoxIsOpen = false
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local msg = {}
	msg.module =  moduleName
	msg.goodsID = wparam
	msg.goodsInfo = catchGoods
	msg.msg_code = 'OnBuyGoods'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
	catchGoods = {}
end
rawset(_G, "festShop_buy_goods", festShop_buy_goods)

function FestShopOpen()
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'OnOpenRequest'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end
rawset(_G, "FestShopOpen", FestShopOpen)
----------------初始化窗口-----------------------
festShop_Wnd_init()


----------------------------------------------------------------节日兑换商店主窗口-----------------------------------------------------
local specialMainShop_Wnd_ID 	= 1050
local cur_flip_num		= 0
local subWndList 		= {}
local flip_Page			= nil
local animate_wenhao 	= nil

local mainShopWnd 		= nil
local mainTitle			= nil

function festMainShopWndinit()
	mainShopWnd = core.createWindow('Data/Scp/Windows/Windows_FestivalShop.scp',specialMainShop_Wnd_ID)
	
	local btn_close = mainShopWnd:GetButton('关闭按钮')
	btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'festMainShopWnd_OnClose')
	
	flip_Page	= mainShopWnd:GetFlipPage('切换页')
	for k=1, (flip_Page:GetPageNum()) do 
		local flipBtn 	= flip_Page:GetPageBtnx(k-1)
		flipBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'festMainShopWnd_SwitchFlip')
	end
	
	mainTitle = mainShopWnd:GetLabel('标题')
	mainTitle:setText('节日兑换')
	
	cur_flip_num = 0
	mainShopWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'festMainShopWnd_OnShow')
	
end

function festMainShopWnd_OnShow()
	cur_flip_num = 0
	----添加蟠桃园窗口
	local festShopWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(festShop_Wnd_ID) 
	if subWndList[0] == nil then
		subWndList[0] = festShopWnd
		mainShopWnd:AddWindow(festShopWnd)
	end
	
	festMainShopWnd_OnSwitchFlip(0)
end
rawset(_G, "festMainShopWnd_OnShow", festMainShopWnd_OnShow)

function festMainShopWnd_SwitchFlip(wnd)
	local index = XButton:CastToButton(wnd):GetTag1()
	festMainShopWnd_OnSwitchFlip(index)
end
rawset(_G, "festMainShopWnd_SwitchFlip", festMainShopWnd_SwitchFlip)

function festMainShopWnd_OnSwitchFlip(index)
	subWndList[index]:SetVisible(true)
	flip_Page:TurnPage(index)
	cur_flip_num = index
end

function festMainShopWnd_OnClose()
	mainShopWnd:SetVisible(false)
end
rawset(_G, "festMainShopWnd_OnClose", festMainShopWnd_OnClose)


festMainShopWndinit()
