﻿---------------------------------------------------------------------------------------------------------------------
--文件名:	SkyShop.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.12.25
--版  本:	1.0
--描  述:	逆天圣装兑换窗口
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("SkyShop",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
local modName = "SkyShop"

local thisWnd = nil
local myCanhunLabel = nil  -- 逆天残魂的label
local myCanpoLabel = nil  -- 逆天残魄的label
local canhunId = 23510  
local canpoId = 23511 
local initOk = false
--*常量 end**********************************************************--


--*3 变量************************************************************--

--*变量 end**********************************************************--


--*4 函数实现********************************************************--
-----窗口初始化
function init()
	--注册消息
    api_reg_module_msg_handler(modName, MsgHandler)
	
	thisWnd = core.createWindow('Data/Scp/Windows/Windows_SkyShop.scp',1069)
	
	myCanhunLabel = thisWnd:GetLabel("残魂数量")
	myCanpoLabel = thisWnd:GetLabel("残魄数量")
	
	thisWnd:SetShowEventHandler2(function()
			local shopMainWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1032)
			--XWinUtil:AlignWindow(shopMainWnd, Peach_Wnd,  XWinUtil.enXUAlign_RIGHT_RIGHT, XWinUtil.enXUAlign_TOP_TOP, 80, 0, 10, 0, false);
			XWinUtil:AlignWindow(shopMainWnd, thisWnd,  XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 22,0, 78,  0,false);
			
			--设置残魂数量
			if core.getHero() == nil then return end
			local canhunNum = core.getHero():GetPacketPart():GetNumByGoodsID(canhunId)
			local canpoNum = core.getHero():GetPacketPart():GetNumByGoodsID(canpoId)
			myCanhunLabel:setText(''..canhunNum)
			myCanpoLabel:setText(''..canpoNum)
			
			local msg = {}
			msg.module =  modName
			msg.msg_code = 'RequestCfg'
			local str = cjson.encode(msg)
			g_pGlobal:SendScriptMsg(str)
		end
	)
	
	--兑换按钮
	local panelmgr = thisWnd:GetScrollMgr('scrollmgr'):GetPanelMgr('panelmgr')
	local  panel_count = panelmgr:GetPanelCount()
	for i=1, panel_count do
		local panel = panelmgr:GetPanelWnd(i-1)
		local btn_buy = panel:GetButton('兑换')
		btn_buy:SetClickEventHandler2(OnBtnBuy)
	end
end

function MsgHandler(msg)
	if msg.msg_code == 'RequestCfg' then
		RequestCfg(msg)
	elseif msg.msg_code == 'OnBuyOK' then
		OnBuyOK(msg)
	end
end

function RequestCfg(msg)
	local hero = core.getHero()
	local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local sex  = hero:GetCrtProp(enProp_Sex)
	
	local panelmgr = thisWnd:GetScrollMgr('scrollmgr'):GetPanelMgr('panelmgr')
	local  panel_count = panelmgr:GetPanelCount()
	local panelNo = 0
	for k=1, panel_count do
		local panel = panelmgr:GetPanelWnd(k-1)
		panel:SetVisible(false)
		if k<= #msg.config then
			panel = panelmgr:GetPanelWnd(panelNo)
			local curCfg = msg.config[k]
			
			local goodsCfg = core.getGoodsConfig(curCfg.goodsId)
			if goodsCfg.lClass ~= enGoodsCategory_Equip_Actor or 
			(g_pGlobal:GetGoodsClient():NeedCompare(curCfg.goodsId,cur_occ,sex)== true and goodsCfg.lClass == enGoodsCategory_Equip_Actor) then
				panel:SetVisible(true)
				----物品名
				local goodsName = panel:GetLabel("name")
				local goods_cfg = core.getGoodsConfig(curCfg.goodsId)
				goodsName:setText(goods_cfg.szName)
				----价格
				local btn_buy = panel:GetButton('兑换')
				for k2,v2 in pairs(curCfg.cutGoods) do
					if v2.goodsId == canhunId then
						local label = panel:GetLabel("残魂数量")
						label:setText(""..v2.num)
						btn_buy:SetPropertyInt32('canhunNum',v2.num)
					elseif v2.goodsId == canpoId then
						local label = panel:GetLabel("残魄数量")
						label:setText(""..v2.num)
						btn_buy:SetPropertyInt32('canpoNum',v2.num)
					end
				end
				
				----物品icon
				local viewbox = panel:GetItemViewBox('icon')
				
				viewbox:SetItem(curCfg.goodsId,1,false,6)
				----兑换按钮
				btn_buy:SetPropertyInt32('goodsId',curCfg.goodsId)
				
				panelNo = panelNo+1
			end
		end
	end
end

function OnBuyOK(msg)
	--设置残魂数量
	if core.getHero() == nil then return end
	local canhunNum = core.getHero():GetPacketPart():GetNumByGoodsID(canhunId)
	local canpoNum = core.getHero():GetPacketPart():GetNumByGoodsID(canpoId)
	myCanhunLabel:setText(''..canhunNum)
	myCanpoLabel:setText(''..canpoNum)
end

function OnBtnBuy(wnd,event)
	local goodsId = wnd:GetPropertyInt32('goodsId')
	local canhunNum =  wnd:GetPropertyInt32('canhunNum')
	local canpoNum =  wnd:GetPropertyInt32('canpoNum')
	local goodsCfg = core.getGoodsConfig(goodsId)
	local canhunCfg = core.getGoodsConfig(canhunId)
	local canpoCfg = core.getGoodsConfig(canpoId)
	
	local msg = "是否使用#(color,orange)"..canhunNum.."个逆天残魂#(color, restore)"
	msg = msg.."和#(color,red)"..canpoNum.."个逆天残魄#(color, restore)"
	msg = msg.."兑换#(color,yellow)"..goodsCfg.szName.."#(color,restore)"
	
	--职业符不符合
	local hero = core.getHero()
	local cur_occ = hero:GetCrtProp(enProp_Actor_Occupation)
	local sex  = hero:GetCrtProp(enProp_Sex)
	if goodsCfg ~= nil and goodsCfg.lClass == enGoodsCategory_Equip_Actor then
		if g_pGlobal:GetGoodsClient():NeedCompare(goodsId,cur_occ,sex) == false then
			msg = msg.."(这件装备不符合您穿戴)"
			
		end
	end	
	
	g_pGlobal:GetMainUI():ShowMessageBox(msg,"SkyShopBuyGoods",goodsId,0,"确定","取消")
end

function BuyGoods(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local msg = {}
	msg.module =  modName
	msg.goodsId = wparam
	msg.msg_code = 'OnBuyGoods'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end
--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
rawset(_G,"SkyShopBuyGoods",BuyGoods)--把函数设置成全局的
init()
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--
--*加载子模块 end****************************************************--