---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_copy_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.10.21
--版  本:	1.0
--描  述:	副本界面

----------------------------------------------------------------------------------------------------------------------
--**********************************************************--
------------------------一些变量------------------------------
local activityPropConfig = {
							[1]		= {countProp = enProp_Actor_XuemokuEnterTimes	, 	lastTimeProp = enProp_Actor_XuemokuLastTime}	 		,	--血魔窟
							[2]		= {countProp = enProp_Actor_FiveElementNum 		,	lastTimeProp = enProp_Actor_FiveElementLastTime}		,	--五行阵
							[3]		= {countProp = enProp_Actor_DemonCount			,	lastTimeProp = enProp_Actor_DemonLastTime}				,	--锁妖塔
							[4]		= {countProp = enProp_Actor_SecretsChamberCount	,	lastTimeProp = enProp_Actor_LastSecretsChamberTime}		,	--琅环阁
							[5]		= {countProp = enProp_Actor_WarriorTrialEnterCount, lastTimeProp = enProp_Actor_WarriorTrialLastTime}		, 	--试炼谷
							[13]		= {countProp = enProp_Actor_HuaguoshanEnterTimes,	lastTimeProp = enProp_Actor_HuaguoshanLastTime}		    ,	--轮回谷
							[30]    	= {countProp = enProp_Actor_XuemokuHardEnterTimes,  lastTimeProp = enProp_Actor_XuemokuHardLastTime}        ,   --精英血魔窟
							[31]    	= {countProp = enProp_Actor_FiveElementHardNum  ,   lastTimeProp = enProp_Actor_FiveElementHardLastTime}    ,   --精英五行阵
							[32]    	= {countProp = enProp_Actor_DemonHardCount      ,   lastTimeProp = enProp_Actor_DemonHardLastTime}    		,	--精英锁妖塔
							}
--不能帮我完成的活动
local cantHelpFinishActs = {5,30,31,32 }


activitycopy 					= {}	--自己
activitycopy.thisWnd  				= nil				
activitycopy.label_open_level		= nil
activitycopy.label_enter_count 		= nil
activitycopy.html_game_carbon_desc	= nil
activitycopy.btn_enter				= nil
activitycopy.btn_helpfinsh 			= nil
activitycopy.scrollmgr 				= nil
activitycopy.reward 				= {}
activitycopy.map_list 				= {}

--副本活动数据
activitycopy.activityList 			= nil
activitycopy.mouseX					= nil
activitycopy.currentSelIndex 		= 1
--帮我完成相关数据
activitycopy.helpfinishList 		= nil

function ActivityCopyInit(wnd)
	activitycopy.thisWnd = wnd
	--注册显示回调事件
	activitycopy.thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnActivityCopyShow')

	--副本缩略图
	activitycopy.scrollmgr 	= activitycopy.thisWnd:GetScrollMgr("activity_copy_scrollmgr")
	local panelmgr  	= activitycopy.scrollmgr:GetPanelMgr("map_mgr")
	local panelCount 	= panelmgr:GetPanelCount()
	for i=1, panelCount do
		local map_info = {}
		local panelwnd 				= panelmgr:GetPanelWnd(i-1)
		panelwnd:SetEventToWindow(activitycopy.scrollmgr)

		map_info.panelwnd 			= panelwnd
		map_info.game_carbon_name 	= panelwnd:GetLabel("game_carbon_name")
		map_info.map_icon_bg 		= panelwnd:GetButton("map_icon_bg")
		map_info.map_icon 			= panelwnd:GetButton("map_icon")
		map_info.to_be_continue 	= panelwnd:GetButton("to_be_continue")
		map_info.n_level_activate 	= panelwnd:GetButton("n_level_activate")
		map_info.n_level 			= panelwnd:GetLabel("n_level")
		map_info.map_selected 		= panelwnd:GetStaticBitmap("map_selected")
		map_info.exp_icon			= panelwnd:GetStaticBitmap("exp_icon")

		table.insert(activitycopy.map_list, map_info)

		panelwnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateCopyInfo')
		panelwnd:SetLuaEvent(XWIN_EVENT_MOUSEDOWN,"OnSelectCopy")
	end

	--奖励
	local panelmgr 				= activitycopy.thisWnd:GetPanelMgr("reward_mgr")
	for i=1, panelmgr:GetPanelCount() do
		local panelwnd 			= panelmgr:GetPanelWnd(i-1)
		local reward_icon 		= panelwnd:getWindow("reward_icon")
		local reward_quality 	= panelwnd:getWindow("reward_quality")
		
		local reward 			= {
								reward_icon 		= reward_icon,
								reward_quality		= reward_quality,
									}
		table.insert(activitycopy.reward, reward)
	end

	activitycopy.label_open_level			= activitycopy.thisWnd:GetLabel("open_level")
	activitycopy.label_enter_count 			= activitycopy.thisWnd:GetLabel("enter_count")
	activitycopy.html_game_carbon_desc		= activitycopy.thisWnd:GetHtml("game_carbon_desc")

	activitycopy.btn_enter 					= activitycopy.thisWnd:GetButton("enter_game_carbon")
	activitycopy.btn_enter:SetLuaEvent(XWIN_EVENT_CLICK, 'OnEnterGameCarBon')
	activitycopy.btn_helpfinsh				= activitycopy.thisWnd:GetButton("helpfinish")
	activitycopy.btn_helpfinsh:SetLuaEvent(XWIN_EVENT_CLICK, 'OnHelpFinish')


	--向前滚按钮
	activitycopy.thisWnd:GetButton('preChunk'):SetClickEventHandler2(
		function ( wnd, event) 	
			local chunkNo = activitycopy.scrollmgr:GetChunkNo()
			if chunkNo > 0 then
				activitycopy.scrollmgr:SetChunkNo(chunkNo-1)
			end	
		end
		)
		
	--向后滚按钮
	activitycopy.thisWnd:GetButton('nextChunk'):SetClickEventHandler2(
		function ( wnd, event) 	
			local chunkNo = activitycopy.scrollmgr:GetChunkNo()
			if chunkNo < 2 then
				activitycopy.scrollmgr:SetChunkNo(chunkNo+1)
			end	
		end
		)

end


--发消息请求帮我完成的数据
local function GetHelpFinishList()
	--发消息
	local msg = {}
	msg.module   	= "activity_info"
	msg.msg_code 	= "getHelpFinishInfo"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end


--排序函数
local function ActivityCopySortFunc(a, b)
	return a.activityLevel[1] < b.activityLevel[1]
end

function OnActivityCopyShow(wnd, event)
	local hero = core.getHero()
	if hero == nil then return end
	--请求帮我完成的数据
	if activitycopy.helpfinishList == nil then
		GetHelpFinishList()
	end

	if activitycopy.activityList == nil then
		activitycopy.activityList = GetAllActivityInfoByActivityType(1)
		--API_Trace(cjson.encode(activitycopy.activityList))
		--排序
		table.sort(activitycopy.activityList, ActivityCopySortFunc)
	end
	--玩家等级
	local level = API_GetHeroLevel()
	
	for i=1 , #activitycopy.map_list do
		local activityInfo = activitycopy.activityList[i]
		if activityInfo ~= nil then
			activitycopy.map_list[i].map_icon:SetBitmap("Icon/"..activityInfo.activityMapICON..".png")
			activitycopy.map_list[i].exp_icon:SetBitmap("text3/activity_exp"..activityInfo.activityExpLevel..".png")
			activitycopy.map_list[i].game_carbon_name:setText(activityInfo.activityName)
			--判断等级 等级不够的情况
			if level < activityInfo.activityLevel[1] then
				activitycopy.map_list[i].n_level:setText(activityInfo.activityLevel[1])
				activitycopy.map_list[i].n_level:SetVisible(true)
				activitycopy.map_list[i].n_level_activate:SetVisible(true)
				activitycopy.map_list[i].map_icon:SetEnabled(false)
				activitycopy.map_list[i].exp_icon:SetVisible(false)
				activitycopy.map_list[i].map_icon_bg:SetEnabled(false)
			else
				activitycopy.map_list[i].n_level:SetVisible(false)
				activitycopy.map_list[i].n_level_activate:SetVisible(false)
				activitycopy.map_list[i].map_icon:SetEnabled(true)
				activitycopy.map_list[i].exp_icon:SetVisible(true)
				activitycopy.map_list[i].map_icon_bg:SetEnabled(true)
			end
			--判断今日参加次数
			--hero:GetCrtProp(activityPropConfig[activityInfo.activityID])

		else
			activitycopy.map_list[i].panelwnd:SetVisible(false)
		end
	end

	activitycopy.mouseX = nil
	--选中第一个
	OnUpdateCopyInfo(activitycopy.map_list[1].panelwnd)
end

function OnSelectCopy(wnd, event)
	activitycopy.mouseX = XDesktop:GetInstance():GetMouseXY().x
end

function OnUpdateCopyInfo(wnd, event)
	--API_Trace("OnUpdateCopyInfo")
	--滚动的时候防止被点击到
	if activitycopy.mouseX ~= nil and math.abs(activitycopy.mouseX - XDesktop:GetInstance():GetMouseXY().x) > 10 then
		return
	end

	local hero = core.getHero()
	if hero == nil then return end
	--玩家等级
	local level = API_GetHeroLevel()

	for i=1 , #activitycopy.map_list do
		local activityInfo = activitycopy.activityList[i]
		if wnd == activitycopy.map_list[i].panelwnd then
			activitycopy.label_open_level:setText(FormatLevel(activityInfo.activityLevel))

			local enterCount 		= API_GetActivityAlreadyTimes(activityPropConfig[activityInfo.activityID]['countProp'], activityPropConfig[activityInfo.activityID]['lastTimeProp'])
			
			if activityInfo.activityCount ~= 0 then
				activitycopy.label_enter_count:setText(enterCount.."/"..activityInfo.activityCount)
			else
				activitycopy.label_enter_count:setText("无限制")
			end
			activitycopy.html_game_carbon_desc:Clear()
			activitycopy.html_game_carbon_desc:ParseContext(activityInfo.activityDesc)
			--更新奖励
			local rewardCount 	= table.maxn(activityInfo.activityReward)
		 	for i=1, #activitycopy.reward do
		 		if i <= rewardCount then
		 			
		 			activitycopy.reward[i].reward_icon:SetBitmapIcon(activityInfo.activityReward[i].rewardICON)
		 			activitycopy.reward[i].reward_icon:SetToolTipIndex(activityInfo.activityReward[i].rewardToolTipID)
		 			activitycopy.reward[i].reward_icon:SetVisible(true)
		 			if activityInfo.activityReward[i].rewardQuality == 0 then
		 				activitycopy.reward[i].reward_quality:SetVisible(false)
		 			else
		 				activitycopy.reward[i].reward_quality:SetBitmap( ActivityClient.Quality[activityInfo.activityReward[i].rewardQuality] )
		 				activitycopy.reward[i].reward_quality:SetVisible(true)
		 			end
		 		else
		 			
		 			activitycopy.reward[i].reward_icon:SetVisible(false)
		 			activitycopy.reward[i].reward_quality:SetVisible(false)
		 			activitycopy.reward[i].reward_icon:SetToolTipIndex(-1)
		 		end
		 	end
		 	--如果等级不在范围 那么 "帮我完成"按钮灰色
		 	if level >= activityInfo.activityLevel[1] and (activityInfo.activityLevel[2] == -1 or level <= activityInfo.activityLevel[2]) then
		 		activitycopy.btn_helpfinsh:SetEnabled(true)
		 		activitycopy.btn_enter:SetEnabled(true)
		 	else
		 		activitycopy.btn_helpfinsh:SetEnabled(false)
		 		activitycopy.btn_enter:SetEnabled(false)
		 	end
		 	--下面是特殊处理的
		 	---[[试炼谷没法帮我完成
		 	if IsInTable(cantHelpFinishActs, activityInfo.activityID) then
				activitycopy.btn_helpfinsh:SetEnabled(false)
		 	end
			--]]
		 	--显示选中状态
		 	activitycopy.map_list[i].map_selected:SetVisible(true)
		 	--更新当前选中的index
		 	activitycopy.currentSelIndex = i
		else
			--取消其他的选中状态
			activitycopy.map_list[i].map_selected:SetVisible(false)
		end
	end	
end

--进入副本
function OnEnterGameCarBon(wnd, event)
	local activityInfo = activitycopy.activityList[activitycopy.currentSelIndex]
	if activityInfo == nil then
		return
	end
	ActivityTransmit(activityInfo.activityID)
	----发消息
	--local msg = {}
	--msg.module   	= "activity_info"
	--msg.msg_code 	= "enterActivity"
	--msg.activity_id = activityInfo.activityID
	--local jsonstr = cjson.encode(msg)
	--g_pGlobal:SendScriptMsg(jsonstr)
end

--function OnHelpFinishAsk(wnd, event)
	----API_Trace(cjson.encode(activitycopy.helpfinishList))
	--local hero = core.getHero()
	--if hero == nil then API_Trace("getHero error") return end
--
	--if activitycopy.helpfinishList == nil then
	--	API_ShowSystemMessage(enSysMsgDisplayType_Float, "数据加载中，请稍后重试。")
	--	return 
	--end 
	--local activityInfo 		= activitycopy.activityList[activitycopy.currentSelIndex]
--
	--local helpfinishInfo  	= nil
	--for k, v in pairs(activitycopy.helpfinishList) do
	--	if v.activityID == activityInfo.activityID then
	--		helpfinishInfo = v
	--	end
	--end
	--if helpfinishInfo ~= nil then
	--	local sliverIngot  	= hero:GetCrtProp(enProp_Actor_SilverIngot)
	--	local ingot 		= hero:GetCrtProp(enProp_Actor_M_GoldIngot)
	--	if sliverIngot + ingot < helpfinishInfo.needIngots then
	--		API_ShowSystemMessage(enSysMsgDisplayType_Float, "您的元宝不足#(GoldIngot,"..helpfinishInfo.needIngots..")")
	--		return
	--	end
	--	g_pGlobal:GetMainUI():ShowMessageBox("使用帮我完成会扣除#(GoldIngot,"..helpfinishInfo.needIngots..")，若绑定元宝不够，会扣除元宝，是否继续？","OnHelpFinish",0,0,"确定","取消");
	--end
--end

--消息框回调函数
function OnHelpFinish(msgid,wparam,lparam)
	--if(msgid ~= WE_AW_BTN1_CLICKED) then
	--	return
	--end
--
	local activityInfo = activitycopy.activityList[activitycopy.currentSelIndex]
	if activityInfo == nil then
		return
	end
	if activityInfo.activityID == 5 then return end
	--发消息
	local msg = {}
	msg.module   	= "activity_info"
	msg.msg_code 	= "help_finish"
	msg.activityName = activityInfo.activityName
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end