---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\auction\auction_add_sell_thing_wnd.lua
--版  权:	(C)盛游
--创建人:	linhongwei
--日  期:	2013.8.6
--版  本:	1.0
--描  述:	出售窗口
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
AuctionAddSellThingWnd = {}

AuctionAddSellThingWnd.this_wnd = nil  				--自己
AuctionAddSellThingWnd.auc_thing_vb = nil			--拍卖品viewbox
AuctionAddSellThingWnd.fix_price_medit = nil		--一口价的moneyedit
AuctionAddSellThingWnd.fee_mlabel = nil				--手续费
AuctionAddSellThingWnd.packet_btn = nil				--背包按钮
AuctionAddSellThingWnd.pet_btn = nil				--宠物按钮
AuctionAddSellThingWnd.sell_btn	= nil					--上架按钮



local sell_thing_uid = nil		--当前放在viewbox中的物品的uid
local sell_thing_nLevel = nil	
local sell_thing_nId = nil
local sell_thing_quality = nil
local sell_thing_nStarLevel = nil 
local show_pet_wnd_Id = nil

local wndid_packet = 68			--背包窗口的id

--**********************************************************--
------------------------函数列表------------------------------
--初始化
function auction_add_sell_thing_init(wnd)
	AuctionAddSellThingWnd.this_wnd = wnd
	
	--设置显示时的调用
	AuctionAddSellThingWnd.this_wnd:SetShowEventHandler('auction_add_sell_thing_onshow')
	AuctionAddSellThingWnd.this_wnd:SetHideEventHandler('auction_add_sell_thing_onhide')
	
	--关闭按钮
	local btn_close = AuctionAddSellThingWnd.this_wnd:GetButton('关闭按钮')
	btn_close:SetClickEventHandler('auction_add_sell_thing_btn_close')
	
	--拍卖品viewbox 
	AuctionAddSellThingWnd.auc_thing_vb = AuctionAddSellThingWnd.this_wnd:GetItemViewBox('拍卖品vb')
	AuctionAddSellThingWnd.auc_thing_vb:SetLuaEvent(XWIN_EVENT_DBCLK, 'auction_add_sell_vb_dclick')
	
	
	--一口价的moneyedit
	AuctionAddSellThingWnd.fix_price_medit = AuctionAddSellThingWnd.this_wnd:GetMoneyEdit('一口价值')
	AuctionAddSellThingWnd.fix_price_medit:SetLuaEvent(XWIN_EVENT_MEDIT_CHANGE, 'auction_add_sell_thing_fixprice')

	--背包按钮
	AuctionAddSellThingWnd.packet_btn = AuctionAddSellThingWnd.this_wnd:GetButton('背包')
	AuctionAddSellThingWnd.packet_btn:SetClickEventHandler("auction_add_sell_packet_click")
	
	--宠物按钮
	AuctionAddSellThingWnd.pet_btn= AuctionAddSellThingWnd.this_wnd:GetButton('伙伴')
	AuctionAddSellThingWnd.pet_btn:SetClickEventHandler("auction_add_sell_pet_click")
	
	--上架按钮
	AuctionAddSellThingWnd.sell_btn = AuctionAddSellThingWnd.this_wnd:GetButton('上架')
	AuctionAddSellThingWnd.sell_btn:SetClickEventHandler("auction_add_sell_sellthing_click")
	
	--背包双击物品监听
	api_reg_packet_listen(auction_add_sell_packet_listen)
		
	AuctionAddSellThingWnd.this_wnd:GetButton('一口价加'):SetClickEventHandler2( 
		function ( wnd, event) 	
			local fixprice = AuctionAddSellThingWnd.fix_price_medit:GetMoney()
			if fixprice < 0 then 
				fixprice = 0
			end
			AuctionAddSellThingWnd.fix_price_medit:SetMoney(fixprice+1)
		end
		)
		
	AuctionAddSellThingWnd.this_wnd:GetButton('一口价减'):SetClickEventHandler2( 
		function ( wnd, event) 	
			local fixprice = AuctionAddSellThingWnd.fix_price_medit:GetMoney()
			if fixprice > 1 then 
				AuctionAddSellThingWnd.fix_price_medit:SetMoney(fixprice-1)
			end
		end
		)
end



--窗口打开时
function auction_add_sell_thing_onshow()
	--改变下位置
	XWinUtil:AlignWindow(WndSystem:GetInstance():GetGameDesktop(),AuctionAddSellThingWnd.this_wnd,0, 15)
	XWinUtil:AlignWindow(WndSystem:GetInstance():GetGameDesktop(),AuctionAddSellThingWnd.this_wnd,9)
	
	--初始化支付方式为金币
	AuctionAddSellThingWnd.set_cur_paytype(enMoneyType_Ingot)
	
	--打开背包，先隐藏再显示可以确保显示在前端
	WndSystem:GetInstance():ShowWnd(wndid_packet,0);
	WndSystem:GetInstance():ShowWnd(wndid_packet,1);
	
	XWinUtil:AlignWindow(AuctionAddSellThingWnd.this_wnd,WndSystem:GetInstance():GetGameDesktop():FindWindowByID(wndid_packet),1, 15)
	
end

--窗口关闭时
function auction_add_sell_thing_onhide()
	--关闭背包
	WndSystem:GetInstance():ShowWnd(wndid_packet,0);
	
	--清空viewbox
	AuctionAddSellThingWnd.clear_vb()
	
	--关闭宠物列表窗口
	if show_pet_wnd_Id ~= nil then
		WndSystem:GetInstance():ShowWnd(show_pet_wnd_Id,0);
	end
end

--点击关闭
function auction_add_sell_thing_btn_close()
	AuctionAddSellThingWnd.this_wnd:SetVisible(false)
end

local function set_cur_paytype(moneytype)
	AuctionAddSellThingWnd.fix_price_medit:SetMoneyType(moneytype)
	
	--初始化数量
	AuctionAddSellThingWnd.fix_price_medit:SetMoney(0)
end

--点击背包按钮
function auction_add_sell_packet_click()
	WndSystem:GetInstance():ToggleWnd(wndid_packet)
end

--点击宠物按钮
function auction_add_sell_pet_click()
	if show_pet_wnd_Id ~= nil and WndSystem:GetInstance():IsWindowVisible(show_pet_wnd_Id) == true then
		WndSystem:GetInstance():ShowWnd(show_pet_wnd_Id,0);
	else
		local uid = core.strToUID(sell_thing_uid)
		AuctionAddSellThingWnd.update_pet_list(uid)
	end
end

--更新宠物列表
local function update_pet_list(uid)
	if uid ~= nil and AuctionAddSellThingWnd.check_is_monster(uid) == true then
		show_pet_wnd_Id = g_pGlobal:GetGoodsClient():ShowSelPetWnd('auction_add_pet_sel_cb',0,uid)--默认是不能选择绑定的宠物的
	else
		show_pet_wnd_Id = g_pGlobal:GetGoodsClient():ShowSelPetWnd('auction_add_pet_sel_cb')
	end
	
	XWinUtil:AlignWindow(AuctionAddSellThingWnd.this_wnd:GetID(),show_pet_wnd_Id,1)
	XWinUtil:AlignWindow(AuctionAddSellThingWnd.this_wnd:GetID(),show_pet_wnd_Id,9)
end

--查看这个uid对应的thing是不是物品
local function check_is_goods(uid)
	if uid == nil or uid == 0 then
		return false
	end
	
	local pThing = g_pGlobal:GetClientWorld():Find2(uid)
	if pThing == nil then
		return false
	end
	
	return pThing:GetThingClass()==enThing_Class_Goods
end

--查看这个uid对应的thing是不是宠物
local function check_is_monster(uid)
	if uid == nil then
		return false
	end
	
	local pThing = g_pGlobal:GetClientWorld():Find2(uid)
	if pThing == nil then
		return false
	end
	
	return pThing:GetThingClass()==enThing_Class_NPC
end

--一口价改变
function auction_add_sell_thing_fixprice()
	
end
	
--点击上架按钮
function auction_add_sell_sellthing_click()
	local hero = core.getHero()
	if hero==nil  then return end
	
	if sell_thing_uid == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先放入要交易的物品")
		return 
	end
	
	local moneyType =enMoneyType_Ingot
	
	local fixprice = AuctionAddSellThingWnd.fix_price_medit:GetMoney()
	if fixprice<=0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "一口价不能为空")
		return 
	end		
	
	AuctionClient.sell_thing(sell_thing_uid,moneyType,fixprice,fixprice)
end

--双击背包物品回调
function auction_add_sell_packet_listen(uid_packet_cb)
	--窗口开着才监听
	if AuctionAddSellThingWnd.this_wnd:IsVisible() == false then
		return false
	end
	
	--这里只要是物品而且是不绑定的就可以上架
	local pCGoods = core.getHero():GetPacketPart():GetContainerGoods2(uid_packet_cb)
	if pCGoods ==  nil then
		API_Trace("auction_add_sell_packet_listen error cannot find pCGoods by GetPacketPart():GetContainerGoods2() :"..uid_packet_cb:ToString())
		return false
	end
	local pGoods  = pCGoods:GetGoods2()
	if pGoods == nil then
		API_Trace("auction_add_sell_packet_listen error GetGoods2  :"..uid_packet_cb:ToString())
		return false
	end
	
	--锁了就不能放
	if pCGoods:IsLock() == true then
		return false
	end
	
	if pGoods:GetPropNum(enProp_Goods_Bind) == 1 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "只有不绑定的物品可以在交易行上架")
		return true --这里提示后就不再让其他模块监听了
	end
	
	--必须清空原来的
	AuctionAddSellThingWnd.clear_vb()
	
	--用UID做参数加入到viewbox
	AuctionAddSellThingWnd.auc_thing_vb:SetItem(uid_packet_cb)
	
	--上锁
	pCGoods:SetLock(true)
	
	sell_thing_uid = uid_packet_cb:ToString()
	sell_thing_nLevel = pGoods:GetPropNum(enProp_Level)
	sell_thing_nId = pGoods:GetPropNum(enProp_Goods_GoodsID)
	sell_thing_quality = pGoods:GetPropNum(enProp_Goods_Quality)
	sell_thing_nStarLevel = pGoods:GetPropNum(enProp_Goods_StarLevel) 

	--请求参考价
	AuctionClient.request_price(sell_thing_uid,sell_thing_nLevel,sell_thing_nId,sell_thing_quality,sell_thing_nStarLevel)
	
	return true
end

--选择宠物列表回调
function auction_add_pet_sel_cb(uid,user_data)
	--API_Trace("uid:"..uid:ToString())
	--窗口开着才监听
	if AuctionAddSellThingWnd.this_wnd:IsVisible() == false then
		return false
	end
	
	--必须清空原来的
	AuctionAddSellThingWnd.clear_vb()
	
	--用UID做参数加入到viewbox
	AuctionAddSellThingWnd.auc_thing_vb:SetItem(uid)
	
	sell_thing_uid = uid:ToString()
	
	AuctionAddSellThingWnd.update_pet_list(uid)
	
	--请求参考价
	local pPet = g_pGlobal:GetClientWorld():GetCreature2(uid)
	if pPet == nil then
		return false
	end
	
	sell_thing_nLevel = pPet:GetCrtProp(enProp_Level)
	sell_thing_nId = pPet:GetCrtProp(enProp_NPC_MonsterID)
	sell_thing_quality = pPet:GetCrtProp(enProp_NPC_Cur_Growth)-1 --这里是按物品品质算的，所以要减一
	sell_thing_nStarLevel = pPet:GetCrtProp(enProp_NPC_Cur_ClassLevel) 
	AuctionClient.request_price(sell_thing_uid,sell_thing_nLevel,sell_thing_nId,sell_thing_quality,sell_thing_nStarLevel)
	
end

local function clear_vb()
	local uid = core.strToUID(sell_thing_uid)
	--API_Trace("uid:"..uid:ToString())
	if AuctionAddSellThingWnd.check_is_goods(uid) == true then --如果是容器物品，那么应该先解锁
		local pCGoods = core.getHero():GetPacketPart():GetContainerGoods2(uid)
		if pCGoods ~=  nil then
			pCGoods:SetLock(false)
		end
		
	elseif AuctionAddSellThingWnd.check_is_monster(uid) == true then --如果是宠物的要更新下列表
		AuctionAddSellThingWnd.update_pet_list(nil)
	end

	AuctionAddSellThingWnd.auc_thing_vb:ClearItem()
	
	sell_thing_uid = nil
	sell_thing_nLevel = nil
	sell_thing_nId = nil 
	sell_thing_quality = nil
	sell_thing_nStarLevel = nil
end

--viewbox被双击
function auction_add_sell_vb_dclick()
	AuctionAddSellThingWnd.clear_vb()
end

--填入参考价
local function input_reference_price(uidThing,nLevel,nId,quality,nStarLevel,ref_bidprice,ref_fixprice)
	if AuctionAddSellThingWnd.this_wnd:IsVisible() == false then
		return false
	end

	if sell_thing_uid == nil or sell_thing_nLevel == nil or sell_thing_nId == nil 
			or sell_thing_quality == nil or sell_thing_nStarLevel == nil then
		return		
	end
	
	if sell_thing_uid ~= uidThing or sell_thing_nLevel ~= nLevel or sell_thing_nId ~= nId 
			or sell_thing_quality ~= quality or sell_thing_nStarLevel ~= nStarLevel then
		return		
	end
	
	if ref_fixprice == 0 then
		ref_fixprice = 1
	end
	AuctionAddSellThingWnd.fix_price_medit:SetMoney(ref_fixprice)
	
end
--**********************************************************--
--------------------刷脚本的时候执行--------------------------
AuctionAddSellThingWnd.set_cur_paytype=set_cur_paytype
AuctionAddSellThingWnd.clear_vb = clear_vb 
AuctionAddSellThingWnd.check_is_goods = check_is_goods 
AuctionAddSellThingWnd.check_is_monster = check_is_monster 
AuctionAddSellThingWnd.update_pet_list = update_pet_list
AuctionAddSellThingWnd.input_reference_price = input_reference_price 

