﻿

module("marry", package.seeall)

local moduleName = "marry"
local marry_Wnd_ID = 1039

local agree_bit		---同意的图片
local agree_btn		---同意的按钮

local agree_flag = false

local npc_talk_htm	---证婚词htm

local cp_actor_male 		---新郎
local cp_actor_female		---新娘
local cp_zhenghun_npc		---证婚人

local maleName		= 0
local femaleName	= 0
local maleActorID	= 0
local femaleActorID = 0

local fireworks1
local fireworks2		----烟花
local ringAni			----交换戒指

local marry_npc_talk = {
	[1] = "%s，无论顺境还是逆境，无论贫穷还是富有，无论健康还是疾病，你愿意和%s相亲相爱不离不弃直到永远吗？",
	[2] = "你愿意吗",
	[3] = "恭喜你们有情人终成眷属，祝愿你们百年好合，幸福永远！~",
}

local marry_npc_talk_idx = 1

function Marry_Wnd_init()
	--注册消息
    api_reg_module_msg_handler(moduleName, Marry_msg_handler)
	
	MarryWnd = core.createWindow('Data/Scp/Windows/Windows_Relation.scp',marry_Wnd_ID)
	
	agree_bit = MarryWnd:GetStaticBitmap("同意背景")
	agree_btn = MarryWnd:GetButton("同意按钮")

	agree_btn:SetLuaEvent2(XWIN_EVENT_CLICK, Marry_Agree)
	
	close_btn = MarryWnd:GetButton('关闭按钮')
	close_btn:SetLuaEvent2(XWIN_EVENT_CLICK, Marry_OnWndCanClose)
	
	cp_actor_male 	= MarryWnd:GetCreaturePreviewCtrl('cp_actor_male')
	cp_actor_female = MarryWnd:GetCreaturePreviewCtrl('cp_actor_female')
	cp_zhenghun_npc = MarryWnd:GetCreaturePreviewCtrl('cp_zhenghun_npc')
	
	fireworks1	= MarryWnd:GetAni('烟花1')
	fireworks2	= MarryWnd:GetAni('烟花2')
	
	ringAni		= MarryWnd:GetAni('交换戒指')
	
	npc_talk_htm = MarryWnd:GetHtml("证婚词")
	
end

function Marry_msg_handler(msg)
	if msg.msg_code == 'OnOpenMarryWnd' then
		maleName = msg.actorID1Name
		femaleName = msg.actorID2Name
		maleActorID	= msg.actorID1
		femaleActorID = msg.actorID2
		Marry_OpenWnd(msg.actorID1, msg.actorID2)
	elseif msg.msg_code == 'marry_succeed' then
		Marry_StartChangeRing(msg)
	elseif msg.msg_code == 'marry_failed' then
		Marry_Failed(msg)
	elseif msg.msg_code == 'fullScreenEffect' then
		EffectFlowerWndOpen()
	elseif msg.msg_code == 'OpenGiveFlowerWnd' then
		OnOpenGiveFlowerWnd(msg.targetActorID)
	elseif msg.msg_code == 'showSpecialFlower' then
		ShowReceiveFlowerWnd(msg.actorID, msg.actorName, msg.flowerID, msg.flowerNum, msg.fromFlag)
	elseif msg.msg_code == "useFlower" then
		WndSystem:GetInstance():ShowWnd(360,1)
	end
end

-----交换戒指 后燃放烟花
function Marry_StartChangeRing(msg)
	agree_flag = true
	agree_bit:SetVisible(false)
	agree_btn:SetVisible(false)
	npc_talk_htm:Clear()
	npc_talk_htm:ParseContext('请交换结婚戒指')
	npc_talk_htm:StartStepRenderMode(4)
	ringAni:PlayAni(true)
	timer.setTimer('Marry_StartFireWorks', marry_Wnd_ID, 1800)
	timer.setTimer('Marry_NpcTalkAfterChange', marry_Wnd_ID, 1800)
end
	
function Marry_NpcTalkAfterChange()
	npc_talk_htm:Clear()
	npc_talk_htm:ParseContext('恭喜你们有情人终成眷属，祝愿你们百年好合，幸福永远！')
	timer.killTimer('Marry_NpcTalkAfterChange', marry_Wnd_ID)
end
rawset(_G, "Marry_NpcTalkAfterChange", Marry_NpcTalkAfterChange)

-----婚礼成功 燃放烟花
function Marry_StartFireWorks()
	ringAni:PlayAni(false)
	timer.killTimer('Marry_StartFireWorks', marry_Wnd_ID)
	timer.setTimer('Marry_OnFireWorks1', marry_Wnd_ID, 1200)
	timer.setTimer('Marry_OnFireWorks2', marry_Wnd_ID, 900)
end
rawset(_G, "Marry_StartFireWorks", Marry_StartFireWorks)

function Marry_OnFireWorks1()
	local WndRect 		= MarryWnd:GetWindowXRect()
	local fireworksRect = fireworks1:GetWindowXRect()
	local right 		= math.random(20, WndRect.right)
	local bottom 		= math.random(20, WndRect.bottom)
	fireworks1:MoveWindowTo(right,bottom)
	fireworks1:PlayAni(true)
end

function Marry_OnFireWorks2()
	local WndRect 		= MarryWnd:GetWindowXRect()
	local fireworksRect = fireworks2:GetWindowXRect()
	local right 		= math.random(20, WndRect.right)
	local bottom 		= math.random(20, WndRect.bottom)
	fireworks2:MoveWindowTo(right,bottom)
	fireworks2:PlayAni(true)
end

rawset(_G, "Marry_OnFireWorks1", Marry_OnFireWorks1)
rawset(_G, "Marry_OnFireWorks2", Marry_OnFireWorks2)

function Marry_Failed(msg)
	g_pGlobal:GetMainUI():ShowMessageBox("别等了，对方把你抛弃了","",0,0,"知道了")
	agree_flag = true
end

function Marry_Agree()
	local msg = {}
	msg.module =  moduleName
	msg.goodsID = wparam
	msg.msg_code = 'agree'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

Marry_FlushNpcTalk = function ()
	npc_talk_htm:Clear()
	str = marry_npc_talk[marry_npc_talk_idx]
	local name1, name2
	if core.getHero():GetActorDBID() == maleActorID then
		name1 = maleName
		name2 = femaleName
	else
		name1 = femaleName
		name2 = maleName
	end
	
	if marry_npc_talk_idx == 1 then
		str = '#(color,%%0,255,255%%)'..name1.."#(color,restore)，无论顺境还是逆境，无论贫穷还是富有，无论健康还是疾病，你愿意和#(color,%%0,255,255%%)"..name2.."#(color,restore)相亲相爱不离不弃直到永远吗？"
	end
	npc_talk_htm:ParseContext(str)
	npc_talk_htm:StartStepRenderMode(4)
	marry_npc_talk_idx = marry_npc_talk_idx + 1
	
	if marry_npc_talk_idx >= #marry_npc_talk then
		timer.killTimer('Marry_FlushNpcTalk', marry_Wnd_ID)
		agree_bit:SetVisible(true)
		agree_btn:SetVisible(true)
		marry_npc_talk_idx = 1
		return
	end
	
end
---- 将 Marry_FlushNpcTalk 设置为全局函数 方便定时器调用
rawset(_G, "Marry_FlushNpcTalk", Marry_FlushNpcTalk)

function Marry_OpenWnd(male_actorID, female_actorID)
	if male_actorID == nil or female_actorID == nil then
		API_TraceError("male_actorID or female_actorID is nil")
		return
	end
	marry_npc_talk_idx = 1
	agree_flag = false
	MarryWnd:SetVisible(true)
	agree_bit:SetVisible(false)
	agree_btn:SetVisible(false)
	
	fireworks1:PlayAni(false)
	fireworks2:PlayAni(false)
	ringAni:PlayAni(false)
	
	cp_actor_male:SetActorID(male_actorID)
	cp_actor_female:SetActorID(female_actorID)
	----设置婚礼主持人
	cp_zhenghun_npc:SetCreatureID(732)
	
	Marry_FlushNpcTalk()
	timer.setTimer('Marry_FlushNpcTalk', marry_Wnd_ID, 4500)
	
end


function Marry_OnWndCloseCallBack(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	Marry_OnWndClose()
end

rawset(_G, "Marry_OnWndCloseCallBack", Marry_OnWndCloseCallBack)

function Marry_OnWndCanClose()
	if agree_flag == false then
		g_pGlobal:GetMainUI():ShowMessageBox("证婚人：结婚可是一件很神圣的事情，请你们考虑好后再来举办婚礼！","Marry_OnWndCloseCallBack",0,0,"是的","取消")
	else
		Marry_OnWndClose()
	end
end


function Marry_OnWndClose()
	timer.killTimer('Marry_OnFireWorks1', marry_Wnd_ID)
	timer.killTimer('Marry_OnFireWorks2', marry_Wnd_ID)
	timer.killTimer('Marry_FlushNpcTalk', marry_Wnd_ID)
	MarryWnd:SetVisible(false)
	
	if agree_flag == false then
		local msg = {}
		msg.module =  moduleName
		msg.msg_code = 'disagree'
		local str = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(str)
	end
end

Marry_Wnd_init()

-------------------------------------------------------------献花窗口-------------------------------------------------------------

local GiveFlowerWnd
local giveFlower_wnd_ID		= 1043
local give_1Btn
local give_10Btn
local give_viewBox = {}
local give_viewBoxMgr
local choose_Btn = {}
local chooseID = 0
local flowerGoodsID = {}
local targetActorID = 0
local flowerPanel
local noflowerHtml
local flowerDesc
local flowersIDs = {21210, 21211, 21212, 21213, 21214, 21215}

function GiveFlower_Wnd_init()
	GiveFlowerWnd = core.createWindow('Data/Scp/Windows/Windows_Relation.scp',giveFlower_wnd_ID)
	
	give_1Btn	= GiveFlowerWnd:GetButton('送一朵')
	give_10Btn	= GiveFlowerWnd:GetButton('送十朵')
	give_1Btn:SetLuaEvent2(XWIN_EVENT_CLICK, GiveFlower_1)
	give_10Btn:SetLuaEvent2(XWIN_EVENT_CLICK, GiveFlower_10)
	
	GiveFlowerWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'OnGiveFlowerWndShow')
	
	flowerPanel = GiveFlowerWnd:GetPanel('flowerPanel')
	noflowerHtml = GiveFlowerWnd:GetHtml('没有提示')
	
	flowerDesc = GiveFlowerWnd:GetHtml('花描述')
	flowerDesc:Clear()
	noflowerHtml:SetVisible(false)
	noflowerHtml:Clear()
	noflowerHtml:ParseContext('你身上没有鲜花，可通过#(color,%%11,224,234%%)#(link,0,underlinetype=1,close=1,type=openwindow,winid=1071,optype=0,txt=冰雪狂欢)#(color,restore),或#(color,%%11,224,234%%)#(link,0,underlinetype=1,close=1,type=openwindow,winid=542,optype=0,txt=商城)#(color,restore)获得。')
	give_viewBoxMgr = flowerPanel:GetViewBoxMgr('物品栏')
	for i=1,give_viewBoxMgr:GetSize() do
		give_viewBox[i] = give_viewBoxMgr:GetViewBox(i-1)
		choose_Btn[i] = flowerPanel:GetButton('花'..i)
		choose_Btn[i]:SetClickEventHandler2(GiveFlower_ChooseFlower)
		choose_Btn[i]:SetEventToWindow(give_viewBox[i])
	end
	
	GiveFlowerWnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT,GiveFlowerWndEvent)
	
	GiveFlowerWnd:GetButton('关闭按钮'):SetLuaEvent2(XWIN_EVENT_CLICK, GiveFlowerWnd_Close)
	GiveFlowerWnd:SetVisible(false)
end

--OnEvent事件
function GiveFlowerWndEvent(pWnd,event,eventID,param1,param2)
	if eventID == 104301 then
		local targetActorID = tonumber(param1)
		OnOpenGiveFlowerWnd(targetActorID)
	end
end
rawset(_G, "GiveFlowerWndEvent", GiveFlowerWndEvent)

function OnOpenGiveFlowerWnd(actorID)
	targetActorID = actorID
	if actorID == nil then
		GiveFlowerWnd:SetVisible(false)
		return
	end
	GiveFlowerWnd:SetVisible(true)
	chooseID = 0
	flowerDesc:SetVisible(false)
	for k=1, #give_viewBox do
		give_viewBox[k]:SetAlwaysLight(false)
		give_viewBox[k]:SetShowToolTip(false)
	end
end
rawset(_G, "OnOpenGiveFlowerWnd", OnOpenGiveFlowerWnd)

function GiveFlowerWnd_Close()
	GiveFlowerWnd:SetVisible(false)
	chooseID = 0
end

function GiveFlower_ChooseFlower(wnd)
	local tag = XButton:CastToButton(wnd):GetTag1()
	for k=1,#give_viewBox do
		if tag == k then
			give_viewBox[k]:SetAlwaysLight(true)
			chooseID = flowerGoodsID[k]
			if give_viewBox[k].num >= 1 then
				give_1Btn:SetEnabled(true)
			else
				give_1Btn:SetEnabled(false)
			end
			
			if give_viewBox[k].num >= 10 then
				give_10Btn:SetEnabled(true)
			else
				give_10Btn:SetEnabled(false)
			end
			
			flowerDesc:Clear()
			local goods_cfg = core.getGoodsConfig(chooseID)
			flowerDesc:ParseContext(goods_cfg.strDescDetail)
			flowerDesc:SetVisible(true)
		else
			give_viewBox[k]:SetAlwaysLight(false)
		end
	end
end

function GiveFlower_1()
	if chooseID == 0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先选择一种花再送")
		return
	end
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'give_Flower_1'
	msg.flowerID = chooseID
	msg.targetActorID = targetActorID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
	--GiveFlowerWnd:SetVisible(false)
	----献贵重的花 要显示继续
	GiveFlowerWnd:SetVisible(false)
	GiveFlowerWnd:SetVisible(true)
	if 21214 == chooseID then
		GiveFlowerWnd:SetVisible(false)
	end
end

function GiveFlower_10()
	if chooseID == 0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先选择一种花再送")
		return
	end
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'give_Flower_10'
	msg.flowerID = chooseID
	msg.targetActorID = targetActorID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
	--GiveFlowerWnd:SetVisible(false)
	----献贵重的花 要显示继续
	GiveFlowerWnd:SetVisible(false)
	GiveFlowerWnd:SetVisible(true)
	if 21214 == chooseID then
		GiveFlowerWnd:SetVisible(false)
	end
end

function OnGiveFlowerWndShow()
	local k = 0
	for idx,flowerId in pairs(flowersIDs) do
		local flowerNum = core.getHero():GetPacketPart():GetNumByGoodsID(flowerId)
		if flowerNum > 0 then
			k = k + 1
			give_viewBox[k]:ClearItem()
			give_viewBox[k]:SetItem(flowerId, flowerNum)
			give_viewBox[k].num = flowerNum
			give_viewBox[k]:SetVisible(true)
			flowerGoodsID[k] = flowerId
		end
	end
	if k == 0 then
		noflowerHtml:SetVisible(true)
		give_10Btn:SetEnabled(false)
		give_1Btn:SetEnabled(false)
		flowerPanel:SetVisible(false)
	else
		noflowerHtml:SetVisible(false)
		flowerPanel:SetVisible(true)
	end
	
	for i = k+1,#give_viewBox do
		give_viewBox[i]:SetVisible(false)
		give_viewBox[i].num = 0
	end
	local WndRect 		= GiveFlowerWnd:GetWindowXRect()
	flowerPanel:MoveWindowTo(WndRect.left+88+((5-k)*30),WndRect.top+76)
	
end
rawset(_G, "OnGiveFlowerWndShow", OnGiveFlowerWndShow)


GiveFlower_Wnd_init()

-----------------------------------------------------------------------------收花窗口---------------------------------------------------------------------

local ReceiveFlower_Wnd_ID	= 1044
local fromNamelabel
local fromDescLabel
local fromActorID
local fromFlag

function ReceiveFlower_Wnd_init()
	ReceiveFlowerWnd = core.createWindow('Data/Scp/Windows/Windows_Relation.scp',ReceiveFlower_Wnd_ID)
	ReceiveFlowerWnd:GetButton('回赠按钮'):SetLuaEvent2(XWIN_EVENT_CLICK, RetFlower)
	ReceiveFlowerWnd:GetButton('关闭按钮'):SetLuaEvent2(XWIN_EVENT_CLICK, ReceiveFlower_close)
	ReceiveFlowerWnd:SetVisible(false)
	
	fromNamelabel	= ReceiveFlowerWnd:GetLabel('赠送人')
	fromDescLabel	= ReceiveFlowerWnd:GetLabel('赠送说明')
	
end

-----回赠
function RetFlower()
	OnOpenGiveFlowerWnd(fromActorID)
	ReceiveFlowerWnd:SetVisible(false)
end

function ShowReceiveFlowerWnd(actorID, actorName, flowerID, flowerNum, flag)
	fromNamelabel:setText(actorName)
	fromActorID = actorID
	fromFlag = flag
	local goods_cfg = core.getGoodsConfig(flowerID)
	if (fromFlag == 'to') then
		fromDescLabel:setText('向你赠送了'..flowerNum..'束'..goods_cfg.szName)
		fromNamelabel:SetVisible(true)
		ReceiveFlowerWnd:GetButton('回赠按钮'):setText('回赠')
	else
		fromDescLabel:setText('您向'..actorName..'赠送了'..goods_cfg.szName)
		fromNamelabel:SetVisible(false)
		ReceiveFlowerWnd:GetButton('回赠按钮'):setText('继续')
	end
	ReceiveFlowerWnd:SetVisible(true)
end

function ReceiveFlower_close()
	ReceiveFlowerWnd:SetVisible(false)
end

ReceiveFlower_Wnd_init()

----------------------------------------------------------------------------送花的全屏光效------------------------------------
local flowerEffectWnd_ID	= 1045
local EffectFlowerWnd

function EffectFlower_Wnd_init()
	EffectFlowerWnd =  core.createWindow('Data/Scp/Windows/Windows_Relation.scp',flowerEffectWnd_ID)
	EffectFlowerWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'EffectFlowerWndShow')
	EffectFlowerWnd:SetVisible(false)
end

function EffectFlowerWndOpen()
	EffectFlowerWnd:SetVisible(true)
end

function EffectFlowerWndShow()
	timer.setTimer('EffectFlowerWndClose', flowerEffectWnd_ID, 8000)
end
rawset(_G, "EffectFlowerWndShow", EffectFlowerWndShow)

function EffectFlowerWndClose()
	timer.killTimer('EffectFlowerWndClose', flowerEffectWnd_ID)
	EffectFlowerWnd:SetVisible(false)
end
rawset(_G, "EffectFlowerWndClose", EffectFlowerWndClose)

EffectFlower_Wnd_init()