﻿--------窗口变量--------
local wndsys  				= nil	--窗口系统
local desktop 				= nil	--桌面
local systemwnd				= nil	--系统栏

local openfunction		 	= {}	--本脚本一些窗口变量
openfunction.main_wnd	 	= nil	--主窗口
openfunction.main_bg	 	= nil	--窗口背景（为了能隐藏背景）
openfunction.title_bg	 	= nil	--标题背景
openfunction.title_pic	 	= nil	--标题
openfunction.function_pic	= nil	--用于指示功能的图标

--------普通变量--------
local cur_fun_id		= ""			--当前功能ID

--------充当常量--------
local int_max			= 2147483647 	--最大整数
local main_wndid 		= 1089			--主窗口的窗口ID
local systemwndid		= 60			--系统栏的窗口ID
local move_speed		= 300			--指示功能的图标的移动速度
local function_cfg		=				--功能配置
{
	["Actor"] =
	{
		fun_name     = "角色",                  --新功能的名字
		icon_path    = "text3/icon_actor.png",   --显示在中间的图标
		dest_iconset = "60/600",          		--中间图标要移到的图标集控件路径(节点可以是ID或名字)
		dest_iconctn = "60001",                 --中间图标要移到的图标容器ID或名字
		dest_iconid  = "600011",   				--中间图标要移到的图标ID或名字
		dest_anim	 = "flashanim",				--闪动动画控件（如果没有就填nil）
		hide_fisrt   = true,                    --移动到目标前，图标要隐藏（也就是开启的是图标总功能）
		end_call     = "OnContinueTask",		--结束时调用的全局LUA函数
	},
	["WorkSkill"] =
	{
		fun_name     = "炼器",
		icon_path    = "text3/icon_workskill.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["Skill"] =
	{
		fun_name     = "技能",
		icon_path    = "text3/icon_skill.png",
		dest_iconset = "60/600",
		dest_iconctn = "60003",
		dest_iconid  = "600031",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "OnContinueTask",
	},
	["Task"] =
	{
		fun_name     = "任务",
		icon_path    = "text3/icon_task.png",
		dest_iconset = "60/600",
		dest_iconctn = "60004",
		dest_iconid  = "600041",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["Pet"] =
	{
		fun_name     = "伙伴",
		icon_path    = "text3/icon_pet.png",
		dest_iconset = "60/600",
		dest_iconctn = "60005",
		dest_iconid  = "600051",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "OnContinueTask",
	},
	["Arena"] =
	{
		fun_name     = "竞技",
		icon_path    = "text3/icon_arena.png",
		dest_iconset = "60/600",
		dest_iconctn = "60006",
		dest_iconid  = "600061",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["Relation"] =
	{
		fun_name     = "社交",
		icon_path    = "text3/icon_relation.png",
		dest_iconset = "60/600",
		dest_iconctn = "60007",
		dest_iconid  = "600071",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "OnContinueTask",
	},
	["Setting"] =
	{
		fun_name     = "设置",
		icon_path    = "text3/icon_setting.png",
		dest_iconset = "60/600",
		dest_iconctn = "60008",
		dest_iconid  = "600081",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["FirstRecharge"] =
	{
		fun_name     = "首充",
		icon_path    = "text3/icon_firstrecharge.png",
		dest_iconset = "2013/201301",
		dest_iconctn = "830",
		dest_iconid  = "83000",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["Sign"] =
	{
		fun_name     = "签到",
		icon_path    = "text3/icon_sign.png",
		dest_iconset = "2013/201301",
		dest_iconctn = "819",
		dest_iconid  = "81900",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["Peach"] =
	{
		fun_name     = "蟠桃园",
		icon_path    = "text3/icon_peach.png",
		dest_iconset = "2014/201401",
		dest_iconctn = "1099",
		dest_iconid  = "10990",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["Rank"] =
	{
		fun_name     = "仙界榜",
		icon_path    = "text3/icon_rank.png",
		dest_iconset = "2013/201301",
		dest_iconctn = "1021",
		dest_iconid  = "102101",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["FairyLand"] =
	{
		fun_name     = "一统仙界",
		icon_path    = "text3/icon_fairyland.png",
		dest_iconset = "2013/201301",
		dest_iconctn = "1031",
		dest_iconid  = "pvpact_launch_btn",
		dest_anim	 = "pvpact_ani",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	["MoneyTree"] =
	{
		fun_name     = "摇钱树",
		icon_path    = "text3/icon_moneytree.png",
		dest_iconset = "2013/201301",
		dest_iconctn = "973",
		dest_iconid  = "97301",
		dest_anim	 = "flashanim",
		hide_fisrt   = true,
		end_call     = "OnContinueTask",
	},
	["Activity"] =
	{
		fun_name     = "每日必修",
		icon_path    = "text3/icon_activity.png",
		dest_iconset = "2014/201401",
		dest_iconctn = "905",
		dest_iconid  = "activityLaunchBtn",
		dest_anim	 = "activityAni",
		hide_fisrt   = true,
		end_call     = "on_pic_move_end_call",
	},
	-- ["AutoBattle"] =
	-- {
		-- fun_name     = "挂机",
		-- icon_path    = "text3/icon_autobattle.png",
		-- dest_iconset = "2014/201401",
		-- dest_iconctn = "966",
		-- dest_iconid  = "96601",
		-- dest_anim	 = "flashanim",
		-- hide_fisrt   = true,
		-- end_call     = "on_pic_move_end_call",
	-- },
	["Enhance"] =
	{
		fun_name     = "强化",
		icon_path    = "Icon/text/fun_enhance.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Quenching"] =
	{
		fun_name     = "淬炼",
		icon_path    = "Icon/text/fun_quenching.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Refine"] =
	{
		fun_name     = "精炼",
		icon_path    = "Icon/text/fun_refine.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Gem"] =
	{
		fun_name     = "宝石",
		icon_path    = "Icon/text/fun_gem.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Compose"] =
	{
		fun_name     = "合成",
		icon_path    = "Icon/text/fun_compose.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Inherit"] =
	{
		fun_name     = "星级继承",
		icon_path    = "Icon/text/fun_inherit.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["CulSkill"] =
	{
		fun_name     = "修为技能",
		icon_path    = "Icon/text/fun_culskill.png",
		dest_iconset = "60/600",
		dest_iconctn = "60003",
		dest_iconid  = "600031",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["CulTask"] =
	{
		fun_name     = "修为任务",
		icon_path    = "Icon/text/fun_cultask.png",
		dest_iconset = "60/600",
		dest_iconctn = "60004",
		dest_iconid  = "600041",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "OnContinueTask",
	},
	["Friend"] =
	{
		fun_name     = "好友",
		icon_path    = "Icon/text/fun_friend.png",
		dest_iconset = "60/600",
		dest_iconctn = "60007",
		dest_iconid  = "600071",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["GodWork"] =
	{
		fun_name     = "神工商店",
		icon_path    = "Icon/text/fun_shengong.png",
		dest_iconset = "2014/201401",
		dest_iconctn = "1099",
		dest_iconid  = "10990",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Ride"] =
	{
		fun_name     = "坐骑",
		icon_path    = "Icon/text/fun_ride.png",
		dest_iconset = "60/600",
		dest_iconctn = "60005",
		dest_iconid  = "600051",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "OnContinueTask",
	},
	["PetPill"] =
	{
		fun_name     = "炼化",
		icon_path    = "Icon/text/fun_petpill.png",
		dest_iconset = "60/600",
		dest_iconctn = "60005",
		dest_iconid  = "600051",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["PetWash"] =
	{
		fun_name     = "洗髓",
		icon_path    = "Icon/text/fun_petwash.png",
		dest_iconset = "60/600",
		dest_iconctn = "60005",
		dest_iconid  = "600051",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["Copy"] =
	{
		fun_name     = "副本",
		icon_path    = "Icon/text/fun_copy.png",
		dest_iconset = "2014/201401",
		dest_iconctn = "905",
		dest_iconid  = "activityLaunchBtn",
		dest_anim	 = "activityAni",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},
	["GongHui"] =
	{
		fun_name     = "公会",
		icon_path    = "Icon/text/fun_gonghui.png",
		dest_iconset = "60/600",
		dest_iconctn = "60007",
		dest_iconid  = "600071",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},	
	["Jingji"] =
	{
		fun_name     = "竞技场",
		icon_path    = "Icon/text/fun_jingji.png",
		dest_iconset = "60/600",
		dest_iconctn = "60006",
		dest_iconid  = "600061",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},	
	["workskill_task_open_4"] =
	{
		fun_name     = "升华",
		icon_path    = "Icon/text/fun_shenghua.png",
		dest_iconset = "60/600",
		dest_iconctn = "60002",
		dest_iconid  = "600021",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},	
	["Huoban"] =
	{
		fun_name     = "伙伴",
		icon_path    = "Icon/text/fun_huoban.png",
		dest_iconset = "60/600",
		dest_iconctn = "60005",
		dest_iconid  = "600051",
		dest_anim	 = "flashanim",
		hide_fisrt   = false,
		end_call     = "OnContinueTask",
	},	
	["PetEnhance"] =
	{
		fun_name     = "伙伴强化",
		icon_path    = "Icon/text/fun_petenhance.png",
		dest_iconset = "60/600",
		dest_iconctn = "60005",
		dest_iconid  = "600051",
		hide_fisrt   = false,
		end_call     = "on_pic_move_end_call",
	},	
	
}
local system_icon_open_condition = 		--功能图标的开启配置
{
	["60/600"] = 
	{
		[60001] = 
		{
			--props = {"OpenFun_Actor"},
			--level = {minlv=0, maxlv=100},
		},
		[60002] = 
		{
			props = {"OpenFun_WorkSkill"},
			level = {minlv=0, maxlv=100},
		},
		[60003] = 
		{
			props = {"OpenFun_Skill"},
			level = {minlv=0, maxlv=100},
		},
		[60004] = 
		{
			props = {"OpenFun_Task"},
			level = {minlv=0, maxlv=100},
		},
		[60005] = 
		{
			props = {"OpenFun_Pet"},
			level = {minlv=0, maxlv=100},
		},
		[60006] = 
		{
			props = {"OpenFun_Arena"},
			level = {minlv=0, maxlv=100},
		},
		[60007] = 
		{
			props = {"OpenFun_Relation"},
			level = {minlv=0, maxlv=100},
		},
		[60008] = 
		{
			--props = {"OpenFun_Setting"},
			--level = {minlv=0, maxlv=100},
		}
	},
	["2013/201301"] =
	{
		[819] = 
		{
			props = {"OpenFun_Sign"},
			level = {minlv=0, maxlv=100},
		},
		[1021] = 
		{
			props = {"OpenFun_Rank"},
			level = {minlv=0, maxlv=100},
		},
		[830] = 
		{
			--props = {"OpenFun_FirstRecharge"},
			--level = {minlv=0, maxlv=100},
		},
		[1031] = 
		{
			--props = {"OpenFun_FairyLand"},
			--level = {minlv=0, maxlv=100},
		},
		[973] = 
		{
			props = {"OpenFun_MoneyTree"},
			level = {minlv=0, maxlv=100},
		},
	},
	["2014/201401"] =
	{
		[905] = 
		{
			props = {"OpenFun_Activity"},
			level = {minlv=0, maxlv=100},
		},
		[1099] = 
		{
			props = {"OpenFun_Peach"},
			level = {minlv=0, maxlv=100},
		},
		-- [966] = 
		-- {
			-- props = {"OpenFun_AutoBattle"},
			-- level = {minlv=0, maxlv=100},
		-- },
	},
}

--------普通函数--------
--本窗口的初始化函数
local function openfunction_init()
	--获取一些全局的窗口
	wndsys = WndSystem:GetInstance()
	desktop = wndsys:GetGameDesktop()
	systemwnd = desktop:FindWindowByID(systemwndid)

	--创建主窗口
	openfunction.main_wnd = desktop:FindWindowByID(main_wndid) or core.createWindow('Data/Scp/Windows/Windows_Main.scp', main_wndid)
	--窗口事件
	openfunction.main_wnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT, openfunction.onevent)
	--屏幕变化
	openfunction.main_wnd:SetClientRectChangedCallback("openfunction_on_client_rect_change")
	--显示事件
	openfunction.main_wnd:SetShowEventHandler2(openfunction.onshow)

	--获取主背景
	openfunction.main_bg = openfunction.main_wnd:getWindow("main_bg")
	--背景点击事件
	openfunction.main_bg:SetClickEventHandler2(openfunction.onclick)
	--获取主背景2
	openfunction.title_bg = openfunction.main_wnd:getWindow("title_bg")
	--获取标题图片
	openfunction.title_pic = openfunction.main_wnd:getWindow("title_pic")
	--获取功能图片
	openfunction.function_pic = openfunction.main_wnd:getWindow("function_pic")
	--移动结束事件
	openfunction.function_pic:AddWindowAnimLuaCallback("openfunction_on_pic_move_end")

	--注册网络消息
	api_reg_module_msg_handler("open_function", openfunction.onnetmsg)
	
	--注册角色登录事件
	api_reg_hero_all_data_ready_listen(openfunction.onlogin)
end

--屏幕变化调整位置
function openfunction_on_client_rect_change()
	openfunction.adjpos()
end

--指示图标移动结束
function on_pic_move_end_call(fun_id)
	local cfg = function_cfg[fun_id]
	-- if cfg then
		-- API_ShowMessageBox("开启新功能[#(color,yellow)" .. cfg.fun_name .. "#(color,restore)]")
	-- else
		-- API_ShowMessageBox("开启新功能！！！")
	-- end
end

--功能图标出现并找到正确位置的事件
function openfunction_pic_delay_move(pWnd)
	if pWnd then
		pWnd:RemoveWindowAnimLuaCallback("openfunction_pic_delay_move")
	end

	local cfg = function_cfg[cur_fun_id]
	if cfg == nil then
		API_TraceError("unknown fun id ".. cur_fun_id)
	else
		local iconsetpath = cfg.dest_iconset
		local iconctnpath = iconsetpath .. "/" .. cfg.dest_iconctn
		local iconpath    = iconctnpath .. "/" .. cfg.dest_iconid
		local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath(iconsetpath))
		local destctn  = API_GetWindowByPath(iconctnpath)
		local desticon = API_GetWindowByPath(iconpath)

		if iconset == nil or destctn == nil or desticon == nil then
			API_TraceError("function cfg error, some wnd can not be found ".. cur_fun_id)
		else
			openfunction.function_pic:SetMoveSpeed(move_speed)
			local icon_rect = desticon:GetWindowXRect()
			openfunction.function_pic:MoveToWithAni(icon_rect.left, icon_rect.top)
		end
	end
end

--指示图标移动结束的事件
function openfunction_on_pic_move_end()
	--先隐藏本窗口
	openfunction.main_wnd:SetVisible(false)

	local cfg = function_cfg[cur_fun_id]
	if cfg then
		local iconctnpath	= cfg.dest_iconset .. "/" .. cfg.dest_iconctn
		local iconpath		= iconctnpath .. "/" .. cfg.dest_iconid
		local destcnt		= API_GetWindowByPath(iconctnpath)
		local desticon 		= API_GetWindowByPath(iconpath)
		if desticon and false == desticon:IsVisible()  then
			desticon:SetVisible(true)
		end
		--如果有光效控件，那让它显示并发光，点击按钮后不发光
		if cfg.dest_anim and destcnt and desticon then
			local dest_anim = destcnt:GetAni(cfg.dest_anim)
			if dest_anim then
				dest_anim:PlayAni(true)
				desticon:SetClickEventHandler2(function(wnd, evt, p1, p2, p3)
					dest_anim:PlayAni(false)
				end)
			end
		end
		--调用新函数
		if cfg.end_call and string.len(cfg.end_call) > 0 then
			api_call_function(cfg.end_call, cur_fun_id)
		end
	end
	
	cur_fun_id = 0
end

--角色登录成功后调用（决定哪些功能图标要隐藏或显示）
local function openfunction_onlogin()
	local hero = core.getHero()
	if hero == nil then 
		return 
	end
	local herolv = hero:GetCrtProp(enProp_Level)
	for k,v in pairs(system_icon_open_condition) do
		local system_iconset = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath(k))
		local is_enable_move = system_iconset:IsMoveAnimEnabled()
		system_iconset:EnableMoveAnim(false)
		for k1,v1 in pairs(v) do
			local iconctn = system_iconset:FindWindowByID(k1)
			if iconctn then
				local bshow = false
				if v1.props then
					for i = 1, #v1.props do
						if hero:GetPropEx(v1.props[i]) ~= 0 then
							bshow = true
							break
						end
					end
				else
					bshow = true
				end

				if bshow == true then
					if v1.level and (herolv < v1.level.minlv or herolv > v1.level.maxlv) then
						bshow = false
					end
				end
				
				system_iconset:SetChildVisible(k1, bshow)
			end
		end
		system_iconset:EnableMoveAnim(is_enable_move)
	end	
end

--窗口事件响应
local function openfunction_onevent(pWnd, event, eventID, param1, param2)

end

--主窗口点击事件，然后开始移动指示图标
local function openfunction_onclick(pWnd, event, param1, param2, param3)
	openfunction.main_bg:SetVisible(false)
	openfunction.title_bg:SetVisible(false)
	openfunction.title_pic:SetVisible(false)

	local cfg = function_cfg[cur_fun_id]
	if cfg == nil then
		API_TraceError("unknown fun id ".. cur_fun_id)
		openfunction.main_wnd:SetVisible(false)
		cur_fun_id = 0
		return
	else
		local iconsetpath = cfg.dest_iconset
		local iconctnpath = iconsetpath .. "/" .. cfg.dest_iconctn
		local iconpath    = iconctnpath .. "/" .. cfg.dest_iconid
		local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath(iconsetpath))
		local destctn  = API_GetWindowByPath(iconctnpath)
		local desticon = API_GetWindowByPath(iconpath)

		if iconset == nil or destctn == nil or desticon == nil then
			API_TraceError("function cfg error, some wnd can not be found ".. cur_fun_id)
			openfunction.main_wnd:SetVisible(false)
			cur_fun_id = 0
			return
		else
			local bShouldWait = false
			if false == destctn:IsVisible() then
				iconset:SetChildVisible(tonumber(cfg.dest_iconctn), true)
				--还不显示？可能被阻止显示了，后面不管了
				if false == destctn:IsVisible() then
					openfunction.main_wnd:SetVisible(false)
					cur_fun_id = 0
					return
				end
				bShouldWait = true
			end
			if true == cfg.hide_fisrt and desticon:IsVisible() then
				desticon:SetVisible(false)
			end
			--如果目标图标集带移动效果就等移动完再移动我们自己的图标
			if true == bShouldWait and iconset:IsMoveAnimEnabled() then
				--添加目标图标容器移动结束的监听
				destctn:AddWindowAnimLuaCallback("openfunction_pic_delay_move")
			else
				--否则直接移动
				openfunction_pic_delay_move(destctn)
			end
		end
	end
end

--主窗口显示时事件
local function openfunction_onshow(pWnd, event, param1, param2, param3)
	--先主角暂停行走
	API_HeroStopMove()
	openfunction.main_bg:SetVisible(true)
	openfunction.title_bg:SetVisible(true)
	openfunction.title_pic:SetVisible(true)
	openfunction.adjpos()
	if false == systemwnd:IsVisible() then
		systemwnd:SetVisible(true)
	end
	--触发引导
	OnClickNewFunctionGuid()
end

--调整窗口和控件的大小和位置
local function openfunction_adjpos()
	local deskRect = desktop:GetWindowXRect()
	openfunction.main_wnd:SetWindowRect(deskRect)
	openfunction.main_bg:SetWindowRect(deskRect)
	XWinUtil:AlignWindow(desktop, openfunction.main_wnd, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 0, 0, false)
	XWinUtil:AlignWindow(openfunction.main_wnd, openfunction.main_bg, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 0, 0, false)
	XWinUtil:AlignWindow(openfunction.main_wnd, openfunction.title_bg, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, -35, 0, false)
	XWinUtil:AlignWindow(openfunction.main_wnd, openfunction.title_pic, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 55, 0, false)
	XWinUtil:AlignWindow(openfunction.main_wnd, openfunction.function_pic, XWinUtil.enXUAlign_X_CENTER, XWinUtil.enXUAlign_Y_CENTER, 0, 0, 0, 0, false)
end

--接受网络消息
local function openfunction_onnetmsg(msg)
	if (msg.msg_code=="open") then
		openfunction.onopen(msg.fun_id)
	else
		API_TraceError("unknown cmd ".. msg.msg_code)
	end
end

--开始显示某个功能的开启
local function openfunction_onopen(fun_id)
	local cfg = function_cfg[fun_id]
	if cfg == nil then
		API_TraceError("unknown fun id ".. fun_id)
	else
		--清理老的，如果有的话
		openfunction.clearold()

		--local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath("2013/201301"))
		--iconset:SetChildVisible("791", false)
		--local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath("60/600"))
		--iconset:SetChildVisible("60001", false)

		--处理新的
		openfunction.function_pic:SetBitmap(cfg.icon_path)
		cur_fun_id = fun_id
		if false == openfunction.main_wnd:IsVisible() then
			openfunction.main_wnd:SetVisible(true)
		else
			openfunction_onshow()
		end
	end
end

--如果老的功能开启的显示没结束，先结束动画，并清理
local function openfunction_clearold()
	--先让图片停住
	openfunction.function_pic:MoveToWithAni(int_max, int_max)
	--回复位置
	openfunction_adjpos()
	--目标图标恢复
	local cfg = function_cfg[cur_fun_id]
	if cfg then
		local iconctnpath = cfg.dest_iconset .. "/" .. cfg.dest_iconctn
		local iconpath = iconctnpath .. "/" .. cfg.dest_iconid
		local destctn  = API_GetWindowByPath(iconctnpath)
		local desticon = API_GetWindowByPath(iconpath)
		--取消订阅
		if destctn then
			destctn:RemoveWindowAnimLuaCallback("openfunction_pic_delay_move")
		end
		--老图标显示出来
		if desticon and false == desticon:IsVisible() then
			desticon:SetVisible(true)
		end
	end
	cur_fun_id = 0
end

--保存局部函数引用
openfunction.onevent = openfunction_onevent
openfunction.onclick = openfunction_onclick
openfunction.onshow = openfunction_onshow
openfunction.adjpos = openfunction_adjpos
openfunction.onnetmsg = openfunction_onnetmsg
openfunction.onopen = openfunction_onopen
openfunction.onlogin = openfunction_onlogin
openfunction.clearold = openfunction_clearold

--真正初始化窗口
openfunction_init()