--------窗口变量--------
local wndsys  			= nil
local desktop 			= nil
local pet_frame_wnd		= nil

local pill_panel		= nil
local wash_panel		= nil

local pill_scroll_cards	= nil
local pill_vbmgr_cards	= nil
local pill_lbl_curpill	= nil
local pill_lbl_willget	= nil
local pill_btn_donow	= nil

local wash_lbl_petname  = nil
local wash_bmp_gender	= nil
local wash_lbl_race		= nil
local wash_html_btlval	= nil
local wash_lbl_level	= nil
local wash_petsw_pets 	= nil
local wash_prgbar_aptall= nil
local wash_prgbar_aptatk= nil
local wash_prgbar_aptdfd= nil
local wash_prgbar_aptmgc= nil
local wash_prgbar_aptrsm= nil
local wash_prgbar_apthp = nil
local wash_lbl_all_add	= nil
local wash_lbl_atk_add	= nil
local wash_lbl_dfd_add	= nil
local wash_lbl_mgc_add	= nil
local wash_lbl_rsm_add	= nil
local wash_lbl_hp_add	= nil
local wash_bmp_all_up	= nil
local wash_bmp_all_down	= nil
local wash_bmp_atk_up	= nil
local wash_bmp_atk_down	= nil
local wash_bmp_dfd_up	= nil
local wash_bmp_dfd_down	= nil
local wash_bmp_mgc_up	= nil
local wash_bmp_mgc_down	= nil
local wash_bmp_rsm_up	= nil
local wash_bmp_rsm_down	= nil
local wash_bmp_hp_up	= nil
local wash_bmp_hp_down	= nil
local wash_lbl_curpill 	= nil
local wash_chb_goodwash	= nil
local wash_btn_donow	= nil
local wash_btn_confirm	= nil
local wash_btn_revert	= nil
local wash_btn_larrow	= nil
local wash_btn_rarrow	= nil

--------普通变量--------
local pt_vb_down_pos	= nil
local table_wash_history= {}

--------充当常量--------
local invalid_petindex  = 4294967295
local module_name		= "PetCultivate"
local wndid_pet_ride	= 802
local wndid_pet_apt		= 1020
local wndid_pill_panel	= 1090
local wndid_wash_panel	= 1091
local clrRed 			= XColor:new(255, 0, 0)
local clrGreen 			= XColor:new(255, 255, 0)
local clrWhite 			= XColor:new(255, 255, 255)
--以1为起始下标
local NPCRaceTypeDesc = 
{
	"@misc_npc_race_type_demon",
	"@misc_npc_race_type_ghost",
	"@misc_npc_race_type_immortal",
	"@misc_npc_race_type_human",
}
local pet_card_quality_innerpill_map = 
{
	[0] = 1,
	[1] = 10,
	[2] = 30,
	[3] = 600,
	[4] = 3000,
	[5] = 3000
}

--------全局函数--------
function api_pet_preview(mstid)
	wndsys:OnEvent(wndid_pet_apt, 256, mstid, 1)
end

function api_round_number(num, cnt)
	local mul = 10 ^ cnt
	return math.floor(num * mul + 0.5) / mul
end

function api_get_pet_apt_color(aptavg, aptval)
	if aptavg > 0 then
		return petutil.GetPetAptColor(api_round_number(aptval / aptavg, 2))
	else
		return petutil.GetPetAptColor(0)
	end
end

function api_clear_wash_history()
	table_wash_history = {}
end

function OnBuyPetClassLevelGoods()
	WndSystem:GetInstance():OnEvent(wndid_pet_ride, 6809, INVALID_GOODS_ID, 0)
end

--------网络消息处理--------
function pet_pill_wash_msg_handler(msg)
	if (msg.msg_code=="inner_pill_op") then
		pet_pill_wash_netmsg_pill_ret(msg)
	elseif (msg.msg_code=="wash_pet") then
		pet_pill_wash_netmsg_wash_ret(msg)
	elseif (msg.msg_code=="wash_confirm") then
		pet_pill_wash_netmsg_cancel_ret(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end

local function pet_pill_wash_netmsg_show_msg(msgobj)
	if msgobj.msg ~= nil and string.len(msgobj.msg) then
		local msgtype = msgobj.msgtype or enSysMsgDisplayType_Float
		if msgtype == enSysMsgDisplayType_MsgBox then
			API_ShowMessageBox(msgobj.msg, "", 0x0001)
		else
			API_ShowSystemMessage(msgtype, msgobj.msg)
		end
	end
end

function pet_pill_wash_netmsg_pill_ret(msg)
	pet_pill_wash_netmsg_show_msg(msg)
	pet_pill_wash_pill_refresh_wnd()
end

function pet_pill_wash_netmsg_wash_ret(msg)
	pet_pill_wash_netmsg_show_msg(msg)
	if msg.history ~= nil then
		table_wash_history[msg.history.uid] = msg.history
	end
	pet_pill_wash_wash_refreshwnd()
end

function pet_pill_wash_netmsg_cancel_ret(msg)
	pet_pill_wash_netmsg_show_msg(msg)
	if msg.pet_index == nil then
		return
	end
	local pet = petutil.GetPetByIndex(msg.pet_index)
	if pet == nil then
		return
	end
	local str_uid_pet = UID.ToString(pet:GetUID())
	if msg.ok then
		table_wash_history[str_uid_pet] = nil
	end
	pet_pill_wash_wash_refreshwnd()
end
--------整体初始化--------
function pet_pill_wash_init()
	--注册网络消息
	api_reg_module_msg_handler("PetCultivate", pet_pill_wash_msg_handler)

	--获取一些窗口引用
	wndsys = WndSystem:GetInstance()
	desktop = wndsys:GetGameDesktop()
	pet_frame_wnd = desktop:FindWindowByID(wndid_pet_ride)

	--创建分页
	pill_panel = pet_frame_wnd:FindWindowByID(wndid_pill_panel) or core.createWindow('Data/Scp/Windows/Windows_PetMain.scp', wndid_pill_panel, false, pet_frame_wnd)
	wash_panel = pet_frame_wnd:FindWindowByID(wndid_wash_panel) or core.createWindow('Data/Scp/Windows/Windows_PetMain.scp', wndid_wash_panel, false, pet_frame_wnd)

	--执行窗口创建事件
	pet_pill_wash_on_create()
end

--------主窗口创建--------
function pet_pill_wash_on_create()
	--初始化炼化面板
	pill_panel:SetShowEventHandler("pet_pill_wash_pill_on_show")
	pill_panel:SetHideEventHandler("pet_pill_wash_pill_on_hide")
	pill_scroll_cards 	= pill_panel:GetScrollMgr("滚动管理")
	pill_vbmgr_cards 	= pill_scroll_cards:GetViewBoxMgr("伙伴图标管理器")
	pill_lbl_curpill	= pill_panel:GetLabel("当前内丹数")
	pill_lbl_willget	= pill_panel:GetLabel("可得内丹数")
	pill_btn_donow		= pill_panel:GetButton("炼化按钮")
	pill_btn_donow:SetClickEventHandler("pet_pill_wash_pill_on_btnpill")
	
	--洗髓面板控件
	wash_panel:SetShowEventHandler("pet_pill_wash_wash_on_show")
	wash_panel:SetHideEventHandler("pet_pill_wash_wash_on_hide")
	wash_lbl_petname  	= wash_panel:GetLabel("伙伴名")
	wash_bmp_gender		= wash_panel:GetStaticBitmap("性别")
	wash_lbl_race		= wash_panel:GetLabel("种族值")
	wash_html_btlval	= wash_panel:GetHtml("战斗力值")
	wash_lbl_level		= wash_panel:GetLabel("伙伴等级")
	wash_petsw_pets 	= wash_panel:GetPetSwitchCtrl("伙伴预览")
	wash_petsw_pets:AddPetSwitchLuaCallback("pet_pill_wash_wash_on_switch_pet")
	wash_prgbar_aptall	= wash_panel:GetProgressBar("总资质进度条")
	wash_prgbar_aptatk	= wash_panel:GetProgressBar("外功资质进度条")
	wash_prgbar_aptdfd	= wash_panel:GetProgressBar("外防资质进度条")
	wash_prgbar_aptmgc	= wash_panel:GetProgressBar("内法资质进度条")
	wash_prgbar_aptrsm	= wash_panel:GetProgressBar("内防资质进度条")
	wash_prgbar_apthp 	= wash_panel:GetProgressBar("气血资质进度条")	
	wash_lbl_all_add	= wash_panel:GetLabel("总资质增长值")
	wash_lbl_atk_add	= wash_panel:GetLabel("外功资质增长值")
	wash_lbl_dfd_add	= wash_panel:GetLabel("外防资质增长值")
	wash_lbl_mgc_add	= wash_panel:GetLabel("内法资质增长值")
	wash_lbl_rsm_add	= wash_panel:GetLabel("内防资质增长值")
	wash_lbl_hp_add		= wash_panel:GetLabel("气血资质增长值")
	wash_bmp_all_up		= wash_panel:GetStaticBitmap("总资质上升箭头")
	wash_bmp_all_down	= wash_panel:GetStaticBitmap("总资质下降箭头")
	wash_bmp_atk_up		= wash_panel:GetStaticBitmap("外功资质上升箭头")
	wash_bmp_atk_down	= wash_panel:GetStaticBitmap("外功资质下降箭头")
	wash_bmp_dfd_up		= wash_panel:GetStaticBitmap("外防资质上升箭头")
	wash_bmp_dfd_down	= wash_panel:GetStaticBitmap("外防资质下降箭头")
	wash_bmp_mgc_up		= wash_panel:GetStaticBitmap("内法资质上升箭头")
	wash_bmp_mgc_down	= wash_panel:GetStaticBitmap("内法资质下降箭头")
	wash_bmp_rsm_up		= wash_panel:GetStaticBitmap("内防资质上升箭头")
	wash_bmp_rsm_down	= wash_panel:GetStaticBitmap("内防资质下降箭头")
	wash_bmp_hp_up		= wash_panel:GetStaticBitmap("气血资质上升箭头")
	wash_bmp_hp_down	= wash_panel:GetStaticBitmap("气血资质下降箭头")
	wash_lbl_curpill 	= wash_panel:GetLabel("当前内丹数")
	wash_chb_goodwash	= wash_panel:GetCheckBox("至尊洗髓")
	wash_btn_donow		= wash_panel:GetButton("洗髓按钮")
	wash_btn_confirm	= wash_panel:GetButton("确定按钮")
	wash_btn_revert		= wash_panel:GetButton("还原按钮")
	wash_btn_larrow		= wash_panel:GetButton("左箭头")
	wash_btn_rarrow		= wash_panel:GetButton("右箭头")
	wash_btn_donow:SetClickEventHandler("pet_pill_wash_wash_on_btnwash")
	wash_btn_confirm:SetClickEventHandler("pet_pill_wash_wash_on_btnconfirm")
	wash_btn_revert:SetClickEventHandler("pet_pill_wash_wash_on_btnrevert")
	wash_btn_larrow:SetClickEventHandler("pet_pill_wash_wash_on_btn_left")
	wash_btn_rarrow:SetClickEventHandler("pet_pill_wash_wash_on_btn_right")
end

--------炼化面板逻辑--------
function pet_pill_wash_pill_on_show()
	pet_pill_wash_pill_refresh_wnd()
end

function pet_pill_wash_pill_on_hide()

end

local pill_growth_efx = 
{
	[enPetGrowth_Min] 		= 0,
	[enPetGrowth_Normal]	= 0,
	[enPetGrowth_Good]		= 0,
	[enPetGrowth_Excellent]	= 0,
	[enPetGrowth_NonSuch]	= 410000,
	[enPetGrowth_Perfect]	= 440000,
};

function pet_pill_wash_pill_refresh_wnd()
	local hero = core.getHero()	
	if hero == nil then
		return
	end
	local packet = hero:GetPacketPart()
	if packet == nil then
		return
	end
	--刷新丹
	local innerpill = hero:GetCrtProp(enProp_Actor_InnerPill)
	pill_lbl_curpill:setText(tostring(innerpill))
	--刷新图标
	local clr = XColor:new(255,255,0)
	local mstinfo_list = {}
	local peach_msg_cfg = GetPillMonsterCfg()
	for i = 1,#peach_msg_cfg do
		local cfg = peach_msg_cfg[i]
		if cfg.pinzhi >= 0 and cfg.pinzhi <= 5 then
			for j = 1, #(cfg.pets) do
				local cfg2 = cfg.pets[j]
				local goodscnt = packet:GetDestroyNumByGoodsID(cfg2.gdsid)
				if goodscnt > 0 then
					local info = {mstid=cfg2.mst, goodsid=cfg2.gdsid, goodscnt = goodscnt, quality=cfg.pinzhi}
					table.insert(mstinfo_list, info)
				end
			end
		end
	end
	table.sort(mstinfo_list, function(a, b) return a.quality < b.quality end)
	if #mstinfo_list > 0 then
		local vbcnt = pill_vbmgr_cards:GetSize()
		if vbcnt > #mstinfo_list then
			pill_vbmgr_cards:DeleteViewBoxs(vbcnt - #mstinfo_list)
		elseif vbcnt < #mstinfo_list then
			pill_vbmgr_cards:AppendViewBoxs(#mstinfo_list - vbcnt)
		end
		pill_vbmgr_cards:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, "pet_pill_wash_pill_on_vb_mousedown")
		pill_vbmgr_cards:SetLuaEvent(XWIN_EVENT_MOUSEUP, "pet_pill_wash_pill_on_vb_mouseup")
		pill_vbmgr_cards:SetLuaEvent(XWIN_EVENT_DBCLK, "pet_pill_wash_pill_on_vb_dbclk")
		vbcnt = pill_vbmgr_cards:GetSize()
		for i = 1,#mstinfo_list do
			if i <= vbcnt then
				local vb = pill_vbmgr_cards:GetViewBox(i-1)
				vb:SetEventToWindow(pill_scroll_cards)
				local info = mstinfo_list[i]
				vb:SetAlwaysLight(false)
				vb:Set_RB_Color(clr)
				vb:SetMonsterItem(info.mstid, 60)
				vb:SetPropertyInt32("mstid", info.mstid)
				vb:SetPropertyInt32("goodsid", info.goodsid)
				vb:Set_RB_String(tostring(info.goodscnt))
				local mstcfg = core.getMonsterConfig(info.mstid)
				if mstcfg == nil then
					vb:SetPropertyInt32("growth", 0)
					vb:SetShowForeEffect(false)
				else
					local growth = mstcfg.nGrowthValue
					vb:Set_RB_Color(petutil.GetPetColor(growth))
					vb:SetPropertyInt32("growth", growth)
					if mstcfg.nGrowthValue >= enPetGrowth_NonSuch then
						vb:SetForeEffect(pill_growth_efx[growth] or 0)
						vb:SetShowForeEffect(true)
					else
						vb:SetForeEffect(0)
						vb:SetShowForeEffect(false)
					end					
				end
			end		
		end
	else
		local vbcnt = pill_vbmgr_cards:GetSize()
		pill_vbmgr_cards:DeleteViewBoxs(vbcnt)
	end
	pet_pill_wash_pill_refresh_pill_will_get()
end

local function pill_request_dopill(check_good_pet)
	local goodsids = {}
	local goodpetids = {}
	local pet_icon_cnt = pill_vbmgr_cards:GetSize()
	for i = 1,pet_icon_cnt do
		local vb = pill_vbmgr_cards:GetViewBox(i-1)
		local growth = vb:GetPropertyInt32("growth")
		if vb:IsAlwaysLight() then
			goodsids[#goodsids+1] = vb:GetPropertyInt32("goodsid")
			if growth >= enPetGrowth_NonSuch then
				goodpetids[#goodpetids+1] = vb:GetPropertyInt32("mstid")
			end
		end		
	end
	
	if check_good_pet and #goodpetids > 0 then
		local str = ""
		for i = 1, #goodpetids do
			local mstcfg = core.getMonsterConfig(goodpetids[i])
			str = str .. "#(color,light_green)[" .. mstcfg.szName .. "]#(color,restore)"
			if i < #goodpetids then
				str = str .. "、"
			elseif #goodpetids > 1 then
				str = str .. "都"
			end
		end
		str = str .. "是比较#(color,light_green)稀缺#(color,restore)的伙伴，是否继续？"
		API_ShowMessageBox(str, "", 256, "pet_pill_wash_pill_on_msgbox_pill")
		return
	end

	if #goodsids > 0 then	
		local msg = {}
		msg.module   = module_name
		msg.msg_code = "inner_pill_op"
		msg.goodsids = goodsids
		local jsonstr = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(jsonstr)
	else
		if pet_icon_cnt > 0 then
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "没有选中伙伴卷轴，炼化未进行")
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "没有可炼化的伙伴卷轴，炼化未进行")
		end
	end
end

function pet_pill_wash_pill_on_msgbox_pill(msgid, param1, param2)
	if msgid == WE_AW_MSGYES then
		pill_request_dopill(false)
	end
end

function pet_pill_wash_pill_on_btnpill()
	pill_request_dopill(true)
end

function pet_pill_wash_pill_on_vb_mousedown(wnd, evt)
	pt_vb_down_pos = desktop:GetMouseXY()
end

function pet_pill_wash_pill_refresh_pill_will_get()
	local hero = core.getHero()	
	if hero == nil then
		return
	end
	local packet = hero:GetPacketPart()
	if packet == nil then
		return
	end

	local cards_map = {}
	local peach_msg_cfg = GetPillMonsterCfg()
	for i = 1,#peach_msg_cfg do
		local cfg = peach_msg_cfg[i]
		if cfg.pinzhi >= 0 and cfg.pinzhi <= 5 then
			for j = 1, #(cfg.pets) do
				local cfg2 = cfg.pets[j]
				cards_map[cfg2.gdsid] = pet_card_quality_innerpill_map[cfg.pinzhi]
			end
		end
	end

	local total_cnt		= 0
	local pet_icon_cnt 	= pill_vbmgr_cards:GetSize()
	for i = 1,pet_icon_cnt do
		local vb = pill_vbmgr_cards:GetViewBox(i-1)
		if vb:IsAlwaysLight() then
			local goodsid = vb:GetPropertyInt32("goodsid")
			local add_per = cards_map[goodsid]
			local goodscnt = packet:GetDestroyNumByGoodsID(goodsid)
			if add_per then
				total_cnt = total_cnt + add_per * goodscnt
			end
		end
	end
	pill_lbl_willget:setText("炼化后可得内丹" .. total_cnt .. "个")
end

function pet_pill_wash_pill_on_vb_mouseup(wnd, evt)
	local cur_mouse_pos = desktop:GetMouseXY()
	if pt_vb_down_pos == nil or (math.abs(pt_vb_down_pos.x - cur_mouse_pos.x) < 10 and math.abs(pt_vb_down_pos.y - cur_mouse_pos.y) < 10) then
		wnd:SetAlwaysLight(not wnd:IsAlwaysLight())
		pet_pill_wash_pill_refresh_pill_will_get()
	end
end

function pet_pill_wash_pill_on_vb_dbclk(wnd, evt)
	local mstid = wnd:GetPropertyInt32("mstid")
	api_pet_preview(mstid)	
end

--------洗髓面板逻辑--------
function pet_pill_wash_wash_on_show()
	wash_petsw_pets:CheckCurPetIndex()	
end

function pet_pill_wash_wash_on_hide()
	
end

function pet_pill_wash_wash_on_switch_pet(wnd, index, is_data_change)
	pet_pill_wash_wash_refreshwnd()
end

local function wash_clear_apt_ctrls(prgbar, lblinc, bmpinc, bmpdec)
	prgbar:SetRange(0, 0)
	prgbar:SetPos(0)
	local aptclr = api_get_pet_apt_color(0, 0)
	prgbar:SetDigitalColor(aptclr)
	lblinc:setText("")
	bmpinc:SetVisible(false)
	bmpdec:SetVisible(false)
end

local function wash_clearwnd()
	wash_clear_apt_ctrls(wash_prgbar_aptall, wash_lbl_all_add, wash_bmp_all_up, wash_bmp_all_down)
	wash_clear_apt_ctrls(wash_prgbar_aptatk, wash_lbl_atk_add, wash_bmp_atk_up, wash_bmp_atk_down)
	wash_clear_apt_ctrls(wash_prgbar_aptdfd, wash_lbl_dfd_add, wash_bmp_dfd_up, wash_bmp_dfd_down)
	wash_clear_apt_ctrls(wash_prgbar_aptmgc, wash_lbl_mgc_add, wash_bmp_mgc_up, wash_bmp_mgc_down)
	wash_clear_apt_ctrls(wash_prgbar_aptrsm, wash_lbl_rsm_add, wash_bmp_rsm_up, wash_bmp_rsm_down)
	wash_clear_apt_ctrls(wash_prgbar_apthp , wash_lbl_hp_add , wash_bmp_hp_up , wash_bmp_hp_down )	
	
	wash_lbl_petname:setText("")
	wash_lbl_petname:SetForeColor(clrWhite)
	wash_bmp_gender:SetBitmap("")
	wash_lbl_race:setText("")
	wash_html_btlval:Clear()
	wash_lbl_level:setText("")
	wash_lbl_curpill:setText("")
end

local function get_wash_history_prop(pet, propid)
	local history = table_wash_history[UID.ToString(pet:GetUID())]
	if history == nil then
		return nil
	end
	if propid == nil then
		local sum = 0
		for i = 1, #history.data do
			local info = history.data[i]
			sum = sum + info.val
		end
		return sum
	else
		for i = 1, #history.data do
			local info = history.data[i]
			if info.propid == propid then
				return info.val
			end
		end
	end
	return 0
end

local function wash_set_apt_ctrls(apt_datas, prgbar, lblinc, bmpinc, bmpdec, pet, mstcfg, propid)
	if mstcfg == nil then
		wash_clear_apt_ctrls(prgbar, lblinc, bmpinc, bmpdec)
		return
	end
	--获取新老值
	local oldval = get_wash_history_prop(pet, propid)
	local curval = 0
	local avg    = 0
	local limit  = 0	
	if propid == nil then
		for k, v in pairs(apt_datas) do
			curval = curval + v.val
			avg = avg + v.avg
			limit = limit + v.limit			
		end	
	else
		curval = apt_datas[propid].val
		avg = apt_datas[propid].avg
		limit = apt_datas[propid].limit
	end
	
	--设置进度条上限值
	prgbar:SetRange(0, limit)

	--设置进度条当前值
	prgbar:SetPos(curval)
	local aptclr = api_get_pet_apt_color(avg, curval)
	prgbar:SetDigitalColor(aptclr)

	--设置新值、变化值
	if oldval then
		local diff = curval - oldval
		if diff > 0 then
			lblinc:setText(tostring(diff))
			lblinc:SetForeColor(clrGreen)
			bmpinc:SetVisible(true)
			bmpdec:SetVisible(false)
		elseif diff < 0 then
			lblinc:setText(tostring(-diff))
			lblinc:SetForeColor(clrRed)
			bmpinc:SetVisible(false)
			bmpdec:SetVisible(true)
		else
			lblinc:setText("")
			lblinc:SetForeColor(clrWhite)
			bmpinc:SetVisible(false)
			bmpdec:SetVisible(false)
		end
	else
		lblinc:setText("")
		bmpinc:SetVisible(false)
		bmpdec:SetVisible(false)
	end
end

function pet_pill_wash_wash_refreshwnd()
	local hero = core.getHero()	
	if hero == nil then
		return
	end

	local index = wash_petsw_pets:GetCurPetIndex()
	local pet = petutil.GetPetByIndex(index)
	if pet ~= nil then
		wash_lbl_petname:setText(pet:GetName())
		wash_lbl_petname:SetForeColor(petutil.GetPetColor(pet))
		
		local sex = pet:GetCrtProp(enProp_Sex)
		if sex == enCreatureSex_Male then
			wash_bmp_gender:SetBitmap("Pet/chong_wu~_yang.png")
		elseif sex == enCreatureSex_Female then
			wash_bmp_gender:SetBitmap("Pet/chong_wu~_yin.png")
		else
			wash_bmp_gender:SetBitmap("")
		end
		
		local race = pet:GetCrtProp(enProp_NPC_Cur_RaceType)
		wash_lbl_race:setText(NPCRaceTypeDesc[race])
		
        local btlval = pet:GetCrtProp(enProp_Cur_FightForceValue)
        local strnum = tostring(btlval)
		local str    = ""
        for i = 1,string.len(strnum) do
            str = str..string.format("#(image,Data/UI/flow_num/red2/00%s.png)", string.sub(strnum, i, i))
        end
        wash_html_btlval:Clear()
		wash_html_btlval:ParseContext(str)
		
		local level = pet:GetCrtProp(enProp_Level)
		wash_lbl_level:setText(tostring(level))
		
		local pillcnt = hero:GetCrtProp(enProp_Actor_InnerPill)
		wash_lbl_curpill:setText(tostring(pillcnt))

		local mstid = pet:GetCrtProp(enProp_NPC_MonsterID)
		local mstcfg = core.getMonsterConfig(mstid)

		local val_avg_limit_data =
		{
			[enProp_NPC_Aptitude_Attack]      = {val = pet:GetCrtProp(enProp_NPC_Aptitude_Attack),      avg = mstcfg.nAptitude_A,  limit = mstcfg.nAptitude_A_Max},
			[enProp_NPC_Aptitude_Defence]     = {val = pet:GetCrtProp(enProp_NPC_Aptitude_Defence),     avg = mstcfg.nAptitude_D,  limit = mstcfg.nAptitude_D_Max},
			[enProp_NPC_Aptitude_Magic]       = {val = pet:GetCrtProp(enProp_NPC_Aptitude_Magic),       avg = mstcfg.nAptitude_M,  limit = mstcfg.nAptitude_M_Max},
			[enProp_NPC_Aptitude_ResistMagic] = {val = pet:GetCrtProp(enProp_NPC_Aptitude_ResistMagic), avg = mstcfg.nAptitude_RM, limit = mstcfg.nAptitude_RM_Max},
			[enProp_NPC_Aptitude_HP]          = {val = pet:GetCrtProp(enProp_NPC_Aptitude_HP),          avg = mstcfg.nAptitude_HP, limit = mstcfg.nAptitude_HP_Max},
		}

		--如果全满就不保存历史
		local bNeedInc = false
		for k, v in pairs(val_avg_limit_data) do
			if v.val < v.limit then
				bNeedInc = true
				break
			end
		end
		local str_uid_pet = UID.ToString(pet:GetUID())
		if not bNeedInc then
			table_wash_history[str_uid_pet] = nil
		end

		wash_set_apt_ctrls(val_avg_limit_data, wash_prgbar_aptall, wash_lbl_all_add, wash_bmp_all_up, wash_bmp_all_down, pet, mstcfg, nil								)
		wash_set_apt_ctrls(val_avg_limit_data, wash_prgbar_aptatk, wash_lbl_atk_add, wash_bmp_atk_up, wash_bmp_atk_down, pet, mstcfg, enProp_NPC_Aptitude_Attack		)
		wash_set_apt_ctrls(val_avg_limit_data, wash_prgbar_aptdfd, wash_lbl_dfd_add, wash_bmp_dfd_up, wash_bmp_dfd_down, pet, mstcfg, enProp_NPC_Aptitude_Defence		)
		wash_set_apt_ctrls(val_avg_limit_data, wash_prgbar_aptmgc, wash_lbl_mgc_add, wash_bmp_mgc_up, wash_bmp_mgc_down, pet, mstcfg, enProp_NPC_Aptitude_Magic		)
		wash_set_apt_ctrls(val_avg_limit_data, wash_prgbar_aptrsm, wash_lbl_rsm_add, wash_bmp_rsm_up, wash_bmp_rsm_down, pet, mstcfg, enProp_NPC_Aptitude_ResistMagic	)
		wash_set_apt_ctrls(val_avg_limit_data, wash_prgbar_apthp , wash_lbl_hp_add , wash_bmp_hp_up , wash_bmp_hp_down , pet, mstcfg, enProp_NPC_Aptitude_HP			)
		
		if table_wash_history[str_uid_pet] == nil then
			wash_btn_donow:SetVisible(true)
			wash_btn_confirm:SetVisible(false)
			wash_btn_revert:SetVisible(false)
		else
			wash_btn_donow:SetVisible(false)
			wash_btn_confirm:SetVisible(true)
			wash_btn_revert:SetVisible(true)
		end
	else
		wash_clearwnd()
	end
end

function pet_pill_wash_wash_on_btnwash()
	local pet_index = wash_petsw_pets:GetCurPetIndex()
	if invalid_petindex == pet_index then
		return
	end

	local use_ingot = wash_chb_goodwash:GetState()
	local msg = {}
	msg.module   = module_name
	msg.msg_code = "wash_pet"
	msg.pet_index= pet_index
	msg.use_ingot= use_ingot
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function pet_pill_wash_wash_on_btnconfirm()
	local pet_index = wash_petsw_pets:GetCurPetIndex()
	if invalid_petindex == pet_index then
		return
	end

	local msg = {}
	msg.module    = module_name
	msg.msg_code  = "wash_confirm"
	msg.pet_index = pet_index
	msg.is_confirm= true
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function pet_pill_wash_wash_on_btnrevert()
	local pet_index = wash_petsw_pets:GetCurPetIndex()
	if invalid_petindex == pet_index then
		return
	end

	local msg = {}
	msg.module   = module_name
	msg.msg_code = "wash_confirm"
	msg.pet_index= pet_index
	msg.is_confirm= false
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function pet_pill_wash_wash_on_btn_left()
	wash_petsw_pets:SwitchToNext(true)
end

function pet_pill_wash_wash_on_btn_right()
	wash_petsw_pets:SwitchToNext(false)
end

--------开始执行初始化--------
pet_pill_wash_init()