---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\pvp\pvp_act_landwar.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.12.2
--版  本:	1.0
--描  述:	领地争夺战 英雄榜 和 当前排行榜
----------------------------------------------------------------------------------------------------------------------
---------------------------英雄榜
----------------------------------------------------------------------------------------------------------------------
--窗口相关变量

LandwarHeroRankWnd				= {}
LandwarHeroRankWnd.thisWnd 		= nil
LandwarHeroRankWnd.ctrl_flip 	= nil
LandwarHeroRankWnd.title 		= {}
LandwarHeroRankWnd.cur_page 	= 1
LandwarHeroRankWnd.selfInfoLabel = nil

LandwarHeroRankWnd.actorKillRank= {}
LandwarHeroRankWnd.clanKillRank	= {}
LandwarHeroRankWnd.clanZLRank	= {}
LandwarHeroRankWnd.selfRankData 	= {}


--职位描述
local function get_occ_str(occ)
	if occ ==3 then
		return "魔羽"
	elseif occ ==4 then
		return "神剑"
	elseif occ ==5 then
		return "鬼影"
	elseif occ ==6 then
		return "仙乐"
	else
		return ""
	end
end

--前三名的颜色
local function GetColor(i)
	local clr = XColor:new(71,255,219)
	if i == 1 then
		clr = XColor:new(253,0,1)
	elseif i == 2 then
		clr = XColor:new(251,209,1)
	elseif i == 3 then
		clr = XColor:new(0,255,0)
	end
	return clr
end

----------------------------------------------------------------------------------------------------------------------
function LandwarHeroRankWndInit(wnd)
	LandwarHeroRankWnd.thisWnd = wnd
	
	--打开的时候
	LandwarHeroRankWnd.thisWnd:SetShowEventHandler2(LandwarHeroRankWnd.on_show)

	--切页控件
	LandwarHeroRankWnd.ctrl_flip = LandwarHeroRankWnd.thisWnd:GetFlipPage('flip')
	local page_count = LandwarHeroRankWnd.ctrl_flip:GetPageNum()
	for i=1, page_count do 
		local page_btn = LandwarHeroRankWnd.ctrl_flip:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler2(LandwarHeroRankWnd.on_flip_page)
	end

	--列表框
	LandwarHeroRankWnd.listbox = LandwarHeroRankWnd.thisWnd:GetListBox("listbox")
	LandwarHeroRankWnd.listbox:SetLineHeight(28)

	--个人击杀榜title
	LandwarHeroRankWnd.actorRankTitle = LandwarHeroRankWnd.thisWnd:GetPanel("actor_kill_title")
	LandwarHeroRankWnd.title[1] 	= LandwarHeroRankWnd.actorRankTitle
	--公会击杀榜title
	LandwarHeroRankWnd.clanRankTitle = LandwarHeroRankWnd.thisWnd:GetPanel("clan_kill_title")
	LandwarHeroRankWnd.title[2] 	= LandwarHeroRankWnd.clanRankTitle
	--公会占领榜title
	LandwarHeroRankWnd.clanZLTitle = LandwarHeroRankWnd.thisWnd:GetPanel("clan_zhanling_title")
	LandwarHeroRankWnd.title[3] 	= LandwarHeroRankWnd.clanZLTitle

	LandwarHeroRankWnd.selfInfoLabel = LandwarHeroRankWnd.thisWnd:GetLabel("self_info")

	--关闭按钮
	LandwarHeroRankWnd.thisWnd:GetButton("btn_close"):SetClickEventHandler2(function()
				LandwarHeroRankWnd.thisWnd:SetVisible(false)
			end)
end


--点击切页
local function landwar_hero_rank_wnd_flip_page(wnd)
	local page = XButton:CastToButton(wnd):GetTag1()
	LandwarHeroRankWnd.ctrl_flip:TurnPage(page-1)
	LandwarHeroRankWnd.cur_page = page
	LandwarHeroRankWnd.update_ui(page)
end
--切换表头
local function landwar_hero_rank_wnd_update_title(page)
	if #LandwarHeroRankWnd.title == 0 then
		API_TraceError("error LandwarHeroRankWnd.title empty")
		return
	end
	for i=1, 3 do
		if page == i then
			LandwarHeroRankWnd.title[i]:SetVisible(true)
		else
			LandwarHeroRankWnd.title[i]:SetVisible(false)
		end
	end
end

--更新列表
local function landwar_hero_rank_wnd_update_ui(page)
	if page < 1 or page > 3 then
		API_TraceError("error landwar_hero_rank_wnd_update_ui page:"..page)
		return
	end

	LandwarHeroRankWnd.listbox:RemoveAll()
	LandwarHeroRankWnd.update_title(page)
	if page == 1 then
		LandwarHeroRankWnd.listbox:SetColCount(5);
	
		LandwarHeroRankWnd.listbox:SetColFormat(0,140);
		LandwarHeroRankWnd.listbox:SetColAlign(0, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(1,220);
		LandwarHeroRankWnd.listbox:SetColAlign(1,1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(2,100);
		LandwarHeroRankWnd.listbox:SetColAlign(2, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(3,175);
		LandwarHeroRankWnd.listbox:SetColAlign(3, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(4,100);
		LandwarHeroRankWnd.listbox:SetColAlign(4, 1);

		for i =1,#LandwarHeroRankWnd.actorKillRank do	
			local v = LandwarHeroRankWnd.actorKillRank[i];
			local nCol = 0;
			LandwarHeroRankWnd.listbox:AddItem(0)
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, v.actorName)
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, get_occ_str(v.occ) )
			nCol = nCol + 1

			--listbox需要一个空格 不然会不显示。
			if v.clanName == "" then v.clanName = " " end
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, v.clanName)
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(v.killCount))

			LandwarHeroRankWnd.listbox:SetItemTextColor(i-1, GetColor(i))
		end
		if LandwarHeroRankWnd.selfRankData.selfKillCount ~= nil then
			LandwarHeroRankWnd.selfInfoLabel:setText("我上一次的击杀数 "..LandwarHeroRankWnd.selfRankData.selfKillCount)
		end
	elseif page == 2 then
		LandwarHeroRankWnd.listbox:SetColCount(4);
	
		LandwarHeroRankWnd.listbox:SetColFormat(0,150);
		LandwarHeroRankWnd.listbox:SetColAlign(0, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(1,338);
		LandwarHeroRankWnd.listbox:SetColAlign(1,1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(2,151);
		LandwarHeroRankWnd.listbox:SetColAlign(2, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(3,100);
		LandwarHeroRankWnd.listbox:SetColAlign(3, 1);
		
		for i =1,#LandwarHeroRankWnd.clanKillRank do	
			local v = LandwarHeroRankWnd.clanKillRank[i];
			local nCol = 0;
			LandwarHeroRankWnd.listbox:AddItem(0)
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
			nCol = nCol + 1

			--listbox需要一个空格 不然会不显示。
			if v.clanName == "" then v.clanName = " " end
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, v.clanName)
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(v.clanLevel))
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(v.killCount))

			LandwarHeroRankWnd.listbox:SetItemTextColor(i-1, GetColor(i))
		end

		if LandwarHeroRankWnd.selfRankData.selfClanKillCount ~= nil then
			LandwarHeroRankWnd.selfInfoLabel:setText("我的公会上一次的击杀数 "..LandwarHeroRankWnd.selfRankData.selfClanKillCount)
		end
	elseif page == 3 then
		LandwarHeroRankWnd.listbox:SetColCount(4);
	
		LandwarHeroRankWnd.listbox:SetColFormat(0,150);
		LandwarHeroRankWnd.listbox:SetColAlign(0, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(1,338);
		LandwarHeroRankWnd.listbox:SetColAlign(1,1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(2,151);
		LandwarHeroRankWnd.listbox:SetColAlign(2, 1);
		
		LandwarHeroRankWnd.listbox:SetColFormat(3,100);
		LandwarHeroRankWnd.listbox:SetColAlign(3, 1);
		
		for i =1,#LandwarHeroRankWnd.clanZLRank do	
			local v = LandwarHeroRankWnd.clanZLRank[i];
			local nCol = 0;
			LandwarHeroRankWnd.listbox:AddItem(0)
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, v.clanName)
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(v.clanLevel))
			nCol = nCol + 1
			LandwarHeroRankWnd.listbox:SetItem(i-1, nCol, tostring(v.zlCount))

			LandwarHeroRankWnd.listbox:SetItemTextColor(i-1, GetColor(i))
		end
		LandwarHeroRankWnd.selfInfoLabel:setText("")
	end
end


local function landwar_hero_rank_wnd_on_show()

	local msg = {}
	msg.module		= "LANDWAR_MODULE"
	msg.msg_code 	= "getRank"
	local jsonstr 	= cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

local function landwar_hero_rank_wnd_on_get_rank(msg)
	LandwarHeroRankWnd.actorKillRank	= msg.actorKillRank
	LandwarHeroRankWnd.clanKillRank		= msg.clanKillRank
	LandwarHeroRankWnd.clanZLRank		= msg.clanZLRank
	LandwarHeroRankWnd.selfRankData 	= msg.selfRankData
	
	--刷新界面
	LandwarHeroRankWnd.update_ui(LandwarHeroRankWnd.cur_page)
end


LandwarHeroRankWnd.on_flip_page 	= landwar_hero_rank_wnd_flip_page
LandwarHeroRankWnd.update_ui    	= landwar_hero_rank_wnd_update_ui
LandwarHeroRankWnd.update_title 	= landwar_hero_rank_wnd_update_title
LandwarHeroRankWnd.on_show			= landwar_hero_rank_wnd_on_show
LandwarHeroRankWnd.OnGetRank 		= landwar_hero_rank_wnd_on_get_rank


--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
----------------------------------------------当前排行榜
--------------------------------------------------------------------------------------------------------------
--窗口相关变量
LandwarRankWnd				= {}
LandwarRankWnd.thisWnd 		= nil
LandwarRankWnd.ctrl_flip 	= nil
LandwarRankWnd.title 		= {}
LandwarRankWnd.cur_page 	= 1
LandwarRankWnd.selfInfoLabel = nil

LandwarRankWnd.actorKillRank= {}
LandwarRankWnd.clanKillRank	= {}
LandwarRankWnd.selfRankData 	= {}

----------------------------------------------------------------------------------------------------------------------
function LandwarRankWndInit(wnd)
	LandwarRankWnd.thisWnd = wnd
	
	--打开的时候
	LandwarRankWnd.thisWnd:SetShowEventHandler2(LandwarRankWnd.on_show)

	--切页控件
	LandwarRankWnd.ctrl_flip = LandwarRankWnd.thisWnd:GetFlipPage('flip')
	local page_count = LandwarRankWnd.ctrl_flip:GetPageNum()
	for i=1, page_count do 
		local page_btn = LandwarRankWnd.ctrl_flip:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler2(LandwarRankWnd.on_flip_page)
	end

	--列表框
	LandwarRankWnd.listbox = LandwarRankWnd.thisWnd:GetListBox("listbox")
	LandwarRankWnd.listbox:SetLineHeight(28)

	--个人击杀榜title
	LandwarRankWnd.actorRankTitle = LandwarRankWnd.thisWnd:GetPanel("actor_kill_title")
	LandwarRankWnd.title[1] 	= LandwarRankWnd.actorRankTitle
	--公会击杀榜title
	LandwarRankWnd.clanRankTitle = LandwarRankWnd.thisWnd:GetPanel("clan_kill_title")
	LandwarRankWnd.title[2] 	= LandwarRankWnd.clanRankTitle

	LandwarRankWnd.selfInfoLabel = LandwarRankWnd.thisWnd:GetLabel("self_info")

	--关闭按钮
	LandwarRankWnd.thisWnd:GetButton("btn_close"):SetClickEventHandler2(function()
				LandwarRankWnd.thisWnd:SetVisible(false)
			end)
end


--点击切页
local function landwar_rank_wnd_flip_page(wnd)
	local page = XButton:CastToButton(wnd):GetTag1()
	LandwarRankWnd.ctrl_flip:TurnPage(page-1)
	LandwarRankWnd.cur_page = page
	LandwarRankWnd.update_ui(page)
end
--切换表头
local function landwar_rank_wnd_update_title(page)
	if #LandwarRankWnd.title == 0 then
		API_TraceError("error LandwarRankWnd.title empty")
		return
	end
	for i=1, LandwarRankWnd.ctrl_flip:GetPageNum() do
		if page == i then
			LandwarRankWnd.title[i]:SetVisible(true)
		else
			LandwarRankWnd.title[i]:SetVisible(false)
		end
	end
end

--更新列表
local function landwar_rank_wnd_update_ui(page)
	if page < 1 or page > 3 then
		API_TraceError("error landwar_rank_wnd_update_ui page:"..page)
		return
	end

	LandwarRankWnd.listbox:RemoveAll()
	LandwarRankWnd.update_title(page)
	if page == 1 then
		LandwarRankWnd.listbox:SetColCount(5);
	
		LandwarRankWnd.listbox:SetColFormat(0,140);
		LandwarRankWnd.listbox:SetColAlign(0, 1);
		
		LandwarRankWnd.listbox:SetColFormat(1,220);
		LandwarRankWnd.listbox:SetColAlign(1,1);
		
		LandwarRankWnd.listbox:SetColFormat(2,100);
		LandwarRankWnd.listbox:SetColAlign(2, 1);
		
		LandwarRankWnd.listbox:SetColFormat(3,175);
		LandwarRankWnd.listbox:SetColAlign(3, 1);
		
		LandwarRankWnd.listbox:SetColFormat(4,100);
		LandwarRankWnd.listbox:SetColAlign(4, 1);

		for i =1,#LandwarRankWnd.actorKillRank do	
			local v = LandwarRankWnd.actorKillRank[i];
			local nCol = 0;
			LandwarRankWnd.listbox:AddItem(0)
			LandwarRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
			nCol = nCol + 1
			LandwarRankWnd.listbox:SetItem(i-1, nCol, v.actorName)
			nCol = nCol + 1
			LandwarRankWnd.listbox:SetItem(i-1, nCol, get_occ_str(v.occ) )
			nCol = nCol + 1
			--listbox需要一个空格 不然会不显示。
			if v.clanName == "" then v.clanName = " " end
			LandwarRankWnd.listbox:SetItem(i-1, nCol, v.clanName)
			nCol = nCol + 1
			LandwarRankWnd.listbox:SetItem(i-1, nCol, tostring(v.killCount))

			LandwarRankWnd.listbox:SetItemTextColor(i-1, GetColor(i))
		end
		if LandwarRankWnd.selfRankData.selfKillCount ~= nil then
			LandwarRankWnd.selfInfoLabel:setText("我当前的击杀数 "..LandwarRankWnd.selfRankData.selfKillCount)
		else
			LandwarRankWnd.selfInfoLabel:setText("")
		end
	elseif page == 2 then
		LandwarRankWnd.listbox:SetColCount(4);
	
		LandwarRankWnd.listbox:SetColFormat(0,150);
		LandwarRankWnd.listbox:SetColAlign(0, 1);
		
		LandwarRankWnd.listbox:SetColFormat(1,338);
		LandwarRankWnd.listbox:SetColAlign(1,1);
		
		LandwarRankWnd.listbox:SetColFormat(2,151);
		LandwarRankWnd.listbox:SetColAlign(2, 1);
		
		LandwarRankWnd.listbox:SetColFormat(3,100);
		LandwarRankWnd.listbox:SetColAlign(3, 1);
		
		for i =1,#LandwarRankWnd.clanKillRank do	
			local v = LandwarRankWnd.clanKillRank[i];
			local nCol = 0;
			LandwarRankWnd.listbox:AddItem(0)
			LandwarRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
			nCol = nCol + 1
			--listbox需要一个空格 不然会不显示。
			if v.clanName == "" then v.clanName = " " end
			LandwarRankWnd.listbox:SetItem(i-1, nCol, v.clanName)
			nCol = nCol + 1
			LandwarRankWnd.listbox:SetItem(i-1, nCol, tostring(v.clanLevel))
			nCol = nCol + 1
			LandwarRankWnd.listbox:SetItem(i-1, nCol, tostring(v.killCount))

			LandwarRankWnd.listbox:SetItemTextColor(i-1, GetColor(i))
		end

		if LandwarRankWnd.selfRankData.selfClanKillCount ~= nil then
			LandwarRankWnd.selfInfoLabel:setText("我的公会当前的击杀数 "..LandwarRankWnd.selfRankData.selfClanKillCount)
		else
			LandwarRankWnd.selfInfoLabel:setText("")
		end
	end
end


local function landwar_rank_wnd_on_show()

	local msg = {}
	msg.module		= "LANDWAR_MODULE"
	msg.msg_code 	= "getRankRT"
	local jsonstr 	= cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

local function landwar_rank_wnd_on_get_rank(msg)
	LandwarRankWnd.actorKillRank	= msg.actorKillRank
	LandwarRankWnd.clanKillRank		= msg.clanKillRank
	LandwarRankWnd.clanZLRank		= msg.clanZLRank
	LandwarRankWnd.selfRankData 	= msg.selfRankData
	
	--刷新界面
	LandwarRankWnd.update_ui(LandwarRankWnd.cur_page)
end


LandwarRankWnd.on_flip_page 	= landwar_rank_wnd_flip_page
LandwarRankWnd.update_ui    	= landwar_rank_wnd_update_ui
LandwarRankWnd.update_title 	= landwar_rank_wnd_update_title
LandwarRankWnd.on_show			= landwar_rank_wnd_on_show
LandwarRankWnd.OnGetRank 		= landwar_rank_wnd_on_get_rank

-----------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------
--当前排行榜launch

LandwarRankLaunch 			= {}
LandwarRankLaunch.thisWnd 	= nil
LandwarRankLaunch.launchBtn = nil
LandwarRankLaunch.bCanShowWin  = false


function LandwarRankLaunchInit(wnd)
	LandwarRankLaunch.thisWnd = wnd
	LandwarRankLaunch.launchBtn = LandwarRankLaunch.thisWnd:GetButton("btn_paihang")
	LandwarRankLaunch.launchBtn:SetClickEventHandler2(
		function()
			LandwarRankWnd.thisWnd:SetVisible(true)
		end
	)

	--api_reg_system_bar_pos_listen(OnSystemSortCut_LandwarRankLaunch)

	--屏幕尺寸变化调用
	LandwarRankLaunch.thisWnd:SetClientRectChangedCallback("LandwarRankLaunchClientRectChangeListen")

	LandwarRankLaunch.thisWnd:SetVisible(false)
end

--屏幕变化
function LandwarRankLaunchClientRectChangeListen()
	LandwarRankLaunch.LandwarRankLaunchResetPos()
end

local function LandwarRankLaunchResetPos()
	local desktop = WndSystem:GetInstance():GetGameDesktop()
	XWinUtil:AlignWindow(desktop, LandwarRankLaunch.thisWnd, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 120, 0, 75, 0, false)
end

--function OnSystemSortCut_LandwarRankLaunch()
--	if API_IsSystemWindowVisible() then
--		if LandwarRankLaunch.bCanShowWin then
--			LandwarRankLaunch.thisWnd:SetVisible(true)
--		end
--	else
--		LandwarRankLaunch.thisWnd:SetVisible(false)
--	end
--end

local function SetIsCanShowWin(b)
	if b == nil then b = false end

	if b then
		if LandwarRankLaunch.thisWnd:IsVisible() == false then
			LandwarRankLaunch.thisWnd:SetVisible(b)
		end
	else
		if LandwarRankLaunch.thisWnd:IsVisible() then
			LandwarRankLaunch.thisWnd:SetVisible(b)
		end
	end
end

LandwarRankLaunch.SetIsCanShowWin 			= SetIsCanShowWin
LandwarRankLaunch.LandwarRankLaunchResetPos = LandwarRankLaunchResetPos



