﻿---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\pvp\pvp_act_zhengba.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.10.8
--版  本:	1.0
--描  述:	争霸的客户端
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------仙界争霸主窗口------------------------------
ZBClient = {}
ZBClient.this_wnd 				= nil  	--自己
ZBClient.module_name = "zhengba"
ZBClient.mapID = 227 --副本的地图id
ZBClient.ZB_position_name = {"仙帝","仙后","战神","天王","天尊","法神",}--职位表对应的职位称呼

ZBClient.ZB_max_position = 6
ZBClient.friendList = {}
ZBClient.next_time = nil 
ZBClient.ZB_position_table = nil

--初始化
function ZB_init(wnd)
	ZBClient.this_wnd = wnd
	
	--模块相关窗口初始化
	ZBLaunch.init()
	ZBRankWnd.init()
	ZBHighRankWnd.init()
	ZBRenmingWnd.init()
	--规则窗口-------------------------
	local tipwnd = core.createWindow('Data/Scp/Windows/Windows_Zhengba.scp',1084)
	local html_tip = tipwnd:GetHtml("tip1")
	local tip_txt = "1、参加条件：天梯排行榜前300名#(br,1)"
	tip_txt = tip_txt.."2、活动时间：每晚8点28分可进副本(此时副本为和平模式)，8点30正式开始(副本变成组队PK模式)，8点50结束#(br,1)"
	tip_txt = tip_txt.."3、积分值: 干掉怪或玩家可得积分。活动结束时积分越高奖励越多，并且第一名将成为仙帝。#(br,1)"
	tip_txt = tip_txt.."4、悬赏值：干掉别的玩家或者BOSS将获得的积分。#(br,1)"
	tip_txt = tip_txt.."5、积分boss：开赛1、11分钟时刷新4个BOSS，有高额的悬赏值。#(br,1)"
	tip_txt = tip_txt.."6、仙帝:活动第一名，可以在主界面中任命好友的职位，好友将获得丰厚奖励#(br,1)"
	tip_txt = tip_txt.."7、副本中可组队#(br,1)"
	--tip_txt = tip_txt.."8、副本中每分钟有经验奖励#(br,1)"
	tip_txt = tip_txt.."8、结束奖励：#(br,1)"
	tip_txt = tip_txt.."    排名   发放荣誉  发放物品#(br,1)"
	tip_txt = tip_txt.."    1      3000    1个3级宝石，5个极效强化石#(br,1)"
	tip_txt = tip_txt.."    （仙帝及其任命的好友将获得有属性加成的翅膀）#(br,1)"
	tip_txt = tip_txt.."    2      2650    1个3级宝石，5个极效强化石#(br,1)"
	tip_txt = tip_txt.."    3      2400    1个3级宝石，5个极效强化石#(br,1)"
	tip_txt = tip_txt.."    4~6    2250    1个2级宝石，4个极效强化石#(br,1)"
	tip_txt = tip_txt.."    7~10   2100    1个2级宝石，4个极效强化石#(br,1)"
	tip_txt = tip_txt.."    11~20  2000    1个2级宝石，3个极效强化石#(br,1)"
	tip_txt = tip_txt.."    21~50  1900    1个1级宝石，2个极效强化石#(br,1)"
	tip_txt = tip_txt.."    51~300 1800    1个1级宝石，1个极效强化石"
	html_tip:Clear()
	html_tip:ParseContext(tip_txt)
	tipwnd:GetButton('btn_close'):SetClickEventHandler2( function ( wnd, event) 	
										WndSystem:GetInstance():ShowWnd(1084,0)
										end)
	--规则窗口 end---------------------
										
	--前往按钮
	ZBClient.this_wnd:GetButton("btn_qianwang"):SetClickEventHandler2(ZBClient.on_btn_qianwang)
	
	--战神榜按钮
	ZBClient.this_wnd:GetButton("btn_zhanshenbang"):SetClickEventHandler2(function()
				ZBHighRankWnd.this_wnd:SetVisible(true)	
			end)
	
	--规则按钮
	ZBClient.this_wnd:GetButton("btn_rule"):SetClickEventHandler2(function()
				WndSystem:GetInstance():ShowWnd(1084,1)
			end)
			
	--称号奖励按钮
	ZBClient.this_wnd:GetButton("称号"):SetClickEventHandler2(function()
				WndSystem:GetInstance():ShowWnd(1086,1)
			end)
	
	--任命按钮点击事件
	for i =1,ZBClient.ZB_max_position do
		local btn_sel = ZBClient.this_wnd:GetButton("btn_sel"..i)
		btn_sel:SetClickEventHandler2(ZBClient.on_btn_renming)
	end
	
	--注册网络消息
	api_reg_module_msg_handler(ZBClient.module_name,ZBClient.msg_handler)
	
	--用于倒计时
	timer.setTimer('zb_main_wnd_ontime',1080,60000);
	
end

--点击前往按钮
local function on_btn_qianwang()
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "enter"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

local function on_btn_renming(wnd)
	local cursel = XButton:CastToButton(wnd):GetTag1()
	if ZBClient.ZB_position_table == nil or ZBClient.ZB_position_table[cursel] == nil then
		return
	end
	local hero = core.getHero()
	if hero == nil then  return end
	
	local data = ZBClient.ZB_position_table[cursel]
	if data.actorID ~= 0 then
		--弹出poplist
		local pt 	= XDesktop:GetInstance():GetMouseXY()
		pt.x 		= pt.x + 15
		g_pGlobal:GetMainUI():ShowCreaturePopMenu(data.actorID, pt)
	else
		if cursel == 1  then
			return
		end
		
		if ZBClient.ZB_position_table[1].actorID ~= hero:GetActorDBID() then
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您不是"..ZBClient.ZB_position_name[1].."不能任命"..ZBClient.ZB_position_name[cursel])
			return
		end
		
		
		--弹出任命窗口 
		ZBRenmingWnd.update_ui(cursel)
		ZBRenmingWnd.this_wnd:SetVisible(true)
	end

end

--打开主界面的时候向服务端请求数据
local function send_open_window()
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "open_mainwnd"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--打开主界面请求数据的回调
local function ZB_on_open_main_wnd(msg)
	--API_Trace(cjson.encode(msg))
	ZBClient.next_time = msg.next_time 
	ZBClient.ZB_position_table = {}
	ZBClient.ZB_position_table = msg.ZB_position_table
	ZBClient.friendList = msg.friendList
	ZBClient.update_ui()  
end

function zb_main_wnd_ontime()
	if ZBClient.next_time == nil then
		return
	end
	
	ZBClient.update_ui() 
end

local function zb_main_wnd_update_ui()
	local hero = core.getHero()
	if hero == nil then  return end
	
	--倒计时
	local label_countdown = ZBClient.this_wnd:GetLabel("label_countdown")
	if ZBClient.next_time == 0 then
		label_countdown:setText("活动进行中")
	else
		local curTime = XDate:GetInstance():GetCurrentVTime()
		local strTL = format_time_dd_hh_mm(math.ceil((ZBClient.next_time - curTime)/60))
		label_countdown:setText(strTL)
	end
	
	for i =1,ZBClient.ZB_max_position do
		if ZBClient.ZB_position_table[i] == nil then
			break
		end
		
		local data = ZBClient.ZB_position_table[i]
		local data_one = ZBClient.ZB_position_table[1]
		--每个玩家名
		local label_name = ZBClient.this_wnd:GetLabel("label_name"..i)
		label_name:setText(data.name)
		
		--按钮底图,没有空位显示空背景，有空位的自己能任命的显示任命，不能显示虚位以待
		local btn_sel = ZBClient.this_wnd:GetButton("btn_sel"..i)
		if i == 1 then
			if data.actorID == 0 then
				btn_sel:SetBitmap("text1/xuwei.png")
			else
				btn_sel:SetBitmap("Clan/bk.png")
			end
		else
			if data.actorID == 0 then
				if data_one.actorID == 0 or data_one.actorID ~= hero:GetActorDBID() then 
					btn_sel:SetBitmap("text1/xuwei.png")
				else
					btn_sel:SetBitmap("text1/renming.png")
				end
			else
				btn_sel:SetBitmap("Clan/bk.png")
			end
		end
		
		--生物视图
		local preview_ctrl = ZBClient.this_wnd:GetCreaturePreviewCtrl('cp_actor'..i)
		preview_ctrl:SetActorID(data.actorID)
	end
end

function format_time_dd_hh_mm(minute)
	if minute <= 0 then
		return ""
	elseif minute<60 then
		return minute.."分钟"
	elseif minute<24*60 then
		local hh = math.floor(minute/60)
		local mm = minute - hh*60
		return hh.."小时"..mm.."分钟"
	else
		local dd = math.floor(minute/(60*24))
		local hh =  math.floor((minute - dd*60*24)/60)
		local mm = minute - dd*60*24 - hh*60
		return dd.."天"..hh.."小时"..mm.."分钟"
	end

end

local function get_occ_str(occ)
	if occ ==3 then
		return "魔羽"
	elseif occ ==4 then
		return "神剑"
	elseif occ ==5 then
		return "鬼影"
	elseif occ ==6 then
		return "仙乐"
	else
		return ""
	end
end
--------网络消息处理--------
--接收网络消息
local function msg_handler(msg)
	if (msg.msg_code=="get_currank") then --副本中获得排行信息回送
		ZBRankWnd.OnGetCurrank(msg)
	elseif msg.msg_code=="open_mainwnd"  then --打开主窗口获得下次时间和争霸职位表回送
		ZBClient.OnOpenMainWnd(msg)
	elseif msg.msg_code == "get_highrank" then --打开战神榜窗口获得战神榜信息回送
		ZBHighRankWnd.OnGetRank(msg)
	elseif msg.msg_code=="score_change"  then --副本中玩家积分显示更新
		ZBLaunch.OnScoreChange(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end

ZBClient.init = ZB_init
ZBClient.on_btn_qianwang = on_btn_qianwang
ZBClient.msg_handler = msg_handler
ZBClient.send_open_window = send_open_window
ZBClient.OnOpenMainWnd = ZB_on_open_main_wnd
ZBClient.update_ui = zb_main_wnd_update_ui
ZBClient.on_btn_renming = on_btn_renming
ZBClient.get_occ_str = get_occ_str

--**********************************************************--
------------------------仙界争霸任命好友窗口-------------------
ZBRenmingWnd = {}
ZBRenmingWnd.this_wnd = nil --自己
ZBRenmingWnd.listbox = nil
ZBRenmingWnd.cursel = 2
local function zb_renming_wnd_init()
	ZBRenmingWnd.this_wnd = core.createWindow('Data/Scp/Windows/Windows_Zhengba.scp',1083)
	
	--列表框
	ZBRenmingWnd.listbox = ZBRenmingWnd.this_wnd:GetListBox("listbox")	
	ZBRenmingWnd.listbox:SetColCount(3);
	
	ZBRenmingWnd.listbox:SetColFormat(0,240);
	ZBRenmingWnd.listbox:SetColAlign(0, 1);
	
	ZBRenmingWnd.listbox:SetColFormat(1,80);
	ZBRenmingWnd.listbox:SetColAlign(0,1);
	
	ZBRenmingWnd.listbox:SetColFormat(2,110);
	ZBRenmingWnd.listbox:SetColAlign(0, 60);
	
	ZBRenmingWnd.listbox:SetLineHeight(40)
	
	--标题
	ZBRenmingWnd.label_title = ZBRenmingWnd.this_wnd:GetLabel("label_title")
	
	--任命按钮
	ZBRenmingWnd.this_wnd:GetButton("btn_renming"):SetClickEventHandler2(ZBRenmingWnd.on_btn_renming)
	
	--关闭按钮
	ZBRenmingWnd.this_wnd:GetButton("btn_close"):SetClickEventHandler2(function()
				ZBRenmingWnd.this_wnd:SetVisible(false)
			end)
end

local function zb_renming_wnd_update_ui(cursel)
	ZBRenmingWnd.cursel =cursel
	--标题
	ZBRenmingWnd.label_title:setText("任命好友为"..ZBClient.ZB_position_name[ZBRenmingWnd.cursel])
	
	--列表框
	ZBRenmingWnd.listbox:RemoveAll()
	if #ZBClient.friendList == 0 then
		return
	end
	for i =1,#ZBClient.friendList do	
		local v = ZBClient.friendList[i]
		local nCol = 0;
		ZBRenmingWnd.listbox:AddItem(0)
		
		ZBRenmingWnd.listbox:SetItem(i-1, nCol," "..v.name )
		
		nCol = nCol + 1
		ZBRenmingWnd.listbox:SetItem(i-1, nCol,ZBClient.get_occ_str(v.occ) )
		
		nCol = nCol + 1
		ZBRenmingWnd.listbox:SetItem(i-1, nCol, tostring(v.level))		
	end
	ZBRenmingWnd.listbox:SetCurSel(0)
end

local function zb_renming_wnd_on_btn_renming()
	if #ZBClient.friendList == 0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "当前没有好友")
		return
	end

	local friendsel = ZBRenmingWnd.listbox:GetCurSel()
	if friendsel <0 or  friendsel>= #ZBClient.friendList then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先选中一个好友")
		return
	end
	
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "appoint"
	msg.position = ZBRenmingWnd.cursel
	msg.fd_actorID =ZBClient.friendList[friendsel+1].actorID
	API_Trace(cjson.encode(ZBClient.friendList[friendsel+1]))
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
	
	ZBRenmingWnd.this_wnd:SetVisible(false)
end
ZBRenmingWnd.init = zb_renming_wnd_init
ZBRenmingWnd.update_ui =  zb_renming_wnd_update_ui
ZBRenmingWnd.on_btn_renming = zb_renming_wnd_on_btn_renming

--**********************************************************--
------------------------仙界争霸副本中launch-------------------
ZBLaunch = {}
ZBLaunch.this_wnd = nil --自己
ZBLaunch.label_score = nil
--ZBLaunch.bLight = false --用于判断有没有从争霸赛副本中出来
local function zb_launch_init()
	--创建各个窗口并初始化
	ZBLaunch.this_wnd = core.createWindow('Data/Scp/Windows/Windows_Zhengba.scp',1081)
	
	--当前积分label
	ZBLaunch.label_score = ZBLaunch.this_wnd:GetLabel("label_jifen")
	
	--离开按钮
	ZBLaunch.this_wnd:GetButton("btn_likai"):SetClickEventHandler2(ZBLaunch.on_btn_likai)
	
	--当前排行按钮
	ZBLaunch.this_wnd:GetButton("btn_paihang"):SetClickEventHandler2(ZBLaunch.on_btn_paihang)
	
	--规则按钮
	ZBLaunch.this_wnd:GetButton("btn_guize"):SetClickEventHandler2(function()
				WndSystem:GetInstance():ShowWnd(1084,1)
			end)
			
	--监听玩家切换场景
	api_reg_hero_all_data_ready_listen(zb_launch_hero_all_data_ready_listen)
	
	--屏幕尺寸变化调用
	ZBLaunch.this_wnd:SetClientRectChangedCallback("zb_launch_hero_all_data_ready_listen")
	
	--监听systemwnd显示和关闭
	api_reg_system_bar_pos_listen(zb_launch_hero_all_data_ready_listen)
end

function zb_launch_hero_all_data_ready_listen()
	--判断在不在仙界争霸战副本
	local hero = core.getHero()
	if hero == nil then  ZBLaunch.this_wnd:SetVisible(false) return end
	local cur_map_id = g_pGlobal:GetClientWorld():GetMapID()
	if cur_map_id ~= ZBClient.mapID then	
		ZBLaunch.this_wnd:SetVisible(false)
		--[[--调整亮度
		if ZBLaunch.bLight == true then
			g_pGlobal:GetDisplayMgr():GetScreenEffectMgr():SetScreenLight(false)
			ZBLaunch.bLight = false
		end--]]
		return
	end	
	
	--如果是有配置掉落的场景那么就显示图标
	ZBLaunch.reset_pos()
	ZBLaunch.this_wnd:SetVisible(true)	
	
	--[[--调整亮度
	if ZBLaunch.bLight == false then
		g_pGlobal:GetDisplayMgr():GetScreenEffectMgr():SetScreenLight(true)
		ZBLaunch.bLight = true
	end-]]
end

local function zb_launch_reset_pos()	
	--[[local nYPos
	if WndSystem:GetInstance():IsWindowVisible(60) == true then
		nYPos = 85
	else
		nYPos = 0
	end--]]
	
	local desktop = WndSystem:GetInstance():GetGameDesktop()
	XWinUtil:AlignWindow(desktop, ZBLaunch.this_wnd, XWinUtil.enXUAlign_RIGHT_RIGHT, XWinUtil.enXUAlign_TOP_TOP, 0, 0, 4, 0, false)
end

--点击离开按钮
local function zb_launch_on_btn_likai()
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "leave"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--点击排行按钮
local function zb_launch_on_btn_paihang()
	--判断在不在仙界争霸战副本
	local hero = core.getHero()
	if hero == nil then  ZBLaunch.this_wnd:SetVisible(false) return end
	local cur_map_id = g_pGlobal:GetClientWorld():GetMapID()
	if cur_map_id ~= ZBClient.mapID then
		ZBLaunch.this_wnd:SetVisible(false)
		return
	end	
	
	ZBRankWnd.this_wnd:SetVisible(true)
end

--积分改变消息
local function zb_launch_score_change(msg)
	ZBLaunch.label_score:setText("积分:"..msg.cur_score)
end

ZBLaunch.init = zb_launch_init
ZBLaunch.reset_pos = zb_launch_reset_pos
ZBLaunch.on_btn_likai = zb_launch_on_btn_likai
ZBLaunch.on_btn_paihang = zb_launch_on_btn_paihang
ZBLaunch.OnScoreChange = zb_launch_score_change

--**********************************************************--
------------------------仙界争霸副本中排行榜窗口-------------------
ZBRankWnd = {}
ZBRankWnd.this_wnd = nil --自己
ZBRankWnd.listbox = nil
ZBRankWnd.ZB_score_rank = nil	
ZBRankWnd.ZB_kill_rank = nil	
ZBRankWnd.ZB_dead_rank = nil
ZBRankWnd.ZB_bounty_rank = nil
ZBRankWnd.self_score = nil
ZBRankWnd.cur_page = 1
local function zb_rank_wnd_init()
	ZBRankWnd.this_wnd = core.createWindow('Data/Scp/Windows/Windows_Zhengba.scp',1082)
	
	--打开的时候
	ZBRankWnd.this_wnd:SetShowEventHandler2(ZBRankWnd.on_show)
	
	--切页控件
	ZBRankWnd.ctrl_flip = ZBRankWnd.this_wnd:GetFlipPage('flip')
	local page_count = ZBRankWnd.ctrl_flip:GetPageNum()
	for i=1, page_count do 
		local page_btn = ZBRankWnd.ctrl_flip:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler2(ZBRankWnd.on_flip_page)
	end
	
	--列表框
	ZBRankWnd.listbox = ZBRankWnd.this_wnd:GetListBox("listbox")	
	ZBRankWnd.listbox:SetColCount(5);
	
	ZBRankWnd.listbox:SetColFormat(0,120);
	ZBRankWnd.listbox:SetColAlign(0, 0);
	
	ZBRankWnd.listbox:SetColFormat(1,230);
	ZBRankWnd.listbox:SetColAlign(1,0);
	
	ZBRankWnd.listbox:SetColFormat(2,100);
	ZBRankWnd.listbox:SetColAlign(2, 0);
	
	ZBRankWnd.listbox:SetColFormat(3,160);
	ZBRankWnd.listbox:SetColAlign(3, 0);
	
	ZBRankWnd.listbox:SetColFormat(4,120);
	ZBRankWnd.listbox:SetColAlign(4, 1);
	
	ZBRankWnd.listbox:SetLineHeight(28)
	
	--第三列的表头叫什么
	ZBRankWnd.label_title_3 = ZBRankWnd.this_wnd:GetLabel("title_3")
	
	--我的信息
	ZBRankWnd.html_self_no	= ZBRankWnd.this_wnd:GetHtml("self_no")
	ZBRankWnd.label_self_info	= ZBRankWnd.this_wnd:GetLabel("self_info")
	
	--关闭按钮
	ZBRankWnd.this_wnd:GetButton("btn_close"):SetClickEventHandler2(function()
				ZBRankWnd.this_wnd:SetVisible(false)
			end)
			
	timer.setTimer('zb_rank_wnd_ontime',1082,5000);
end

local function zb_rank_wnd_on_show()
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "get_currank"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function zb_rank_wnd_ontime()
	if( not ZBRankWnd.this_wnd:IsVisible()) then
		return
	end
	
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "get_currank"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
	
end
local function zb_rank_wnd_on_get_currank(msg)
	ZBRankWnd.ZB_score_rank = msg.ZB_score_rank	
	ZBRankWnd.ZB_kill_rank = msg.ZB_kill_rank	
	ZBRankWnd.ZB_dead_rank = msg.ZB_dead_rank
	ZBRankWnd.ZB_bounty_rank = msg.ZB_bounty_rank
	ZBRankWnd.self_score = msg.self_score
	
	--刷新界面
	ZBRankWnd.update_ui(ZBRankWnd.cur_page)
end

--点击切页
local function zb_rank_wnd_flip_page(wnd)
	local page = XButton:CastToButton(wnd):GetTag1()
	ZBRankWnd.ctrl_flip:TurnPage(page-1)
	ZBRankWnd.update_ui(page)
end

local function zb_rank_wnd_update_ui(page)
	ZBRankWnd.cur_page = page
	
	local strTitle3 = ""
	local strSelfInfo = ""
	local selfNo = 0
	local rank_table = {}
	local rank_key = ""
	if page == 1 then
		strTitle3 = "总积分"
		selfNo = ZBRankWnd.self_score.score_no
		strSelfInfo = "积分 "..ZBRankWnd.self_score.score
		rank_table = ZBRankWnd.ZB_score_rank
		rank_key = "score"
	elseif page == 2 then
		strTitle3 = "杀人数"
		selfNo = ZBRankWnd.self_score.kill_no
		strSelfInfo = "杀人数 "..ZBRankWnd.self_score.kill_count
		rank_table = ZBRankWnd.ZB_kill_rank
		rank_key = "kill_count"
	elseif page == 3 then
		strTitle3 = "被杀次数"
		selfNo = ZBRankWnd.self_score.dead_no
		strSelfInfo = "死亡次数 "..ZBRankWnd.self_score.dead_count
		rank_table = ZBRankWnd.ZB_dead_rank
		rank_key = "dead_count"
	elseif page == 4 then
		strTitle3 = "当前悬赏额"
		selfNo = ZBRankWnd.self_score.bounty_no
		strSelfInfo = "悬赏额 "..ZBRankWnd.self_score.bounty
		rank_table = ZBRankWnd.ZB_bounty_rank
		rank_key = "bounty"
	else
		return
	end
				
	--第三列表头
	ZBRankWnd.label_title_3:setText(strTitle3)
	
	--我的信息
	local str = tostring(math.floor(selfNo))
	local len = string.len(str)
	local strTemp = ""
	for j = 1,len do
		local strOne = string.sub(str,j,j)
		strTemp = strTemp.."#(image,Data/UI/flow_num/blue2/00"..strOne..".png)"
	end
	ZBRankWnd.html_self_no:Clear()
	ZBRankWnd.html_self_no:ParseContext(strTemp)
	ZBRankWnd.label_self_info:setText(strSelfInfo)
	
	--列表控件
	ZBRankWnd.listbox:RemoveAll()
	if #rank_table == 0 then
		return
	end
	for i =1,#rank_table do	
		local v = rank_table[i]
		local nCol = 0;
		ZBRankWnd.listbox:AddItem(0)
		ZBRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
		nCol = nCol + 1
		ZBRankWnd.listbox:SetItem(i-1, nCol, v.name)
		nCol = nCol + 1
		ZBRankWnd.listbox:SetItem(i-1, nCol, ZBClient.get_occ_str(v.occ))
		nCol = nCol + 1
		if v.chan_name == "" then 
			ZBRankWnd.listbox:SetItem(i-1, nCol, " ")
		else
			ZBRankWnd.listbox:SetItem(i-1, nCol, v.chan_name)
		end
		nCol = nCol + 1
		ZBRankWnd.listbox:SetItem(i-1, nCol, tostring(v[rank_key]))	

		local clr = XColor:new(71,255,219)
		if i == 1 then
			clr = XColor:new(253,0,1)
		elseif i == 2 then
			clr = XColor:new(251,209,1)
		elseif i == 3 then
			clr = XColor:new(0,255,0)
		end
		ZBRankWnd.listbox:SetItemTextColor(i-1, clr);		
	end
	--ZBRankWnd.listbox:SetCurSel(0)
end

ZBRankWnd.init = zb_rank_wnd_init
ZBRankWnd.on_show = zb_rank_wnd_on_show
ZBRankWnd.OnGetCurrank = zb_rank_wnd_on_get_currank
ZBRankWnd.update_ui =  zb_rank_wnd_update_ui
ZBRankWnd.on_flip_page =zb_rank_wnd_flip_page

--**********************************************************--
------------------------战神榜窗口-------------------

ZBHighRankWnd = {}
ZBHighRankWnd.this_wnd = nil --自己
ZBHighRankWnd.listbox = nil
ZBHighRankWnd.ZB_high_score_rank = nil	
ZBHighRankWnd.ZB_high_kill_rank = nil	
ZBHighRankWnd.ZB_high_dead_rank = nil
ZBHighRankWnd.ZB_high_bounty_rank = nil
ZBHighRankWnd.ZB_first_count_rank = nil
ZBHighRankWnd.self_score = nil
ZBHighRankWnd.cur_page = 1
local function zb_high_rank_wnd_init()
	ZBHighRankWnd.this_wnd = core.createWindow('Data/Scp/Windows/Windows_Zhengba.scp',1085)
	
	--打开的时候
	ZBHighRankWnd.this_wnd:SetShowEventHandler2(ZBHighRankWnd.on_show)
	
	--切页控件
	ZBHighRankWnd.ctrl_flip = ZBHighRankWnd.this_wnd:GetFlipPage('flip')
	local page_count = ZBHighRankWnd.ctrl_flip:GetPageNum()
	for i=1, page_count do 
		local page_btn = ZBHighRankWnd.ctrl_flip:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler2(ZBHighRankWnd.on_flip_page)
	end
	
	--列表框
	ZBHighRankWnd.listbox = ZBHighRankWnd.this_wnd:GetListBox("listbox")	
	ZBHighRankWnd.listbox:SetColCount(5);
	
	ZBHighRankWnd.listbox:SetColFormat(0,120);
	ZBHighRankWnd.listbox:SetColAlign(0, 0);
	
	ZBHighRankWnd.listbox:SetColFormat(1,230);
	ZBHighRankWnd.listbox:SetColAlign(1,0);
	
	ZBHighRankWnd.listbox:SetColFormat(2,100);
	ZBHighRankWnd.listbox:SetColAlign(2, 0);
	
	ZBHighRankWnd.listbox:SetColFormat(3,160);
	ZBHighRankWnd.listbox:SetColAlign(3, 0);
	
	ZBHighRankWnd.listbox:SetColFormat(4,120);
	ZBHighRankWnd.listbox:SetColAlign(4, 1);
	
	ZBHighRankWnd.listbox:SetLineHeight(28)
	
	--第三列的表头叫什么
	ZBHighRankWnd.label_title_3 = ZBHighRankWnd.this_wnd:GetLabel("title_3")
	
	--我的信息
	ZBHighRankWnd.html_self_no	= ZBHighRankWnd.this_wnd:GetHtml("self_no")
	ZBHighRankWnd.label_self_info	= ZBHighRankWnd.this_wnd:GetLabel("self_info")
	
	--关闭按钮
	ZBHighRankWnd.this_wnd:GetButton("btn_close"):SetClickEventHandler2(function()
				ZBHighRankWnd.this_wnd:SetVisible(false)
			end)
end

local function zb_high_rank_wnd_on_show()
	local msg = {}
	msg.module   = ZBClient.module_name
	msg.msg_code = "get_highrank"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

local function zb_high_rank_wnd_on_get_rank(msg)
	ZBHighRankWnd.ZB_high_score_rank = msg.ZB_high_score_rank	
	ZBHighRankWnd.ZB_high_kill_rank = msg.ZB_high_kill_rank	
	ZBHighRankWnd.ZB_high_dead_rank = msg.ZB_high_dead_rank
	ZBHighRankWnd.ZB_high_bounty_rank = msg.ZB_high_bounty_rank
	ZBHighRankWnd.ZB_first_count_rank = msg.ZB_first_count_rank
	ZBHighRankWnd.self_score = msg.self_score
	
	--刷新界面
	ZBHighRankWnd.update_ui(ZBHighRankWnd.cur_page)
end

--点击切页
local function zb_high_rank_wnd_flip_page(wnd)
	local page = XButton:CastToButton(wnd):GetTag1()
	ZBHighRankWnd.ctrl_flip:TurnPage(page-1)
	ZBHighRankWnd.update_ui(page)
end

local function zb_high_rank_wnd_update_ui(page)
	ZBHighRankWnd.cur_page = page
	
	local hero = core.getHero()
	if hero == nil then  return end
	
	local strTitle3 = ""
	local strSelfInfo = ""
	local rank_table = {}
	local rank_key = ""
	if page == 1 then
		strTitle3 = "总积分"
		rank_table = ZBHighRankWnd.ZB_high_score_rank
		rank_key = "score"
		if ZBHighRankWnd.self_score ~= nil then
			strSelfInfo = "我上次活动时的积分 "..ZBHighRankWnd.self_score.score
		end
	elseif page == 2 then
		strTitle3 = "杀人数"
		rank_table = ZBHighRankWnd.ZB_high_kill_rank
		rank_key = "kill_count"
		if ZBHighRankWnd.self_score ~= nil then
			strSelfInfo = "我上次活动时的杀人数 "..ZBHighRankWnd.self_score.kill_count
		end
	elseif page == 3 then
		strTitle3 = "被杀次数"
		rank_table = ZBHighRankWnd.ZB_high_dead_rank
		rank_key = "dead_count"
		if ZBHighRankWnd.self_score ~= nil then
			strSelfInfo = "我上次活动时的死亡次数 "..ZBHighRankWnd.self_score.dead_count
		end
	elseif page == 4 then
		strTitle3 = "当前悬赏额"
		rank_table = ZBHighRankWnd.ZB_high_bounty_rank
		rank_key = "bounty"
		if ZBHighRankWnd.self_score ~= nil then
			strSelfInfo = "我上次活动时的悬赏额 "..ZBHighRankWnd.self_score.bounty
		end
	elseif page == 5 then
		strTitle3 = "王者次数"
		rank_table = ZBHighRankWnd.ZB_first_count_rank
		rank_key = "first_count"
		strSelfInfo = "我的王者次数:"..hero:GetPropEx("zb_first_count")
	else
		return
	end
				
	--第三列表头
	ZBHighRankWnd.label_title_3:setText(strTitle3)
	
	--我的信息
	ZBHighRankWnd.label_self_info:setText(strSelfInfo)
	
	--列表控件
	ZBHighRankWnd.listbox:RemoveAll()
	if #rank_table == 0 then
		return
	end
	for i =1,#rank_table do	
		local v = rank_table[i]
		local nCol = 0;
		ZBHighRankWnd.listbox:AddItem(0)
		ZBHighRankWnd.listbox:SetItem(i-1, nCol, tostring(i))
		nCol = nCol + 1
		ZBHighRankWnd.listbox:SetItem(i-1, nCol, v.name)
		nCol = nCol + 1
		ZBHighRankWnd.listbox:SetItem(i-1, nCol, ZBClient.get_occ_str(v.occ))
		nCol = nCol + 1
		if v.chan_name == "" then 
			ZBHighRankWnd.listbox:SetItem(i-1, nCol, " ")
		else
			ZBHighRankWnd.listbox:SetItem(i-1, nCol, v.chan_name)
		end
		nCol = nCol + 1
		ZBHighRankWnd.listbox:SetItem(i-1, nCol, tostring(v[rank_key]))	

		local clr = XColor:new(71,255,219)
		if i == 1 then
			clr = XColor:new(253,0,1)
		elseif i == 2 then
			clr = XColor:new(251,209,1)
		elseif i == 3 then
			clr = XColor:new(0,255,0)
		end
		ZBHighRankWnd.listbox:SetItemTextColor(i-1, clr);		
	end
end

ZBHighRankWnd.init = zb_high_rank_wnd_init
ZBHighRankWnd.on_show = zb_high_rank_wnd_on_show
ZBHighRankWnd.OnGetRank = zb_high_rank_wnd_on_get_rank
ZBHighRankWnd.update_ui =  zb_high_rank_wnd_update_ui
ZBHighRankWnd.on_flip_page =zb_high_rank_wnd_flip_page