﻿local specialShop_Wnd_ID	= 1025
local moduleName = 'specialShop'

local ShopWnd 		= nil
local labelShenLNum	= nil
local Shop			= {}

local shenLishiID 	= 25082

-----窗口初始化
function SpecialShop_Wnd_init()
	--注册消息
    api_reg_module_msg_handler(moduleName, SpecialShop_msg_handler)
	
	ShopWnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',specialShop_Wnd_ID)
	
	ShopWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'Shop_SendOpenRequest')
	labelShenLNum = ShopWnd:GetLabel('神灵石个数')
	labelShenLNum:setText('0')
end

function SpecialShop_msg_handler(msg)
	if msg.msg_code == 'OnShowWnd' then
		Shop.Shop_updateList(msg)
	elseif msg.msg_code == 'OnBuyOK' then
		Shop.Shop_updateShenLNum(msg)
	end
end

local function Shop_updateList(msg)

	local shopMainWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1032)
	--XWinUtil:AlignWindow(shopMainWnd, Peach_Wnd,  XWinUtil.enXUAlign_RIGHT_RIGHT, XWinUtil.enXUAlign_TOP_TOP, 80, 0, 10, 0, false);
    XWinUtil:AlignWindow(shopMainWnd, ShopWnd,  XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 22,0, 78,  0,false);

	local panelmgr = ShopWnd:GetScrollMgr('scrollmgr'):GetPanelMgr('panelmgr')
	local  panel_count = panelmgr:GetPanelCount()
	for k=1, panel_count do
		local panel = panelmgr:GetPanelWnd(k-1)
		if k<= #msg.goodsList then
			local panel = panelmgr:GetPanelWnd(k-1)
			goodsInfo = msg.goodsList[k]
			panel:SetVisible(true)
			----物品名
			local goodsName = panel:GetLabel('name')
			local goods_cfg = core.getGoodsConfig(goodsInfo.goodsID)
			goodsName:setText(goods_cfg.szName)
			----价格
			local priceLabel = panel:GetLabel('price')
			priceLabel:setText(''..goodsInfo.price)
			----物品icon
			local viewbox = panel:GetItemViewBox('icon')
			
			viewbox:SetItem(goodsInfo.goodsID,1,false,0)
			----兑换按钮
			local btn_buy = panel:GetButton('兑换')
			btn_buy:SetClickEventHandler('specialShop_buy_handler')
			btn_buy:SetPropertyInt32('goodsID',goodsInfo.goodsID)
			btn_buy:SetPropertyInt32('price',goodsInfo.price)
			----伙伴预览按钮
			local bit_petView = panel:GetStaticBitmap('petViewBit')
			if goodsInfo.type == 2 then
				bit_petView:SetClickEventHandler('specialShop_petView_handler')
				bit_petView:SetPropertyInt32('petID', goodsInfo.petID)
				
				local headPicID = g_pGlobal:GetPetSystem():GetHeadPicID(goodsInfo.petID) --g_pGlobal:GetResourceMgr():RequestIcon()
				bit_petView:SetBitmapIcon(headPicID)
				bit_petView:SetVisible(true)
				viewbox:ClearItem()
			else
				bit_petView:SetVisible(false)
			end
		else
			panel:SetVisible(false)
		end
	end
end

local function Shop_updateShenLNum(msg)
	local shenLiNum = core.getHero():GetPacketPart():GetNumByGoodsID(shenLishiID)
	labelShenLNum:setText(''..shenLiNum)
end

function specialShop_buy_handler(wnd,event)
	local price = wnd:GetPropertyInt32('price')
	local goodsID = wnd:GetPropertyInt32('goodsID')
	local goods_cfg = core.getGoodsConfig(goodsID)
	g_pGlobal:GetMainUI():ShowMessageBox("是否使用#(color,orange)"..price.."个神灵之石#(color,restore)兑换#(color,orange)"..goods_cfg.szName.."#(color,restore)","specialShop_buy_goods",goodsID,0,"确定","取消")
end

function specialShop_buy_goods(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local msg = {}
	msg.module =  moduleName
	msg.goodsID = wparam
	msg.msg_code = 'OnBuyGoods'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

function specialShop_petView_handler(wnd,event)
	local petID = wnd:GetPropertyInt32('petID')
	WndSystem:GetInstance():OnEvent(1020, 256, petID, 1)
	WndSystem:GetInstance():ShowWnd(77, 0)
end

function Shop_SendOpenRequest()
	local shenLiNum = core.getHero():GetPacketPart():GetNumByGoodsID(shenLishiID)
	labelShenLNum:setText(''..shenLiNum)
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'OnOpenRequest'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end
----------------初始化窗口-----------------------
SpecialShop_Wnd_init()

Shop.Shop_updateList = Shop_updateList
Shop.Shop_updateShenLNum	= Shop_updateShenLNum


----------------------------------------------------------------神工商店主窗口-----------------------------------------------------
local specialMainShop_Wnd_ID 	= 1032
local cur_flip_num		= 0
local subWndList 		= {}
local flip_Page			= nil
local animate_wenhao 	= nil

local event_open_peachwnd 	= 82001
local event_open_specialwnd = 82005
local mainShopWnd 		= nil
local mainTitle			= nil

function specialMainWndinit()
	mainShopWnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',specialMainShop_Wnd_ID)
	
	local btn_close = mainShopWnd:GetButton('关闭按钮')
	btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'specialMainWnd_OnClose')
	
	animate_wenhao 	= mainShopWnd:GetAni('问号')
	animate_wenhao:SetLuaEvent(XWIN_EVENT_CLICK, 'specialMainWnd_OnBtnTipsClick');
	animate_wenhao:SetVisible(false)
	animate_wenhao:PlayAni(false)
	
	flip_Page	= mainShopWnd:GetFlipPage('切换页')
	for k=1, (flip_Page:GetPageNum()) do 
		local flipBtn 	= flip_Page:GetPageBtnx(k-1)
		flipBtn:SetLuaEvent(XWIN_EVENT_CLICK, 'specialMainWnd_SwitchFlip')
	end
	
	mainTitle = mainShopWnd:GetLabel('标题')
	mainTitle:setText('蟠桃园')
	
	--窗口的事件
	mainShopWnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT,OnSpecialShopMainWndEvent)
	
	cur_flip_num = 0
	mainShopWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'specialMainWnd_OnShow')
	
end

function specialMainWnd_OnBtnTipsClick()
	WndSystem:GetInstance():ToggleWnd(823);
end

function OnSpecialShopMainWndEvent(pWnd,event,eventID,param1,param2)
	mainShopWnd:SetVisible(true)
	if eventID == event_open_peachwnd then
		specialMainWnd_OnSwitchFlip(0)
	elseif eventID == event_open_specialwnd then
		specialMainWnd_OnSwitchFlip(1)
	elseif eventID == 82006 then
		specialMainWnd_OnSwitchFlip(2)
	end
end

function specialMainWnd_OnShow()
	cur_flip_num = 0
	----添加蟠桃园窗口
	local peachWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(822) 
	if subWndList[0] == nil then
		subWndList[0] = peachWnd
		XWinUtil:AlignWindow(mainShopWnd, peachWnd,  XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, 22,0, 78,  0,false);
		mainShopWnd:AddWindow(peachWnd)
	end
	
	----添加神工商店窗口
	local shopWnd = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1025)
	if subWndList[1] == nil then
		subWndList[1] = shopWnd
		mainShopWnd:AddWindow(shopWnd)
	end
	
	----添加逆天商店窗口
	local skyShop = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1069)
	if subWndList[2] == nil then
		subWndList[2] = skyShop
		mainShopWnd:AddWindow(skyShop)
	end
	
	specialMainWnd_OnSwitchFlip(0)
end

function specialMainWnd_SwitchFlip(wnd)
	local index = XButton:CastToButton(wnd):GetTag1()
	specialMainWnd_OnSwitchFlip(index)
end

function specialMainWnd_OnSwitchFlip(index)
	subWndList[0]:SetVisible(false)
	subWndList[1]:SetVisible(false)
	subWndList[2]:SetVisible(false)
	subWndList[index]:SetVisible(true)
	
	flip_Page:TurnPage(index)
	
	if index == 0 then
		animate_wenhao:SetVisible(true)
		animate_wenhao:PlayAni(true)
		mainTitle:setText('蟠桃园')
	elseif index == 1 then
		animate_wenhao:SetVisible(false)
		animate_wenhao:PlayAni(false)
		mainTitle:setText('神工商店')
	elseif index == 2 then
		animate_wenhao:SetVisible(false)
		animate_wenhao:PlayAni(false)
		mainTitle:setText('逆天商店')
	end
	cur_flip_num = index
end

function specialMainWnd_OnClose()
	mainShopWnd:SetVisible(false)
end


specialMainWndinit()